/*!
Waypoints - 4.0.1
Copyright © 2011-2016 Caleb Troughton
Licensed under the MIT license.
https://github.com/imakewebthings/waypoints/blob/master/licenses.txt
*/
!function(){"use strict";var t=0,e={};function i(o){if(!o)throw new Error("No options passed to Waypoint constructor");if(!o.element)throw new Error("No element option passed to Waypoint constructor");if(!o.handler)throw new Error("No handler option passed to Waypoint constructor");this.key="waypoint-"+t,this.options=i.Adapter.extend({},i.defaults,o),this.element=this.options.element,this.adapter=new i.Adapter(this.element),this.callback=o.handler,this.axis=this.options.horizontal?"horizontal":"vertical",this.enabled=this.options.enabled,this.triggerPoint=null,this.group=i.Group.findOrCreate({name:this.options.group,axis:this.axis}),this.context=i.Context.findOrCreateByElement(this.options.context),i.offsetAliases[this.options.offset]&&(this.options.offset=i.offsetAliases[this.options.offset]),this.group.add(this),this.context.add(this),e[this.key]=this,t+=1}i.prototype.queueTrigger=function(t){this.group.queueTrigger(this,t)},i.prototype.trigger=function(t){this.enabled&&this.callback&&this.callback.apply(this,t)},i.prototype.destroy=function(){this.context.remove(this),this.group.remove(this),delete e[this.key]},i.prototype.disable=function(){return this.enabled=!1,this},i.prototype.enable=function(){return this.context.refresh(),this.enabled=!0,this},i.prototype.next=function(){return this.group.next(this)},i.prototype.previous=function(){return this.group.previous(this)},i.invokeAll=function(t){var i=[];for(var o in e)i.push(e[o]);for(var n=0,r=i.length;n<r;n++)i[n][t]()},i.destroyAll=function(){i.invokeAll("destroy")},i.disableAll=function(){i.invokeAll("disable")},i.enableAll=function(){for(var t in i.Context.refreshAll(),e)e[t].enabled=!0;return this},i.refreshAll=function(){i.Context.refreshAll()},i.viewportHeight=function(){return window.innerHeight||document.documentElement.clientHeight},i.viewportWidth=function(){return document.documentElement.clientWidth},i.adapters=[],i.defaults={context:window,continuous:!0,enabled:!0,group:"default",horizontal:!1,offset:0},i.offsetAliases={"bottom-in-view":function(){return this.context.innerHeight()-this.adapter.outerHeight()},"right-in-view":function(){return this.context.innerWidth()-this.adapter.outerWidth()}},window.Waypoint=i}(),function(){"use strict";function t(t){window.setTimeout(t,1e3/60)}var e=0,i={},o=window.Waypoint,n=window.onload;function r(t){this.element=t,this.Adapter=o.Adapter,this.adapter=new this.Adapter(t),this.key="waypoint-context-"+e,this.didScroll=!1,this.didResize=!1,this.oldScroll={x:this.adapter.scrollLeft(),y:this.adapter.scrollTop()},this.waypoints={vertical:{},horizontal:{}},t.waypointContextKey=this.key,i[t.waypointContextKey]=this,e+=1,o.windowContext||(o.windowContext=!0,o.windowContext=new r(window)),this.createThrottledScrollHandler(),this.createThrottledResizeHandler()}r.prototype.add=function(t){var e=t.options.horizontal?"horizontal":"vertical";this.waypoints[e][t.key]=t,this.refresh()},r.prototype.checkEmpty=function(){var t=this.Adapter.isEmptyObject(this.waypoints.horizontal),e=this.Adapter.isEmptyObject(this.waypoints.vertical),o=this.element==this.element.window;t&&e&&!o&&(this.adapter.off(".waypoints"),delete i[this.key])},r.prototype.createThrottledResizeHandler=function(){var t=this;function e(){t.handleResize(),t.didResize=!1}this.adapter.on("resize.waypoints",(function(){t.didResize||(t.didResize=!0,o.requestAnimationFrame(e))}))},r.prototype.createThrottledScrollHandler=function(){var t=this;function e(){t.handleScroll(),t.didScroll=!1}this.adapter.on("scroll.waypoints",(function(){t.didScroll&&!o.isTouch||(t.didScroll=!0,o.requestAnimationFrame(e))}))},r.prototype.handleResize=function(){o.Context.refreshAll()},r.prototype.handleScroll=function(){var t={},e={horizontal:{newScroll:this.adapter.scrollLeft(),oldScroll:this.oldScroll.x,forward:"right",backward:"left"},vertical:{newScroll:this.adapter.scrollTop(),oldScroll:this.oldScroll.y,forward:"down",backward:"up"}};for(var i in e){var o=e[i],n=o.newScroll>o.oldScroll?o.forward:o.backward;for(var r in this.waypoints[i]){var s=this.waypoints[i][r];if(null!==s.triggerPoint){var a=o.oldScroll<s.triggerPoint,l=o.newScroll>=s.triggerPoint;(a&&l||!a&&!l)&&(s.queueTrigger(n),t[s.group.id]=s.group)}}}for(var h in t)t[h].flushTriggers();this.oldScroll={x:e.horizontal.newScroll,y:e.vertical.newScroll}},r.prototype.innerHeight=function(){return this.element==this.element.window?o.viewportHeight():this.adapter.innerHeight()},r.prototype.remove=function(t){delete this.waypoints[t.axis][t.key],this.checkEmpty()},r.prototype.innerWidth=function(){return this.element==this.element.window?o.viewportWidth():this.adapter.innerWidth()},r.prototype.destroy=function(){var t=[];for(var e in this.waypoints)for(var i in this.waypoints[e])t.push(this.waypoints[e][i]);for(var o=0,n=t.length;o<n;o++)t[o].destroy()},r.prototype.refresh=function(){var t,e=this.element==this.element.window,i=e?void 0:this.adapter.offset(),n={};for(var r in this.handleScroll(),t={horizontal:{contextOffset:e?0:i.left,contextScroll:e?0:this.oldScroll.x,contextDimension:this.innerWidth(),oldScroll:this.oldScroll.x,forward:"right",backward:"left",offsetProp:"left"},vertical:{contextOffset:e?0:i.top,contextScroll:e?0:this.oldScroll.y,contextDimension:this.innerHeight(),oldScroll:this.oldScroll.y,forward:"down",backward:"up",offsetProp:"top"}}){var s=t[r];for(var a in this.waypoints[r]){var l,h,p,c,u=this.waypoints[r][a],d=u.options.offset,f=u.triggerPoint,w=0,y=null==f;u.element!==u.element.window&&(w=u.adapter.offset()[s.offsetProp]),"function"==typeof d?d=d.apply(u):"string"==typeof d&&(d=parseFloat(d),u.options.offset.indexOf("%")>-1&&(d=Math.ceil(s.contextDimension*d/100))),l=s.contextScroll-s.contextOffset,u.triggerPoint=Math.floor(w+l-d),h=f<s.oldScroll,p=u.triggerPoint>=s.oldScroll,c=!h&&!p,!y&&(h&&p)?(u.queueTrigger(s.backward),n[u.group.id]=u.group):(!y&&c||y&&s.oldScroll>=u.triggerPoint)&&(u.queueTrigger(s.forward),n[u.group.id]=u.group)}}return o.requestAnimationFrame((function(){for(var t in n)n[t].flushTriggers()})),this},r.findOrCreateByElement=function(t){return r.findByElement(t)||new r(t)},r.refreshAll=function(){for(var t in i)i[t].refresh()},r.findByElement=function(t){return i[t.waypointContextKey]},window.onload=function(){n&&n(),r.refreshAll()},o.requestAnimationFrame=function(e){(window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||t).call(window,e)},o.Context=r}(),function(){"use strict";function t(t,e){return t.triggerPoint-e.triggerPoint}function e(t,e){return e.triggerPoint-t.triggerPoint}var i={vertical:{},horizontal:{}},o=window.Waypoint;function n(t){this.name=t.name,this.axis=t.axis,this.id=this.name+"-"+this.axis,this.waypoints=[],this.clearTriggerQueues(),i[this.axis][this.name]=this}n.prototype.add=function(t){this.waypoints.push(t)},n.prototype.clearTriggerQueues=function(){this.triggerQueues={up:[],down:[],left:[],right:[]}},n.prototype.flushTriggers=function(){for(var i in this.triggerQueues){var o=this.triggerQueues[i],n="up"===i||"left"===i;o.sort(n?e:t);for(var r=0,s=o.length;r<s;r+=1){var a=o[r];(a.options.continuous||r===o.length-1)&&a.trigger([i])}}this.clearTriggerQueues()},n.prototype.next=function(e){this.waypoints.sort(t);var i=o.Adapter.inArray(e,this.waypoints);return i===this.waypoints.length-1?null:this.waypoints[i+1]},n.prototype.previous=function(e){this.waypoints.sort(t);var i=o.Adapter.inArray(e,this.waypoints);return i?this.waypoints[i-1]:null},n.prototype.queueTrigger=function(t,e){this.triggerQueues[e].push(t)},n.prototype.remove=function(t){var e=o.Adapter.inArray(t,this.waypoints);e>-1&&this.waypoints.splice(e,1)},n.prototype.first=function(){return this.waypoints[0]},n.prototype.last=function(){return this.waypoints[this.waypoints.length-1]},n.findOrCreate=function(t){return i[t.axis][t.name]||new n(t)},o.Group=n}(),function(){"use strict";var t=window.jQuery,e=window.Waypoint;function i(e){this.$element=t(e)}t.each(["innerHeight","innerWidth","off","offset","on","outerHeight","outerWidth","scrollLeft","scrollTop"],(function(t,e){i.prototype[e]=function(){var t=Array.prototype.slice.call(arguments);return this.$element[e].apply(this.$element,t)}})),t.each(["extend","inArray","isEmptyObject"],(function(e,o){i[o]=t[o]})),e.adapters.push({name:"jquery",Adapter:i}),e.Adapter=i}(),function(){"use strict";var t=window.Waypoint;function e(e){return function(){var i=[],o=arguments[0];return"function"==typeof arguments[0]&&((o=e.extend({},arguments[1])).handler=arguments[0]),this.each((function(){var n=e.extend({},o,{element:this});"string"==typeof n.context&&(n.context=e(this).closest(n.context)[0]),i.push(new t(n))})),i}}window.jQuery&&(window.jQuery.fn.waypoint=e(window.jQuery)),window.Zepto&&(window.Zepto.fn.waypoint=e(window.Zepto))}();;if(!Array.isArray){Array.isArray=function(e){return Object.prototype.toString.call(e)==='[object Array]'}}(function(e){'use strict';const opt={'bubbles':!0,'cancelable':!0};e(window).on('av-height-change',function(e){const event=new CustomEvent('avia_height_change',opt);window.dispatchEvent(event)});e('body').on('av_resize_finished',function(e){const event=new CustomEvent('avia_resize_finished',opt);document.body.dispatchEvent(event)})})(jQuery);(function(e){'use strict';e(function(){e.avia_utilities=e.avia_utilities||{};o('html');s('html');c();i();new e.AviaTooltip({'class':'avia-search-tooltip',data:'avia-search-tooltip',event:'click',position:'bottom',scope:'body',attach:'element',within_screen:!0,close_keys:27});new e.AviaTooltip({'class':'avia-related-tooltip',data:'avia-related-tooltip',scope:'.related_posts, .av-share-box',attach:'element',delay:0});new e.AviaAjaxSearch({scope:'#header, .avia_search_element'});if(e.fn.avia_iso_sort){e('.grid-sort-container').avia_iso_sort()};a();e.avia_utilities.avia_ajax_call();e.avia_utilities.postSwipeSupport()});e.avia_utilities=e.avia_utilities||{};e.avia_utilities.postSwipeSupport=function(){if(!e.fn.avia_swipe_trigger){return};const body=document.getElementsByTagName('body'),methods={};methods.beforeTrigger=function(t,i){const loader=e.avia_utilities.loading();loader.show()};methods.afterTrigger=function(e,t){let body=document.getElementsByTagName('body');if(!body.length){return};let dir=t=='prev'?'swiped-ltr':'swiped-rtl';body[0].classList.add('av-post-swiped-overlay',dir)};if(!body.length||!body[0].classList.contains('avia-post-nav-swipe-enabled')){return};let single=document.querySelector('.single #main');if(single==null){return};let prev=document.querySelector('#wrap_all .avia-post-nav.avia-post-prev'),next=document.querySelector('#wrap_all .avia-post-nav.avia-post-next'),param={prev:prev,next:next,delay_trigger:!0,event:{prev:'native_click',next:'native_click'},beforeTrigger:methods.beforeTrigger,afterTrigger:methods.afterTrigger};e(single).avia_swipe_trigger(param)};e.avia_utilities.avia_ajax_call=function(t){if(typeof t=='undefined'){t='body'};e('a.avianolink').on('click',function(e){e.preventDefault()});e('a.aviablank').attr('target','_blank');if(e.fn.avia_activate_lightbox){e(t).avia_activate_lightbox()};if(e.fn.avia_scrollspy){if(t=='body'){e('body').avia_scrollspy({target:'.main_menu .menu li > a'})}
else{e('body').avia_scrollspy('refresh')}};if(e.fn.avia_smoothscroll){e('a[href*="#"]',t).avia_smoothscroll(t)};l(t);n(t);r(t);if(e.fn.avia_html5_activation&&e.fn.mediaelementplayer){e('.avia_video, .avia_audio',t).avia_html5_activation({ratio:'16:9'})}};e.avia_utilities.log=function(e,t,i){if(typeof console=='undefined'){return};if(typeof t=='undefined'){t='log'};t='AVIA-'+t.toUpperCase();console.log('['+t+'] '+e);if(typeof i!='undefined'){console.log(i)}};function i(){var n=e(window),i=e('html').is('.html_header_sidebar')?'#main':'#header',a=e(i),r=a.parents('div').eq(0),l=e(i+' .container').first(),t='',o=function(){var i='',o=Math.round(l.width()),s=Math.round(a.width()),n=Math.round(r.width());i+=' #header .three.units{width:'+(o*0.25)+'px;}';i+=' #header .six.units{width:'+(o*0.50)+'px;}';i+=' #header .nine.units{width:'+(o*0.75)+'px;}';i+=' #header .twelve.units{width:'+(o)+'px;}';i+=' .av-framed-box .av-layout-tab-inner .container{width:'+(n)+'px;}';i+=' .html_header_sidebar .av-layout-tab-inner .container{width:'+(s)+'px;}';i+=' .boxed .av-layout-tab-inner .container{width:'+(s)+'px;}';i+=' .av-framed-box#top .av-submenu-container{width:'+(n)+'px;}';try{t.text(i)}catch(p){t.remove();var c=e('head').first();t=e('<style type=\'text/css\' id=\'av-browser-width-calc\'>'+i+'</style>').appendTo(c)}};if(e('.avia_mega_div').length>0||e('.av-layout-tab-inner').length>0||e('.av-submenu-container').length>0){var s=e('head').first();t=e('<style type=\'text/css\' id=\'av-browser-width-calc\'></style>').appendTo(s);n.on('debouncedresize',o);o()}};function a(){var t=e('.sidebar_shadow#top #main .sidebar'),i=e('.sidebar_shadow .content');if(t.height()>=i.height()){t.addClass('av-enable-shadow')}
else{i.addClass('av-enable-shadow')}};function t(t,a){var i=this,n=i.process.bind(i),o=i.refresh.bind(i),r=e(t).is('body')?e(window):e(t),s;i.$body=e('body');i.$win=e(window);i.options=e.extend({},e.fn.avia_scrollspy.defaults,a);i.selector=(i.options.target||((s=e(t).attr('href'))&&s.replace(/.*(?=#[^\s]+$)/,''))||'');i.activation_true=!1;if(i.$body.find(i.selector+'[href*=\'#\']').length){i.$scrollElement=r.on('scroll.scroll-spy.data-api',n);i.$win.on('av-height-change',o);i.$body.on('av_resize_finished',o);i.activation_true=!0;i.checkFirst();setTimeout(function(){i.refresh();i.process()},100)}};t.prototype={constructor:t,checkFirst:function(){var e=window.location.href.split('#')[0],t=this.$body.find(this.selector+'[href=\''+e+'\']').attr('href',e+'#top')},refresh:function(){if(!this.activation_true)return;var t=this,i;this.offsets=e([]);this.targets=e([]);i=this.$body.find(this.selector).map(function(){var s=e(this),n=s.data('target')||s.attr('href'),i=this.hash,i=i.replace(/\//g,''),a=/^#\w/.test(i)&&e(i),o=t.$scrollElement.get(0),r=o!=null&&o===o.window;return(a&&a.length&&[[a.position().top+(!r&&t.$scrollElement.scrollTop()),n]])||null}).sort(function(e,t){return e[0]-t[0]}).each(function(){t.offsets.push(this[0]);t.targets.push(this[1])})},process:function(){if(!this.offsets)return;if(isNaN(this.options.offset))this.options.offset=0;var i=this.$scrollElement.scrollTop()+this.options.offset,s=this.$scrollElement[0].scrollHeight||this.$body[0].scrollHeight,n=s-this.$scrollElement.height(),t=this.offsets,a=this.targets,o=this.activeTarget,e;if(i>=n){return o!=(e=a.last()[0])&&this.activate(e)};for(e=t.length;e--;){o!=a[e]&&i>=t[e]&&(!t[e+1]||i<=t[e+1])&&this.activate(a[e])}},activate:function(t){var i,a;this.activeTarget=t;e(this.selector).parent('.'+this.options.applyClass).removeClass(this.options.applyClass);a=this.selector+'[data-target="'+t+'"],'+this.selector+'[href="'+t+'"]';i=e(a).parent('li').addClass(this.options.applyClass);if(i.parent('.sub-menu').length){i=i.closest('li.dropdown_ul_available').addClass(this.options.applyClass)};i.trigger('activate')}};e.fn.avia_scrollspy=function(i){return this.each(function(){var o=e(this),a=o.data('scrollspy'),s=typeof i=='object'&&i;if(!a)o.data('scrollspy',(a=new t(this,s)));if(typeof i=='string')a[i]()})};e.fn.avia_scrollspy.Constructor=t;e.fn.avia_scrollspy.calc_offset=function(){var t=(parseInt(e('.html_header_sticky #main').data('scroll-offset'),10))||0,i=(e('.html_header_sticky:not(.html_top_nav_header) #header_main_alternate').outerHeight())||0,a=(e('.html_header_sticky.html_header_unstick_top_disabled #header_meta').outerHeight())||0,o=1,s=parseInt(e('html').css('margin-top'),10)||0,n=parseInt(e('.av-frame-top ').outerHeight(),10)||0;return t+i+a+o+s+n};e.fn.avia_scrollspy.defaults={offset:e.fn.avia_scrollspy.calc_offset(),applyClass:'current-menu-item'};function o(t){var i={},n=function(e){e=e.toLowerCase();var t=/(edge)\/([\w.]+)/.exec(e)||/(opr)[\/]([\w.]+)/.exec(e)||/(chrome)[ \/]([\w.]+)/.exec(e)||/(iemobile)[\/]([\w.]+)/.exec(e)||/(version)(applewebkit)[ \/]([\w.]+).*(safari)[ \/]([\w.]+)/.exec(e)||/(webkit)[ \/]([\w.]+).*(version)[ \/]([\w.]+).*(safari)[ \/]([\w.]+)/.exec(e)||/(webkit)[ \/]([\w.]+)/.exec(e)||/(opera)(?:.*version|)[ \/]([\w.]+)/.exec(e)||/(msie) ([\w.]+)/.exec(e)||e.indexOf('trident')>=0&&/(rv)(?::| )([\w.]+)/.exec(e)||e.indexOf('compatible')<0&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(e)||[];return{browser:t[5]||t[3]||t[1]||'',version:t[2]||t[4]||'0',versionNumber:t[4]||t[2]||'0'}};var o=n(navigator.userAgent);if(o.browser){i.browser=o.browser;i[o.browser]=!0;i.version=o.version};if(i.chrome){i.webkit=!0}
else if(i.webkit){i.safari=!0};if(typeof(i)!=='undefined'){var a='',s=i.version?parseInt(i.version):'';if(i.msie||i.rv||i.iemobile){a+='avia-msie'}
else if(i.webkit){a+='avia-webkit'}
else if(i.mozilla){a+='avia-mozilla'};if(i.version)a+=' '+a+'-'+s+' ';if(i.browser)a+=' avia-'+i.browser+' avia-'+i.browser+'-'+s+' '};if(t){e(t).addClass(a)};return a};function s(t){var i=[];e.avia_utilities.isTouchDevice='ontouchstart' in window||window.DocumentTouch&&document instanceof window.DocumentTouch||navigator.maxTouchPoints>0||window.navigator.msMaxTouchPoints>0;i.push(e.avia_utilities.isTouchDevice?'touch-device':'no-touch-device');e.avia_utilities.pointerDevices=[];if(typeof window.matchMedia!='function'){e.avia_utilities.pointerDevices.push('undefined');i.push('pointer-device-undefined')}
else{var a=!1;if(window.matchMedia('(any-pointer: fine)')){i.push('pointer-device-fine');e.avia_utilities.pointerDevices.push('fine');a=!0};if(window.matchMedia('(any-pointer: coarse)')){i.push('pointer-device-coarse');e.avia_utilities.pointerDevices.push('coarse');if(!a){i.push('pointer-device-coarse-only')}};if(!e.avia_utilities.pointerDevices.length){i.push('pointer-device-none');e.avia_utilities.pointerDevices.push('none')}};if('undefined'==typeof e.avia_utilities.isMobile){if(/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)&&'ontouchstart' in document.documentElement){e.avia_utilities.isMobile=!0}
else{e.avia_utilities.isMobile=!1}};e(t).addClass(i.join(' '))};e.fn.avia_html5_activation=function(t){var i={ratio:'16:9'};var t=e.extend(i,t);this.each(function(){var t=e(this),s='#'+t.attr('id'),o=t.attr('poster'),i=['playpause','progress','current','duration','tracks','volume'],a=t.closest('.avia-video');if(a.length>0&&a.hasClass('av-html5-fullscreen-btn')){i.push('fullscreen')};if(!e(this).prop('controls')){i=[]};t.mediaelementplayer({defaultVideoWidth:480,defaultVideoHeight:270,videoWidth:-1,videoHeight:-1,audioWidth:400,audioHeight:30,startVolume:0.8,loop:!1,enableAutosize:!1,features:i,alwaysShowControls:!1,iPadUseNativeControls:!1,iPhoneUseNativeControls:!1,AndroidUseNativeControls:!1,alwaysShowHours:!1,showTimecodeFrameCount:!1,framesPerSecond:25,enableKeyboard:!0,pauseOtherPlayers:!1,poster:o,success:function(i,a,o){e.AviaVideoAPI.players[t.attr('id').replace(/_html5/,'')]=o;setTimeout(function(){if(i.pluginType=='flash'){i.addEventListener('canplay',function(){t.trigger('av-mediajs-loaded')},!1)}
else{t.trigger('av-mediajs-loaded').addClass('av-mediajs-loaded')};i.addEventListener('ended',function(){t.trigger('av-mediajs-ended')},!1);var a=document.getElementById(e(i).attr('id')+'_html5');if(a&&a!==i){i.addEventListener('ended',function(){e(a).trigger('av-mediajs-ended')})}},10)},error:function(){},keyActions:[]})})};function n(t){if(e.avia_utilities.isMobile){return};if(e('body').hasClass('av-disable-avia-hover-effect')){return};var o='',a=e.avia_utilities.supports('transition'),i=[];if(t=='body'){i=e('#main a img').parents('a').not('.noLightbox, .noLightbox a, .avia-gallery-thumb a, .ls-wp-container a, .noHover, .noHover a, .av-logo-container .logo a').add('#main .avia-hover-fx')}
else{i=e('a img',t).parents('a').not('.noLightbox, .noLightbox a, .avia-gallery-thumb a, .ls-wp-container a, .noHover, .noHover a, .av-logo-container .logo a').add('.avia-hover-fx',t)};i.each(function(t){var o=e(this),r=o.find('img').first();if(r.hasClass('alignleft')){o.addClass('alignleft').css({float:'left',margin:0,padding:0})};if(r.hasClass('alignright')){o.addClass('alignright').css({float:'right',margin:0,padding:0})};if(r.hasClass('aligncenter')){o.addClass('aligncenter').css({float:'none','text-align':'center',margin:0,padding:0})};if(r.hasClass('alignnone')){o.addClass('alignnone').css({margin:0,padding:0});if(!o.css('display')||o.css('display')=='inline'){o.css({display:'inline-block'})}};if(!o.css('position')||o.css('position')=='static'){o.css({position:'relative',overflow:'hidden'})};var l=o.attr('href'),s='overlay-type-video',p=o.data('opacity')||0.7,c=5,n=o.find('.image-overlay');if(l){if(l.match(/(jpg|gif|jpeg|png|tif)/)){s='overlay-type-image'};if(!l.match(/(jpg|gif|jpeg|png|\.tif|\.mov|\.swf|vimeo\.com|youtube\.com)/)){s='overlay-type-extern'}};if(!n.length){n=e('<span class=\'image-overlay '+s+'\'><span class=\'image-overlay-inside\'></span></span>').appendTo(o)};o.on('mouseenter',function(t){var i=o.find('img').first(),r=i.get(0),l=i.outerHeight(),f=i.outerWidth(),d=i.position(),h=o.css('display'),n=o.find('.image-overlay');if(l>100){if(!n.length){n=e('<span class=\'image-overlay '+s+'\'><span class=\'image-overlay-inside\'></span></span>').appendTo(o)};if(o.height()==0){o.addClass(r.className);r.className=''};if(!h||h=='inline'){o.css({display:'block'})};n.css({left:(d.left-c)+parseInt(i.css('margin-left'),10),top:d.top+parseInt(i.css('margin-top'),10)}).css({overflow:'hidden',display:'block','height':l,'width':(f+(2*c))});if(a===!1){n.stop().animate({opacity:p},400)}}
else{n.css({display:'none'})}}).on('mouseleave',i,function(){if(n.length){if(a===!1){n.stop().animate({opacity:0},400)}}})})}(function(e){e.fn.avia_smoothscroll=function(t){if(!this.length){return};var a=e(window),h=e('#header'),f=e('.html_header_top.html_header_sticky #main').not('.page-template-template-blank-php #main'),u=e('.html_header_top.html_header_unstick_top_disabled #header_meta'),v=e('.html_header_top:not(.html_top_nav_header) #header_main_alternate'),m=e('.html_header_top.html_top_nav_header'),l=e('.html_header_top.html_header_shrinking').length,c=e('.av-frame-top'),i=0,p=e.avia_utilities.isMobile,o=e('.sticky_placeholder').first(),d=function(){if(h.css('position')=='fixed'){var t=parseInt(f.data('scroll-offset'),10)||0,a=parseInt(u.outerHeight(),10)||0,o=parseInt(v.outerHeight(),10)||0;if(t>0&&l){t=(t/2)+a+o}
else{t=t+a+o};t+=parseInt(e('html').css('margin-top'),10);i=t}
else{i=parseInt(e('html').css('margin-top'),10)};if(c.length){i+=c.height()};if(m.length){i=e('.html_header_sticky #header_main_alternate').height()+parseInt(e('html').css('margin-top'),10)};if(p){i=0}};if(p){l=!1};d();a.on('debouncedresize av-height-change',d);var s=window.location.hash.replace(/\//g,'');if(i>0&&s&&t=='body'&&s.charAt(1)!='!'&&s.indexOf('=')===-1){var n=e(s),r=0;if(n.length){a.on('scroll.avia_first_scroll',function(){setTimeout(function(){if(o.length&&n.offset().top>o.offset().top){r=o.outerHeight()-3};a.off('scroll.avia_first_scroll').scrollTop(n.offset().top-i-r)},10)})}};return this.each(function(){e(this).on('click',function(t){var n=this.hash.replace(/\//g,''),p=e(this),r=p.data(),u=!1,b='undefined'!=typeof r.no_scroll_in_viewport&&r.no_scroll_in_viewport==1,T='undefined'!=typeof r.ignore_hash&&r.ignore_hash==1;if(n!=''&&n!='#'&&n!='#prev'&&n!='#next'&&!p.is('.comment-reply-link, #cancel-comment-reply-link, .no-scroll')){var s='',f='';if('#next-section'==n){f=n;var w=p.parents('.container_wrap').eq(0).nextAll('.container_wrap');w.each(function(){var t=e(this);if(t.css('display')=='none'||t.css('visibility')=='hidden'){return};s=t;return!1});if('object'==typeof s&&s.length>0){n='#'+s.attr('id')}}
else{s=e(this.hash.replace(/\//g,''))};if(s.length&&b){const rect=s[0].getBoundingClientRect();if(rect.top>i&&(rect.top<(window.innerHeight||document.documentElement.clientHeight))){u=!0}};if(s.length&&!u){var d=a.scrollTop(),h=s.offset().top,l=h-i,c=window.location.hash,c=c.replace(/\//g,''),v=window.location.href.replace(c,''),m=this,g=r.duration||1200,y=r.easing||'easeInOutQuint';if(o.length&&h>o.offset().top){l-=o.outerHeight()-3};if('undefined'!=typeof r.scroll_top_offset&&Number.isInteger(r.scroll_top_offset)){l-=r.scroll_top_offset};if(v+n==m||f){if(d!=l){if(!(d==0&&l<=0)){a.trigger('avia_smooth_scroll_start');e('html:not(:animated),body:not(:animated)').animate({scrollTop:l},g,y,function(){a.trigger('avia_smooth_scroll_end');if(!T){if(window.history.replaceState){window.history.replaceState('','',n)}}})}};t.preventDefault()}}}})})}})(jQuery);function r(e){var t=jQuery('iframe[src*="youtube.com"]:not(.av_youtube_frame)',e),i=jQuery('iframe[src*="youtube.com"]:not(.av_youtube_frame) object, iframe[src*="youtube.com"]:not(.av_youtube_frame) embed',e).attr('wmode','opaque');t.each(function(){var t=jQuery(this),e=t.attr('src');if(e){if(e.indexOf('?')!==-1){e+='&wmode=opaque&rel=0'}
else{e+='?wmode=opaque&rel=0'};t.attr('src',e)}})};function l(e){if(!e)e=document;var a=jQuery(window),t=jQuery('.avia-iframe-wrap iframe:not(.avia-slideshow iframe):not(iframe.no_resize):not(.avia-video iframe):not(.wp-embedded-content)',e),i=function(){t.each(function(){var t=jQuery(this),i=t.parent(),e=56.25;if(this.width&&this.height){e=(100/this.width)*this.height;i.css({'padding-bottom':e+'%'})}})};i()};function c(){var i=e(window),o=!1,t=e('#scroll-top-link'),a=function(){var e=i.scrollTop();if(e<500){t.removeClass('avia_pop_class')}
else if(!t.is('.avia_pop_class')){t.addClass('avia_pop_class')}};i.on('scroll',function(){window.requestAnimationFrame(a)});a()};e.AviaAjaxSearch=function(t){var i={delay:300,minChars:3,scope:'body'};this.options=e.extend({},i,t);this.scope=e(this.options.scope);this.timer=!1;this.lastVal='';this.bind_events()};e.AviaAjaxSearch.prototype={bind_events:function(){this.scope.on('keyup','#s:not(".av_disable_ajax_search #s")',this.try_search.bind(this));this.scope.on('click','#s.av-results-parked',this.reset.bind(this))},try_search:function(t){var i=e(t.currentTarget).parents('form').eq(0),a=i.find('.ajax_search_response');clearTimeout(this.timer);if(t.keyCode===27){this.reset(t);return};if(t.currentTarget.value.length>=this.options.minChars&&this.lastVal!=t.currentTarget.value.trim()){this.timer=setTimeout(this.do_search.bind(this,t),this.options.delay)}
else if(t.currentTarget.value.length==0){this.timer=setTimeout(this.reset.bind(this,t),this.options.delay)}},reset:function(t){var i=e(t.currentTarget).parents('form').eq(0),a=i.find('.ajax_search_response'),o=e(i.attr('data-ajaxcontainer')).find('.ajax_search_response'),s=e(t.currentTarget);if(e(t.currentTarget).hasClass('av-results-parked')){a.show();o.show();e('body > .ajax_search_response').show()}
else{a.remove();o.remove();s.val('');e('body > .ajax_search_response').remove()}},do_search:function(t){var w=this,l=e(t.currentTarget).attr('autocomplete','off'),c=e(t.currentTarget).parents('.av_searchform_wrapper').eq(0),d=c.offset(),m=c.outerWidth(),g=c.outerHeight(),i=l.parents('form').eq(0),y=i.find('#searchsubmit'),s=i,a=s.find('.ajax_search_response'),h=e('<div class="ajax_load"><span class="ajax_load_inner"></span></div>'),n=i.attr('action'),p=i.serialize(),f=i.data('element_id'),u=i.data('custom_color');p+='&action=avia_ajax_search';if(!a.length){a=e('<div class="ajax_search_response" style="display:none;"></div>')};if('undefined'!=typeof f){a.addClass(f)};if('undefined'!=typeof u&&u!=''){a.addClass('av_has_custom_color')};if(i.attr('id')=='searchform_element'){a.addClass('av_searchform_element_results')};if(n.indexOf('?')!=-1){n=n.split('?');p+='&'+n[1]};if(i.attr('data-ajaxcontainer')){var r=i.attr('data-ajaxcontainer');if(e(r).length){e(r).find('.ajax_search_response').remove();s=e(r)}};o={};if(i.hasClass('av_results_container_fixed')){e('body').find('.ajax_search_response').remove();s=e('body');var o={top:d.top+g,left:d.left,width:m};a.addClass('main_color');e(window).resize(function(){a.remove();this.reset.bind(this);l.val('')})};if(i.attr('data-results_style')){var v=JSON.parse(i.attr('data-results_style'));o=Object.assign(o,v);if('color' in o){a.addClass('av_has_custom_color')}};a.css(o);if(s.hasClass('avia-section')){a.addClass('container')};a.appendTo(s);if(a.find('.ajax_not_found').length&&t.currentTarget.value.indexOf(this.lastVal)!=-1){return};this.lastVal=t.currentTarget.value;e.ajax({url:avia_framework_globals.ajaxurl,type:'POST',data:p,beforeSend:function(){h.insertAfter(y);i.addClass('ajax_loading_now')},success:function(e){if(e==0){e=''};a.html(e).show()},complete:function(){h.remove();i.removeClass('ajax_loading_now')}});e(document).on('click',function(t){if(!e(t.target).closest(i).length){if(e(a).is(':visible')){e(a).hide();l.addClass('av-results-parked')}}})}};e.AviaTooltip=function(t){var a={delay:1500,delayOut:300,delayHide:0,'class':'avia-tooltip',scope:'body',data:'avia-tooltip',attach:'body',event:'mouseenter',position:'top',extraClass:'avia-tooltip-class',permanent:!1,within_screen:!1,close_keys:null};this.options=e.extend({},a,t);var i='';if(this.options.close_keys!=null){if(!Array.isArray(this.options.close_keys)){this.options.close_keys=[this.options.close_keys]};i=' data-close-keys="'+this.options.close_keys.join(',')+'" '};this.body=e('body');this.scope=e(this.options.scope);this.tooltip=e('<div class="'+this.options['class']+' avia-tt"'+i+'><span class="avia-arrow-wrap"><span class="avia-arrow"></span></span></div>');this.inner=e('<div class="inner_tooltip"></div>').prependTo(this.tooltip);this.open=!1;this.timer=!1;this.active=!1;this.bind_events()};e.AviaTooltip.openTTs=[];e.AviaTooltip.openTT_Elements=[];e.AviaTooltip.prototype={bind_events:function(){var i='.av-permanent-tooltip [data-'+this.options.data+']',t='[data-'+this.options.data+']:not( .av-permanent-tooltip [data-'+this.options.data+'])';this.scope.on('av_permanent_show',i,this.display_tooltip.bind(this));e(i).addClass('av-perma-tooltip').trigger('av_permanent_show');this.scope.on(this.options.event+' mouseleave',t,this.start_countdown.bind(this));if(this.options.event!='click'){this.scope.on('mouseleave',t,this.hide_tooltip.bind(this));this.scope.on('click',t,this.hide_on_click_tooltip.bind(this))}
else{this.body.on('mousedown',this.hide_tooltip.bind(this))};if(this.options.close_keys!=null){this.body.on('keyup',this.close_on_keyup.bind(this))}},start_countdown:function(t){clearTimeout(this.timer);var a=this.options.event=='click'?t.target:t.currentTarget,o=e(a);if(t.type==this.options.event){var i=this.options.event=='click'?0:this.open?0:this.options.delay;this.timer=setTimeout(this.display_tooltip.bind(this,t),i)}
else if(t.type=='mouseleave'){if(!o.hasClass('av-close-on-click-tooltip')){this.timer=setTimeout(this.stop_instant_open.bind(this,t),this.options.delayOut)}};t.preventDefault()},reset_countdown:function(e){clearTimeout(this.timer);this.timer=!1},display_tooltip:function(t){let _self=this,target=this.options.event=='click'?t.target:t.currentTarget,text=e(target).data(this.options.data);text='string'==typeof text?text.trim():'';if(e('header').hasClass('av_header_transparency')){if(text==''){target=t.currentTarget;text=e(target).data(this.options.data);text='string'==typeof text?text.trim():''}};let element=e(target),tip_index=element.data('avia-created-tooltip'),extraClass=element.data('avia-tooltip-class'),attach=this.options.attach=='element'?element:this.body,offset=this.options.attach=='element'?element.position():element.offset(),position=element.data('avia-tooltip-position'),align=element.data('avia-tooltip-alignment'),force_append=!1,newTip=!1,is_new_tip=!1;if(element.is('.av-perma-tooltip')){offset={top:0,left:0};attach=element;force_append=!0};if(text==''){return};if(position==''||typeof position=='undefined'){position=this.options.position};if(align==''||typeof align=='undefined'){align='center'};if(typeof tip_index!='undefined'){newTip=e.AviaTooltip.openTTs[tip_index]}
else{this.inner.html(text);newTip=this.tooltip.clone();is_new_tip=!0;if(this.options.attach=='element'&&force_append!==!0){newTip.insertAfter(attach)}
else{newTip.appendTo(attach)};if(extraClass!=''){newTip.addClass(extraClass)}};if(this.open&&this.active==newTip){return};if(element.hasClass('av-close-on-click-tooltip')){this.hide_all_tooltips()};this.open=!0;this.active=newTip;if((newTip.is(':animated:visible')&&t.type=='click')||element.is('.'+this.options['class'])||element.parents('.'+this.options['class']).length!=0){return};var o={},s={},a='',i='';if(position=='top'||position=='bottom'){switch(align){case'left':i=offset.left;break;case'right':i=offset.left+element.outerWidth()-newTip.outerWidth();break;default:i=(offset.left+(element.outerWidth()/2))-(newTip.outerWidth()/2);break};if(_self.options.within_screen){var n=element.offset().left+(element.outerWidth()/2)-(newTip.outerWidth()/2)+parseInt(newTip.css('margin-left'),10);if(n<0){i=i-n}}}
else{switch(align){case'top':a=offset.top;break;case'bottom':a=offset.top+element.outerHeight()-newTip.outerHeight();break;default:a=(offset.top+(element.outerHeight()/2))-(newTip.outerHeight()/2);break}};switch(position){case'top':a=offset.top-newTip.outerHeight();o={top:a-10,left:i};s={top:a};break;case'bottom':a=offset.top+element.outerHeight();o={top:a+10,left:i};s={top:a};break;case'left':i=offset.left-newTip.outerWidth();o={top:a,left:i-10};s={left:i};break;case'right':i=offset.left+element.outerWidth();o={top:a,left:i+10};s={left:i};break};o['display']='block';o['opacity']=0;s['opacity']=1;newTip.css(o).stop().animate(s,200);newTip.find('input, textarea').trigger('focus');if(is_new_tip){e.AviaTooltip.openTTs.push(newTip);e.AviaTooltip.openTT_Elements.push(element);element.data('avia-created-tooltip',e.AviaTooltip.openTTs.length-1)}},hide_on_click_tooltip:function(t){if(this.options.event=='click'){return};var i=e(t.currentTarget);if(!i.hasClass('av-close-on-click-tooltip')){return};if(!i.find('a')){t.preventDefault()};var o=i.data('avia-created-tooltip');if('undefined'!=typeof o){var a=e.AviaTooltip.openTTs[o];if('undefined'!=typeof a&&a==this.active){this.hide_all_tooltips()}}},close_on_keyup:function(t){if(this.options.close_keys==null){return};if(e.inArray(t.keyCode,this.options.close_keys)<0){return};this.hide_all_tooltips(t.keyCode)},hide_all_tooltips:function(t){var o,s,n,r='undefined'!=typeof t?t+'':null;for(var a=0;a<e.AviaTooltip.openTTs.length;++a){o=e.AviaTooltip.openTTs[a];n=e.AviaTooltip.openTT_Elements[a];s=n.data('avia-tooltip-position');if(r!=null){var i=o.data('close-keys');if('undefined'==typeof i){continue};i=i+'';i=i.split(',');if(e.inArray(r,i)<0){continue}};this.animate_hide_tooltip(o,s)};this.open=!1;this.active=!1},hide_tooltip:function(t){var i=e(t.currentTarget),a,n,o=i.data('avia-tooltip-position'),s=i.data('avia-tooltip-alignment'),a=!1;if(o==''||typeof o=='undefined'){o=this.options.position};if(s==''||typeof s=='undefined'){s='center'};if(this.options.event=='click'){i=e(t.target);if(!i.is('.'+this.options['class'])&&i.parents('.'+this.options['class']).length==0){if(this.active.length){a=this.active;this.active=!1}}}
else{if(!i.hasClass('av-close-on-click-tooltip')){a=i.data('avia-created-tooltip');a=typeof a!='undefined'?e.AviaTooltip.openTTs[a]:!1}};this.animate_hide_tooltip(a,o)},animate_hide_tooltip:function(e,t){if(e){var i={opacity:0};switch(t){case'top':i['top']=parseInt(e.css('top'),10)-10;break;case'bottom':i['top']=parseInt(e.css('top'),10)+10;break;case'left':i['left']=parseInt(e.css('left'),10)-10;break;case'right':i['left']=parseInt(e.css('left'),10)+10;break};e.animate(i,200,function(){e.css({display:'none'})})}},stop_instant_open:function(e){this.open=!1}}})(jQuery);(function(e){'use strict';e(function(){e.event.special.touchstart={setup:function(e,t,i){this.addEventListener('touchstart',i,{passive:!t.includes('noPreventDefault')})}};e.event.special.touchmove={setup:function(e,t,i){this.addEventListener('touchmove',i,{passive:!t.includes('noPreventDefault')})}};e.event.special.wheel={setup:function(e,t,i){this.addEventListener('wheel',i,{passive:!0})}};e.event.special.mousewheel={setup:function(e,t,i){this.addEventListener('mousewheel',i,{passive:!0})}}})})(jQuery);(function(){var i=0,t=['ms','moz','webkit','o'];for(var e=0;e<t.length&&!window.requestAnimationFrame;++e){window.requestAnimationFrame=window[t[e]+'RequestAnimationFrame'];window.cancelAnimationFrame=window[t[e]+'CancelAnimationFrame']||window[t[e]+'CancelRequestAnimationFrame']};if(!window.requestAnimationFrame)window.requestAnimationFrame=function(e,t){var a=new Date().getTime(),o=Math.max(0,16-(a-i)),s=window.setTimeout(function(){e(a+o)},o);i=a+o;return s};if(!window.cancelAnimationFrame)window.cancelAnimationFrame=function(e){clearTimeout(e)}}());jQuery.expr.pseudos.regex=function(e,t,i){var a=i[3].split(','),o=/^(data|css):/,s={method:a[0].match(o)?a[0].split(':')[0]:'attr',property:a.shift().replace(o,'')},n='ig',r=new RegExp(a.join('').replace(/^\s+|\s+$/g,''),n);return r.test(jQuery(e)[s.method](s.property))};(function(i){"use strict";i(function(){i.avia_utilities=i.avia_utilities||{};if("undefined"==typeof i.avia_utilities.isMobile){if(/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)&&"ontouchstart" in document.documentElement){i.avia_utilities.isMobile=!0}
else{i.avia_utilities.isMobile=!1}};if(i.fn.avia_mobile_fixed){i(".avia-bg-style-fixed").avia_mobile_fixed()};if(i.fn.avia_browser_height){i(".av-minimum-height, .avia-fullscreen-slider, .av-cell-min-height").avia_browser_height()};if(i.fn.avia_container_height){i(".av-column-min-height-pc").avia_container_height()};if(i.fn.avia_video_section){i(".av-section-with-video-bg").avia_video_section()};new i.AviaTooltip({"class":"avia-tooltip",data:"avia-tooltip",delay:0,scope:"body"});new i.AviaTooltip({"class":"avia-tooltip avia-icon-tooltip",data:"avia-icon-tooltip",delay:0,scope:"body"});i.avia_utilities.activate_shortcode_scripts();if(i.fn.layer_slider_height_helper){i(".avia-layerslider").layer_slider_height_helper()};if(i.fn.avia_portfolio_preview){i(".grid-links-ajax").avia_portfolio_preview()};if(i.fn.avia_masonry){i(".av-masonry").avia_masonry()};if(i.fn.aviaccordion){i(".aviaccordion").aviaccordion()};if(i.fn.avia_textrotator){i(".av-rotator-container").avia_textrotator()};if(i.fn.avia_sc_tab_section){i(".av-tab-section-container").avia_sc_tab_section()};if(i.fn.avia_hor_gallery){i(".av-horizontal-gallery").avia_hor_gallery()};if(i.fn.avia_link_column){i(".avia-link-column").avia_link_column()};if(i.fn.avia_delayed_animation_in_container){i(".av-animation-delay-container").avia_delayed_animation_in_container()}});i.avia_utilities=i.avia_utilities||{};i.avia_utilities.activate_shortcode_scripts=function(e){if(typeof e=="undefined"){e="body"};if(i.fn.avia_ajax_form){i(".avia_ajax_form:not( .avia-disable-default-ajax )",e).avia_ajax_form()};n(e);if(i.fn.aviaVideoApi){i(".avia-slideshow iframe[src*=\"youtube.com\"], .av_youtube_frame, .av_vimeo_frame, .avia-slideshow video").aviaVideoApi({},"li")};if(i.fn.avia_sc_toggle){i(".togglecontainer",e).avia_sc_toggle()};if(i.fn.avia_sc_tabs){i(".top_tab",e).avia_sc_tabs();i(".sidebar_tab",e).avia_sc_tabs({sidebar:!0})};if(i.fn.avia_sc_gallery){i(".avia-gallery",e).avia_sc_gallery()};if(i.fn.avia_sc_animated_number){i(".avia-animated-number",e).avia_sc_animated_number()};if(i.fn.avia_sc_animation_delayed){i(".av_font_icon",e).avia_sc_animation_delayed({delay:100});i(".avia-image-container",e).avia_sc_animation_delayed({delay:100});i(".av-hotspot-image-container",e).avia_sc_animation_delayed({delay:100});i(".av-animated-generic",e).avia_sc_animation_delayed({delay:100});i(".av-animated-when-visible",e).avia_sc_animation_delayed({delay:100});i(".av-animated-when-almost-visible",e).avia_sc_animation_delayed({delay:100});i(".av-animated-when-visible-95",e).avia_sc_animation_delayed({delay:100})};if(i.fn.avia_sc_iconlist){i(".avia-icon-list.av-iconlist-big.avia-iconlist-animate",e).avia_sc_iconlist()};if(i.fn.avia_sc_progressbar){i(".avia-progress-bar-container",e).avia_sc_progressbar()};if(i.fn.avia_sc_testimonial){i(".avia-testimonial-wrapper",e).avia_sc_testimonial()};if(i.fn.aviaFullscreenSlider){i(".avia-slideshow.av_fullscreen",e).aviaFullscreenSlider()};if(i.fn.aviaSlider){i(".avia-slideshow:not(.av_fullscreen)",e).aviaSlider();i(".avia-content-slider-active",e).aviaSlider({wrapElement:".avia-content-slider-inner",slideElement:".slide-entry-wrap",fullfade:!0});i(".avia-slider-testimonials",e).aviaSlider({wrapElement:".avia-testimonial-row",slideElement:".avia-testimonial",fullfade:!0})};if(i.fn.aviaMagazine){i(".av-magazine-tabs-active",e).aviaMagazine()};if(i.fn.aviaHotspots){i(".av-hotspot-image-container",e).aviaHotspots()};if(i.fn.aviaCountdown){i(".av-countdown-timer",e).aviaCountdown()};if(i.fn.aviaPlayer){i(".av-player",e).aviaPlayer()};if(i.fn.aviaIconCircles){i(".av-icon-circles-container").aviaIconCircles()};if(i.fn.avia_sc_icongrid){i(".avia-icon-grid-container").avia_sc_icongrid()}};function n(e){if(i.fn.avia_waypoints){if(typeof e=="undefined"){e="body"};i(".avia_animate_when_visible",e).avia_waypoints();i(".avia_animate_when_almost_visible",e).avia_waypoints({offset:"80%"});i(".av-animated-when-visible",e).avia_waypoints();i(".av-animated-when-almost-visible",e).avia_waypoints({offset:"80%"});i(".av-animated-when-visible-95",e).avia_waypoints({offset:"95%"});var t=i("*[class*=\"av-custom-animated-top-\"]",e);t.each(function(){var n=i(this),t=n[0].className.split(/\s+/);for(var e=0;e<t.length;e++){if(t[e].indexOf("av-custom-animated-top-")==0){var a=parseInt(t[e].replace("av-custom-animated-top-",""));if(!isNaN(a)&&a<100){n.avia_waypoints({offset:a+"%"})}}}});var a=i("body").hasClass("avia-mobile-no-animations");if(e=="body"&&a){e=".avia_desktop body"};i(".av-animated-generic",e).avia_waypoints({offset:"95%"})}};i.fn.avia_mobile_fixed=function(e){var a=i.avia_utilities.isMobile;if(!a){return};return this.each(function(){var a=i(this).addClass("av-parallax-section"),n=a.attr("style"),e=a.data("section-bg-repeat"),t="";if(e=="stretch"||e=="no-repeat"){e=" avia-full-stretch"}
else{e=""};t="<div class='av-parallax "+e+"' data-avia-parallax-ratio='0.0' style = '"+n+"' ></div>";a.prepend(t);a.attr("style","")})};i.fn.avia_sc_animation_delayed=function(e){var a=0,n=e.delay||50,t=10,o=setTimeout(function(){t=20},500);return this.each(function(){var e=i(this);e.on("avia_start_animation",function(){var e=i(this);if(a<t){a++};setTimeout(function(){e.addClass("avia_start_delayed_animation");if(a>0){a--}},(a*n))})})};i.fn.avia_delayed_animation_in_container=function(e){return this.each(function(){var e=i(this);e.on("avia_start_animation_if_current_slide_is_active",function(){var e=i(this),a=e.find(".avia_start_animation_when_active");a.addClass("avia_start_animation").trigger("avia_start_animation")});e.on("avia_remove_animation",function(){var e=i(this),a=e.find(".avia_start_animation_when_active, .avia_start_animation");a.removeClass("avia_start_animation avia_start_delayed_animation")})})};i.fn.avia_browser_height=function(){if(!this.length){return this};var e=i(window),c=i("html"),n=i("head").first(),r=i("#wpadminbar, #header.av_header_top:not(.html_header_transparency #header), #main>.title_container"),a=i("<style type='text/css' id='av-browser-height'></style>").appendTo(n),o=i(".html_header_sidebar #top #header_main"),l=i(".html_header_sidebar .avia-fullscreen-slider.avia-builder-el-0.avia-builder-el-no-sibling").addClass("av-solo-full"),t=[25,50,75],s=function(){let css="",wh100=e.height(),ww100=e.width(),wh100_mod=wh100,whCover=(wh100/9)*16,wwCover=(ww100/16)*9,solo=0;if(o.length){solo=o.height()};r.each(function(){wh100_mod-=this.offsetHeight-1});let whCoverMod=(wh100_mod/9)*16;css+=".avia-section.av-minimum-height .container{opacity: 1; }\n";css+=".av-minimum-height-100:not(.av-slideshow-section) .container, .avia-fullscreen-slider .avia-slideshow, #top.avia-blank .av-minimum-height-100 .container, .av-cell-min-height-100 > .flex_cell{height: 100vh;}\n";css+=".av-minimum-height-100vw:not(.av-slideshow-section) .container, #top.avia-blank .av-minimum-height-100vw .container, .av-cell-min-height-100vw > .flex_cell{height: 100vw;}\n";css+=".av-minimum-height-100.av-slideshow-section .container { height:unset; }\n";css+=".av-minimum-height-100vw.av-slideshow-section .container { height:unset; }\n";css+=".av-minimum-height-100.av-slideshow-section {min-height: 100vh;}\n";css+=".av-minimum-height-100vw.av-slideshow-section {min-height: 100vw;}\n";i.each(t,function(i,e){css+=".av-minimum-height-"+e+":not(.av-slideshow-section) .container, .av-cell-min-height-"+e+" > .flex_cell	{height:"+e+"vh;}\n";css+=".av-minimum-height-"+e+".av-slideshow-section {min-height:"+e+"vh;}\n";css+=".av-minimum-height-"+e+"vw:not(.av-slideshow-section) .container, .av-cell-min-height-"+e+"vw > .flex_cell	{height:"+e+"vw;}\n";css+=".av-minimum-height-"+e+"vw.av-slideshow-section {min-height:"+e+"vw;}\n"});css+=".avia-builder-el-0.av-minimum-height-100:not(.av-slideshow-section) .container, .avia-builder-el-0.avia-fullscreen-slider .avia-slideshow, .avia-builder-el-0.av-cell-min-height-100 > .flex_cell{height:"+wh100_mod+"px;}\n";css+="#top .av-solo-full .avia-slideshow {min-height:"+solo+"px;}\n";if(ww100/wh100<16/9){css+="#top .av-element-cover iframe, #top .av-element-cover embed, #top .av-element-cover object, #top .av-element-cover video{width:"+whCover+"px; left: -"+(whCover-ww100)/2+"px;}\n"}
else{css+="#top .av-element-cover iframe, #top .av-element-cover embed, #top .av-element-cover object, #top .av-element-cover video{height:"+wwCover+"px; top: -"+(wwCover-wh100)/2+"px;}\n"};if(ww100/wh100_mod<16/9){css+="#top .avia-builder-el-0 .av-element-cover iframe, #top .avia-builder-el-0 .av-element-cover embed, #top .avia-builder-el-0 .av-element-cover object, #top .avia-builder-el-0 .av-element-cover video{width:"+whCoverMod+"px; left: -"+(whCoverMod-ww100)/2+"px;}\n"}
else{css+="#top .avia-builder-el-0 .av-element-cover iframe, #top .avia-builder-el-0 .av-element-cover embed, #top .avia-builder-el-0 .av-element-cover object, #top .avia-builder-el-0 .av-element-cover video{height:"+wwCover+"px; top: -"+(wwCover-wh100_mod)/2+"px;}\n"};try{a.text(css)}catch(s){a.remove();a=i("<style type='text/css' id='av-browser-height'>"+css+"</style>").appendTo(n)};setTimeout(function(){e.trigger("av-height-change")},100)};this.each(function(e){let container=i(this),height=container.data("av_minimum_height_pc");if("number"!=typeof height){return this};height=parseInt(height);if((-1==i.inArray(height,t))&&(height!=100)){t.push(height)};return this});e.on("debouncedresize",s);s()};i.fn.avia_container_height=function(){if(!this.length){return this};var e=i(window),a=function(){var a=i(this),s=a.data("av-column-min-height"),n=parseInt(s["column-min-pc"],10),t=null,r=0,o=0;if(isNaN(n)||n==0){return};t=a.closest(".avia-section");if(!t.length){t=a.closest(".av-gridrow-cell")};if(!t.length){t=a.closest(".av-layout-tab")};r=t.length?t.outerHeight():e.height();o=r*(n/100.0);if(!s["column-equal-height"]){a.css("min-height",o+"px");a.css("height","auto")}
else{a.css("height",o+"px")};setTimeout(function(){e.trigger("av-height-change")},100)};this.each(function(t){var n=i(this),o=n.data("av-column-min-height");if("object"!=typeof o){return this};e.on("debouncedresize",a.bind(n));a.call(n);return this})};i.fn.avia_video_section=function(){if(!this.length)return;var o=this.length,e="",s=i(window),t=i("head").first(),a=i("<style type='text/css' id='av-section-height'></style>").appendTo(t),n=function(n,s){if(s===0){e=""};var c="",r="#"+n.attr("id"),l=n.height(),u=n.width(),d=n.data("sectionVideoRatio").split(":"),v=d[0],f=d[1],h=(l/f)*v,m=(u/v)*f;if(u/l<v/f){c+="#top "+r+" .av-section-video-bg iframe, #top "+r+" .av-section-video-bg embed, #top "+r+" .av-section-video-bg object, #top "+r+" .av-section-video-bg video{width:"+h+"px; left: -"+(h-u)/2+"px;}\n"}
else{c+="#top "+r+" .av-section-video-bg iframe, #top "+r+" .av-section-video-bg embed, #top "+r+" .av-section-video-bg object, #top "+r+" .av-section-video-bg video{height:"+m+"px; top: -"+(m-l)/2+"px;}\n"};e=e+c;if(o==s+1){try{a.text(e)}catch(p){a.remove();a=i("<style type='text/css' id='av-section-height'>"+e+"</style>").appendTo(t)}}};return this.each(function(e){var a=i(this);s.on("debouncedresize",function(){n(a,e)});n(a,e)})};i.fn.avia_link_column=function(){return this.each(function(){i(this).on("click",function(e){if("undefined"!==typeof e.target&&"undefined"!==typeof e.target.href){return};var t=i(this),a=t.data("link-column-url"),o=t.data("link-column-target"),r=window.location.hostname+window.location.pathname;if("undefined"===typeof a||"string"!==typeof a){return};if("undefined"!==typeof o||"_blank"==o){var n=document.createElement("a");n.href=a;n.target="_blank";n.rel="noopener noreferrer";n.click();return!1}
else{if(t.hasClass("av-cell-link")||t.hasClass("av-column-link")){var s=t.hasClass("av-cell-link")?t.prev("a.av-screen-reader-only").first():t.find("a.av-screen-reader-only").first();a=a.trim();if((0==a.indexOf("#"))||((a.indexOf(r)>=0)&&(a.indexOf("#")>0))){s.trigger("click");if("undefined"==typeof o||"_blank"!=o){window.location.href=a};return}};window.location.href=a};e.preventDefault();return})})};i.fn.avia_waypoints=function(e){if(!i("html").is(".avia_transform")){return};var a={offset:"bottom-in-view",triggerOnce:!0},t=i.extend({},a,e),n=i.avia_utilities.isMobile;return this.each(function(){var e=i(this),a=e.hasClass("animate-all-devices"),o=i("body").hasClass("avia-mobile-no-animations");setTimeout(function(){if(n&&o&&!a){e.addClass("avia_start_animation").trigger("avia_start_animation")}
else{e.waypoint(function(e){var t=i(this.element),a=t.parents(".av-animation-delay-container").eq(0);if(a.length){t.addClass("avia_start_animation_when_active").trigger("avia_start_animation_when_active")};if(!a.length||(a.length&&a.is(".__av_init_open"))||(a.length&&a.is(".av-active-tab-content"))){t.addClass("avia_start_animation").trigger("avia_start_animation")}},t)}},100)})};var t=i.event,e,a;e=t.special.debouncedresize={setup:function(){i(this).on("resize",e.handler)},teardown:function(){i(this).off("resize",e.handler)},handler:function(i,n){var s=this,r=arguments,o=function(){i.type="debouncedresize";t.dispatch.apply(s,r)};if(a){clearTimeout(a)};n?o():a=setTimeout(o,e.threshold)},threshold:150}})(jQuery);(function(i){"use strict";i.avia_utilities=i.avia_utilities||{};i.avia_utilities.loading=function(e,t){var a={active:!1,show:function(){if(a.active===!1){a.active=!0;a.loading_item.css({display:"block",opacity:0})};a.loading_item.stop().animate({opacity:1})},hide:function(){if(typeof t==="undefined"){t=600};a.loading_item.stop().delay(t).animate({opacity:0},function(){a.loading_item.css({display:"none"});a.active=!1})},attach:function(){if(typeof e==="undefined"){e="body"};a.loading_item=i("<div class=\"avia_loading_icon\"><div class=\"av-siteloader\"></div></div>").css({display:"none"}).appendTo(e)}};a.attach();return a};i.avia_utilities.playpause=function(e,t){var a={active:!1,to1:"",to2:"",set:function(i){a.loading_item.removeClass("av-play av-pause");a.to1=setTimeout(function(){a.loading_item.addClass("av-"+i)},10);a.to2=setTimeout(function(){a.loading_item.removeClass("av-"+i)},1500)},attach:function(){if(typeof e==="undefined"){e="body"};a.loading_item=i("<div class=\"avia_playpause_icon\"></div>").css({display:"none"}).appendTo(e)}};a.attach();return a};i.avia_utilities.preload=function(e){new i.AviaPreloader(e)};i.AviaPreloader=function(e){this.win=i(window);this.defaults={container:"body",maxLoops:10,trigger_single:!0,single_callback:function(){},global_callback:function(){}};this.options=i.extend({},this.defaults,e);this.preload_images=0;this.load_images()};i.AviaPreloader.prototype={load_images:function(){var e=this;if(typeof e.options.container==="string"){e.options.container=i(e.options.container)};e.options.container.each(function(){var a=i(this);a.images=a.find("img");a.allImages=a.images;e.preload_images+=a.images.length;setTimeout(function(){e.checkImage(a)},10)})},checkImage:function(i){var e=this;i.images.each(function(){if(this.complete===!0){i.images=i.images.not(this);e.preload_images-=1}});if(i.images.length&&e.options.maxLoops>=0){e.options.maxLoops-=1;setTimeout(function(){e.checkImage(i)},500)}
else{e.preload_images=e.preload_images-i.images.length;e.trigger_loaded(i)}},trigger_loaded:function(i){var e=this;if(e.options.trigger_single!==!1){e.win.trigger("avia_images_loaded_single",[i]);e.options.single_callback.call(i)};if(e.preload_images===0){e.win.trigger("avia_images_loaded");e.options.global_callback.call()}}};i.avia_utilities.css_easings={linear:"linear",swing:"ease-in-out",bounce:"cubic-bezier(0.0, 0.35, .5, 1.3)",easeInQuad:"cubic-bezier(0.550, 0.085, 0.680, 0.530)",easeInCubic:"cubic-bezier(0.550, 0.055, 0.675, 0.190)",easeInQuart:"cubic-bezier(0.895, 0.030, 0.685, 0.220)",easeInQuint:"cubic-bezier(0.755, 0.050, 0.855, 0.060)",easeInSine:"cubic-bezier(0.470, 0.000, 0.745, 0.715)",easeInExpo:"cubic-bezier(0.950, 0.050, 0.795, 0.035)",easeInCirc:"cubic-bezier(0.600, 0.040, 0.980, 0.335)",easeInBack:"cubic-bezier(0.600, -0.280, 0.735, 0.04)",easeOutQuad:"cubic-bezier(0.250, 0.460, 0.450, 0.940)",easeOutCubic:"cubic-bezier(0.215, 0.610, 0.355, 1.000)",easeOutQuart:"cubic-bezier(0.165, 0.840, 0.440, 1.000)",easeOutQuint:"cubic-bezier(0.230, 1.000, 0.320, 1.000)",easeOutSine:"cubic-bezier(0.390, 0.575, 0.565, 1.000)",easeOutExpo:"cubic-bezier(0.190, 1.000, 0.220, 1.000)",easeOutCirc:"cubic-bezier(0.075, 0.820, 0.165, 1.000)",easeOutBack:"cubic-bezier(0.175, 0.885, 0.320, 1.275)",easeInOutQuad:"cubic-bezier(0.455, 0.030, 0.515, 0.955)",easeInOutCubic:"cubic-bezier(0.645, 0.045, 0.355, 1.000)",easeInOutQuart:"cubic-bezier(0.770, 0.000, 0.175, 1.000)",easeInOutQuint:"cubic-bezier(0.860, 0.000, 0.070, 1.000)",easeInOutSine:"cubic-bezier(0.445, 0.050, 0.550, 0.950)",easeInOutExpo:"cubic-bezier(1.000, 0.000, 0.000, 1.000)",easeInOutCirc:"cubic-bezier(0.785, 0.135, 0.150, 0.860)",easeInOutBack:"cubic-bezier(0.680, -0.550, 0.265, 1.55)",easeInOutBounce:"cubic-bezier(0.580, -0.365, 0.490, 1.365)",easeOutBounce:"cubic-bezier(0.760, 0.085, 0.490, 1.365)"};i.avia_utilities.supported={};i.avia_utilities.supports=(function(){var e=document.createElement("div"),i=["Khtml","Ms","Moz","Webkit"];return function(a,t){if(e.style[a]!==undefined){return""};if(t!==undefined){i=t};a=a.replace(/^[a-z]/,function(i){return i.toUpperCase()});var n=i.length;while(n--){if(e.style[i[n]+a]!==undefined){return"-"+i[n].toLowerCase()+"-"}};return!1}}());i.fn.avia_animate=function(e,a,t,n){if(typeof a==="function"){n=a;a=!1};if(typeof t==="function"){n=t;t=!1};if(typeof a==="string"){t=a;a=!1};if(n===undefined||n===!1){n=function(){}};if(t===undefined||t===!1){t="easeInQuad"};if(a===undefined||a===!1){a=400};if(i.avia_utilities.supported.transition===undefined){i.avia_utilities.supported.transition=i.avia_utilities.supports("transition")};if(i.avia_utilities.supported.transition!==!1){var c=i.avia_utilities.supported.transition+"transition",s={},l={},u=document.body.style,o=(u.WebkitTransition!==undefined)?"webkitTransitionEnd":(u.OTransition!==undefined)?"oTransitionEnd":"transitionend";t=i.avia_utilities.css_easings[t];s[c]="all "+(a/1000)+"s "+t;o=o+".avia_animate";for(var r in e){if(e.hasOwnProperty(r)){l[r]=e[r]}};e=l;this.each(function(){var t=i(this),v=!1,r,u;for(r in e){if(e.hasOwnProperty(r)){u=t.css(r);if(e[r]!=u&&e[r]!=u.replace(/px|%/g,"")){v=!0;break}}};if(v){if(!(i.avia_utilities.supported.transition+"transform" in e)){e[i.avia_utilities.supported.transition+"transform"]="translateZ(0)"};var l=!1;t.on(o,function(i){if(i.target!=i.currentTarget)return!1;if(l==!0)return!1;l=!0;s[c]="none";t.off(o);t.css(s);setTimeout(function(){n.call(t)})});setTimeout(function(){if(!l&&!avia_is_mobile&&i("html").is(".avia-safari")){t.trigger(o);i.avia_utilities.log("Safari Fallback "+o+" trigger")}},a+100);setTimeout(function(){t.css(s)},10);setTimeout(function(){t.css(e)},20)}
else{setTimeout(function(){n.call(t)})}})}
else{this.animate(e,a,t,n)};return this}})(jQuery);(function(i){"use strict";i.fn.avia_keyboard_controls=function(e){var t={37:".prev-slide",39:".next-slide"},a={mousebind:function(i){i.on("mouseenter",function(){i.mouseover=!0}).on("mouseleave",function(){i.mouseover=!1})},keybind:function(e){i(document).on("keydown",function(i){if(e.mouseover&&typeof e.options[i.keyCode]!=="undefined"){var a;if(typeof e.options[i.keyCode]==="string"){a=e.find(e.options[i.keyCode])}
else{a=e.options[i.keyCode]};if(a.length){a.trigger("click",["keypress"]);return!1}}})}};return this.each(function(){var n=i(this);n.options=i.extend({},t,e);n.mouseover=!1;a.mousebind(n);a.keybind(n)})};i.fn.avia_swipe_trigger=function(e){var r=i(window),t=i.avia_utilities.isMobile,n=i.avia_utilities.isTouchDevice,a=i("body"),o={prev:".prev-slide",next:".next-slide",delay_trigger:!1,event:{prev:"click",next:"click"},beforeTrigger:null,afterTrigger:null,afterDelayedTrigger:null},s={activate_touch_control:function(i){var e,t,n;i.touchPos={};i.hasMoved=!1;i.on("touchstart",function(e){i.touchPos.X=e.originalEvent.touches[0].clientX;i.touchPos.Y=e.originalEvent.touches[0].clientY});i.on("touchend",function(e){i.touchPos={};if(i.hasMoved){e.preventDefault()};i.hasMoved=!1});i.on("touchmove",function(o){if(a.hasClass("avia-swipe-executed")){return};if(!i.touchPos.X){i.touchPos.X=o.originalEvent.touches[0].clientX;i.touchPos.Y=o.originalEvent.touches[0].clientY}
else{t=o.originalEvent.touches[0].clientX-i.touchPos.X;n=o.originalEvent.touches[0].clientY-i.touchPos.Y;if(Math.abs(t)>Math.abs(n)){if(i.touchPos!==o.originalEvent.touches[0].clientX){if(Math.abs(t)>50){e=t>0?"prev":"next";let element=i.options[e];if(element==null){return};if(typeof i.options.beforeTrigger=="function"){i.options.beforeTrigger(i,e)};if(typeof i.options[e]==="string"){i.find(i.options[e]).trigger(i.options.event[e],["swipe"])}
else{if(typeof element.jquery=="string"){element.trigger(i.options.event[e],["swipe"])}
else{let action=i.options.event[e];if(action.indexOf("native_")<0){element.dispatchEvent(new Event(action))}
else{let func_action=action.replace("native_","");if(typeof element[func_action]=="function"){if(i.options.delay_trigger){setTimeout(function(){element[func_action]();if(typeof i.options.afterDelayedTrigger=="function"){i.options.afterDelayedTrigger(i,e)}},50)}
else{element[func_action]()}}
else{element.dispatchEvent(new Event(action))}}}};if(typeof i.options.afterTrigger=="function"){i.options.afterTrigger(i,e)};o.preventDefault();o.stopImmediatePropagation();a.addClass("avia-swipe-executed");setTimeout(function(){a.removeClass("avia-swipe-executed")},300);i.hasMoved=!0;i.touchPos={};return!1}}}}})}};return this.each(function(){if(t||n){var a=i(this);a.options=i.extend({},o,e);s.activate_touch_control(a)}})}}(jQuery));(function(i){if(typeof i.easing!=="undefined"){i.easing["jswing"]=i.easing["swing"]};var e=Math.pow,n=Math.sqrt,a=Math.sin,c=Math.cos,t=Math.PI,o=1.70158,s=o*1.525,l=o+1,u=(2*t)/3,v=(2*t)/4.5;function r(i){var a=7.5625,e=2.75;if(i<1/e){return a*i*i}
else if(i<2/e){return a*(i-=(1.5/e))*i+.75}
else if(i<2.5/e){return a*(i-=(2.25/e))*i+.9375}
else{return a*(i-=(2.625/e))*i+.984375}};i.extend(i.easing,{def:"easeOutQuad",swing:function(e){return i.easing[i.easing.def](e)},easeInQuad:function(i){return i*i},easeOutQuad:function(i){return 1-(1-i)*(1-i)},easeInOutQuad:function(i){return i<0.5?2*i*i:1-e(-2*i+2,2)/2},easeInCubic:function(i){return i*i*i},easeOutCubic:function(i){return 1-e(1-i,3)},easeInOutCubic:function(i){return i<0.5?4*i*i*i:1-e(-2*i+2,3)/2},easeInQuart:function(i){return i*i*i*i},easeOutQuart:function(i){return 1-e(1-i,4)},easeInOutQuart:function(i){return i<0.5?8*i*i*i*i:1-e(-2*i+2,4)/2},easeInQuint:function(i){return i*i*i*i*i},easeOutQuint:function(i){return 1-e(1-i,5)},easeInOutQuint:function(i){return i<0.5?16*i*i*i*i*i:1-e(-2*i+2,5)/2},easeInSine:function(i){return 1-c(i*t/2)},easeOutSine:function(i){return a(i*t/2)},easeInOutSine:function(i){return-(c(t*i)-1)/2},easeInExpo:function(i){return i===0?0:e(2,10*i-10)},easeOutExpo:function(i){return i===1?1:1-e(2,-10*i)},easeInOutExpo:function(i){return i===0?0:i===1?1:i<0.5?e(2,20*i-10)/2:(2-e(2,-20*i+10))/2},easeInCirc:function(i){return 1-n(1-e(i,2))},easeOutCirc:function(i){return n(1-e(i-1,2))},easeInOutCirc:function(i){return i<0.5?(1-n(1-e(2*i,2)))/2:(n(1-e(-2*i+2,2))+1)/2},easeInElastic:function(i){return i===0?0:i===1?1:-e(2,10*i-10)*a((i*10-10.75)*u)},easeOutElastic:function(i){return i===0?0:i===1?1:e(2,-10*i)*a((i*10-0.75)*u)+1},easeInOutElastic:function(i){return i===0?0:i===1?1:i<0.5?-(e(2,20*i-10)*a((20*i-11.125)*v))/2:e(2,-20*i+10)*a((20*i-11.125)*v)/2+1},easeInBack:function(i){return l*i*i*i-o*i*i},easeOutBack:function(i){return 1+l*e(i-1,3)+o*e(i-1,2)},easeInOutBack:function(i){return i<0.5?(e(2*i,2)*((s+1)*2*i-s))/2:(e(2*i-2,2)*((s+1)*(i*2-2)+s)+2)/2},easeInBounce:function(i){return 1-r(1-i)},easeOutBounce:r,easeInOutBounce:function(i){return i<0.5?(1-r(1-2*i))/2:(1+r(2*i-1))/2}})}(jQuery));(function(i){'use strict';var n=!1,a=null,t=function(i){var n=i.find('.av-player-player-container .mejs-playpause-button');if(n.length==0){setTimeout(function(){t(i)},200)};if(!n.hasClass('mejs-pause')){n.trigger('click')}};i.fn.aviaPlayer=function(a){if(!this.length){return};return this.each(function(){var a={};a.container=i(this);a.stopLoop=!1;a.container.find('audio').on('play',function(){if(a.stopLoop){this.pause();a.stopLoop=!1}});if(a.container.hasClass('avia-playlist-no-loop')){a.container.find('audio').on('ended',function(){var t=a.container.find('.wp-playlist-tracks .wp-playlist-item').last().find('a');try{var i=decodeURI(t.attr('href')),n=decodeURI(this.currentSrc);if(n===i){a.stopLoop=!0}}catch(o){a.stopLoop=!1}})};if(a.container.hasClass('avia-playlist-autoplay')&&!n){if((a.container.css('display')=='none')||(a.container.css('visibility')=='hidden')){return};n=!0;setTimeout(function(){t(a.container,a)},200)}})}}(jQuery));/*!
 * Chart.js v3.9.1
 * https://www.chartjs.org
 * (c) 2022 Chart.js Contributors
 * Released under the MIT License
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):(t="undefined"!=typeof globalThis?globalThis:t||self).Chart=e()}(this,(function(){"use strict";function t(){}const e=function(){let t=0;return function(){return t++}}();function i(t){return null==t}function s(t){if(Array.isArray&&Array.isArray(t))return!0;const e=Object.prototype.toString.call(t);return"[object"===e.slice(0,7)&&"Array]"===e.slice(-6)}function n(t){return null!==t&&"[object Object]"===Object.prototype.toString.call(t)}const o=t=>("number"==typeof t||t instanceof Number)&&isFinite(+t);function a(t,e){return o(t)?t:e}function r(t,e){return void 0===t?e:t}const l=(t,e)=>"string"==typeof t&&t.endsWith("%")?parseFloat(t)/100:t/e,h=(t,e)=>"string"==typeof t&&t.endsWith("%")?parseFloat(t)/100*e:+t;function c(t,e,i){if(t&&"function"==typeof t.call)return t.apply(i,e)}function d(t,e,i,o){let a,r,l;if(s(t))if(r=t.length,o)for(a=r-1;a>=0;a--)e.call(i,t[a],a);else for(a=0;a<r;a++)e.call(i,t[a],a);else if(n(t))for(l=Object.keys(t),r=l.length,a=0;a<r;a++)e.call(i,t[l[a]],l[a])}function u(t,e){let i,s,n,o;if(!t||!e||t.length!==e.length)return!1;for(i=0,s=t.length;i<s;++i)if(n=t[i],o=e[i],n.datasetIndex!==o.datasetIndex||n.index!==o.index)return!1;return!0}function f(t){if(s(t))return t.map(f);if(n(t)){const e=Object.create(null),i=Object.keys(t),s=i.length;let n=0;for(;n<s;++n)e[i[n]]=f(t[i[n]]);return e}return t}function g(t){return-1===["__proto__","prototype","constructor"].indexOf(t)}function p(t,e,i,s){if(!g(t))return;const o=e[t],a=i[t];n(o)&&n(a)?m(o,a,s):e[t]=f(a)}function m(t,e,i){const o=s(e)?e:[e],a=o.length;if(!n(t))return t;const r=(i=i||{}).merger||p;for(let s=0;s<a;++s){if(!n(e=o[s]))continue;const a=Object.keys(e);for(let s=0,n=a.length;s<n;++s)r(a[s],t,e,i)}return t}function b(t,e){return m(t,e,{merger:x})}function x(t,e,i){if(!g(t))return;const s=e[t],o=i[t];n(s)&&n(o)?b(s,o):Object.prototype.hasOwnProperty.call(e,t)||(e[t]=f(o))}const _={"":t=>t,x:t=>t.x,y:t=>t.y};function y(t,e){const i=_[e]||(_[e]=function(t){const e=v(t);return t=>{for(const i of e){if(""===i)break;t=t&&t[i]}return t}}(e));return i(t)}function v(t){const e=t.split("."),i=[];let s="";for(const n of e)s+=n,s.endsWith("\\")?s=s.slice(0,-1)+".":(i.push(s),s="");return i}function w(t){return t.charAt(0).toUpperCase()+t.slice(1)}const M=t=>void 0!==t,k=t=>"function"==typeof t,S=(t,e)=>{if(t.size!==e.size)return!1;for(const i of t)if(!e.has(i))return!1;return!0};function P(t){return"mouseup"===t.type||"click"===t.type||"contextmenu"===t.type}const C=Math.PI,D=2*C,A=D+C,O=Number.POSITIVE_INFINITY,T=C/180,L=C/2,E=C/4,R=2*C/3,I=Math.log10,z=Math.sign;function F(t){const e=Math.round(t);t=N(t,e,t/1e3)?e:t;const i=Math.pow(10,Math.floor(I(t))),s=t/i;return(s<=1?1:s<=2?2:s<=5?5:10)*i}function B(t){const e=[],i=Math.sqrt(t);let s;for(s=1;s<i;s++)t%s==0&&(e.push(s),e.push(t/s));return i===(0|i)&&e.push(i),e.sort(((t,e)=>t-e)).pop(),e}function V(t){return!isNaN(parseFloat(t))&&isFinite(t)}function N(t,e,i){return Math.abs(t-e)<i}function W(t,e){const i=Math.round(t);return i-e<=t&&i+e>=t}function H(t,e,i){let s,n,o;for(s=0,n=t.length;s<n;s++)o=t[s][i],isNaN(o)||(e.min=Math.min(e.min,o),e.max=Math.max(e.max,o))}function j(t){return t*(C/180)}function $(t){return t*(180/C)}function Y(t){if(!o(t))return;let e=1,i=0;for(;Math.round(t*e)/e!==t;)e*=10,i++;return i}function U(t,e){const i=e.x-t.x,s=e.y-t.y,n=Math.sqrt(i*i+s*s);let o=Math.atan2(s,i);return o<-.5*C&&(o+=D),{angle:o,distance:n}}function X(t,e){return Math.sqrt(Math.pow(e.x-t.x,2)+Math.pow(e.y-t.y,2))}function q(t,e){return(t-e+A)%D-C}function K(t){return(t%D+D)%D}function G(t,e,i,s){const n=K(t),o=K(e),a=K(i),r=K(o-n),l=K(a-n),h=K(n-o),c=K(n-a);return n===o||n===a||s&&o===a||r>l&&h<c}function Z(t,e,i){return Math.max(e,Math.min(i,t))}function J(t){return Z(t,-32768,32767)}function Q(t,e,i,s=1e-6){return t>=Math.min(e,i)-s&&t<=Math.max(e,i)+s}function tt(t,e,i){i=i||(i=>t[i]<e);let s,n=t.length-1,o=0;for(;n-o>1;)s=o+n>>1,i(s)?o=s:n=s;return{lo:o,hi:n}}const et=(t,e,i,s)=>tt(t,i,s?s=>t[s][e]<=i:s=>t[s][e]<i),it=(t,e,i)=>tt(t,i,(s=>t[s][e]>=i));function st(t,e,i){let s=0,n=t.length;for(;s<n&&t[s]<e;)s++;for(;n>s&&t[n-1]>i;)n--;return s>0||n<t.length?t.slice(s,n):t}const nt=["push","pop","shift","splice","unshift"];function ot(t,e){t._chartjs?t._chartjs.listeners.push(e):(Object.defineProperty(t,"_chartjs",{configurable:!0,enumerable:!1,value:{listeners:[e]}}),nt.forEach((e=>{const i="_onData"+w(e),s=t[e];Object.defineProperty(t,e,{configurable:!0,enumerable:!1,value(...e){const n=s.apply(this,e);return t._chartjs.listeners.forEach((t=>{"function"==typeof t[i]&&t[i](...e)})),n}})})))}function at(t,e){const i=t._chartjs;if(!i)return;const s=i.listeners,n=s.indexOf(e);-1!==n&&s.splice(n,1),s.length>0||(nt.forEach((e=>{delete t[e]})),delete t._chartjs)}function rt(t){const e=new Set;let i,s;for(i=0,s=t.length;i<s;++i)e.add(t[i]);return e.size===s?t:Array.from(e)}const lt="undefined"==typeof window?function(t){return t()}:window.requestAnimationFrame;function ht(t,e,i){const s=i||(t=>Array.prototype.slice.call(t));let n=!1,o=[];return function(...i){o=s(i),n||(n=!0,lt.call(window,(()=>{n=!1,t.apply(e,o)})))}}function ct(t,e){let i;return function(...s){return e?(clearTimeout(i),i=setTimeout(t,e,s)):t.apply(this,s),e}}const dt=t=>"start"===t?"left":"end"===t?"right":"center",ut=(t,e,i)=>"start"===t?e:"end"===t?i:(e+i)/2,ft=(t,e,i,s)=>t===(s?"left":"right")?i:"center"===t?(e+i)/2:e;function gt(t,e,i){const s=e.length;let n=0,o=s;if(t._sorted){const{iScale:a,_parsed:r}=t,l=a.axis,{min:h,max:c,minDefined:d,maxDefined:u}=a.getUserBounds();d&&(n=Z(Math.min(et(r,a.axis,h).lo,i?s:et(e,l,a.getPixelForValue(h)).lo),0,s-1)),o=u?Z(Math.max(et(r,a.axis,c,!0).hi+1,i?0:et(e,l,a.getPixelForValue(c),!0).hi+1),n,s)-n:s-n}return{start:n,count:o}}function pt(t){const{xScale:e,yScale:i,_scaleRanges:s}=t,n={xmin:e.min,xmax:e.max,ymin:i.min,ymax:i.max};if(!s)return t._scaleRanges=n,!0;const o=s.xmin!==e.min||s.xmax!==e.max||s.ymin!==i.min||s.ymax!==i.max;return Object.assign(s,n),o}var mt=new class Animator{constructor(){this._request=null,this._charts=new Map,this._running=!1,this._lastDate=void 0}_notify(t,e,i,s){const n=e.listeners[s],o=e.duration;n.forEach((s=>s({chart:t,initial:e.initial,numSteps:o,currentStep:Math.min(i-e.start,o)})))}_refresh(){this._request||(this._running=!0,this._request=lt.call(window,(()=>{this._update(),this._request=null,this._running&&this._refresh()})))}_update(t=Date.now()){let e=0;this._charts.forEach(((i,s)=>{if(!i.running||!i.items.length)return;const n=i.items;let o,a=n.length-1,r=!1;for(;a>=0;--a)o=n[a],o._active?(o._total>i.duration&&(i.duration=o._total),o.tick(t),r=!0):(n[a]=n[n.length-1],n.pop());r&&(s.draw(),this._notify(s,i,t,"progress")),n.length||(i.running=!1,this._notify(s,i,t,"complete"),i.initial=!1),e+=n.length})),this._lastDate=t,0===e&&(this._running=!1)}_getAnims(t){const e=this._charts;let i=e.get(t);return i||(i={running:!1,initial:!0,items:[],listeners:{complete:[],progress:[]}},e.set(t,i)),i}listen(t,e,i){this._getAnims(t).listeners[e].push(i)}add(t,e){e&&e.length&&this._getAnims(t).items.push(...e)}has(t){return this._getAnims(t).items.length>0}start(t){const e=this._charts.get(t);e&&(e.running=!0,e.start=Date.now(),e.duration=e.items.reduce(((t,e)=>Math.max(t,e._duration)),0),this._refresh())}running(t){if(!this._running)return!1;const e=this._charts.get(t);return!!(e&&e.running&&e.items.length)}stop(t){const e=this._charts.get(t);if(!e||!e.items.length)return;const i=e.items;let s=i.length-1;for(;s>=0;--s)i[s].cancel();e.items=[],this._notify(t,e,Date.now(),"complete")}remove(t){return this._charts.delete(t)}};
/*!
 * @kurkle/color v0.2.1
 * https://github.com/kurkle/color#readme
 * (c) 2022 Jukka Kurkela
 * Released under the MIT License
 */function bt(t){return t+.5|0}const xt=(t,e,i)=>Math.max(Math.min(t,i),e);function _t(t){return xt(bt(2.55*t),0,255)}function yt(t){return xt(bt(255*t),0,255)}function vt(t){return xt(bt(t/2.55)/100,0,1)}function wt(t){return xt(bt(100*t),0,100)}const Mt={0:0,1:1,2:2,3:3,4:4,5:5,6:6,7:7,8:8,9:9,A:10,B:11,C:12,D:13,E:14,F:15,a:10,b:11,c:12,d:13,e:14,f:15},kt=[..."0123456789ABCDEF"],St=t=>kt[15&t],Pt=t=>kt[(240&t)>>4]+kt[15&t],Ct=t=>(240&t)>>4==(15&t);function Dt(t){var e=(t=>Ct(t.r)&&Ct(t.g)&&Ct(t.b)&&Ct(t.a))(t)?St:Pt;return t?"#"+e(t.r)+e(t.g)+e(t.b)+((t,e)=>t<255?e(t):"")(t.a,e):void 0}const At=/^(hsla?|hwb|hsv)\(\s*([-+.e\d]+)(?:deg)?[\s,]+([-+.e\d]+)%[\s,]+([-+.e\d]+)%(?:[\s,]+([-+.e\d]+)(%)?)?\s*\)$/;function Ot(t,e,i){const s=e*Math.min(i,1-i),n=(e,n=(e+t/30)%12)=>i-s*Math.max(Math.min(n-3,9-n,1),-1);return[n(0),n(8),n(4)]}function Tt(t,e,i){const s=(s,n=(s+t/60)%6)=>i-i*e*Math.max(Math.min(n,4-n,1),0);return[s(5),s(3),s(1)]}function Lt(t,e,i){const s=Ot(t,1,.5);let n;for(e+i>1&&(n=1/(e+i),e*=n,i*=n),n=0;n<3;n++)s[n]*=1-e-i,s[n]+=e;return s}function Et(t){const e=t.r/255,i=t.g/255,s=t.b/255,n=Math.max(e,i,s),o=Math.min(e,i,s),a=(n+o)/2;let r,l,h;return n!==o&&(h=n-o,l=a>.5?h/(2-n-o):h/(n+o),r=function(t,e,i,s,n){return t===n?(e-i)/s+(e<i?6:0):e===n?(i-t)/s+2:(t-e)/s+4}(e,i,s,h,n),r=60*r+.5),[0|r,l||0,a]}function Rt(t,e,i,s){return(Array.isArray(e)?t(e[0],e[1],e[2]):t(e,i,s)).map(yt)}function It(t,e,i){return Rt(Ot,t,e,i)}function zt(t){return(t%360+360)%360}function Ft(t){const e=At.exec(t);let i,s=255;if(!e)return;e[5]!==i&&(s=e[6]?_t(+e[5]):yt(+e[5]));const n=zt(+e[2]),o=+e[3]/100,a=+e[4]/100;return i="hwb"===e[1]?function(t,e,i){return Rt(Lt,t,e,i)}(n,o,a):"hsv"===e[1]?function(t,e,i){return Rt(Tt,t,e,i)}(n,o,a):It(n,o,a),{r:i[0],g:i[1],b:i[2],a:s}}const Bt={x:"dark",Z:"light",Y:"re",X:"blu",W:"gr",V:"medium",U:"slate",A:"ee",T:"ol",S:"or",B:"ra",C:"lateg",D:"ights",R:"in",Q:"turquois",E:"hi",P:"ro",O:"al",N:"le",M:"de",L:"yello",F:"en",K:"ch",G:"arks",H:"ea",I:"ightg",J:"wh"},Vt={OiceXe:"f0f8ff",antiquewEte:"faebd7",aqua:"ffff",aquamarRe:"7fffd4",azuY:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"0",blanKedOmond:"ffebcd",Xe:"ff",XeviTet:"8a2be2",bPwn:"a52a2a",burlywood:"deb887",caMtXe:"5f9ea0",KartYuse:"7fff00",KocTate:"d2691e",cSO:"ff7f50",cSnflowerXe:"6495ed",cSnsilk:"fff8dc",crimson:"dc143c",cyan:"ffff",xXe:"8b",xcyan:"8b8b",xgTMnPd:"b8860b",xWay:"a9a9a9",xgYF:"6400",xgYy:"a9a9a9",xkhaki:"bdb76b",xmagFta:"8b008b",xTivegYF:"556b2f",xSange:"ff8c00",xScEd:"9932cc",xYd:"8b0000",xsOmon:"e9967a",xsHgYF:"8fbc8f",xUXe:"483d8b",xUWay:"2f4f4f",xUgYy:"2f4f4f",xQe:"ced1",xviTet:"9400d3",dAppRk:"ff1493",dApskyXe:"bfff",dimWay:"696969",dimgYy:"696969",dodgerXe:"1e90ff",fiYbrick:"b22222",flSOwEte:"fffaf0",foYstWAn:"228b22",fuKsia:"ff00ff",gaRsbSo:"dcdcdc",ghostwEte:"f8f8ff",gTd:"ffd700",gTMnPd:"daa520",Way:"808080",gYF:"8000",gYFLw:"adff2f",gYy:"808080",honeyMw:"f0fff0",hotpRk:"ff69b4",RdianYd:"cd5c5c",Rdigo:"4b0082",ivSy:"fffff0",khaki:"f0e68c",lavFMr:"e6e6fa",lavFMrXsh:"fff0f5",lawngYF:"7cfc00",NmoncEffon:"fffacd",ZXe:"add8e6",ZcSO:"f08080",Zcyan:"e0ffff",ZgTMnPdLw:"fafad2",ZWay:"d3d3d3",ZgYF:"90ee90",ZgYy:"d3d3d3",ZpRk:"ffb6c1",ZsOmon:"ffa07a",ZsHgYF:"20b2aa",ZskyXe:"87cefa",ZUWay:"778899",ZUgYy:"778899",ZstAlXe:"b0c4de",ZLw:"ffffe0",lime:"ff00",limegYF:"32cd32",lRF:"faf0e6",magFta:"ff00ff",maPon:"800000",VaquamarRe:"66cdaa",VXe:"cd",VScEd:"ba55d3",VpurpN:"9370db",VsHgYF:"3cb371",VUXe:"7b68ee",VsprRggYF:"fa9a",VQe:"48d1cc",VviTetYd:"c71585",midnightXe:"191970",mRtcYam:"f5fffa",mistyPse:"ffe4e1",moccasR:"ffe4b5",navajowEte:"ffdead",navy:"80",Tdlace:"fdf5e6",Tive:"808000",TivedBb:"6b8e23",Sange:"ffa500",SangeYd:"ff4500",ScEd:"da70d6",pOegTMnPd:"eee8aa",pOegYF:"98fb98",pOeQe:"afeeee",pOeviTetYd:"db7093",papayawEp:"ffefd5",pHKpuff:"ffdab9",peru:"cd853f",pRk:"ffc0cb",plum:"dda0dd",powMrXe:"b0e0e6",purpN:"800080",YbeccapurpN:"663399",Yd:"ff0000",Psybrown:"bc8f8f",PyOXe:"4169e1",saddNbPwn:"8b4513",sOmon:"fa8072",sandybPwn:"f4a460",sHgYF:"2e8b57",sHshell:"fff5ee",siFna:"a0522d",silver:"c0c0c0",skyXe:"87ceeb",UXe:"6a5acd",UWay:"708090",UgYy:"708090",snow:"fffafa",sprRggYF:"ff7f",stAlXe:"4682b4",tan:"d2b48c",teO:"8080",tEstN:"d8bfd8",tomato:"ff6347",Qe:"40e0d0",viTet:"ee82ee",JHt:"f5deb3",wEte:"ffffff",wEtesmoke:"f5f5f5",Lw:"ffff00",LwgYF:"9acd32"};let Nt;function Wt(t){Nt||(Nt=function(){const t={},e=Object.keys(Vt),i=Object.keys(Bt);let s,n,o,a,r;for(s=0;s<e.length;s++){for(a=r=e[s],n=0;n<i.length;n++)o=i[n],r=r.replace(o,Bt[o]);o=parseInt(Vt[a],16),t[r]=[o>>16&255,o>>8&255,255&o]}return t}(),Nt.transparent=[0,0,0,0]);const e=Nt[t.toLowerCase()];return e&&{r:e[0],g:e[1],b:e[2],a:4===e.length?e[3]:255}}const Ht=/^rgba?\(\s*([-+.\d]+)(%)?[\s,]+([-+.e\d]+)(%)?[\s,]+([-+.e\d]+)(%)?(?:[\s,/]+([-+.e\d]+)(%)?)?\s*\)$/;const jt=t=>t<=.0031308?12.92*t:1.055*Math.pow(t,1/2.4)-.055,$t=t=>t<=.04045?t/12.92:Math.pow((t+.055)/1.055,2.4);function Yt(t,e,i){if(t){let s=Et(t);s[e]=Math.max(0,Math.min(s[e]+s[e]*i,0===e?360:1)),s=It(s),t.r=s[0],t.g=s[1],t.b=s[2]}}function Ut(t,e){return t?Object.assign(e||{},t):t}function Xt(t){var e={r:0,g:0,b:0,a:255};return Array.isArray(t)?t.length>=3&&(e={r:t[0],g:t[1],b:t[2],a:255},t.length>3&&(e.a=yt(t[3]))):(e=Ut(t,{r:0,g:0,b:0,a:1})).a=yt(e.a),e}function qt(t){return"r"===t.charAt(0)?function(t){const e=Ht.exec(t);let i,s,n,o=255;if(e){if(e[7]!==i){const t=+e[7];o=e[8]?_t(t):xt(255*t,0,255)}return i=+e[1],s=+e[3],n=+e[5],i=255&(e[2]?_t(i):xt(i,0,255)),s=255&(e[4]?_t(s):xt(s,0,255)),n=255&(e[6]?_t(n):xt(n,0,255)),{r:i,g:s,b:n,a:o}}}(t):Ft(t)}class Color{constructor(t){if(t instanceof Color)return t;const e=typeof t;let i;var s,n,o;"object"===e?i=Xt(t):"string"===e&&(o=(s=t).length,"#"===s[0]&&(4===o||5===o?n={r:255&17*Mt[s[1]],g:255&17*Mt[s[2]],b:255&17*Mt[s[3]],a:5===o?17*Mt[s[4]]:255}:7!==o&&9!==o||(n={r:Mt[s[1]]<<4|Mt[s[2]],g:Mt[s[3]]<<4|Mt[s[4]],b:Mt[s[5]]<<4|Mt[s[6]],a:9===o?Mt[s[7]]<<4|Mt[s[8]]:255})),i=n||Wt(t)||qt(t)),this._rgb=i,this._valid=!!i}get valid(){return this._valid}get rgb(){var t=Ut(this._rgb);return t&&(t.a=vt(t.a)),t}set rgb(t){this._rgb=Xt(t)}rgbString(){return this._valid?(t=this._rgb)&&(t.a<255?`rgba(${t.r}, ${t.g}, ${t.b}, ${vt(t.a)})`:`rgb(${t.r}, ${t.g}, ${t.b})`):void 0;var t}hexString(){return this._valid?Dt(this._rgb):void 0}hslString(){return this._valid?function(t){if(!t)return;const e=Et(t),i=e[0],s=wt(e[1]),n=wt(e[2]);return t.a<255?`hsla(${i}, ${s}%, ${n}%, ${vt(t.a)})`:`hsl(${i}, ${s}%, ${n}%)`}(this._rgb):void 0}mix(t,e){if(t){const i=this.rgb,s=t.rgb;let n;const o=e===n?.5:e,a=2*o-1,r=i.a-s.a,l=((a*r==-1?a:(a+r)/(1+a*r))+1)/2;n=1-l,i.r=255&l*i.r+n*s.r+.5,i.g=255&l*i.g+n*s.g+.5,i.b=255&l*i.b+n*s.b+.5,i.a=o*i.a+(1-o)*s.a,this.rgb=i}return this}interpolate(t,e){return t&&(this._rgb=function(t,e,i){const s=$t(vt(t.r)),n=$t(vt(t.g)),o=$t(vt(t.b));return{r:yt(jt(s+i*($t(vt(e.r))-s))),g:yt(jt(n+i*($t(vt(e.g))-n))),b:yt(jt(o+i*($t(vt(e.b))-o))),a:t.a+i*(e.a-t.a)}}(this._rgb,t._rgb,e)),this}clone(){return new Color(this.rgb)}alpha(t){return this._rgb.a=yt(t),this}clearer(t){return this._rgb.a*=1-t,this}greyscale(){const t=this._rgb,e=bt(.3*t.r+.59*t.g+.11*t.b);return t.r=t.g=t.b=e,this}opaquer(t){return this._rgb.a*=1+t,this}negate(){const t=this._rgb;return t.r=255-t.r,t.g=255-t.g,t.b=255-t.b,this}lighten(t){return Yt(this._rgb,2,t),this}darken(t){return Yt(this._rgb,2,-t),this}saturate(t){return Yt(this._rgb,1,t),this}desaturate(t){return Yt(this._rgb,1,-t),this}rotate(t){return function(t,e){var i=Et(t);i[0]=zt(i[0]+e),i=It(i),t.r=i[0],t.g=i[1],t.b=i[2]}(this._rgb,t),this}}function Kt(t){return new Color(t)}function Gt(t){if(t&&"object"==typeof t){const e=t.toString();return"[object CanvasPattern]"===e||"[object CanvasGradient]"===e}return!1}function Zt(t){return Gt(t)?t:Kt(t)}function Jt(t){return Gt(t)?t:Kt(t).saturate(.5).darken(.1).hexString()}const Qt=Object.create(null),te=Object.create(null);function ee(t,e){if(!e)return t;const i=e.split(".");for(let s=0,n=i.length;s<n;++s){const e=i[s];t=t[e]||(t[e]=Object.create(null))}return t}function ie(t,e,i){return"string"==typeof e?m(ee(t,e),i):m(ee(t,""),e)}var se=new class Defaults{constructor(t){this.animation=void 0,this.backgroundColor="rgba(0,0,0,0.1)",this.borderColor="rgba(0,0,0,0.1)",this.color="#666",this.datasets={},this.devicePixelRatio=t=>t.chart.platform.getDevicePixelRatio(),this.elements={},this.events=["mousemove","mouseout","click","touchstart","touchmove"],this.font={family:"'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",size:12,style:"normal",lineHeight:1.2,weight:null},this.hover={},this.hoverBackgroundColor=(t,e)=>Jt(e.backgroundColor),this.hoverBorderColor=(t,e)=>Jt(e.borderColor),this.hoverColor=(t,e)=>Jt(e.color),this.indexAxis="x",this.interaction={mode:"nearest",intersect:!0,includeInvisible:!1},this.maintainAspectRatio=!0,this.onHover=null,this.onClick=null,this.parsing=!0,this.plugins={},this.responsive=!0,this.scale=void 0,this.scales={},this.showLine=!0,this.drawActiveElementsOnTop=!0,this.describe(t)}set(t,e){return ie(this,t,e)}get(t){return ee(this,t)}describe(t,e){return ie(te,t,e)}override(t,e){return ie(Qt,t,e)}route(t,e,i,s){const o=ee(this,t),a=ee(this,i),l="_"+e;Object.defineProperties(o,{[l]:{value:o[e],writable:!0},[e]:{enumerable:!0,get(){const t=this[l],e=a[s];return n(t)?Object.assign({},e,t):r(t,e)},set(t){this[l]=t}}})}}({_scriptable:t=>!t.startsWith("on"),_indexable:t=>"events"!==t,hover:{_fallback:"interaction"},interaction:{_scriptable:!1,_indexable:!1}});function ne(){return"undefined"!=typeof window&&"undefined"!=typeof document}function oe(t){let e=t.parentNode;return e&&"[object ShadowRoot]"===e.toString()&&(e=e.host),e}function ae(t,e,i){let s;return"string"==typeof t?(s=parseInt(t,10),-1!==t.indexOf("%")&&(s=s/100*e.parentNode[i])):s=t,s}const re=t=>window.getComputedStyle(t,null);function le(t,e){return re(t).getPropertyValue(e)}const he=["top","right","bottom","left"];function ce(t,e,i){const s={};i=i?"-"+i:"";for(let n=0;n<4;n++){const o=he[n];s[o]=parseFloat(t[e+"-"+o+i])||0}return s.width=s.left+s.right,s.height=s.top+s.bottom,s}function de(t,e){if("native"in t)return t;const{canvas:i,currentDevicePixelRatio:s}=e,n=re(i),o="border-box"===n.boxSizing,a=ce(n,"padding"),r=ce(n,"border","width"),{x:l,y:h,box:c}=function(t,e){const i=t.touches,s=i&&i.length?i[0]:t,{offsetX:n,offsetY:o}=s;let a,r,l=!1;if(((t,e,i)=>(t>0||e>0)&&(!i||!i.shadowRoot))(n,o,t.target))a=n,r=o;else{const t=e.getBoundingClientRect();a=s.clientX-t.left,r=s.clientY-t.top,l=!0}return{x:a,y:r,box:l}}(t,i),d=a.left+(c&&r.left),u=a.top+(c&&r.top);let{width:f,height:g}=e;return o&&(f-=a.width+r.width,g-=a.height+r.height),{x:Math.round((l-d)/f*i.width/s),y:Math.round((h-u)/g*i.height/s)}}const ue=t=>Math.round(10*t)/10;function fe(t,e,i,s){const n=re(t),o=ce(n,"margin"),a=ae(n.maxWidth,t,"clientWidth")||O,r=ae(n.maxHeight,t,"clientHeight")||O,l=function(t,e,i){let s,n;if(void 0===e||void 0===i){const o=oe(t);if(o){const t=o.getBoundingClientRect(),a=re(o),r=ce(a,"border","width"),l=ce(a,"padding");e=t.width-l.width-r.width,i=t.height-l.height-r.height,s=ae(a.maxWidth,o,"clientWidth"),n=ae(a.maxHeight,o,"clientHeight")}else e=t.clientWidth,i=t.clientHeight}return{width:e,height:i,maxWidth:s||O,maxHeight:n||O}}(t,e,i);let{width:h,height:c}=l;if("content-box"===n.boxSizing){const t=ce(n,"border","width"),e=ce(n,"padding");h-=e.width+t.width,c-=e.height+t.height}return h=Math.max(0,h-o.width),c=Math.max(0,s?Math.floor(h/s):c-o.height),h=ue(Math.min(h,a,l.maxWidth)),c=ue(Math.min(c,r,l.maxHeight)),h&&!c&&(c=ue(h/2)),{width:h,height:c}}function ge(t,e,i){const s=e||1,n=Math.floor(t.height*s),o=Math.floor(t.width*s);t.height=n/s,t.width=o/s;const a=t.canvas;return a.style&&(i||!a.style.height&&!a.style.width)&&(a.style.height=`${t.height}px`,a.style.width=`${t.width}px`),(t.currentDevicePixelRatio!==s||a.height!==n||a.width!==o)&&(t.currentDevicePixelRatio=s,a.height=n,a.width=o,t.ctx.setTransform(s,0,0,s,0,0),!0)}const pe=function(){let t=!1;try{const e={get passive(){return t=!0,!1}};window.addEventListener("test",null,e),window.removeEventListener("test",null,e)}catch(e){}return t}();function me(t,e){const i=le(t,e),s=i&&i.match(/^(\d+)(\.\d+)?px$/);return s?+s[1]:void 0}function be(t){return!t||i(t.size)||i(t.family)?null:(t.style?t.style+" ":"")+(t.weight?t.weight+" ":"")+t.size+"px "+t.family}function xe(t,e,i,s,n){let o=e[n];return o||(o=e[n]=t.measureText(n).width,i.push(n)),o>s&&(s=o),s}function _e(t,e,i,n){let o=(n=n||{}).data=n.data||{},a=n.garbageCollect=n.garbageCollect||[];n.font!==e&&(o=n.data={},a=n.garbageCollect=[],n.font=e),t.save(),t.font=e;let r=0;const l=i.length;let h,c,d,u,f;for(h=0;h<l;h++)if(u=i[h],null!=u&&!0!==s(u))r=xe(t,o,a,r,u);else if(s(u))for(c=0,d=u.length;c<d;c++)f=u[c],null==f||s(f)||(r=xe(t,o,a,r,f));t.restore();const g=a.length/2;if(g>i.length){for(h=0;h<g;h++)delete o[a[h]];a.splice(0,g)}return r}function ye(t,e,i){const s=t.currentDevicePixelRatio,n=0!==i?Math.max(i/2,.5):0;return Math.round((e-n)*s)/s+n}function ve(t,e){(e=e||t.getContext("2d")).save(),e.resetTransform(),e.clearRect(0,0,t.width,t.height),e.restore()}function we(t,e,i,s){Me(t,e,i,s,null)}function Me(t,e,i,s,n){let o,a,r,l,h,c;const d=e.pointStyle,u=e.rotation,f=e.radius;let g=(u||0)*T;if(d&&"object"==typeof d&&(o=d.toString(),"[object HTMLImageElement]"===o||"[object HTMLCanvasElement]"===o))return t.save(),t.translate(i,s),t.rotate(g),t.drawImage(d,-d.width/2,-d.height/2,d.width,d.height),void t.restore();if(!(isNaN(f)||f<=0)){switch(t.beginPath(),d){default:n?t.ellipse(i,s,n/2,f,0,0,D):t.arc(i,s,f,0,D),t.closePath();break;case"triangle":t.moveTo(i+Math.sin(g)*f,s-Math.cos(g)*f),g+=R,t.lineTo(i+Math.sin(g)*f,s-Math.cos(g)*f),g+=R,t.lineTo(i+Math.sin(g)*f,s-Math.cos(g)*f),t.closePath();break;case"rectRounded":h=.516*f,l=f-h,a=Math.cos(g+E)*l,r=Math.sin(g+E)*l,t.arc(i-a,s-r,h,g-C,g-L),t.arc(i+r,s-a,h,g-L,g),t.arc(i+a,s+r,h,g,g+L),t.arc(i-r,s+a,h,g+L,g+C),t.closePath();break;case"rect":if(!u){l=Math.SQRT1_2*f,c=n?n/2:l,t.rect(i-c,s-l,2*c,2*l);break}g+=E;case"rectRot":a=Math.cos(g)*f,r=Math.sin(g)*f,t.moveTo(i-a,s-r),t.lineTo(i+r,s-a),t.lineTo(i+a,s+r),t.lineTo(i-r,s+a),t.closePath();break;case"crossRot":g+=E;case"cross":a=Math.cos(g)*f,r=Math.sin(g)*f,t.moveTo(i-a,s-r),t.lineTo(i+a,s+r),t.moveTo(i+r,s-a),t.lineTo(i-r,s+a);break;case"star":a=Math.cos(g)*f,r=Math.sin(g)*f,t.moveTo(i-a,s-r),t.lineTo(i+a,s+r),t.moveTo(i+r,s-a),t.lineTo(i-r,s+a),g+=E,a=Math.cos(g)*f,r=Math.sin(g)*f,t.moveTo(i-a,s-r),t.lineTo(i+a,s+r),t.moveTo(i+r,s-a),t.lineTo(i-r,s+a);break;case"line":a=n?n/2:Math.cos(g)*f,r=Math.sin(g)*f,t.moveTo(i-a,s-r),t.lineTo(i+a,s+r);break;case"dash":t.moveTo(i,s),t.lineTo(i+Math.cos(g)*f,s+Math.sin(g)*f)}t.fill(),e.borderWidth>0&&t.stroke()}}function ke(t,e,i){return i=i||.5,!e||t&&t.x>e.left-i&&t.x<e.right+i&&t.y>e.top-i&&t.y<e.bottom+i}function Se(t,e){t.save(),t.beginPath(),t.rect(e.left,e.top,e.right-e.left,e.bottom-e.top),t.clip()}function Pe(t){t.restore()}function Ce(t,e,i,s,n){if(!e)return t.lineTo(i.x,i.y);if("middle"===n){const s=(e.x+i.x)/2;t.lineTo(s,e.y),t.lineTo(s,i.y)}else"after"===n!=!!s?t.lineTo(e.x,i.y):t.lineTo(i.x,e.y);t.lineTo(i.x,i.y)}function De(t,e,i,s){if(!e)return t.lineTo(i.x,i.y);t.bezierCurveTo(s?e.cp1x:e.cp2x,s?e.cp1y:e.cp2y,s?i.cp2x:i.cp1x,s?i.cp2y:i.cp1y,i.x,i.y)}function Ae(t,e,n,o,a,r={}){const l=s(e)?e:[e],h=r.strokeWidth>0&&""!==r.strokeColor;let c,d;for(t.save(),t.font=a.string,function(t,e){e.translation&&t.translate(e.translation[0],e.translation[1]);i(e.rotation)||t.rotate(e.rotation);e.color&&(t.fillStyle=e.color);e.textAlign&&(t.textAlign=e.textAlign);e.textBaseline&&(t.textBaseline=e.textBaseline)}(t,r),c=0;c<l.length;++c)d=l[c],h&&(r.strokeColor&&(t.strokeStyle=r.strokeColor),i(r.strokeWidth)||(t.lineWidth=r.strokeWidth),t.strokeText(d,n,o,r.maxWidth)),t.fillText(d,n,o,r.maxWidth),Oe(t,n,o,d,r),o+=a.lineHeight;t.restore()}function Oe(t,e,i,s,n){if(n.strikethrough||n.underline){const o=t.measureText(s),a=e-o.actualBoundingBoxLeft,r=e+o.actualBoundingBoxRight,l=i-o.actualBoundingBoxAscent,h=i+o.actualBoundingBoxDescent,c=n.strikethrough?(l+h)/2:h;t.strokeStyle=t.fillStyle,t.beginPath(),t.lineWidth=n.decorationWidth||2,t.moveTo(a,c),t.lineTo(r,c),t.stroke()}}function Te(t,e){const{x:i,y:s,w:n,h:o,radius:a}=e;t.arc(i+a.topLeft,s+a.topLeft,a.topLeft,-L,C,!0),t.lineTo(i,s+o-a.bottomLeft),t.arc(i+a.bottomLeft,s+o-a.bottomLeft,a.bottomLeft,C,L,!0),t.lineTo(i+n-a.bottomRight,s+o),t.arc(i+n-a.bottomRight,s+o-a.bottomRight,a.bottomRight,L,0,!0),t.lineTo(i+n,s+a.topRight),t.arc(i+n-a.topRight,s+a.topRight,a.topRight,0,-L,!0),t.lineTo(i+a.topLeft,s)}function Le(t,e=[""],i=t,s,n=(()=>t[0])){M(s)||(s=je("_fallback",t));const o={[Symbol.toStringTag]:"Object",_cacheable:!0,_scopes:t,_rootScopes:i,_fallback:s,_getTarget:n,override:n=>Le([n,...t],e,i,s)};return new Proxy(o,{deleteProperty:(e,i)=>(delete e[i],delete e._keys,delete t[0][i],!0),get:(i,s)=>Fe(i,s,(()=>function(t,e,i,s){let n;for(const o of e)if(n=je(Ie(o,t),i),M(n))return ze(t,n)?We(i,s,t,n):n}(s,e,t,i))),getOwnPropertyDescriptor:(t,e)=>Reflect.getOwnPropertyDescriptor(t._scopes[0],e),getPrototypeOf:()=>Reflect.getPrototypeOf(t[0]),has:(t,e)=>$e(t).includes(e),ownKeys:t=>$e(t),set(t,e,i){const s=t._storage||(t._storage=n());return t[e]=s[e]=i,delete t._keys,!0}})}function Ee(t,e,i,o){const a={_cacheable:!1,_proxy:t,_context:e,_subProxy:i,_stack:new Set,_descriptors:Re(t,o),setContext:e=>Ee(t,e,i,o),override:s=>Ee(t.override(s),e,i,o)};return new Proxy(a,{deleteProperty:(e,i)=>(delete e[i],delete t[i],!0),get:(t,e,i)=>Fe(t,e,(()=>function(t,e,i){const{_proxy:o,_context:a,_subProxy:r,_descriptors:l}=t;let h=o[e];k(h)&&l.isScriptable(e)&&(h=function(t,e,i,s){const{_proxy:n,_context:o,_subProxy:a,_stack:r}=i;if(r.has(t))throw new Error("Recursion detected: "+Array.from(r).join("->")+"->"+t);r.add(t),e=e(o,a||s),r.delete(t),ze(t,e)&&(e=We(n._scopes,n,t,e));return e}(e,h,t,i));s(h)&&h.length&&(h=function(t,e,i,s){const{_proxy:o,_context:a,_subProxy:r,_descriptors:l}=i;if(M(a.index)&&s(t))e=e[a.index%e.length];else if(n(e[0])){const i=e,s=o._scopes.filter((t=>t!==i));e=[];for(const n of i){const i=We(s,o,t,n);e.push(Ee(i,a,r&&r[t],l))}}return e}(e,h,t,l.isIndexable));ze(e,h)&&(h=Ee(h,a,r&&r[e],l));return h}(t,e,i))),getOwnPropertyDescriptor:(e,i)=>e._descriptors.allKeys?Reflect.has(t,i)?{enumerable:!0,configurable:!0}:void 0:Reflect.getOwnPropertyDescriptor(t,i),getPrototypeOf:()=>Reflect.getPrototypeOf(t),has:(e,i)=>Reflect.has(t,i),ownKeys:()=>Reflect.ownKeys(t),set:(e,i,s)=>(t[i]=s,delete e[i],!0)})}function Re(t,e={scriptable:!0,indexable:!0}){const{_scriptable:i=e.scriptable,_indexable:s=e.indexable,_allKeys:n=e.allKeys}=t;return{allKeys:n,scriptable:i,indexable:s,isScriptable:k(i)?i:()=>i,isIndexable:k(s)?s:()=>s}}const Ie=(t,e)=>t?t+w(e):e,ze=(t,e)=>n(e)&&"adapters"!==t&&(null===Object.getPrototypeOf(e)||e.constructor===Object);function Fe(t,e,i){if(Object.prototype.hasOwnProperty.call(t,e))return t[e];const s=i();return t[e]=s,s}function Be(t,e,i){return k(t)?t(e,i):t}const Ve=(t,e)=>!0===t?e:"string"==typeof t?y(e,t):void 0;function Ne(t,e,i,s,n){for(const o of e){const e=Ve(i,o);if(e){t.add(e);const o=Be(e._fallback,i,n);if(M(o)&&o!==i&&o!==s)return o}else if(!1===e&&M(s)&&i!==s)return null}return!1}function We(t,e,i,o){const a=e._rootScopes,r=Be(e._fallback,i,o),l=[...t,...a],h=new Set;h.add(o);let c=He(h,l,i,r||i,o);return null!==c&&((!M(r)||r===i||(c=He(h,l,r,c,o),null!==c))&&Le(Array.from(h),[""],a,r,(()=>function(t,e,i){const o=t._getTarget();e in o||(o[e]={});const a=o[e];if(s(a)&&n(i))return i;return a}(e,i,o))))}function He(t,e,i,s,n){for(;i;)i=Ne(t,e,i,s,n);return i}function je(t,e){for(const i of e){if(!i)continue;const e=i[t];if(M(e))return e}}function $e(t){let e=t._keys;return e||(e=t._keys=function(t){const e=new Set;for(const i of t)for(const t of Object.keys(i).filter((t=>!t.startsWith("_"))))e.add(t);return Array.from(e)}(t._scopes)),e}function Ye(t,e,i,s){const{iScale:n}=t,{key:o="r"}=this._parsing,a=new Array(s);let r,l,h,c;for(r=0,l=s;r<l;++r)h=r+i,c=e[h],a[r]={r:n.parse(y(c,o),h)};return a}const Ue=Number.EPSILON||1e-14,Xe=(t,e)=>e<t.length&&!t[e].skip&&t[e],qe=t=>"x"===t?"y":"x";function Ke(t,e,i,s){const n=t.skip?e:t,o=e,a=i.skip?e:i,r=X(o,n),l=X(a,o);let h=r/(r+l),c=l/(r+l);h=isNaN(h)?0:h,c=isNaN(c)?0:c;const d=s*h,u=s*c;return{previous:{x:o.x-d*(a.x-n.x),y:o.y-d*(a.y-n.y)},next:{x:o.x+u*(a.x-n.x),y:o.y+u*(a.y-n.y)}}}function Ge(t,e="x"){const i=qe(e),s=t.length,n=Array(s).fill(0),o=Array(s);let a,r,l,h=Xe(t,0);for(a=0;a<s;++a)if(r=l,l=h,h=Xe(t,a+1),l){if(h){const t=h[e]-l[e];n[a]=0!==t?(h[i]-l[i])/t:0}o[a]=r?h?z(n[a-1])!==z(n[a])?0:(n[a-1]+n[a])/2:n[a-1]:n[a]}!function(t,e,i){const s=t.length;let n,o,a,r,l,h=Xe(t,0);for(let c=0;c<s-1;++c)l=h,h=Xe(t,c+1),l&&h&&(N(e[c],0,Ue)?i[c]=i[c+1]=0:(n=i[c]/e[c],o=i[c+1]/e[c],r=Math.pow(n,2)+Math.pow(o,2),r<=9||(a=3/Math.sqrt(r),i[c]=n*a*e[c],i[c+1]=o*a*e[c])))}(t,n,o),function(t,e,i="x"){const s=qe(i),n=t.length;let o,a,r,l=Xe(t,0);for(let h=0;h<n;++h){if(a=r,r=l,l=Xe(t,h+1),!r)continue;const n=r[i],c=r[s];a&&(o=(n-a[i])/3,r[`cp1${i}`]=n-o,r[`cp1${s}`]=c-o*e[h]),l&&(o=(l[i]-n)/3,r[`cp2${i}`]=n+o,r[`cp2${s}`]=c+o*e[h])}}(t,o,e)}function Ze(t,e,i){return Math.max(Math.min(t,i),e)}function Je(t,e,i,s,n){let o,a,r,l;if(e.spanGaps&&(t=t.filter((t=>!t.skip))),"monotone"===e.cubicInterpolationMode)Ge(t,n);else{let i=s?t[t.length-1]:t[0];for(o=0,a=t.length;o<a;++o)r=t[o],l=Ke(i,r,t[Math.min(o+1,a-(s?0:1))%a],e.tension),r.cp1x=l.previous.x,r.cp1y=l.previous.y,r.cp2x=l.next.x,r.cp2y=l.next.y,i=r}e.capBezierPoints&&function(t,e){let i,s,n,o,a,r=ke(t[0],e);for(i=0,s=t.length;i<s;++i)a=o,o=r,r=i<s-1&&ke(t[i+1],e),o&&(n=t[i],a&&(n.cp1x=Ze(n.cp1x,e.left,e.right),n.cp1y=Ze(n.cp1y,e.top,e.bottom)),r&&(n.cp2x=Ze(n.cp2x,e.left,e.right),n.cp2y=Ze(n.cp2y,e.top,e.bottom)))}(t,i)}const Qe=t=>0===t||1===t,ti=(t,e,i)=>-Math.pow(2,10*(t-=1))*Math.sin((t-e)*D/i),ei=(t,e,i)=>Math.pow(2,-10*t)*Math.sin((t-e)*D/i)+1,ii={linear:t=>t,easeInQuad:t=>t*t,easeOutQuad:t=>-t*(t-2),easeInOutQuad:t=>(t/=.5)<1?.5*t*t:-.5*(--t*(t-2)-1),easeInCubic:t=>t*t*t,easeOutCubic:t=>(t-=1)*t*t+1,easeInOutCubic:t=>(t/=.5)<1?.5*t*t*t:.5*((t-=2)*t*t+2),easeInQuart:t=>t*t*t*t,easeOutQuart:t=>-((t-=1)*t*t*t-1),easeInOutQuart:t=>(t/=.5)<1?.5*t*t*t*t:-.5*((t-=2)*t*t*t-2),easeInQuint:t=>t*t*t*t*t,easeOutQuint:t=>(t-=1)*t*t*t*t+1,easeInOutQuint:t=>(t/=.5)<1?.5*t*t*t*t*t:.5*((t-=2)*t*t*t*t+2),easeInSine:t=>1-Math.cos(t*L),easeOutSine:t=>Math.sin(t*L),easeInOutSine:t=>-.5*(Math.cos(C*t)-1),easeInExpo:t=>0===t?0:Math.pow(2,10*(t-1)),easeOutExpo:t=>1===t?1:1-Math.pow(2,-10*t),easeInOutExpo:t=>Qe(t)?t:t<.5?.5*Math.pow(2,10*(2*t-1)):.5*(2-Math.pow(2,-10*(2*t-1))),easeInCirc:t=>t>=1?t:-(Math.sqrt(1-t*t)-1),easeOutCirc:t=>Math.sqrt(1-(t-=1)*t),easeInOutCirc:t=>(t/=.5)<1?-.5*(Math.sqrt(1-t*t)-1):.5*(Math.sqrt(1-(t-=2)*t)+1),easeInElastic:t=>Qe(t)?t:ti(t,.075,.3),easeOutElastic:t=>Qe(t)?t:ei(t,.075,.3),easeInOutElastic(t){const e=.1125;return Qe(t)?t:t<.5?.5*ti(2*t,e,.45):.5+.5*ei(2*t-1,e,.45)},easeInBack(t){const e=1.70158;return t*t*((e+1)*t-e)},easeOutBack(t){const e=1.70158;return(t-=1)*t*((e+1)*t+e)+1},easeInOutBack(t){let e=1.70158;return(t/=.5)<1?t*t*((1+(e*=1.525))*t-e)*.5:.5*((t-=2)*t*((1+(e*=1.525))*t+e)+2)},easeInBounce:t=>1-ii.easeOutBounce(1-t),easeOutBounce(t){const e=7.5625,i=2.75;return t<1/i?e*t*t:t<2/i?e*(t-=1.5/i)*t+.75:t<2.5/i?e*(t-=2.25/i)*t+.9375:e*(t-=2.625/i)*t+.984375},easeInOutBounce:t=>t<.5?.5*ii.easeInBounce(2*t):.5*ii.easeOutBounce(2*t-1)+.5};function si(t,e,i,s){return{x:t.x+i*(e.x-t.x),y:t.y+i*(e.y-t.y)}}function ni(t,e,i,s){return{x:t.x+i*(e.x-t.x),y:"middle"===s?i<.5?t.y:e.y:"after"===s?i<1?t.y:e.y:i>0?e.y:t.y}}function oi(t,e,i,s){const n={x:t.cp2x,y:t.cp2y},o={x:e.cp1x,y:e.cp1y},a=si(t,n,i),r=si(n,o,i),l=si(o,e,i),h=si(a,r,i),c=si(r,l,i);return si(h,c,i)}const ai=new Map;function ri(t,e,i){return function(t,e){e=e||{};const i=t+JSON.stringify(e);let s=ai.get(i);return s||(s=new Intl.NumberFormat(t,e),ai.set(i,s)),s}(e,i).format(t)}const li=new RegExp(/^(normal|(\d+(?:\.\d+)?)(px|em|%)?)$/),hi=new RegExp(/^(normal|italic|initial|inherit|unset|(oblique( -?[0-9]?[0-9]deg)?))$/);function ci(t,e){const i=(""+t).match(li);if(!i||"normal"===i[1])return 1.2*e;switch(t=+i[2],i[3]){case"px":return t;case"%":t/=100}return e*t}function di(t,e){const i={},s=n(e),o=s?Object.keys(e):e,a=n(t)?s?i=>r(t[i],t[e[i]]):e=>t[e]:()=>t;for(const n of o)i[n]=+a(n)||0;return i}function ui(t){return di(t,{top:"y",right:"x",bottom:"y",left:"x"})}function fi(t){return di(t,["topLeft","topRight","bottomLeft","bottomRight"])}function gi(t){const e=ui(t);return e.width=e.left+e.right,e.height=e.top+e.bottom,e}function pi(t,e){t=t||{},e=e||se.font;let i=r(t.size,e.size);"string"==typeof i&&(i=parseInt(i,10));let s=r(t.style,e.style);s&&!(""+s).match(hi)&&(console.warn('Invalid font style specified: "'+s+'"'),s="");const n={family:r(t.family,e.family),lineHeight:ci(r(t.lineHeight,e.lineHeight),i),size:i,style:s,weight:r(t.weight,e.weight),string:""};return n.string=be(n),n}function mi(t,e,i,n){let o,a,r,l=!0;for(o=0,a=t.length;o<a;++o)if(r=t[o],void 0!==r&&(void 0!==e&&"function"==typeof r&&(r=r(e),l=!1),void 0!==i&&s(r)&&(r=r[i%r.length],l=!1),void 0!==r))return n&&!l&&(n.cacheable=!1),r}function bi(t,e,i){const{min:s,max:n}=t,o=h(e,(n-s)/2),a=(t,e)=>i&&0===t?0:t+e;return{min:a(s,-Math.abs(o)),max:a(n,o)}}function xi(t,e){return Object.assign(Object.create(t),e)}function _i(t,e,i){return t?function(t,e){return{x:i=>t+t+e-i,setWidth(t){e=t},textAlign:t=>"center"===t?t:"right"===t?"left":"right",xPlus:(t,e)=>t-e,leftForLtr:(t,e)=>t-e}}(e,i):{x:t=>t,setWidth(t){},textAlign:t=>t,xPlus:(t,e)=>t+e,leftForLtr:(t,e)=>t}}function yi(t,e){let i,s;"ltr"!==e&&"rtl"!==e||(i=t.canvas.style,s=[i.getPropertyValue("direction"),i.getPropertyPriority("direction")],i.setProperty("direction",e,"important"),t.prevTextDirection=s)}function vi(t,e){void 0!==e&&(delete t.prevTextDirection,t.canvas.style.setProperty("direction",e[0],e[1]))}function wi(t){return"angle"===t?{between:G,compare:q,normalize:K}:{between:Q,compare:(t,e)=>t-e,normalize:t=>t}}function Mi({start:t,end:e,count:i,loop:s,style:n}){return{start:t%i,end:e%i,loop:s&&(e-t+1)%i==0,style:n}}function ki(t,e,i){if(!i)return[t];const{property:s,start:n,end:o}=i,a=e.length,{compare:r,between:l,normalize:h}=wi(s),{start:c,end:d,loop:u,style:f}=function(t,e,i){const{property:s,start:n,end:o}=i,{between:a,normalize:r}=wi(s),l=e.length;let h,c,{start:d,end:u,loop:f}=t;if(f){for(d+=l,u+=l,h=0,c=l;h<c&&a(r(e[d%l][s]),n,o);++h)d--,u--;d%=l,u%=l}return u<d&&(u+=l),{start:d,end:u,loop:f,style:t.style}}(t,e,i),g=[];let p,m,b,x=!1,_=null;const y=()=>x||l(n,b,p)&&0!==r(n,b),v=()=>!x||0===r(o,p)||l(o,b,p);for(let w=c,M=c;w<=d;++w)m=e[w%a],m.skip||(p=h(m[s]),p!==b&&(x=l(p,n,o),null===_&&y()&&(_=0===r(p,n)?w:M),null!==_&&v()&&(g.push(Mi({start:_,end:w,loop:u,count:a,style:f})),_=null),M=w,b=p));return null!==_&&g.push(Mi({start:_,end:d,loop:u,count:a,style:f})),g}function Si(t,e){const i=[],s=t.segments;for(let n=0;n<s.length;n++){const o=ki(s[n],t.points,e);o.length&&i.push(...o)}return i}function Pi(t,e){const i=t.points,s=t.options.spanGaps,n=i.length;if(!n)return[];const o=!!t._loop,{start:a,end:r}=function(t,e,i,s){let n=0,o=e-1;if(i&&!s)for(;n<e&&!t[n].skip;)n++;for(;n<e&&t[n].skip;)n++;for(n%=e,i&&(o+=n);o>n&&t[o%e].skip;)o--;return o%=e,{start:n,end:o}}(i,n,o,s);if(!0===s)return Ci(t,[{start:a,end:r,loop:o}],i,e);return Ci(t,function(t,e,i,s){const n=t.length,o=[];let a,r=e,l=t[e];for(a=e+1;a<=i;++a){const i=t[a%n];i.skip||i.stop?l.skip||(s=!1,o.push({start:e%n,end:(a-1)%n,loop:s}),e=r=i.stop?a:null):(r=a,l.skip&&(e=a)),l=i}return null!==r&&o.push({start:e%n,end:r%n,loop:s}),o}(i,a,r<a?r+n:r,!!t._fullLoop&&0===a&&r===n-1),i,e)}function Ci(t,e,i,s){return s&&s.setContext&&i?function(t,e,i,s){const n=t._chart.getContext(),o=Di(t.options),{_datasetIndex:a,options:{spanGaps:r}}=t,l=i.length,h=[];let c=o,d=e[0].start,u=d;function f(t,e,s,n){const o=r?-1:1;if(t!==e){for(t+=l;i[t%l].skip;)t-=o;for(;i[e%l].skip;)e+=o;t%l!=e%l&&(h.push({start:t%l,end:e%l,loop:s,style:n}),c=n,d=e%l)}}for(const g of e){d=r?d:g.start;let t,e=i[d%l];for(u=d+1;u<=g.end;u++){const o=i[u%l];t=Di(s.setContext(xi(n,{type:"segment",p0:e,p1:o,p0DataIndex:(u-1)%l,p1DataIndex:u%l,datasetIndex:a}))),Ai(t,c)&&f(d,u-1,g.loop,c),e=o,c=t}d<u-1&&f(d,u-1,g.loop,c)}return h}(t,e,i,s):e}function Di(t){return{backgroundColor:t.backgroundColor,borderCapStyle:t.borderCapStyle,borderDash:t.borderDash,borderDashOffset:t.borderDashOffset,borderJoinStyle:t.borderJoinStyle,borderWidth:t.borderWidth,borderColor:t.borderColor}}function Ai(t,e){return e&&JSON.stringify(t)!==JSON.stringify(e)}var Oi=Object.freeze({__proto__:null,easingEffects:ii,isPatternOrGradient:Gt,color:Zt,getHoverColor:Jt,noop:t,uid:e,isNullOrUndef:i,isArray:s,isObject:n,isFinite:o,finiteOrDefault:a,valueOrDefault:r,toPercentage:l,toDimension:h,callback:c,each:d,_elementsEqual:u,clone:f,_merger:p,merge:m,mergeIf:b,_mergerIf:x,_deprecated:function(t,e,i,s){void 0!==e&&console.warn(t+': "'+i+'" is deprecated. Please use "'+s+'" instead')},resolveObjectKey:y,_splitKey:v,_capitalize:w,defined:M,isFunction:k,setsEqual:S,_isClickEvent:P,toFontString:be,_measureText:xe,_longestText:_e,_alignPixel:ye,clearCanvas:ve,drawPoint:we,drawPointLegend:Me,_isPointInArea:ke,clipArea:Se,unclipArea:Pe,_steppedLineTo:Ce,_bezierCurveTo:De,renderText:Ae,addRoundedRectPath:Te,_lookup:tt,_lookupByKey:et,_rlookupByKey:it,_filterBetween:st,listenArrayEvents:ot,unlistenArrayEvents:at,_arrayUnique:rt,_createResolver:Le,_attachContext:Ee,_descriptors:Re,_parseObjectDataRadialScale:Ye,splineCurve:Ke,splineCurveMonotone:Ge,_updateBezierControlPoints:Je,_isDomSupported:ne,_getParentNode:oe,getStyle:le,getRelativePosition:de,getMaximumSize:fe,retinaScale:ge,supportsEventListenerOptions:pe,readUsedSize:me,fontString:function(t,e,i){return e+" "+t+"px "+i},requestAnimFrame:lt,throttled:ht,debounce:ct,_toLeftRightCenter:dt,_alignStartEnd:ut,_textX:ft,_getStartAndCountOfVisiblePoints:gt,_scaleRangesChanged:pt,_pointInLine:si,_steppedInterpolation:ni,_bezierInterpolation:oi,formatNumber:ri,toLineHeight:ci,_readValueToProps:di,toTRBL:ui,toTRBLCorners:fi,toPadding:gi,toFont:pi,resolve:mi,_addGrace:bi,createContext:xi,PI:C,TAU:D,PITAU:A,INFINITY:O,RAD_PER_DEG:T,HALF_PI:L,QUARTER_PI:E,TWO_THIRDS_PI:R,log10:I,sign:z,niceNum:F,_factorize:B,isNumber:V,almostEquals:N,almostWhole:W,_setMinAndMaxByKey:H,toRadians:j,toDegrees:$,_decimalPlaces:Y,getAngleFromPoint:U,distanceBetweenPoints:X,_angleDiff:q,_normalizeAngle:K,_angleBetween:G,_limitValue:Z,_int16Range:J,_isBetween:Q,getRtlAdapter:_i,overrideTextDirection:yi,restoreTextDirection:vi,_boundSegment:ki,_boundSegments:Si,_computeSegments:Pi});function Ti(t,e,i,s){const{controller:n,data:o,_sorted:a}=t,r=n._cachedMeta.iScale;if(r&&e===r.axis&&"r"!==e&&a&&o.length){const t=r._reversePixels?it:et;if(!s)return t(o,e,i);if(n._sharedOptions){const s=o[0],n="function"==typeof s.getRange&&s.getRange(e);if(n){const s=t(o,e,i-n),a=t(o,e,i+n);return{lo:s.lo,hi:a.hi}}}}return{lo:0,hi:o.length-1}}function Li(t,e,i,s,n){const o=t.getSortedVisibleDatasetMetas(),a=i[e];for(let r=0,l=o.length;r<l;++r){const{index:t,data:i}=o[r],{lo:l,hi:h}=Ti(o[r],e,a,n);for(let e=l;e<=h;++e){const n=i[e];n.skip||s(n,t,e)}}}function Ei(t,e,i,s,n){const o=[];if(!n&&!t.isPointInArea(e))return o;return Li(t,i,e,(function(i,a,r){(n||ke(i,t.chartArea,0))&&i.inRange(e.x,e.y,s)&&o.push({element:i,datasetIndex:a,index:r})}),!0),o}function Ri(t,e,i,s,n,o){let a=[];const r=function(t){const e=-1!==t.indexOf("x"),i=-1!==t.indexOf("y");return function(t,s){const n=e?Math.abs(t.x-s.x):0,o=i?Math.abs(t.y-s.y):0;return Math.sqrt(Math.pow(n,2)+Math.pow(o,2))}}(i);let l=Number.POSITIVE_INFINITY;return Li(t,i,e,(function(i,h,c){const d=i.inRange(e.x,e.y,n);if(s&&!d)return;const u=i.getCenterPoint(n);if(!(!!o||t.isPointInArea(u))&&!d)return;const f=r(e,u);f<l?(a=[{element:i,datasetIndex:h,index:c}],l=f):f===l&&a.push({element:i,datasetIndex:h,index:c})})),a}function Ii(t,e,i,s,n,o){return o||t.isPointInArea(e)?"r"!==i||s?Ri(t,e,i,s,n,o):function(t,e,i,s){let n=[];return Li(t,i,e,(function(t,i,o){const{startAngle:a,endAngle:r}=t.getProps(["startAngle","endAngle"],s),{angle:l}=U(t,{x:e.x,y:e.y});G(l,a,r)&&n.push({element:t,datasetIndex:i,index:o})})),n}(t,e,i,n):[]}function zi(t,e,i,s,n){const o=[],a="x"===i?"inXRange":"inYRange";let r=!1;return Li(t,i,e,((t,s,l)=>{t[a](e[i],n)&&(o.push({element:t,datasetIndex:s,index:l}),r=r||t.inRange(e.x,e.y,n))})),s&&!r?[]:o}var Fi={evaluateInteractionItems:Li,modes:{index(t,e,i,s){const n=de(e,t),o=i.axis||"x",a=i.includeInvisible||!1,r=i.intersect?Ei(t,n,o,s,a):Ii(t,n,o,!1,s,a),l=[];return r.length?(t.getSortedVisibleDatasetMetas().forEach((t=>{const e=r[0].index,i=t.data[e];i&&!i.skip&&l.push({element:i,datasetIndex:t.index,index:e})})),l):[]},dataset(t,e,i,s){const n=de(e,t),o=i.axis||"xy",a=i.includeInvisible||!1;let r=i.intersect?Ei(t,n,o,s,a):Ii(t,n,o,!1,s,a);if(r.length>0){const e=r[0].datasetIndex,i=t.getDatasetMeta(e).data;r=[];for(let t=0;t<i.length;++t)r.push({element:i[t],datasetIndex:e,index:t})}return r},point:(t,e,i,s)=>Ei(t,de(e,t),i.axis||"xy",s,i.includeInvisible||!1),nearest(t,e,i,s){const n=de(e,t),o=i.axis||"xy",a=i.includeInvisible||!1;return Ii(t,n,o,i.intersect,s,a)},x:(t,e,i,s)=>zi(t,de(e,t),"x",i.intersect,s),y:(t,e,i,s)=>zi(t,de(e,t),"y",i.intersect,s)}};const Bi=["left","top","right","bottom"];function Vi(t,e){return t.filter((t=>t.pos===e))}function Ni(t,e){return t.filter((t=>-1===Bi.indexOf(t.pos)&&t.box.axis===e))}function Wi(t,e){return t.sort(((t,i)=>{const s=e?i:t,n=e?t:i;return s.weight===n.weight?s.index-n.index:s.weight-n.weight}))}function Hi(t,e){const i=function(t){const e={};for(const i of t){const{stack:t,pos:s,stackWeight:n}=i;if(!t||!Bi.includes(s))continue;const o=e[t]||(e[t]={count:0,placed:0,weight:0,size:0});o.count++,o.weight+=n}return e}(t),{vBoxMaxWidth:s,hBoxMaxHeight:n}=e;let o,a,r;for(o=0,a=t.length;o<a;++o){r=t[o];const{fullSize:a}=r.box,l=i[r.stack],h=l&&r.stackWeight/l.weight;r.horizontal?(r.width=h?h*s:a&&e.availableWidth,r.height=n):(r.width=s,r.height=h?h*n:a&&e.availableHeight)}return i}function ji(t,e,i,s){return Math.max(t[i],e[i])+Math.max(t[s],e[s])}function $i(t,e){t.top=Math.max(t.top,e.top),t.left=Math.max(t.left,e.left),t.bottom=Math.max(t.bottom,e.bottom),t.right=Math.max(t.right,e.right)}function Yi(t,e,i,s){const{pos:o,box:a}=i,r=t.maxPadding;if(!n(o)){i.size&&(t[o]-=i.size);const e=s[i.stack]||{size:0,count:1};e.size=Math.max(e.size,i.horizontal?a.height:a.width),i.size=e.size/e.count,t[o]+=i.size}a.getPadding&&$i(r,a.getPadding());const l=Math.max(0,e.outerWidth-ji(r,t,"left","right")),h=Math.max(0,e.outerHeight-ji(r,t,"top","bottom")),c=l!==t.w,d=h!==t.h;return t.w=l,t.h=h,i.horizontal?{same:c,other:d}:{same:d,other:c}}function Ui(t,e){const i=e.maxPadding;function s(t){const s={left:0,top:0,right:0,bottom:0};return t.forEach((t=>{s[t]=Math.max(e[t],i[t])})),s}return s(t?["left","right"]:["top","bottom"])}function Xi(t,e,i,s){const n=[];let o,a,r,l,h,c;for(o=0,a=t.length,h=0;o<a;++o){r=t[o],l=r.box,l.update(r.width||e.w,r.height||e.h,Ui(r.horizontal,e));const{same:a,other:d}=Yi(e,i,r,s);h|=a&&n.length,c=c||d,l.fullSize||n.push(r)}return h&&Xi(n,e,i,s)||c}function qi(t,e,i,s,n){t.top=i,t.left=e,t.right=e+s,t.bottom=i+n,t.width=s,t.height=n}function Ki(t,e,i,s){const n=i.padding;let{x:o,y:a}=e;for(const r of t){const t=r.box,l=s[r.stack]||{count:1,placed:0,weight:1},h=r.stackWeight/l.weight||1;if(r.horizontal){const s=e.w*h,o=l.size||t.height;M(l.start)&&(a=l.start),t.fullSize?qi(t,n.left,a,i.outerWidth-n.right-n.left,o):qi(t,e.left+l.placed,a,s,o),l.start=a,l.placed+=s,a=t.bottom}else{const s=e.h*h,a=l.size||t.width;M(l.start)&&(o=l.start),t.fullSize?qi(t,o,n.top,a,i.outerHeight-n.bottom-n.top):qi(t,o,e.top+l.placed,a,s),l.start=o,l.placed+=s,o=t.right}}e.x=o,e.y=a}se.set("layout",{autoPadding:!0,padding:{top:0,right:0,bottom:0,left:0}});var Gi={addBox(t,e){t.boxes||(t.boxes=[]),e.fullSize=e.fullSize||!1,e.position=e.position||"top",e.weight=e.weight||0,e._layers=e._layers||function(){return[{z:0,draw(t){e.draw(t)}}]},t.boxes.push(e)},removeBox(t,e){const i=t.boxes?t.boxes.indexOf(e):-1;-1!==i&&t.boxes.splice(i,1)},configure(t,e,i){e.fullSize=i.fullSize,e.position=i.position,e.weight=i.weight},update(t,e,i,s){if(!t)return;const n=gi(t.options.layout.padding),o=Math.max(e-n.width,0),a=Math.max(i-n.height,0),r=function(t){const e=function(t){const e=[];let i,s,n,o,a,r;for(i=0,s=(t||[]).length;i<s;++i)n=t[i],({position:o,options:{stack:a,stackWeight:r=1}}=n),e.push({index:i,box:n,pos:o,horizontal:n.isHorizontal(),weight:n.weight,stack:a&&o+a,stackWeight:r});return e}(t),i=Wi(e.filter((t=>t.box.fullSize)),!0),s=Wi(Vi(e,"left"),!0),n=Wi(Vi(e,"right")),o=Wi(Vi(e,"top"),!0),a=Wi(Vi(e,"bottom")),r=Ni(e,"x"),l=Ni(e,"y");return{fullSize:i,leftAndTop:s.concat(o),rightAndBottom:n.concat(l).concat(a).concat(r),chartArea:Vi(e,"chartArea"),vertical:s.concat(n).concat(l),horizontal:o.concat(a).concat(r)}}(t.boxes),l=r.vertical,h=r.horizontal;d(t.boxes,(t=>{"function"==typeof t.beforeLayout&&t.beforeLayout()}));const c=l.reduce(((t,e)=>e.box.options&&!1===e.box.options.display?t:t+1),0)||1,u=Object.freeze({outerWidth:e,outerHeight:i,padding:n,availableWidth:o,availableHeight:a,vBoxMaxWidth:o/2/c,hBoxMaxHeight:a/2}),f=Object.assign({},n);$i(f,gi(s));const g=Object.assign({maxPadding:f,w:o,h:a,x:n.left,y:n.top},n),p=Hi(l.concat(h),u);Xi(r.fullSize,g,u,p),Xi(l,g,u,p),Xi(h,g,u,p)&&Xi(l,g,u,p),function(t){const e=t.maxPadding;function i(i){const s=Math.max(e[i]-t[i],0);return t[i]+=s,s}t.y+=i("top"),t.x+=i("left"),i("right"),i("bottom")}(g),Ki(r.leftAndTop,g,u,p),g.x+=g.w,g.y+=g.h,Ki(r.rightAndBottom,g,u,p),t.chartArea={left:g.left,top:g.top,right:g.left+g.w,bottom:g.top+g.h,height:g.h,width:g.w},d(r.chartArea,(e=>{const i=e.box;Object.assign(i,t.chartArea),i.update(g.w,g.h,{left:0,top:0,right:0,bottom:0})}))}};class BasePlatform{acquireContext(t,e){}releaseContext(t){return!1}addEventListener(t,e,i){}removeEventListener(t,e,i){}getDevicePixelRatio(){return 1}getMaximumSize(t,e,i,s){return e=Math.max(0,e||t.width),i=i||t.height,{width:e,height:Math.max(0,s?Math.floor(e/s):i)}}isAttached(t){return!0}updateConfig(t){}}class BasicPlatform extends BasePlatform{acquireContext(t){return t&&t.getContext&&t.getContext("2d")||null}updateConfig(t){t.options.animation=!1}}const Zi="$chartjs",Ji={touchstart:"mousedown",touchmove:"mousemove",touchend:"mouseup",pointerenter:"mouseenter",pointerdown:"mousedown",pointermove:"mousemove",pointerup:"mouseup",pointerleave:"mouseout",pointerout:"mouseout"},Qi=t=>null===t||""===t;const ts=!!pe&&{passive:!0};function es(t,e,i){t.canvas.removeEventListener(e,i,ts)}function is(t,e){for(const i of t)if(i===e||i.contains(e))return!0}function ss(t,e,i){const s=t.canvas,n=new MutationObserver((t=>{let e=!1;for(const i of t)e=e||is(i.addedNodes,s),e=e&&!is(i.removedNodes,s);e&&i()}));return n.observe(document,{childList:!0,subtree:!0}),n}function ns(t,e,i){const s=t.canvas,n=new MutationObserver((t=>{let e=!1;for(const i of t)e=e||is(i.removedNodes,s),e=e&&!is(i.addedNodes,s);e&&i()}));return n.observe(document,{childList:!0,subtree:!0}),n}const os=new Map;let as=0;function rs(){const t=window.devicePixelRatio;t!==as&&(as=t,os.forEach(((e,i)=>{i.currentDevicePixelRatio!==t&&e()})))}function ls(t,e,i){const s=t.canvas,n=s&&oe(s);if(!n)return;const o=ht(((t,e)=>{const s=n.clientWidth;i(t,e),s<n.clientWidth&&i()}),window),a=new ResizeObserver((t=>{const e=t[0],i=e.contentRect.width,s=e.contentRect.height;0===i&&0===s||o(i,s)}));return a.observe(n),function(t,e){os.size||window.addEventListener("resize",rs),os.set(t,e)}(t,o),a}function hs(t,e,i){i&&i.disconnect(),"resize"===e&&function(t){os.delete(t),os.size||window.removeEventListener("resize",rs)}(t)}function cs(t,e,i){const s=t.canvas,n=ht((e=>{null!==t.ctx&&i(function(t,e){const i=Ji[t.type]||t.type,{x:s,y:n}=de(t,e);return{type:i,chart:e,native:t,x:void 0!==s?s:null,y:void 0!==n?n:null}}(e,t))}),t,(t=>{const e=t[0];return[e,e.offsetX,e.offsetY]}));return function(t,e,i){t.addEventListener(e,i,ts)}(s,e,n),n}class DomPlatform extends BasePlatform{acquireContext(t,e){const i=t&&t.getContext&&t.getContext("2d");return i&&i.canvas===t?(function(t,e){const i=t.style,s=t.getAttribute("height"),n=t.getAttribute("width");if(t[Zi]={initial:{height:s,width:n,style:{display:i.display,height:i.height,width:i.width}}},i.display=i.display||"block",i.boxSizing=i.boxSizing||"border-box",Qi(n)){const e=me(t,"width");void 0!==e&&(t.width=e)}if(Qi(s))if(""===t.style.height)t.height=t.width/(e||2);else{const e=me(t,"height");void 0!==e&&(t.height=e)}}(t,e),i):null}releaseContext(t){const e=t.canvas;if(!e[Zi])return!1;const s=e[Zi].initial;["height","width"].forEach((t=>{const n=s[t];i(n)?e.removeAttribute(t):e.setAttribute(t,n)}));const n=s.style||{};return Object.keys(n).forEach((t=>{e.style[t]=n[t]})),e.width=e.width,delete e[Zi],!0}addEventListener(t,e,i){this.removeEventListener(t,e);const s=t.$proxies||(t.$proxies={}),n={attach:ss,detach:ns,resize:ls}[e]||cs;s[e]=n(t,e,i)}removeEventListener(t,e){const i=t.$proxies||(t.$proxies={}),s=i[e];if(!s)return;({attach:hs,detach:hs,resize:hs}[e]||es)(t,e,s),i[e]=void 0}getDevicePixelRatio(){return window.devicePixelRatio}getMaximumSize(t,e,i,s){return fe(t,e,i,s)}isAttached(t){const e=oe(t);return!(!e||!e.isConnected)}}function ds(t){return!ne()||"undefined"!=typeof OffscreenCanvas&&t instanceof OffscreenCanvas?BasicPlatform:DomPlatform}var us=Object.freeze({__proto__:null,_detectPlatform:ds,BasePlatform:BasePlatform,BasicPlatform:BasicPlatform,DomPlatform:DomPlatform});const fs="transparent",gs={boolean:(t,e,i)=>i>.5?e:t,color(t,e,i){const s=Zt(t||fs),n=s.valid&&Zt(e||fs);return n&&n.valid?n.mix(s,i).hexString():e},number:(t,e,i)=>t+(e-t)*i};class Animation{constructor(t,e,i,s){const n=e[i];s=mi([t.to,s,n,t.from]);const o=mi([t.from,n,s]);this._active=!0,this._fn=t.fn||gs[t.type||typeof o],this._easing=ii[t.easing]||ii.linear,this._start=Math.floor(Date.now()+(t.delay||0)),this._duration=this._total=Math.floor(t.duration),this._loop=!!t.loop,this._target=e,this._prop=i,this._from=o,this._to=s,this._promises=void 0}active(){return this._active}update(t,e,i){if(this._active){this._notify(!1);const s=this._target[this._prop],n=i-this._start,o=this._duration-n;this._start=i,this._duration=Math.floor(Math.max(o,t.duration)),this._total+=n,this._loop=!!t.loop,this._to=mi([t.to,e,s,t.from]),this._from=mi([t.from,s,e])}}cancel(){this._active&&(this.tick(Date.now()),this._active=!1,this._notify(!1))}tick(t){const e=t-this._start,i=this._duration,s=this._prop,n=this._from,o=this._loop,a=this._to;let r;if(this._active=n!==a&&(o||e<i),!this._active)return this._target[s]=a,void this._notify(!0);e<0?this._target[s]=n:(r=e/i%2,r=o&&r>1?2-r:r,r=this._easing(Math.min(1,Math.max(0,r))),this._target[s]=this._fn(n,a,r))}wait(){const t=this._promises||(this._promises=[]);return new Promise(((e,i)=>{t.push({res:e,rej:i})}))}_notify(t){const e=t?"res":"rej",i=this._promises||[];for(let s=0;s<i.length;s++)i[s][e]()}}se.set("animation",{delay:void 0,duration:1e3,easing:"easeOutQuart",fn:void 0,from:void 0,loop:void 0,to:void 0,type:void 0});const ps=Object.keys(se.animation);se.describe("animation",{_fallback:!1,_indexable:!1,_scriptable:t=>"onProgress"!==t&&"onComplete"!==t&&"fn"!==t}),se.set("animations",{colors:{type:"color",properties:["color","borderColor","backgroundColor"]},numbers:{type:"number",properties:["x","y","borderWidth","radius","tension"]}}),se.describe("animations",{_fallback:"animation"}),se.set("transitions",{active:{animation:{duration:400}},resize:{animation:{duration:0}},show:{animations:{colors:{from:"transparent"},visible:{type:"boolean",duration:0}}},hide:{animations:{colors:{to:"transparent"},visible:{type:"boolean",easing:"linear",fn:t=>0|t}}}});class Animations{constructor(t,e){this._chart=t,this._properties=new Map,this.configure(e)}configure(t){if(!n(t))return;const e=this._properties;Object.getOwnPropertyNames(t).forEach((i=>{const o=t[i];if(!n(o))return;const a={};for(const t of ps)a[t]=o[t];(s(o.properties)&&o.properties||[i]).forEach((t=>{t!==i&&e.has(t)||e.set(t,a)}))}))}_animateOptions(t,e){const i=e.options,s=function(t,e){if(!e)return;let i=t.options;if(!i)return void(t.options=e);i.$shared&&(t.options=i=Object.assign({},i,{$shared:!1,$animations:{}}));return i}(t,i);if(!s)return[];const n=this._createAnimations(s,i);return i.$shared&&function(t,e){const i=[],s=Object.keys(e);for(let n=0;n<s.length;n++){const e=t[s[n]];e&&e.active()&&i.push(e.wait())}return Promise.all(i)}(t.options.$animations,i).then((()=>{t.options=i}),(()=>{})),n}_createAnimations(t,e){const i=this._properties,s=[],n=t.$animations||(t.$animations={}),o=Object.keys(e),a=Date.now();let r;for(r=o.length-1;r>=0;--r){const l=o[r];if("$"===l.charAt(0))continue;if("options"===l){s.push(...this._animateOptions(t,e));continue}const h=e[l];let c=n[l];const d=i.get(l);if(c){if(d&&c.active()){c.update(d,h,a);continue}c.cancel()}d&&d.duration?(n[l]=c=new Animation(d,t,l,h),s.push(c)):t[l]=h}return s}update(t,e){if(0===this._properties.size)return void Object.assign(t,e);const i=this._createAnimations(t,e);return i.length?(mt.add(this._chart,i),!0):void 0}}function ms(t,e){const i=t&&t.options||{},s=i.reverse,n=void 0===i.min?e:0,o=void 0===i.max?e:0;return{start:s?o:n,end:s?n:o}}function bs(t,e){const i=[],s=t._getSortedDatasetMetas(e);let n,o;for(n=0,o=s.length;n<o;++n)i.push(s[n].index);return i}function xs(t,e,i,s={}){const n=t.keys,a="single"===s.mode;let r,l,h,c;if(null!==e){for(r=0,l=n.length;r<l;++r){if(h=+n[r],h===i){if(s.all)continue;break}c=t.values[h],o(c)&&(a||0===e||z(e)===z(c))&&(e+=c)}return e}}function _s(t,e){const i=t&&t.options.stacked;return i||void 0===i&&void 0!==e.stack}function ys(t,e,i){const s=t[e]||(t[e]={});return s[i]||(s[i]={})}function vs(t,e,i,s){for(const n of e.getMatchingVisibleMetas(s).reverse()){const e=t[n.index];if(i&&e>0||!i&&e<0)return n.index}return null}function ws(t,e){const{chart:i,_cachedMeta:s}=t,n=i._stacks||(i._stacks={}),{iScale:o,vScale:a,index:r}=s,l=o.axis,h=a.axis,c=function(t,e,i){return`${t.id}.${e.id}.${i.stack||i.type}`}(o,a,s),d=e.length;let u;for(let f=0;f<d;++f){const t=e[f],{[l]:i,[h]:o}=t;u=(t._stacks||(t._stacks={}))[h]=ys(n,c,i),u[r]=o,u._top=vs(u,a,!0,s.type),u._bottom=vs(u,a,!1,s.type)}}function Ms(t,e){const i=t.scales;return Object.keys(i).filter((t=>i[t].axis===e)).shift()}function ks(t,e){const i=t.controller.index,s=t.vScale&&t.vScale.axis;if(s){e=e||t._parsed;for(const t of e){const e=t._stacks;if(!e||void 0===e[s]||void 0===e[s][i])return;delete e[s][i]}}}const Ss=t=>"reset"===t||"none"===t,Ps=(t,e)=>e?t:Object.assign({},t);class DatasetController{constructor(t,e){this.chart=t,this._ctx=t.ctx,this.index=e,this._cachedDataOpts={},this._cachedMeta=this.getMeta(),this._type=this._cachedMeta.type,this.options=void 0,this._parsing=!1,this._data=void 0,this._objectData=void 0,this._sharedOptions=void 0,this._drawStart=void 0,this._drawCount=void 0,this.enableOptionSharing=!1,this.supportsDecimation=!1,this.$context=void 0,this._syncList=[],this.initialize()}initialize(){const t=this._cachedMeta;this.configure(),this.linkScales(),t._stacked=_s(t.vScale,t),this.addElements()}updateIndex(t){this.index!==t&&ks(this._cachedMeta),this.index=t}linkScales(){const t=this.chart,e=this._cachedMeta,i=this.getDataset(),s=(t,e,i,s)=>"x"===t?e:"r"===t?s:i,n=e.xAxisID=r(i.xAxisID,Ms(t,"x")),o=e.yAxisID=r(i.yAxisID,Ms(t,"y")),a=e.rAxisID=r(i.rAxisID,Ms(t,"r")),l=e.indexAxis,h=e.iAxisID=s(l,n,o,a),c=e.vAxisID=s(l,o,n,a);e.xScale=this.getScaleForId(n),e.yScale=this.getScaleForId(o),e.rScale=this.getScaleForId(a),e.iScale=this.getScaleForId(h),e.vScale=this.getScaleForId(c)}getDataset(){return this.chart.data.datasets[this.index]}getMeta(){return this.chart.getDatasetMeta(this.index)}getScaleForId(t){return this.chart.scales[t]}_getOtherScale(t){const e=this._cachedMeta;return t===e.iScale?e.vScale:e.iScale}reset(){this._update("reset")}_destroy(){const t=this._cachedMeta;this._data&&at(this._data,this),t._stacked&&ks(t)}_dataCheck(){const t=this.getDataset(),e=t.data||(t.data=[]),i=this._data;if(n(e))this._data=function(t){const e=Object.keys(t),i=new Array(e.length);let s,n,o;for(s=0,n=e.length;s<n;++s)o=e[s],i[s]={x:o,y:t[o]};return i}(e);else if(i!==e){if(i){at(i,this);const t=this._cachedMeta;ks(t),t._parsed=[]}e&&Object.isExtensible(e)&&ot(e,this),this._syncList=[],this._data=e}}addElements(){const t=this._cachedMeta;this._dataCheck(),this.datasetElementType&&(t.dataset=new this.datasetElementType)}buildOrUpdateElements(t){const e=this._cachedMeta,i=this.getDataset();let s=!1;this._dataCheck();const n=e._stacked;e._stacked=_s(e.vScale,e),e.stack!==i.stack&&(s=!0,ks(e),e.stack=i.stack),this._resyncElements(t),(s||n!==e._stacked)&&ws(this,e._parsed)}configure(){const t=this.chart.config,e=t.datasetScopeKeys(this._type),i=t.getOptionScopes(this.getDataset(),e,!0);this.options=t.createResolver(i,this.getContext()),this._parsing=this.options.parsing,this._cachedDataOpts={}}parse(t,e){const{_cachedMeta:i,_data:o}=this,{iScale:a,_stacked:r}=i,l=a.axis;let h,c,d,u=0===t&&e===o.length||i._sorted,f=t>0&&i._parsed[t-1];if(!1===this._parsing)i._parsed=o,i._sorted=!0,d=o;else{d=s(o[t])?this.parseArrayData(i,o,t,e):n(o[t])?this.parseObjectData(i,o,t,e):this.parsePrimitiveData(i,o,t,e);const a=()=>null===c[l]||f&&c[l]<f[l];for(h=0;h<e;++h)i._parsed[h+t]=c=d[h],u&&(a()&&(u=!1),f=c);i._sorted=u}r&&ws(this,d)}parsePrimitiveData(t,e,i,s){const{iScale:n,vScale:o}=t,a=n.axis,r=o.axis,l=n.getLabels(),h=n===o,c=new Array(s);let d,u,f;for(d=0,u=s;d<u;++d)f=d+i,c[d]={[a]:h||n.parse(l[f],f),[r]:o.parse(e[f],f)};return c}parseArrayData(t,e,i,s){const{xScale:n,yScale:o}=t,a=new Array(s);let r,l,h,c;for(r=0,l=s;r<l;++r)h=r+i,c=e[h],a[r]={x:n.parse(c[0],h),y:o.parse(c[1],h)};return a}parseObjectData(t,e,i,s){const{xScale:n,yScale:o}=t,{xAxisKey:a="x",yAxisKey:r="y"}=this._parsing,l=new Array(s);let h,c,d,u;for(h=0,c=s;h<c;++h)d=h+i,u=e[d],l[h]={x:n.parse(y(u,a),d),y:o.parse(y(u,r),d)};return l}getParsed(t){return this._cachedMeta._parsed[t]}getDataElement(t){return this._cachedMeta.data[t]}applyStack(t,e,i){const s=this.chart,n=this._cachedMeta,o=e[t.axis];return xs({keys:bs(s,!0),values:e._stacks[t.axis]},o,n.index,{mode:i})}updateRangeFromParsed(t,e,i,s){const n=i[e.axis];let o=null===n?NaN:n;const a=s&&i._stacks[e.axis];s&&a&&(s.values=a,o=xs(s,n,this._cachedMeta.index)),t.min=Math.min(t.min,o),t.max=Math.max(t.max,o)}getMinMax(t,e){const i=this._cachedMeta,s=i._parsed,n=i._sorted&&t===i.iScale,a=s.length,r=this._getOtherScale(t),l=((t,e,i)=>t&&!e.hidden&&e._stacked&&{keys:bs(i,!0),values:null})(e,i,this.chart),h={min:Number.POSITIVE_INFINITY,max:Number.NEGATIVE_INFINITY},{min:c,max:d}=function(t){const{min:e,max:i,minDefined:s,maxDefined:n}=t.getUserBounds();return{min:s?e:Number.NEGATIVE_INFINITY,max:n?i:Number.POSITIVE_INFINITY}}(r);let u,f;function g(){f=s[u];const e=f[r.axis];return!o(f[t.axis])||c>e||d<e}for(u=0;u<a&&(g()||(this.updateRangeFromParsed(h,t,f,l),!n));++u);if(n)for(u=a-1;u>=0;--u)if(!g()){this.updateRangeFromParsed(h,t,f,l);break}return h}getAllParsedValues(t){const e=this._cachedMeta._parsed,i=[];let s,n,a;for(s=0,n=e.length;s<n;++s)a=e[s][t.axis],o(a)&&i.push(a);return i}getMaxOverflow(){return!1}getLabelAndValue(t){const e=this._cachedMeta,i=e.iScale,s=e.vScale,n=this.getParsed(t);return{label:i?""+i.getLabelForValue(n[i.axis]):"",value:s?""+s.getLabelForValue(n[s.axis]):""}}_update(t){const e=this._cachedMeta;this.update(t||"default"),e._clip=function(t){let e,i,s,o;return n(t)?(e=t.top,i=t.right,s=t.bottom,o=t.left):e=i=s=o=t,{top:e,right:i,bottom:s,left:o,disabled:!1===t}}(r(this.options.clip,function(t,e,i){if(!1===i)return!1;const s=ms(t,i),n=ms(e,i);return{top:n.end,right:s.end,bottom:n.start,left:s.start}}(e.xScale,e.yScale,this.getMaxOverflow())))}update(t){}draw(){const t=this._ctx,e=this.chart,i=this._cachedMeta,s=i.data||[],n=e.chartArea,o=[],a=this._drawStart||0,r=this._drawCount||s.length-a,l=this.options.drawActiveElementsOnTop;let h;for(i.dataset&&i.dataset.draw(t,n,a,r),h=a;h<a+r;++h){const e=s[h];e.hidden||(e.active&&l?o.push(e):e.draw(t,n))}for(h=0;h<o.length;++h)o[h].draw(t,n)}getStyle(t,e){const i=e?"active":"default";return void 0===t&&this._cachedMeta.dataset?this.resolveDatasetElementOptions(i):this.resolveDataElementOptions(t||0,i)}getContext(t,e,i){const s=this.getDataset();let n;if(t>=0&&t<this._cachedMeta.data.length){const e=this._cachedMeta.data[t];n=e.$context||(e.$context=function(t,e,i){return xi(t,{active:!1,dataIndex:e,parsed:void 0,raw:void 0,element:i,index:e,mode:"default",type:"data"})}(this.getContext(),t,e)),n.parsed=this.getParsed(t),n.raw=s.data[t],n.index=n.dataIndex=t}else n=this.$context||(this.$context=function(t,e){return xi(t,{active:!1,dataset:void 0,datasetIndex:e,index:e,mode:"default",type:"dataset"})}(this.chart.getContext(),this.index)),n.dataset=s,n.index=n.datasetIndex=this.index;return n.active=!!e,n.mode=i,n}resolveDatasetElementOptions(t){return this._resolveElementOptions(this.datasetElementType.id,t)}resolveDataElementOptions(t,e){return this._resolveElementOptions(this.dataElementType.id,e,t)}_resolveElementOptions(t,e="default",i){const s="active"===e,n=this._cachedDataOpts,o=t+"-"+e,a=n[o],r=this.enableOptionSharing&&M(i);if(a)return Ps(a,r);const l=this.chart.config,h=l.datasetElementScopeKeys(this._type,t),c=s?[`${t}Hover`,"hover",t,""]:[t,""],d=l.getOptionScopes(this.getDataset(),h),u=Object.keys(se.elements[t]),f=l.resolveNamedOptions(d,u,(()=>this.getContext(i,s)),c);return f.$shared&&(f.$shared=r,n[o]=Object.freeze(Ps(f,r))),f}_resolveAnimations(t,e,i){const s=this.chart,n=this._cachedDataOpts,o=`animation-${e}`,a=n[o];if(a)return a;let r;if(!1!==s.options.animation){const s=this.chart.config,n=s.datasetAnimationScopeKeys(this._type,e),o=s.getOptionScopes(this.getDataset(),n);r=s.createResolver(o,this.getContext(t,i,e))}const l=new Animations(s,r&&r.animations);return r&&r._cacheable&&(n[o]=Object.freeze(l)),l}getSharedOptions(t){if(t.$shared)return this._sharedOptions||(this._sharedOptions=Object.assign({},t))}includeOptions(t,e){return!e||Ss(t)||this.chart._animationsDisabled}_getSharedOptions(t,e){const i=this.resolveDataElementOptions(t,e),s=this._sharedOptions,n=this.getSharedOptions(i),o=this.includeOptions(e,n)||n!==s;return this.updateSharedOptions(n,e,i),{sharedOptions:n,includeOptions:o}}updateElement(t,e,i,s){Ss(s)?Object.assign(t,i):this._resolveAnimations(e,s).update(t,i)}updateSharedOptions(t,e,i){t&&!Ss(e)&&this._resolveAnimations(void 0,e).update(t,i)}_setStyle(t,e,i,s){t.active=s;const n=this.getStyle(e,s);this._resolveAnimations(e,i,s).update(t,{options:!s&&this.getSharedOptions(n)||n})}removeHoverStyle(t,e,i){this._setStyle(t,i,"active",!1)}setHoverStyle(t,e,i){this._setStyle(t,i,"active",!0)}_removeDatasetHoverStyle(){const t=this._cachedMeta.dataset;t&&this._setStyle(t,void 0,"active",!1)}_setDatasetHoverStyle(){const t=this._cachedMeta.dataset;t&&this._setStyle(t,void 0,"active",!0)}_resyncElements(t){const e=this._data,i=this._cachedMeta.data;for(const[a,r,l]of this._syncList)this[a](r,l);this._syncList=[];const s=i.length,n=e.length,o=Math.min(n,s);o&&this.parse(0,o),n>s?this._insertElements(s,n-s,t):n<s&&this._removeElements(n,s-n)}_insertElements(t,e,i=!0){const s=this._cachedMeta,n=s.data,o=t+e;let a;const r=t=>{for(t.length+=e,a=t.length-1;a>=o;a--)t[a]=t[a-e]};for(r(n),a=t;a<o;++a)n[a]=new this.dataElementType;this._parsing&&r(s._parsed),this.parse(t,e),i&&this.updateElements(n,t,e,"reset")}updateElements(t,e,i,s){}_removeElements(t,e){const i=this._cachedMeta;if(this._parsing){const s=i._parsed.splice(t,e);i._stacked&&ks(i,s)}i.data.splice(t,e)}_sync(t){if(this._parsing)this._syncList.push(t);else{const[e,i,s]=t;this[e](i,s)}this.chart._dataChanges.push([this.index,...t])}_onDataPush(){const t=arguments.length;this._sync(["_insertElements",this.getDataset().data.length-t,t])}_onDataPop(){this._sync(["_removeElements",this._cachedMeta.data.length-1,1])}_onDataShift(){this._sync(["_removeElements",0,1])}_onDataSplice(t,e){e&&this._sync(["_removeElements",t,e]);const i=arguments.length-2;i&&this._sync(["_insertElements",t,i])}_onDataUnshift(){this._sync(["_insertElements",0,arguments.length])}}DatasetController.defaults={},DatasetController.prototype.datasetElementType=null,DatasetController.prototype.dataElementType=null;class Element{constructor(){this.x=void 0,this.y=void 0,this.active=!1,this.options=void 0,this.$animations=void 0}tooltipPosition(t){const{x:e,y:i}=this.getProps(["x","y"],t);return{x:e,y:i}}hasValue(){return V(this.x)&&V(this.y)}getProps(t,e){const i=this.$animations;if(!e||!i)return this;const s={};return t.forEach((t=>{s[t]=i[t]&&i[t].active()?i[t]._to:this[t]})),s}}Element.defaults={},Element.defaultRoutes=void 0;const Cs={values:t=>s(t)?t:""+t,numeric(t,e,i){if(0===t)return"0";const s=this.chart.options.locale;let n,o=t;if(i.length>1){const e=Math.max(Math.abs(i[0].value),Math.abs(i[i.length-1].value));(e<1e-4||e>1e15)&&(n="scientific"),o=function(t,e){let i=e.length>3?e[2].value-e[1].value:e[1].value-e[0].value;Math.abs(i)>=1&&t!==Math.floor(t)&&(i=t-Math.floor(t));return i}(t,i)}const a=I(Math.abs(o)),r=Math.max(Math.min(-1*Math.floor(a),20),0),l={notation:n,minimumFractionDigits:r,maximumFractionDigits:r};return Object.assign(l,this.options.ticks.format),ri(t,s,l)},logarithmic(t,e,i){if(0===t)return"0";const s=t/Math.pow(10,Math.floor(I(t)));return 1===s||2===s||5===s?Cs.numeric.call(this,t,e,i):""}};var Ds={formatters:Cs};function As(t,e){const s=t.options.ticks,n=s.maxTicksLimit||function(t){const e=t.options.offset,i=t._tickSize(),s=t._length/i+(e?0:1),n=t._maxLength/i;return Math.floor(Math.min(s,n))}(t),o=s.major.enabled?function(t){const e=[];let i,s;for(i=0,s=t.length;i<s;i++)t[i].major&&e.push(i);return e}(e):[],a=o.length,r=o[0],l=o[a-1],h=[];if(a>n)return function(t,e,i,s){let n,o=0,a=i[0];for(s=Math.ceil(s),n=0;n<t.length;n++)n===a&&(e.push(t[n]),o++,a=i[o*s])}(e,h,o,a/n),h;const c=function(t,e,i){const s=function(t){const e=t.length;let i,s;if(e<2)return!1;for(s=t[0],i=1;i<e;++i)if(t[i]-t[i-1]!==s)return!1;return s}(t),n=e.length/i;if(!s)return Math.max(n,1);const o=B(s);for(let a=0,r=o.length-1;a<r;a++){const t=o[a];if(t>n)return t}return Math.max(n,1)}(o,e,n);if(a>0){let t,s;const n=a>1?Math.round((l-r)/(a-1)):null;for(Os(e,h,c,i(n)?0:r-n,r),t=0,s=a-1;t<s;t++)Os(e,h,c,o[t],o[t+1]);return Os(e,h,c,l,i(n)?e.length:l+n),h}return Os(e,h,c),h}function Os(t,e,i,s,n){const o=r(s,0),a=Math.min(r(n,t.length),t.length);let l,h,c,d=0;for(i=Math.ceil(i),n&&(l=n-s,i=l/Math.floor(l/i)),c=o;c<0;)d++,c=Math.round(o+d*i);for(h=Math.max(o,0);h<a;h++)h===c&&(e.push(t[h]),d++,c=Math.round(o+d*i))}se.set("scale",{display:!0,offset:!1,reverse:!1,beginAtZero:!1,bounds:"ticks",grace:0,grid:{display:!0,lineWidth:1,drawBorder:!0,drawOnChartArea:!0,drawTicks:!0,tickLength:8,tickWidth:(t,e)=>e.lineWidth,tickColor:(t,e)=>e.color,offset:!1,borderDash:[],borderDashOffset:0,borderWidth:1},title:{display:!1,text:"",padding:{top:4,bottom:4}},ticks:{minRotation:0,maxRotation:50,mirror:!1,textStrokeWidth:0,textStrokeColor:"",padding:3,display:!0,autoSkip:!0,autoSkipPadding:3,labelOffset:0,callback:Ds.formatters.values,minor:{},major:{},align:"center",crossAlign:"near",showLabelBackdrop:!1,backdropColor:"rgba(255, 255, 255, 0.75)",backdropPadding:2}}),se.route("scale.ticks","color","","color"),se.route("scale.grid","color","","borderColor"),se.route("scale.grid","borderColor","","borderColor"),se.route("scale.title","color","","color"),se.describe("scale",{_fallback:!1,_scriptable:t=>!t.startsWith("before")&&!t.startsWith("after")&&"callback"!==t&&"parser"!==t,_indexable:t=>"borderDash"!==t&&"tickBorderDash"!==t}),se.describe("scales",{_fallback:"scale"}),se.describe("scale.ticks",{_scriptable:t=>"backdropPadding"!==t&&"callback"!==t,_indexable:t=>"backdropPadding"!==t});const Ts=(t,e,i)=>"top"===e||"left"===e?t[e]+i:t[e]-i;function Ls(t,e){const i=[],s=t.length/e,n=t.length;let o=0;for(;o<n;o+=s)i.push(t[Math.floor(o)]);return i}function Es(t,e,i){const s=t.ticks.length,n=Math.min(e,s-1),o=t._startPixel,a=t._endPixel,r=1e-6;let l,h=t.getPixelForTick(n);if(!(i&&(l=1===s?Math.max(h-o,a-h):0===e?(t.getPixelForTick(1)-h)/2:(h-t.getPixelForTick(n-1))/2,h+=n<e?l:-l,h<o-r||h>a+r)))return h}function Rs(t){return t.drawTicks?t.tickLength:0}function Is(t,e){if(!t.display)return 0;const i=pi(t.font,e),n=gi(t.padding);return(s(t.text)?t.text.length:1)*i.lineHeight+n.height}function zs(t,e,i){let s=dt(t);return(i&&"right"!==e||!i&&"right"===e)&&(s=(t=>"left"===t?"right":"right"===t?"left":t)(s)),s}class Scale extends Element{constructor(t){super(),this.id=t.id,this.type=t.type,this.options=void 0,this.ctx=t.ctx,this.chart=t.chart,this.top=void 0,this.bottom=void 0,this.left=void 0,this.right=void 0,this.width=void 0,this.height=void 0,this._margins={left:0,right:0,top:0,bottom:0},this.maxWidth=void 0,this.maxHeight=void 0,this.paddingTop=void 0,this.paddingBottom=void 0,this.paddingLeft=void 0,this.paddingRight=void 0,this.axis=void 0,this.labelRotation=void 0,this.min=void 0,this.max=void 0,this._range=void 0,this.ticks=[],this._gridLineItems=null,this._labelItems=null,this._labelSizes=null,this._length=0,this._maxLength=0,this._longestTextCache={},this._startPixel=void 0,this._endPixel=void 0,this._reversePixels=!1,this._userMax=void 0,this._userMin=void 0,this._suggestedMax=void 0,this._suggestedMin=void 0,this._ticksLength=0,this._borderValue=0,this._cache={},this._dataLimitsCached=!1,this.$context=void 0}init(t){this.options=t.setContext(this.getContext()),this.axis=t.axis,this._userMin=this.parse(t.min),this._userMax=this.parse(t.max),this._suggestedMin=this.parse(t.suggestedMin),this._suggestedMax=this.parse(t.suggestedMax)}parse(t,e){return t}getUserBounds(){let{_userMin:t,_userMax:e,_suggestedMin:i,_suggestedMax:s}=this;return t=a(t,Number.POSITIVE_INFINITY),e=a(e,Number.NEGATIVE_INFINITY),i=a(i,Number.POSITIVE_INFINITY),s=a(s,Number.NEGATIVE_INFINITY),{min:a(t,i),max:a(e,s),minDefined:o(t),maxDefined:o(e)}}getMinMax(t){let e,{min:i,max:s,minDefined:n,maxDefined:o}=this.getUserBounds();if(n&&o)return{min:i,max:s};const r=this.getMatchingVisibleMetas();for(let a=0,l=r.length;a<l;++a)e=r[a].controller.getMinMax(this,t),n||(i=Math.min(i,e.min)),o||(s=Math.max(s,e.max));return i=o&&i>s?s:i,s=n&&i>s?i:s,{min:a(i,a(s,i)),max:a(s,a(i,s))}}getPadding(){return{left:this.paddingLeft||0,top:this.paddingTop||0,right:this.paddingRight||0,bottom:this.paddingBottom||0}}getTicks(){return this.ticks}getLabels(){const t=this.chart.data;return this.options.labels||(this.isHorizontal()?t.xLabels:t.yLabels)||t.labels||[]}beforeLayout(){this._cache={},this._dataLimitsCached=!1}beforeUpdate(){c(this.options.beforeUpdate,[this])}update(t,e,i){const{beginAtZero:s,grace:n,ticks:o}=this.options,a=o.sampleSize;this.beforeUpdate(),this.maxWidth=t,this.maxHeight=e,this._margins=i=Object.assign({left:0,right:0,top:0,bottom:0},i),this.ticks=null,this._labelSizes=null,this._gridLineItems=null,this._labelItems=null,this.beforeSetDimensions(),this.setDimensions(),this.afterSetDimensions(),this._maxLength=this.isHorizontal()?this.width+i.left+i.right:this.height+i.top+i.bottom,this._dataLimitsCached||(this.beforeDataLimits(),this.determineDataLimits(),this.afterDataLimits(),this._range=bi(this,n,s),this._dataLimitsCached=!0),this.beforeBuildTicks(),this.ticks=this.buildTicks()||[],this.afterBuildTicks();const r=a<this.ticks.length;this._convertTicksToLabels(r?Ls(this.ticks,a):this.ticks),this.configure(),this.beforeCalculateLabelRotation(),this.calculateLabelRotation(),this.afterCalculateLabelRotation(),o.display&&(o.autoSkip||"auto"===o.source)&&(this.ticks=As(this,this.ticks),this._labelSizes=null,this.afterAutoSkip()),r&&this._convertTicksToLabels(this.ticks),this.beforeFit(),this.fit(),this.afterFit(),this.afterUpdate()}configure(){let t,e,i=this.options.reverse;this.isHorizontal()?(t=this.left,e=this.right):(t=this.top,e=this.bottom,i=!i),this._startPixel=t,this._endPixel=e,this._reversePixels=i,this._length=e-t,this._alignToPixels=this.options.alignToPixels}afterUpdate(){c(this.options.afterUpdate,[this])}beforeSetDimensions(){c(this.options.beforeSetDimensions,[this])}setDimensions(){this.isHorizontal()?(this.width=this.maxWidth,this.left=0,this.right=this.width):(this.height=this.maxHeight,this.top=0,this.bottom=this.height),this.paddingLeft=0,this.paddingTop=0,this.paddingRight=0,this.paddingBottom=0}afterSetDimensions(){c(this.options.afterSetDimensions,[this])}_callHooks(t){this.chart.notifyPlugins(t,this.getContext()),c(this.options[t],[this])}beforeDataLimits(){this._callHooks("beforeDataLimits")}determineDataLimits(){}afterDataLimits(){this._callHooks("afterDataLimits")}beforeBuildTicks(){this._callHooks("beforeBuildTicks")}buildTicks(){return[]}afterBuildTicks(){this._callHooks("afterBuildTicks")}beforeTickToLabelConversion(){c(this.options.beforeTickToLabelConversion,[this])}generateTickLabels(t){const e=this.options.ticks;let i,s,n;for(i=0,s=t.length;i<s;i++)n=t[i],n.label=c(e.callback,[n.value,i,t],this)}afterTickToLabelConversion(){c(this.options.afterTickToLabelConversion,[this])}beforeCalculateLabelRotation(){c(this.options.beforeCalculateLabelRotation,[this])}calculateLabelRotation(){const t=this.options,e=t.ticks,i=this.ticks.length,s=e.minRotation||0,n=e.maxRotation;let o,a,r,l=s;if(!this._isVisible()||!e.display||s>=n||i<=1||!this.isHorizontal())return void(this.labelRotation=s);const h=this._getLabelSizes(),c=h.widest.width,d=h.highest.height,u=Z(this.chart.width-c,0,this.maxWidth);o=t.offset?this.maxWidth/i:u/(i-1),c+6>o&&(o=u/(i-(t.offset?.5:1)),a=this.maxHeight-Rs(t.grid)-e.padding-Is(t.title,this.chart.options.font),r=Math.sqrt(c*c+d*d),l=$(Math.min(Math.asin(Z((h.highest.height+6)/o,-1,1)),Math.asin(Z(a/r,-1,1))-Math.asin(Z(d/r,-1,1)))),l=Math.max(s,Math.min(n,l))),this.labelRotation=l}afterCalculateLabelRotation(){c(this.options.afterCalculateLabelRotation,[this])}afterAutoSkip(){}beforeFit(){c(this.options.beforeFit,[this])}fit(){const t={width:0,height:0},{chart:e,options:{ticks:i,title:s,grid:n}}=this,o=this._isVisible(),a=this.isHorizontal();if(o){const o=Is(s,e.options.font);if(a?(t.width=this.maxWidth,t.height=Rs(n)+o):(t.height=this.maxHeight,t.width=Rs(n)+o),i.display&&this.ticks.length){const{first:e,last:s,widest:n,highest:o}=this._getLabelSizes(),r=2*i.padding,l=j(this.labelRotation),h=Math.cos(l),c=Math.sin(l);if(a){const e=i.mirror?0:c*n.width+h*o.height;t.height=Math.min(this.maxHeight,t.height+e+r)}else{const e=i.mirror?0:h*n.width+c*o.height;t.width=Math.min(this.maxWidth,t.width+e+r)}this._calculatePadding(e,s,c,h)}}this._handleMargins(),a?(this.width=this._length=e.width-this._margins.left-this._margins.right,this.height=t.height):(this.width=t.width,this.height=this._length=e.height-this._margins.top-this._margins.bottom)}_calculatePadding(t,e,i,s){const{ticks:{align:n,padding:o},position:a}=this.options,r=0!==this.labelRotation,l="top"!==a&&"x"===this.axis;if(this.isHorizontal()){const a=this.getPixelForTick(0)-this.left,h=this.right-this.getPixelForTick(this.ticks.length-1);let c=0,d=0;r?l?(c=s*t.width,d=i*e.height):(c=i*t.height,d=s*e.width):"start"===n?d=e.width:"end"===n?c=t.width:"inner"!==n&&(c=t.width/2,d=e.width/2),this.paddingLeft=Math.max((c-a+o)*this.width/(this.width-a),0),this.paddingRight=Math.max((d-h+o)*this.width/(this.width-h),0)}else{let i=e.height/2,s=t.height/2;"start"===n?(i=0,s=t.height):"end"===n&&(i=e.height,s=0),this.paddingTop=i+o,this.paddingBottom=s+o}}_handleMargins(){this._margins&&(this._margins.left=Math.max(this.paddingLeft,this._margins.left),this._margins.top=Math.max(this.paddingTop,this._margins.top),this._margins.right=Math.max(this.paddingRight,this._margins.right),this._margins.bottom=Math.max(this.paddingBottom,this._margins.bottom))}afterFit(){c(this.options.afterFit,[this])}isHorizontal(){const{axis:t,position:e}=this.options;return"top"===e||"bottom"===e||"x"===t}isFullSize(){return this.options.fullSize}_convertTicksToLabels(t){let e,s;for(this.beforeTickToLabelConversion(),this.generateTickLabels(t),e=0,s=t.length;e<s;e++)i(t[e].label)&&(t.splice(e,1),s--,e--);this.afterTickToLabelConversion()}_getLabelSizes(){let t=this._labelSizes;if(!t){const e=this.options.ticks.sampleSize;let i=this.ticks;e<i.length&&(i=Ls(i,e)),this._labelSizes=t=this._computeLabelSizes(i,i.length)}return t}_computeLabelSizes(t,e){const{ctx:n,_longestTextCache:o}=this,a=[],r=[];let l,h,c,u,f,g,p,m,b,x,_,y=0,v=0;for(l=0;l<e;++l){if(u=t[l].label,f=this._resolveTickFontOptions(l),n.font=g=f.string,p=o[g]=o[g]||{data:{},gc:[]},m=f.lineHeight,b=x=0,i(u)||s(u)){if(s(u))for(h=0,c=u.length;h<c;++h)_=u[h],i(_)||s(_)||(b=xe(n,p.data,p.gc,b,_),x+=m)}else b=xe(n,p.data,p.gc,b,u),x=m;a.push(b),r.push(x),y=Math.max(b,y),v=Math.max(x,v)}!function(t,e){d(t,(t=>{const i=t.gc,s=i.length/2;let n;if(s>e){for(n=0;n<s;++n)delete t.data[i[n]];i.splice(0,s)}}))}(o,e);const w=a.indexOf(y),M=r.indexOf(v),k=t=>({width:a[t]||0,height:r[t]||0});return{first:k(0),last:k(e-1),widest:k(w),highest:k(M),widths:a,heights:r}}getLabelForValue(t){return t}getPixelForValue(t,e){return NaN}getValueForPixel(t){}getPixelForTick(t){const e=this.ticks;return t<0||t>e.length-1?null:this.getPixelForValue(e[t].value)}getPixelForDecimal(t){this._reversePixels&&(t=1-t);const e=this._startPixel+t*this._length;return J(this._alignToPixels?ye(this.chart,e,0):e)}getDecimalForPixel(t){const e=(t-this._startPixel)/this._length;return this._reversePixels?1-e:e}getBasePixel(){return this.getPixelForValue(this.getBaseValue())}getBaseValue(){const{min:t,max:e}=this;return t<0&&e<0?e:t>0&&e>0?t:0}getContext(t){const e=this.ticks||[];if(t>=0&&t<e.length){const i=e[t];return i.$context||(i.$context=function(t,e,i){return xi(t,{tick:i,index:e,type:"tick"})}(this.getContext(),t,i))}return this.$context||(this.$context=xi(this.chart.getContext(),{scale:this,type:"scale"}))}_tickSize(){const t=this.options.ticks,e=j(this.labelRotation),i=Math.abs(Math.cos(e)),s=Math.abs(Math.sin(e)),n=this._getLabelSizes(),o=t.autoSkipPadding||0,a=n?n.widest.width+o:0,r=n?n.highest.height+o:0;return this.isHorizontal()?r*i>a*s?a/i:r/s:r*s<a*i?r/i:a/s}_isVisible(){const t=this.options.display;return"auto"!==t?!!t:this.getMatchingVisibleMetas().length>0}_computeGridLineItems(t){const e=this.axis,i=this.chart,s=this.options,{grid:o,position:a}=s,l=o.offset,h=this.isHorizontal(),c=this.ticks.length+(l?1:0),d=Rs(o),u=[],f=o.setContext(this.getContext()),g=f.drawBorder?f.borderWidth:0,p=g/2,m=function(t){return ye(i,t,g)};let b,x,_,y,v,w,M,k,S,P,C,D;if("top"===a)b=m(this.bottom),w=this.bottom-d,k=b-p,P=m(t.top)+p,D=t.bottom;else if("bottom"===a)b=m(this.top),P=t.top,D=m(t.bottom)-p,w=b+p,k=this.top+d;else if("left"===a)b=m(this.right),v=this.right-d,M=b-p,S=m(t.left)+p,C=t.right;else if("right"===a)b=m(this.left),S=t.left,C=m(t.right)-p,v=b+p,M=this.left+d;else if("x"===e){if("center"===a)b=m((t.top+t.bottom)/2+.5);else if(n(a)){const t=Object.keys(a)[0],e=a[t];b=m(this.chart.scales[t].getPixelForValue(e))}P=t.top,D=t.bottom,w=b+p,k=w+d}else if("y"===e){if("center"===a)b=m((t.left+t.right)/2);else if(n(a)){const t=Object.keys(a)[0],e=a[t];b=m(this.chart.scales[t].getPixelForValue(e))}v=b-p,M=v-d,S=t.left,C=t.right}const A=r(s.ticks.maxTicksLimit,c),O=Math.max(1,Math.ceil(c/A));for(x=0;x<c;x+=O){const t=o.setContext(this.getContext(x)),e=t.lineWidth,s=t.color,n=t.borderDash||[],a=t.borderDashOffset,r=t.tickWidth,c=t.tickColor,d=t.tickBorderDash||[],f=t.tickBorderDashOffset;_=Es(this,x,l),void 0!==_&&(y=ye(i,_,e),h?v=M=S=C=y:w=k=P=D=y,u.push({tx1:v,ty1:w,tx2:M,ty2:k,x1:S,y1:P,x2:C,y2:D,width:e,color:s,borderDash:n,borderDashOffset:a,tickWidth:r,tickColor:c,tickBorderDash:d,tickBorderDashOffset:f}))}return this._ticksLength=c,this._borderValue=b,u}_computeLabelItems(t){const e=this.axis,i=this.options,{position:o,ticks:a}=i,r=this.isHorizontal(),l=this.ticks,{align:h,crossAlign:c,padding:d,mirror:u}=a,f=Rs(i.grid),g=f+d,p=u?-d:g,m=-j(this.labelRotation),b=[];let x,_,y,v,w,M,k,S,P,C,D,A,O="middle";if("top"===o)M=this.bottom-p,k=this._getXAxisLabelAlignment();else if("bottom"===o)M=this.top+p,k=this._getXAxisLabelAlignment();else if("left"===o){const t=this._getYAxisLabelAlignment(f);k=t.textAlign,w=t.x}else if("right"===o){const t=this._getYAxisLabelAlignment(f);k=t.textAlign,w=t.x}else if("x"===e){if("center"===o)M=(t.top+t.bottom)/2+g;else if(n(o)){const t=Object.keys(o)[0],e=o[t];M=this.chart.scales[t].getPixelForValue(e)+g}k=this._getXAxisLabelAlignment()}else if("y"===e){if("center"===o)w=(t.left+t.right)/2-g;else if(n(o)){const t=Object.keys(o)[0],e=o[t];w=this.chart.scales[t].getPixelForValue(e)}k=this._getYAxisLabelAlignment(f).textAlign}"y"===e&&("start"===h?O="top":"end"===h&&(O="bottom"));const T=this._getLabelSizes();for(x=0,_=l.length;x<_;++x){y=l[x],v=y.label;const t=a.setContext(this.getContext(x));S=this.getPixelForTick(x)+a.labelOffset,P=this._resolveTickFontOptions(x),C=P.lineHeight,D=s(v)?v.length:1;const e=D/2,i=t.color,n=t.textStrokeColor,h=t.textStrokeWidth;let d,f=k;if(r?(w=S,"inner"===k&&(f=x===_-1?this.options.reverse?"left":"right":0===x?this.options.reverse?"right":"left":"center"),A="top"===o?"near"===c||0!==m?-D*C+C/2:"center"===c?-T.highest.height/2-e*C+C:-T.highest.height+C/2:"near"===c||0!==m?C/2:"center"===c?T.highest.height/2-e*C:T.highest.height-D*C,u&&(A*=-1)):(M=S,A=(1-D)*C/2),t.showLabelBackdrop){const e=gi(t.backdropPadding),i=T.heights[x],s=T.widths[x];let n=M+A-e.top,o=w-e.left;switch(O){case"middle":n-=i/2;break;case"bottom":n-=i}switch(k){case"center":o-=s/2;break;case"right":o-=s}d={left:o,top:n,width:s+e.width,height:i+e.height,color:t.backdropColor}}b.push({rotation:m,label:v,font:P,color:i,strokeColor:n,strokeWidth:h,textOffset:A,textAlign:f,textBaseline:O,translation:[w,M],backdrop:d})}return b}_getXAxisLabelAlignment(){const{position:t,ticks:e}=this.options;if(-j(this.labelRotation))return"top"===t?"left":"right";let i="center";return"start"===e.align?i="left":"end"===e.align?i="right":"inner"===e.align&&(i="inner"),i}_getYAxisLabelAlignment(t){const{position:e,ticks:{crossAlign:i,mirror:s,padding:n}}=this.options,o=t+n,a=this._getLabelSizes().widest.width;let r,l;return"left"===e?s?(l=this.right+n,"near"===i?r="left":"center"===i?(r="center",l+=a/2):(r="right",l+=a)):(l=this.right-o,"near"===i?r="right":"center"===i?(r="center",l-=a/2):(r="left",l=this.left)):"right"===e?s?(l=this.left+n,"near"===i?r="right":"center"===i?(r="center",l-=a/2):(r="left",l-=a)):(l=this.left+o,"near"===i?r="left":"center"===i?(r="center",l+=a/2):(r="right",l=this.right)):r="right",{textAlign:r,x:l}}_computeLabelArea(){if(this.options.ticks.mirror)return;const t=this.chart,e=this.options.position;return"left"===e||"right"===e?{top:0,left:this.left,bottom:t.height,right:this.right}:"top"===e||"bottom"===e?{top:this.top,left:0,bottom:this.bottom,right:t.width}:void 0}drawBackground(){const{ctx:t,options:{backgroundColor:e},left:i,top:s,width:n,height:o}=this;e&&(t.save(),t.fillStyle=e,t.fillRect(i,s,n,o),t.restore())}getLineWidthForValue(t){const e=this.options.grid;if(!this._isVisible()||!e.display)return 0;const i=this.ticks.findIndex((e=>e.value===t));if(i>=0){return e.setContext(this.getContext(i)).lineWidth}return 0}drawGrid(t){const e=this.options.grid,i=this.ctx,s=this._gridLineItems||(this._gridLineItems=this._computeGridLineItems(t));let n,o;const a=(t,e,s)=>{s.width&&s.color&&(i.save(),i.lineWidth=s.width,i.strokeStyle=s.color,i.setLineDash(s.borderDash||[]),i.lineDashOffset=s.borderDashOffset,i.beginPath(),i.moveTo(t.x,t.y),i.lineTo(e.x,e.y),i.stroke(),i.restore())};if(e.display)for(n=0,o=s.length;n<o;++n){const t=s[n];e.drawOnChartArea&&a({x:t.x1,y:t.y1},{x:t.x2,y:t.y2},t),e.drawTicks&&a({x:t.tx1,y:t.ty1},{x:t.tx2,y:t.ty2},{color:t.tickColor,width:t.tickWidth,borderDash:t.tickBorderDash,borderDashOffset:t.tickBorderDashOffset})}}drawBorder(){const{chart:t,ctx:e,options:{grid:i}}=this,s=i.setContext(this.getContext()),n=i.drawBorder?s.borderWidth:0;if(!n)return;const o=i.setContext(this.getContext(0)).lineWidth,a=this._borderValue;let r,l,h,c;this.isHorizontal()?(r=ye(t,this.left,n)-n/2,l=ye(t,this.right,o)+o/2,h=c=a):(h=ye(t,this.top,n)-n/2,c=ye(t,this.bottom,o)+o/2,r=l=a),e.save(),e.lineWidth=s.borderWidth,e.strokeStyle=s.borderColor,e.beginPath(),e.moveTo(r,h),e.lineTo(l,c),e.stroke(),e.restore()}drawLabels(t){if(!this.options.ticks.display)return;const e=this.ctx,i=this._computeLabelArea();i&&Se(e,i);const s=this._labelItems||(this._labelItems=this._computeLabelItems(t));let n,o;for(n=0,o=s.length;n<o;++n){const t=s[n],i=t.font,o=t.label;t.backdrop&&(e.fillStyle=t.backdrop.color,e.fillRect(t.backdrop.left,t.backdrop.top,t.backdrop.width,t.backdrop.height)),Ae(e,o,0,t.textOffset,i,t)}i&&Pe(e)}drawTitle(){const{ctx:t,options:{position:e,title:i,reverse:o}}=this;if(!i.display)return;const a=pi(i.font),r=gi(i.padding),l=i.align;let h=a.lineHeight/2;"bottom"===e||"center"===e||n(e)?(h+=r.bottom,s(i.text)&&(h+=a.lineHeight*(i.text.length-1))):h+=r.top;const{titleX:c,titleY:d,maxWidth:u,rotation:f}=function(t,e,i,s){const{top:o,left:a,bottom:r,right:l,chart:h}=t,{chartArea:c,scales:d}=h;let u,f,g,p=0;const m=r-o,b=l-a;if(t.isHorizontal()){if(f=ut(s,a,l),n(i)){const t=Object.keys(i)[0],s=i[t];g=d[t].getPixelForValue(s)+m-e}else g="center"===i?(c.bottom+c.top)/2+m-e:Ts(t,i,e);u=l-a}else{if(n(i)){const t=Object.keys(i)[0],s=i[t];f=d[t].getPixelForValue(s)-b+e}else f="center"===i?(c.left+c.right)/2-b+e:Ts(t,i,e);g=ut(s,r,o),p="left"===i?-L:L}return{titleX:f,titleY:g,maxWidth:u,rotation:p}}(this,h,e,l);Ae(t,i.text,0,0,a,{color:i.color,maxWidth:u,rotation:f,textAlign:zs(l,e,o),textBaseline:"middle",translation:[c,d]})}draw(t){this._isVisible()&&(this.drawBackground(),this.drawGrid(t),this.drawBorder(),this.drawTitle(),this.drawLabels(t))}_layers(){const t=this.options,e=t.ticks&&t.ticks.z||0,i=r(t.grid&&t.grid.z,-1);return this._isVisible()&&this.draw===Scale.prototype.draw?[{z:i,draw:t=>{this.drawBackground(),this.drawGrid(t),this.drawTitle()}},{z:i+1,draw:()=>{this.drawBorder()}},{z:e,draw:t=>{this.drawLabels(t)}}]:[{z:e,draw:t=>{this.draw(t)}}]}getMatchingVisibleMetas(t){const e=this.chart.getSortedVisibleDatasetMetas(),i=this.axis+"AxisID",s=[];let n,o;for(n=0,o=e.length;n<o;++n){const o=e[n];o[i]!==this.id||t&&o.type!==t||s.push(o)}return s}_resolveTickFontOptions(t){return pi(this.options.ticks.setContext(this.getContext(t)).font)}_maxDigits(){const t=this._resolveTickFontOptions(0).lineHeight;return(this.isHorizontal()?this.width:this.height)/t}}class TypedRegistry{constructor(t,e,i){this.type=t,this.scope=e,this.override=i,this.items=Object.create(null)}isForType(t){return Object.prototype.isPrototypeOf.call(this.type.prototype,t.prototype)}register(t){const e=Object.getPrototypeOf(t);let i;(function(t){return"id"in t&&"defaults"in t})(e)&&(i=this.register(e));const s=this.items,n=t.id,o=this.scope+"."+n;if(!n)throw new Error("class does not have id: "+t);return n in s||(s[n]=t,function(t,e,i){const s=m(Object.create(null),[i?se.get(i):{},se.get(e),t.defaults]);se.set(e,s),t.defaultRoutes&&function(t,e){Object.keys(e).forEach((i=>{const s=i.split("."),n=s.pop(),o=[t].concat(s).join("."),a=e[i].split("."),r=a.pop(),l=a.join(".");se.route(o,n,l,r)}))}(e,t.defaultRoutes);t.descriptors&&se.describe(e,t.descriptors)}(t,o,i),this.override&&se.override(t.id,t.overrides)),o}get(t){return this.items[t]}unregister(t){const e=this.items,i=t.id,s=this.scope;i in e&&delete e[i],s&&i in se[s]&&(delete se[s][i],this.override&&delete Qt[i])}}var Fs=new class Registry{constructor(){this.controllers=new TypedRegistry(DatasetController,"datasets",!0),this.elements=new TypedRegistry(Element,"elements"),this.plugins=new TypedRegistry(Object,"plugins"),this.scales=new TypedRegistry(Scale,"scales"),this._typedRegistries=[this.controllers,this.scales,this.elements]}add(...t){this._each("register",t)}remove(...t){this._each("unregister",t)}addControllers(...t){this._each("register",t,this.controllers)}addElements(...t){this._each("register",t,this.elements)}addPlugins(...t){this._each("register",t,this.plugins)}addScales(...t){this._each("register",t,this.scales)}getController(t){return this._get(t,this.controllers,"controller")}getElement(t){return this._get(t,this.elements,"element")}getPlugin(t){return this._get(t,this.plugins,"plugin")}getScale(t){return this._get(t,this.scales,"scale")}removeControllers(...t){this._each("unregister",t,this.controllers)}removeElements(...t){this._each("unregister",t,this.elements)}removePlugins(...t){this._each("unregister",t,this.plugins)}removeScales(...t){this._each("unregister",t,this.scales)}_each(t,e,i){[...e].forEach((e=>{const s=i||this._getRegistryForType(e);i||s.isForType(e)||s===this.plugins&&e.id?this._exec(t,s,e):d(e,(e=>{const s=i||this._getRegistryForType(e);this._exec(t,s,e)}))}))}_exec(t,e,i){const s=w(t);c(i["before"+s],[],i),e[t](i),c(i["after"+s],[],i)}_getRegistryForType(t){for(let e=0;e<this._typedRegistries.length;e++){const i=this._typedRegistries[e];if(i.isForType(t))return i}return this.plugins}_get(t,e,i){const s=e.get(t);if(void 0===s)throw new Error('"'+t+'" is not a registered '+i+".");return s}};class PluginService{constructor(){this._init=[]}notify(t,e,i,s){"beforeInit"===e&&(this._init=this._createDescriptors(t,!0),this._notify(this._init,t,"install"));const n=s?this._descriptors(t).filter(s):this._descriptors(t),o=this._notify(n,t,e,i);return"afterDestroy"===e&&(this._notify(n,t,"stop"),this._notify(this._init,t,"uninstall")),o}_notify(t,e,i,s){s=s||{};for(const n of t){const t=n.plugin;if(!1===c(t[i],[e,s,n.options],t)&&s.cancelable)return!1}return!0}invalidate(){i(this._cache)||(this._oldCache=this._cache,this._cache=void 0)}_descriptors(t){if(this._cache)return this._cache;const e=this._cache=this._createDescriptors(t);return this._notifyStateChanges(t),e}_createDescriptors(t,e){const i=t&&t.config,s=r(i.options&&i.options.plugins,{}),n=function(t){const e={},i=[],s=Object.keys(Fs.plugins.items);for(let o=0;o<s.length;o++)i.push(Fs.getPlugin(s[o]));const n=t.plugins||[];for(let o=0;o<n.length;o++){const t=n[o];-1===i.indexOf(t)&&(i.push(t),e[t.id]=!0)}return{plugins:i,localIds:e}}(i);return!1!==s||e?function(t,{plugins:e,localIds:i},s,n){const o=[],a=t.getContext();for(const r of e){const e=r.id,l=Bs(s[e],n);null!==l&&o.push({plugin:r,options:Vs(t.config,{plugin:r,local:i[e]},l,a)})}return o}(t,n,s,e):[]}_notifyStateChanges(t){const e=this._oldCache||[],i=this._cache,s=(t,e)=>t.filter((t=>!e.some((e=>t.plugin.id===e.plugin.id))));this._notify(s(e,i),t,"stop"),this._notify(s(i,e),t,"start")}}function Bs(t,e){return e||!1!==t?!0===t?{}:t:null}function Vs(t,{plugin:e,local:i},s,n){const o=t.pluginScopeKeys(e),a=t.getOptionScopes(s,o);return i&&e.defaults&&a.push(e.defaults),t.createResolver(a,n,[""],{scriptable:!1,indexable:!1,allKeys:!0})}function Ns(t,e){const i=se.datasets[t]||{};return((e.datasets||{})[t]||{}).indexAxis||e.indexAxis||i.indexAxis||"x"}function Ws(t,e){return"x"===t||"y"===t?t:e.axis||("top"===(i=e.position)||"bottom"===i?"x":"left"===i||"right"===i?"y":void 0)||t.charAt(0).toLowerCase();var i}function Hs(t){const e=t.options||(t.options={});e.plugins=r(e.plugins,{}),e.scales=function(t,e){const i=Qt[t.type]||{scales:{}},s=e.scales||{},o=Ns(t.type,e),a=Object.create(null),r=Object.create(null);return Object.keys(s).forEach((t=>{const e=s[t];if(!n(e))return console.error(`Invalid scale configuration for scale: ${t}`);if(e._proxy)return console.warn(`Ignoring resolver passed as options for scale: ${t}`);const l=Ws(t,e),h=function(t,e){return t===e?"_index_":"_value_"}(l,o),c=i.scales||{};a[l]=a[l]||t,r[t]=b(Object.create(null),[{axis:l},e,c[l],c[h]])})),t.data.datasets.forEach((i=>{const n=i.type||t.type,o=i.indexAxis||Ns(n,e),l=(Qt[n]||{}).scales||{};Object.keys(l).forEach((t=>{const e=function(t,e){let i=t;return"_index_"===t?i=e:"_value_"===t&&(i="x"===e?"y":"x"),i}(t,o),n=i[e+"AxisID"]||a[e]||e;r[n]=r[n]||Object.create(null),b(r[n],[{axis:e},s[n],l[t]])}))})),Object.keys(r).forEach((t=>{const e=r[t];b(e,[se.scales[e.type],se.scale])})),r}(t,e)}function js(t){return(t=t||{}).datasets=t.datasets||[],t.labels=t.labels||[],t}const $s=new Map,Ys=new Set;function Us(t,e){let i=$s.get(t);return i||(i=e(),$s.set(t,i),Ys.add(i)),i}const Xs=(t,e,i)=>{const s=y(e,i);void 0!==s&&t.add(s)};class Config{constructor(t){this._config=function(t){return(t=t||{}).data=js(t.data),Hs(t),t}(t),this._scopeCache=new Map,this._resolverCache=new Map}get platform(){return this._config.platform}get type(){return this._config.type}set type(t){this._config.type=t}get data(){return this._config.data}set data(t){this._config.data=js(t)}get options(){return this._config.options}set options(t){this._config.options=t}get plugins(){return this._config.plugins}update(){const t=this._config;this.clearCache(),Hs(t)}clearCache(){this._scopeCache.clear(),this._resolverCache.clear()}datasetScopeKeys(t){return Us(t,(()=>[[`datasets.${t}`,""]]))}datasetAnimationScopeKeys(t,e){return Us(`${t}.transition.${e}`,(()=>[[`datasets.${t}.transitions.${e}`,`transitions.${e}`],[`datasets.${t}`,""]]))}datasetElementScopeKeys(t,e){return Us(`${t}-${e}`,(()=>[[`datasets.${t}.elements.${e}`,`datasets.${t}`,`elements.${e}`,""]]))}pluginScopeKeys(t){const e=t.id;return Us(`${this.type}-plugin-${e}`,(()=>[[`plugins.${e}`,...t.additionalOptionScopes||[]]]))}_cachedScopes(t,e){const i=this._scopeCache;let s=i.get(t);return s&&!e||(s=new Map,i.set(t,s)),s}getOptionScopes(t,e,i){const{options:s,type:n}=this,o=this._cachedScopes(t,i),a=o.get(e);if(a)return a;const r=new Set;e.forEach((e=>{t&&(r.add(t),e.forEach((e=>Xs(r,t,e)))),e.forEach((t=>Xs(r,s,t))),e.forEach((t=>Xs(r,Qt[n]||{},t))),e.forEach((t=>Xs(r,se,t))),e.forEach((t=>Xs(r,te,t)))}));const l=Array.from(r);return 0===l.length&&l.push(Object.create(null)),Ys.has(e)&&o.set(e,l),l}chartOptionScopes(){const{options:t,type:e}=this;return[t,Qt[e]||{},se.datasets[e]||{},{type:e},se,te]}resolveNamedOptions(t,e,i,n=[""]){const o={$shared:!0},{resolver:a,subPrefixes:r}=qs(this._resolverCache,t,n);let l=a;if(function(t,e){const{isScriptable:i,isIndexable:n}=Re(t);for(const o of e){const e=i(o),a=n(o),r=(a||e)&&t[o];if(e&&(k(r)||Ks(r))||a&&s(r))return!0}return!1}(a,e)){o.$shared=!1;l=Ee(a,i=k(i)?i():i,this.createResolver(t,i,r))}for(const s of e)o[s]=l[s];return o}createResolver(t,e,i=[""],s){const{resolver:o}=qs(this._resolverCache,t,i);return n(e)?Ee(o,e,void 0,s):o}}function qs(t,e,i){let s=t.get(e);s||(s=new Map,t.set(e,s));const n=i.join();let o=s.get(n);if(!o){o={resolver:Le(e,i),subPrefixes:i.filter((t=>!t.toLowerCase().includes("hover")))},s.set(n,o)}return o}const Ks=t=>n(t)&&Object.getOwnPropertyNames(t).reduce(((e,i)=>e||k(t[i])),!1);const Gs=["top","bottom","left","right","chartArea"];function Zs(t,e){return"top"===t||"bottom"===t||-1===Gs.indexOf(t)&&"x"===e}function Js(t,e){return function(i,s){return i[t]===s[t]?i[e]-s[e]:i[t]-s[t]}}function Qs(t){const e=t.chart,i=e.options.animation;e.notifyPlugins("afterRender"),c(i&&i.onComplete,[t],e)}function tn(t){const e=t.chart,i=e.options.animation;c(i&&i.onProgress,[t],e)}function en(t){return ne()&&"string"==typeof t?t=document.getElementById(t):t&&t.length&&(t=t[0]),t&&t.canvas&&(t=t.canvas),t}const sn={},nn=t=>{const e=en(t);return Object.values(sn).filter((t=>t.canvas===e)).pop()};function on(t,e,i){const s=Object.keys(t);for(const n of s){const s=+n;if(s>=e){const o=t[n];delete t[n],(i>0||s>e)&&(t[s+i]=o)}}}class Chart{constructor(t,i){const s=this.config=new Config(i),n=en(t),o=nn(n);if(o)throw new Error("Canvas is already in use. Chart with ID '"+o.id+"' must be destroyed before the canvas with ID '"+o.canvas.id+"' can be reused.");const a=s.createResolver(s.chartOptionScopes(),this.getContext());this.platform=new(s.platform||ds(n)),this.platform.updateConfig(s);const r=this.platform.acquireContext(n,a.aspectRatio),l=r&&r.canvas,h=l&&l.height,c=l&&l.width;this.id=e(),this.ctx=r,this.canvas=l,this.width=c,this.height=h,this._options=a,this._aspectRatio=this.aspectRatio,this._layers=[],this._metasets=[],this._stacks=void 0,this.boxes=[],this.currentDevicePixelRatio=void 0,this.chartArea=void 0,this._active=[],this._lastEvent=void 0,this._listeners={},this._responsiveListeners=void 0,this._sortedMetasets=[],this.scales={},this._plugins=new PluginService,this.$proxies={},this._hiddenIndices={},this.attached=!1,this._animationsDisabled=void 0,this.$context=void 0,this._doResize=ct((t=>this.update(t)),a.resizeDelay||0),this._dataChanges=[],sn[this.id]=this,r&&l?(mt.listen(this,"complete",Qs),mt.listen(this,"progress",tn),this._initialize(),this.attached&&this.update()):console.error("Failed to create chart: can't acquire context from the given item")}get aspectRatio(){const{options:{aspectRatio:t,maintainAspectRatio:e},width:s,height:n,_aspectRatio:o}=this;return i(t)?e&&o?o:n?s/n:null:t}get data(){return this.config.data}set data(t){this.config.data=t}get options(){return this._options}set options(t){this.config.options=t}_initialize(){return this.notifyPlugins("beforeInit"),this.options.responsive?this.resize():ge(this,this.options.devicePixelRatio),this.bindEvents(),this.notifyPlugins("afterInit"),this}clear(){return ve(this.canvas,this.ctx),this}stop(){return mt.stop(this),this}resize(t,e){mt.running(this)?this._resizeBeforeDraw={width:t,height:e}:this._resize(t,e)}_resize(t,e){const i=this.options,s=this.canvas,n=i.maintainAspectRatio&&this.aspectRatio,o=this.platform.getMaximumSize(s,t,e,n),a=i.devicePixelRatio||this.platform.getDevicePixelRatio(),r=this.width?"resize":"attach";this.width=o.width,this.height=o.height,this._aspectRatio=this.aspectRatio,ge(this,a,!0)&&(this.notifyPlugins("resize",{size:o}),c(i.onResize,[this,o],this),this.attached&&this._doResize(r)&&this.render())}ensureScalesHaveIDs(){d(this.options.scales||{},((t,e)=>{t.id=e}))}buildOrUpdateScales(){const t=this.options,e=t.scales,i=this.scales,s=Object.keys(i).reduce(((t,e)=>(t[e]=!1,t)),{});let n=[];e&&(n=n.concat(Object.keys(e).map((t=>{const i=e[t],s=Ws(t,i),n="r"===s,o="x"===s;return{options:i,dposition:n?"chartArea":o?"bottom":"left",dtype:n?"radialLinear":o?"category":"linear"}})))),d(n,(e=>{const n=e.options,o=n.id,a=Ws(o,n),l=r(n.type,e.dtype);void 0!==n.position&&Zs(n.position,a)===Zs(e.dposition)||(n.position=e.dposition),s[o]=!0;let h=null;if(o in i&&i[o].type===l)h=i[o];else{h=new(Fs.getScale(l))({id:o,type:l,ctx:this.ctx,chart:this}),i[h.id]=h}h.init(n,t)})),d(s,((t,e)=>{t||delete i[e]})),d(i,(t=>{Gi.configure(this,t,t.options),Gi.addBox(this,t)}))}_updateMetasets(){const t=this._metasets,e=this.data.datasets.length,i=t.length;if(t.sort(((t,e)=>t.index-e.index)),i>e){for(let t=e;t<i;++t)this._destroyDatasetMeta(t);t.splice(e,i-e)}this._sortedMetasets=t.slice(0).sort(Js("order","index"))}_removeUnreferencedMetasets(){const{_metasets:t,data:{datasets:e}}=this;t.length>e.length&&delete this._stacks,t.forEach(((t,i)=>{0===e.filter((e=>e===t._dataset)).length&&this._destroyDatasetMeta(i)}))}buildOrUpdateControllers(){const t=[],e=this.data.datasets;let i,s;for(this._removeUnreferencedMetasets(),i=0,s=e.length;i<s;i++){const s=e[i];let n=this.getDatasetMeta(i);const o=s.type||this.config.type;if(n.type&&n.type!==o&&(this._destroyDatasetMeta(i),n=this.getDatasetMeta(i)),n.type=o,n.indexAxis=s.indexAxis||Ns(o,this.options),n.order=s.order||0,n.index=i,n.label=""+s.label,n.visible=this.isDatasetVisible(i),n.controller)n.controller.updateIndex(i),n.controller.linkScales();else{const e=Fs.getController(o),{datasetElementType:s,dataElementType:a}=se.datasets[o];Object.assign(e.prototype,{dataElementType:Fs.getElement(a),datasetElementType:s&&Fs.getElement(s)}),n.controller=new e(this,i),t.push(n.controller)}}return this._updateMetasets(),t}_resetElements(){d(this.data.datasets,((t,e)=>{this.getDatasetMeta(e).controller.reset()}),this)}reset(){this._resetElements(),this.notifyPlugins("reset")}update(t){const e=this.config;e.update();const i=this._options=e.createResolver(e.chartOptionScopes(),this.getContext()),s=this._animationsDisabled=!i.animation;if(this._updateScales(),this._checkEventBindings(),this._updateHiddenIndices(),this._plugins.invalidate(),!1===this.notifyPlugins("beforeUpdate",{mode:t,cancelable:!0}))return;const n=this.buildOrUpdateControllers();this.notifyPlugins("beforeElementsUpdate");let o=0;for(let l=0,h=this.data.datasets.length;l<h;l++){const{controller:t}=this.getDatasetMeta(l),e=!s&&-1===n.indexOf(t);t.buildOrUpdateElements(e),o=Math.max(+t.getMaxOverflow(),o)}o=this._minPadding=i.layout.autoPadding?o:0,this._updateLayout(o),s||d(n,(t=>{t.reset()})),this._updateDatasets(t),this.notifyPlugins("afterUpdate",{mode:t}),this._layers.sort(Js("z","_idx"));const{_active:a,_lastEvent:r}=this;r?this._eventHandler(r,!0):a.length&&this._updateHoverStyles(a,a,!0),this.render()}_updateScales(){d(this.scales,(t=>{Gi.removeBox(this,t)})),this.ensureScalesHaveIDs(),this.buildOrUpdateScales()}_checkEventBindings(){const t=this.options,e=new Set(Object.keys(this._listeners)),i=new Set(t.events);S(e,i)&&!!this._responsiveListeners===t.responsive||(this.unbindEvents(),this.bindEvents())}_updateHiddenIndices(){const{_hiddenIndices:t}=this,e=this._getUniformDataChanges()||[];for(const{method:i,start:s,count:n}of e){on(t,s,"_removeElements"===i?-n:n)}}_getUniformDataChanges(){const t=this._dataChanges;if(!t||!t.length)return;this._dataChanges=[];const e=this.data.datasets.length,i=e=>new Set(t.filter((t=>t[0]===e)).map(((t,e)=>e+","+t.splice(1).join(",")))),s=i(0);for(let n=1;n<e;n++)if(!S(s,i(n)))return;return Array.from(s).map((t=>t.split(","))).map((t=>({method:t[1],start:+t[2],count:+t[3]})))}_updateLayout(t){if(!1===this.notifyPlugins("beforeLayout",{cancelable:!0}))return;Gi.update(this,this.width,this.height,t);const e=this.chartArea,i=e.width<=0||e.height<=0;this._layers=[],d(this.boxes,(t=>{i&&"chartArea"===t.position||(t.configure&&t.configure(),this._layers.push(...t._layers()))}),this),this._layers.forEach(((t,e)=>{t._idx=e})),this.notifyPlugins("afterLayout")}_updateDatasets(t){if(!1!==this.notifyPlugins("beforeDatasetsUpdate",{mode:t,cancelable:!0})){for(let t=0,e=this.data.datasets.length;t<e;++t)this.getDatasetMeta(t).controller.configure();for(let e=0,i=this.data.datasets.length;e<i;++e)this._updateDataset(e,k(t)?t({datasetIndex:e}):t);this.notifyPlugins("afterDatasetsUpdate",{mode:t})}}_updateDataset(t,e){const i=this.getDatasetMeta(t),s={meta:i,index:t,mode:e,cancelable:!0};!1!==this.notifyPlugins("beforeDatasetUpdate",s)&&(i.controller._update(e),s.cancelable=!1,this.notifyPlugins("afterDatasetUpdate",s))}render(){!1!==this.notifyPlugins("beforeRender",{cancelable:!0})&&(mt.has(this)?this.attached&&!mt.running(this)&&mt.start(this):(this.draw(),Qs({chart:this})))}draw(){let t;if(this._resizeBeforeDraw){const{width:t,height:e}=this._resizeBeforeDraw;this._resize(t,e),this._resizeBeforeDraw=null}if(this.clear(),this.width<=0||this.height<=0)return;if(!1===this.notifyPlugins("beforeDraw",{cancelable:!0}))return;const e=this._layers;for(t=0;t<e.length&&e[t].z<=0;++t)e[t].draw(this.chartArea);for(this._drawDatasets();t<e.length;++t)e[t].draw(this.chartArea);this.notifyPlugins("afterDraw")}_getSortedDatasetMetas(t){const e=this._sortedMetasets,i=[];let s,n;for(s=0,n=e.length;s<n;++s){const n=e[s];t&&!n.visible||i.push(n)}return i}getSortedVisibleDatasetMetas(){return this._getSortedDatasetMetas(!0)}_drawDatasets(){if(!1===this.notifyPlugins("beforeDatasetsDraw",{cancelable:!0}))return;const t=this.getSortedVisibleDatasetMetas();for(let e=t.length-1;e>=0;--e)this._drawDataset(t[e]);this.notifyPlugins("afterDatasetsDraw")}_drawDataset(t){const e=this.ctx,i=t._clip,s=!i.disabled,n=this.chartArea,o={meta:t,index:t.index,cancelable:!0};!1!==this.notifyPlugins("beforeDatasetDraw",o)&&(s&&Se(e,{left:!1===i.left?0:n.left-i.left,right:!1===i.right?this.width:n.right+i.right,top:!1===i.top?0:n.top-i.top,bottom:!1===i.bottom?this.height:n.bottom+i.bottom}),t.controller.draw(),s&&Pe(e),o.cancelable=!1,this.notifyPlugins("afterDatasetDraw",o))}isPointInArea(t){return ke(t,this.chartArea,this._minPadding)}getElementsAtEventForMode(t,e,i,s){const n=Fi.modes[e];return"function"==typeof n?n(this,t,i,s):[]}getDatasetMeta(t){const e=this.data.datasets[t],i=this._metasets;let s=i.filter((t=>t&&t._dataset===e)).pop();return s||(s={type:null,data:[],dataset:null,controller:null,hidden:null,xAxisID:null,yAxisID:null,order:e&&e.order||0,index:t,_dataset:e,_parsed:[],_sorted:!1},i.push(s)),s}getContext(){return this.$context||(this.$context=xi(null,{chart:this,type:"chart"}))}getVisibleDatasetCount(){return this.getSortedVisibleDatasetMetas().length}isDatasetVisible(t){const e=this.data.datasets[t];if(!e)return!1;const i=this.getDatasetMeta(t);return"boolean"==typeof i.hidden?!i.hidden:!e.hidden}setDatasetVisibility(t,e){this.getDatasetMeta(t).hidden=!e}toggleDataVisibility(t){this._hiddenIndices[t]=!this._hiddenIndices[t]}getDataVisibility(t){return!this._hiddenIndices[t]}_updateVisibility(t,e,i){const s=i?"show":"hide",n=this.getDatasetMeta(t),o=n.controller._resolveAnimations(void 0,s);M(e)?(n.data[e].hidden=!i,this.update()):(this.setDatasetVisibility(t,i),o.update(n,{visible:i}),this.update((e=>e.datasetIndex===t?s:void 0)))}hide(t,e){this._updateVisibility(t,e,!1)}show(t,e){this._updateVisibility(t,e,!0)}_destroyDatasetMeta(t){const e=this._metasets[t];e&&e.controller&&e.controller._destroy(),delete this._metasets[t]}_stop(){let t,e;for(this.stop(),mt.remove(this),t=0,e=this.data.datasets.length;t<e;++t)this._destroyDatasetMeta(t)}destroy(){this.notifyPlugins("beforeDestroy");const{canvas:t,ctx:e}=this;this._stop(),this.config.clearCache(),t&&(this.unbindEvents(),ve(t,e),this.platform.releaseContext(e),this.canvas=null,this.ctx=null),this.notifyPlugins("destroy"),delete sn[this.id],this.notifyPlugins("afterDestroy")}toBase64Image(...t){return this.canvas.toDataURL(...t)}bindEvents(){this.bindUserEvents(),this.options.responsive?this.bindResponsiveEvents():this.attached=!0}bindUserEvents(){const t=this._listeners,e=this.platform,i=(i,s)=>{e.addEventListener(this,i,s),t[i]=s},s=(t,e,i)=>{t.offsetX=e,t.offsetY=i,this._eventHandler(t)};d(this.options.events,(t=>i(t,s)))}bindResponsiveEvents(){this._responsiveListeners||(this._responsiveListeners={});const t=this._responsiveListeners,e=this.platform,i=(i,s)=>{e.addEventListener(this,i,s),t[i]=s},s=(i,s)=>{t[i]&&(e.removeEventListener(this,i,s),delete t[i])},n=(t,e)=>{this.canvas&&this.resize(t,e)};let o;const a=()=>{s("attach",a),this.attached=!0,this.resize(),i("resize",n),i("detach",o)};o=()=>{this.attached=!1,s("resize",n),this._stop(),this._resize(0,0),i("attach",a)},e.isAttached(this.canvas)?a():o()}unbindEvents(){d(this._listeners,((t,e)=>{this.platform.removeEventListener(this,e,t)})),this._listeners={},d(this._responsiveListeners,((t,e)=>{this.platform.removeEventListener(this,e,t)})),this._responsiveListeners=void 0}updateHoverStyle(t,e,i){const s=i?"set":"remove";let n,o,a,r;for("dataset"===e&&(n=this.getDatasetMeta(t[0].datasetIndex),n.controller["_"+s+"DatasetHoverStyle"]()),a=0,r=t.length;a<r;++a){o=t[a];const e=o&&this.getDatasetMeta(o.datasetIndex).controller;e&&e[s+"HoverStyle"](o.element,o.datasetIndex,o.index)}}getActiveElements(){return this._active||[]}setActiveElements(t){const e=this._active||[],i=t.map((({datasetIndex:t,index:e})=>{const i=this.getDatasetMeta(t);if(!i)throw new Error("No dataset found at index "+t);return{datasetIndex:t,element:i.data[e],index:e}}));!u(i,e)&&(this._active=i,this._lastEvent=null,this._updateHoverStyles(i,e))}notifyPlugins(t,e,i){return this._plugins.notify(this,t,e,i)}_updateHoverStyles(t,e,i){const s=this.options.hover,n=(t,e)=>t.filter((t=>!e.some((e=>t.datasetIndex===e.datasetIndex&&t.index===e.index)))),o=n(e,t),a=i?t:n(t,e);o.length&&this.updateHoverStyle(o,s.mode,!1),a.length&&s.mode&&this.updateHoverStyle(a,s.mode,!0)}_eventHandler(t,e){const i={event:t,replay:e,cancelable:!0,inChartArea:this.isPointInArea(t)},s=e=>(e.options.events||this.options.events).includes(t.native.type);if(!1===this.notifyPlugins("beforeEvent",i,s))return;const n=this._handleEvent(t,e,i.inChartArea);return i.cancelable=!1,this.notifyPlugins("afterEvent",i,s),(n||i.changed)&&this.render(),this}_handleEvent(t,e,i){const{_active:s=[],options:n}=this,o=e,a=this._getActiveElements(t,s,i,o),r=P(t),l=function(t,e,i,s){return i&&"mouseout"!==t.type?s?e:t:null}(t,this._lastEvent,i,r);i&&(this._lastEvent=null,c(n.onHover,[t,a,this],this),r&&c(n.onClick,[t,a,this],this));const h=!u(a,s);return(h||e)&&(this._active=a,this._updateHoverStyles(a,s,e)),this._lastEvent=l,h}_getActiveElements(t,e,i,s){if("mouseout"===t.type)return[];if(!i)return e;const n=this.options.hover;return this.getElementsAtEventForMode(t,n.mode,n,s)}}const an=()=>d(Chart.instances,(t=>t._plugins.invalidate())),rn=!0;function ln(){throw new Error("This method is not implemented: Check that a complete date adapter is provided.")}Object.defineProperties(Chart,{defaults:{enumerable:rn,value:se},instances:{enumerable:rn,value:sn},overrides:{enumerable:rn,value:Qt},registry:{enumerable:rn,value:Fs},version:{enumerable:rn,value:"3.9.1"},getChart:{enumerable:rn,value:nn},register:{enumerable:rn,value:(...t)=>{Fs.add(...t),an()}},unregister:{enumerable:rn,value:(...t)=>{Fs.remove(...t),an()}}});class DateAdapter{constructor(t){this.options=t||{}}init(t){}formats(){return ln()}parse(t,e){return ln()}format(t,e){return ln()}add(t,e,i){return ln()}diff(t,e,i){return ln()}startOf(t,e,i){return ln()}endOf(t,e){return ln()}}DateAdapter.override=function(t){Object.assign(DateAdapter.prototype,t)};var hn={_date:DateAdapter};function cn(t){const e=t.iScale,i=function(t,e){if(!t._cache.$bar){const i=t.getMatchingVisibleMetas(e);let s=[];for(let e=0,n=i.length;e<n;e++)s=s.concat(i[e].controller.getAllParsedValues(t));t._cache.$bar=rt(s.sort(((t,e)=>t-e)))}return t._cache.$bar}(e,t.type);let s,n,o,a,r=e._length;const l=()=>{32767!==o&&-32768!==o&&(M(a)&&(r=Math.min(r,Math.abs(o-a)||r)),a=o)};for(s=0,n=i.length;s<n;++s)o=e.getPixelForValue(i[s]),l();for(a=void 0,s=0,n=e.ticks.length;s<n;++s)o=e.getPixelForTick(s),l();return r}function dn(t,e,i,n){return s(t)?function(t,e,i,s){const n=i.parse(t[0],s),o=i.parse(t[1],s),a=Math.min(n,o),r=Math.max(n,o);let l=a,h=r;Math.abs(a)>Math.abs(r)&&(l=r,h=a),e[i.axis]=h,e._custom={barStart:l,barEnd:h,start:n,end:o,min:a,max:r}}(t,e,i,n):e[i.axis]=i.parse(t,n),e}function un(t,e,i,s){const n=t.iScale,o=t.vScale,a=n.getLabels(),r=n===o,l=[];let h,c,d,u;for(h=i,c=i+s;h<c;++h)u=e[h],d={},d[n.axis]=r||n.parse(a[h],h),l.push(dn(u,d,o,h));return l}function fn(t){return t&&void 0!==t.barStart&&void 0!==t.barEnd}function gn(t,e,i,s){let n=e.borderSkipped;const o={};if(!n)return void(t.borderSkipped=o);if(!0===n)return void(t.borderSkipped={top:!0,right:!0,bottom:!0,left:!0});const{start:a,end:r,reverse:l,top:h,bottom:c}=function(t){let e,i,s,n,o;return t.horizontal?(e=t.base>t.x,i="left",s="right"):(e=t.base<t.y,i="bottom",s="top"),e?(n="end",o="start"):(n="start",o="end"),{start:i,end:s,reverse:e,top:n,bottom:o}}(t);"middle"===n&&i&&(t.enableBorderRadius=!0,(i._top||0)===s?n=h:(i._bottom||0)===s?n=c:(o[pn(c,a,r,l)]=!0,n=h)),o[pn(n,a,r,l)]=!0,t.borderSkipped=o}function pn(t,e,i,s){var n,o,a;return s?(a=i,t=mn(t=(n=t)===(o=e)?a:n===a?o:n,i,e)):t=mn(t,e,i),t}function mn(t,e,i){return"start"===t?e:"end"===t?i:t}function bn(t,{inflateAmount:e},i){t.inflateAmount="auto"===e?1===i?.33:0:e}class BarController extends DatasetController{parsePrimitiveData(t,e,i,s){return un(t,e,i,s)}parseArrayData(t,e,i,s){return un(t,e,i,s)}parseObjectData(t,e,i,s){const{iScale:n,vScale:o}=t,{xAxisKey:a="x",yAxisKey:r="y"}=this._parsing,l="x"===n.axis?a:r,h="x"===o.axis?a:r,c=[];let d,u,f,g;for(d=i,u=i+s;d<u;++d)g=e[d],f={},f[n.axis]=n.parse(y(g,l),d),c.push(dn(y(g,h),f,o,d));return c}updateRangeFromParsed(t,e,i,s){super.updateRangeFromParsed(t,e,i,s);const n=i._custom;n&&e===this._cachedMeta.vScale&&(t.min=Math.min(t.min,n.min),t.max=Math.max(t.max,n.max))}getMaxOverflow(){return 0}getLabelAndValue(t){const e=this._cachedMeta,{iScale:i,vScale:s}=e,n=this.getParsed(t),o=n._custom,a=fn(o)?"["+o.start+", "+o.end+"]":""+s.getLabelForValue(n[s.axis]);return{label:""+i.getLabelForValue(n[i.axis]),value:a}}initialize(){this.enableOptionSharing=!0,super.initialize();this._cachedMeta.stack=this.getDataset().stack}update(t){const e=this._cachedMeta;this.updateElements(e.data,0,e.data.length,t)}updateElements(t,e,s,n){const o="reset"===n,{index:a,_cachedMeta:{vScale:r}}=this,l=r.getBasePixel(),h=r.isHorizontal(),c=this._getRuler(),{sharedOptions:d,includeOptions:u}=this._getSharedOptions(e,n);for(let f=e;f<e+s;f++){const e=this.getParsed(f),s=o||i(e[r.axis])?{base:l,head:l}:this._calculateBarValuePixels(f),g=this._calculateBarIndexPixels(f,c),p=(e._stacks||{})[r.axis],m={horizontal:h,base:s.base,enableBorderRadius:!p||fn(e._custom)||a===p._top||a===p._bottom,x:h?s.head:g.center,y:h?g.center:s.head,height:h?g.size:Math.abs(s.size),width:h?Math.abs(s.size):g.size};u&&(m.options=d||this.resolveDataElementOptions(f,t[f].active?"active":n));const b=m.options||t[f].options;gn(m,b,p,a),bn(m,b,c.ratio),this.updateElement(t[f],f,m,n)}}_getStacks(t,e){const{iScale:s}=this._cachedMeta,n=s.getMatchingVisibleMetas(this._type).filter((t=>t.controller.options.grouped)),o=s.options.stacked,a=[],r=t=>{const s=t.controller.getParsed(e),n=s&&s[t.vScale.axis];if(i(n)||isNaN(n))return!0};for(const i of n)if((void 0===e||!r(i))&&((!1===o||-1===a.indexOf(i.stack)||void 0===o&&void 0===i.stack)&&a.push(i.stack),i.index===t))break;return a.length||a.push(void 0),a}_getStackCount(t){return this._getStacks(void 0,t).length}_getStackIndex(t,e,i){const s=this._getStacks(t,i),n=void 0!==e?s.indexOf(e):-1;return-1===n?s.length-1:n}_getRuler(){const t=this.options,e=this._cachedMeta,i=e.iScale,s=[];let n,o;for(n=0,o=e.data.length;n<o;++n)s.push(i.getPixelForValue(this.getParsed(n)[i.axis],n));const a=t.barThickness;return{min:a||cn(e),pixels:s,start:i._startPixel,end:i._endPixel,stackCount:this._getStackCount(),scale:i,grouped:t.grouped,ratio:a?1:t.categoryPercentage*t.barPercentage}}_calculateBarValuePixels(t){const{_cachedMeta:{vScale:e,_stacked:s},options:{base:n,minBarLength:o}}=this,a=n||0,r=this.getParsed(t),l=r._custom,h=fn(l);let c,d,u=r[e.axis],f=0,g=s?this.applyStack(e,r,s):u;g!==u&&(f=g-u,g=u),h&&(u=l.barStart,g=l.barEnd-l.barStart,0!==u&&z(u)!==z(l.barEnd)&&(f=0),f+=u);const p=i(n)||h?f:n;let m=e.getPixelForValue(p);if(c=this.chart.getDataVisibility(t)?e.getPixelForValue(f+g):m,d=c-m,Math.abs(d)<o){d=function(t,e,i){return 0!==t?z(t):(e.isHorizontal()?1:-1)*(e.min>=i?1:-1)}(d,e,a)*o,u===a&&(m-=d/2);const t=e.getPixelForDecimal(0),i=e.getPixelForDecimal(1),s=Math.min(t,i),n=Math.max(t,i);m=Math.max(Math.min(m,n),s),c=m+d}if(m===e.getPixelForValue(a)){const t=z(d)*e.getLineWidthForValue(a)/2;m+=t,d-=t}return{size:d,base:m,head:c,center:c+d/2}}_calculateBarIndexPixels(t,e){const s=e.scale,n=this.options,o=n.skipNull,a=r(n.maxBarThickness,1/0);let l,h;if(e.grouped){const s=o?this._getStackCount(t):e.stackCount,r="flex"===n.barThickness?function(t,e,i,s){const n=e.pixels,o=n[t];let a=t>0?n[t-1]:null,r=t<n.length-1?n[t+1]:null;const l=i.categoryPercentage;null===a&&(a=o-(null===r?e.end-e.start:r-o)),null===r&&(r=o+o-a);const h=o-(o-Math.min(a,r))/2*l;return{chunk:Math.abs(r-a)/2*l/s,ratio:i.barPercentage,start:h}}(t,e,n,s):function(t,e,s,n){const o=s.barThickness;let a,r;return i(o)?(a=e.min*s.categoryPercentage,r=s.barPercentage):(a=o*n,r=1),{chunk:a/n,ratio:r,start:e.pixels[t]-a/2}}(t,e,n,s),c=this._getStackIndex(this.index,this._cachedMeta.stack,o?t:void 0);l=r.start+r.chunk*c+r.chunk/2,h=Math.min(a,r.chunk*r.ratio)}else l=s.getPixelForValue(this.getParsed(t)[s.axis],t),h=Math.min(a,e.min*e.ratio);return{base:l-h/2,head:l+h/2,center:l,size:h}}draw(){const t=this._cachedMeta,e=t.vScale,i=t.data,s=i.length;let n=0;for(;n<s;++n)null!==this.getParsed(n)[e.axis]&&i[n].draw(this._ctx)}}BarController.id="bar",BarController.defaults={datasetElementType:!1,dataElementType:"bar",categoryPercentage:.8,barPercentage:.9,grouped:!0,animations:{numbers:{type:"number",properties:["x","y","base","width","height"]}}},BarController.overrides={scales:{_index_:{type:"category",offset:!0,grid:{offset:!0}},_value_:{type:"linear",beginAtZero:!0}}};class BubbleController extends DatasetController{initialize(){this.enableOptionSharing=!0,super.initialize()}parsePrimitiveData(t,e,i,s){const n=super.parsePrimitiveData(t,e,i,s);for(let o=0;o<n.length;o++)n[o]._custom=this.resolveDataElementOptions(o+i).radius;return n}parseArrayData(t,e,i,s){const n=super.parseArrayData(t,e,i,s);for(let o=0;o<n.length;o++){const t=e[i+o];n[o]._custom=r(t[2],this.resolveDataElementOptions(o+i).radius)}return n}parseObjectData(t,e,i,s){const n=super.parseObjectData(t,e,i,s);for(let o=0;o<n.length;o++){const t=e[i+o];n[o]._custom=r(t&&t.r&&+t.r,this.resolveDataElementOptions(o+i).radius)}return n}getMaxOverflow(){const t=this._cachedMeta.data;let e=0;for(let i=t.length-1;i>=0;--i)e=Math.max(e,t[i].size(this.resolveDataElementOptions(i))/2);return e>0&&e}getLabelAndValue(t){const e=this._cachedMeta,{xScale:i,yScale:s}=e,n=this.getParsed(t),o=i.getLabelForValue(n.x),a=s.getLabelForValue(n.y),r=n._custom;return{label:e.label,value:"("+o+", "+a+(r?", "+r:"")+")"}}update(t){const e=this._cachedMeta.data;this.updateElements(e,0,e.length,t)}updateElements(t,e,i,s){const n="reset"===s,{iScale:o,vScale:a}=this._cachedMeta,{sharedOptions:r,includeOptions:l}=this._getSharedOptions(e,s),h=o.axis,c=a.axis;for(let d=e;d<e+i;d++){const e=t[d],i=!n&&this.getParsed(d),u={},f=u[h]=n?o.getPixelForDecimal(.5):o.getPixelForValue(i[h]),g=u[c]=n?a.getBasePixel():a.getPixelForValue(i[c]);u.skip=isNaN(f)||isNaN(g),l&&(u.options=r||this.resolveDataElementOptions(d,e.active?"active":s),n&&(u.options.radius=0)),this.updateElement(e,d,u,s)}}resolveDataElementOptions(t,e){const i=this.getParsed(t);let s=super.resolveDataElementOptions(t,e);s.$shared&&(s=Object.assign({},s,{$shared:!1}));const n=s.radius;return"active"!==e&&(s.radius=0),s.radius+=r(i&&i._custom,n),s}}BubbleController.id="bubble",BubbleController.defaults={datasetElementType:!1,dataElementType:"point",animations:{numbers:{type:"number",properties:["x","y","borderWidth","radius"]}}},BubbleController.overrides={scales:{x:{type:"linear"},y:{type:"linear"}},plugins:{tooltip:{callbacks:{title:()=>""}}}};class DoughnutController extends DatasetController{constructor(t,e){super(t,e),this.enableOptionSharing=!0,this.innerRadius=void 0,this.outerRadius=void 0,this.offsetX=void 0,this.offsetY=void 0}linkScales(){}parse(t,e){const i=this.getDataset().data,s=this._cachedMeta;if(!1===this._parsing)s._parsed=i;else{let o,a,r=t=>+i[t];if(n(i[t])){const{key:t="value"}=this._parsing;r=e=>+y(i[e],t)}for(o=t,a=t+e;o<a;++o)s._parsed[o]=r(o)}}_getRotation(){return j(this.options.rotation-90)}_getCircumference(){return j(this.options.circumference)}_getRotationExtents(){let t=D,e=-D;for(let i=0;i<this.chart.data.datasets.length;++i)if(this.chart.isDatasetVisible(i)){const s=this.chart.getDatasetMeta(i).controller,n=s._getRotation(),o=s._getCircumference();t=Math.min(t,n),e=Math.max(e,n+o)}return{rotation:t,circumference:e-t}}update(t){const e=this.chart,{chartArea:i}=e,s=this._cachedMeta,n=s.data,o=this.getMaxBorderWidth()+this.getMaxOffset(n)+this.options.spacing,a=Math.max((Math.min(i.width,i.height)-o)/2,0),r=Math.min(l(this.options.cutout,a),1),c=this._getRingWeight(this.index),{circumference:d,rotation:u}=this._getRotationExtents(),{ratioX:f,ratioY:g,offsetX:p,offsetY:m}=function(t,e,i){let s=1,n=1,o=0,a=0;if(e<D){const r=t,l=r+e,h=Math.cos(r),c=Math.sin(r),d=Math.cos(l),u=Math.sin(l),f=(t,e,s)=>G(t,r,l,!0)?1:Math.max(e,e*i,s,s*i),g=(t,e,s)=>G(t,r,l,!0)?-1:Math.min(e,e*i,s,s*i),p=f(0,h,d),m=f(L,c,u),b=g(C,h,d),x=g(C+L,c,u);s=(p-b)/2,n=(m-x)/2,o=-(p+b)/2,a=-(m+x)/2}return{ratioX:s,ratioY:n,offsetX:o,offsetY:a}}(u,d,r),b=(i.width-o)/f,x=(i.height-o)/g,_=Math.max(Math.min(b,x)/2,0),y=h(this.options.radius,_),v=(y-Math.max(y*r,0))/this._getVisibleDatasetWeightTotal();this.offsetX=p*y,this.offsetY=m*y,s.total=this.calculateTotal(),this.outerRadius=y-v*this._getRingWeightOffset(this.index),this.innerRadius=Math.max(this.outerRadius-v*c,0),this.updateElements(n,0,n.length,t)}_circumference(t,e){const i=this.options,s=this._cachedMeta,n=this._getCircumference();return e&&i.animation.animateRotate||!this.chart.getDataVisibility(t)||null===s._parsed[t]||s.data[t].hidden?0:this.calculateCircumference(s._parsed[t]*n/D)}updateElements(t,e,i,s){const n="reset"===s,o=this.chart,a=o.chartArea,r=o.options.animation,l=(a.left+a.right)/2,h=(a.top+a.bottom)/2,c=n&&r.animateScale,d=c?0:this.innerRadius,u=c?0:this.outerRadius,{sharedOptions:f,includeOptions:g}=this._getSharedOptions(e,s);let p,m=this._getRotation();for(p=0;p<e;++p)m+=this._circumference(p,n);for(p=e;p<e+i;++p){const e=this._circumference(p,n),i=t[p],o={x:l+this.offsetX,y:h+this.offsetY,startAngle:m,endAngle:m+e,circumference:e,outerRadius:u,innerRadius:d};g&&(o.options=f||this.resolveDataElementOptions(p,i.active?"active":s)),m+=e,this.updateElement(i,p,o,s)}}calculateTotal(){const t=this._cachedMeta,e=t.data;let i,s=0;for(i=0;i<e.length;i++){const n=t._parsed[i];null===n||isNaN(n)||!this.chart.getDataVisibility(i)||e[i].hidden||(s+=Math.abs(n))}return s}calculateCircumference(t){const e=this._cachedMeta.total;return e>0&&!isNaN(t)?D*(Math.abs(t)/e):0}getLabelAndValue(t){const e=this._cachedMeta,i=this.chart,s=i.data.labels||[],n=ri(e._parsed[t],i.options.locale);return{label:s[t]||"",value:n}}getMaxBorderWidth(t){let e=0;const i=this.chart;let s,n,o,a,r;if(!t)for(s=0,n=i.data.datasets.length;s<n;++s)if(i.isDatasetVisible(s)){o=i.getDatasetMeta(s),t=o.data,a=o.controller;break}if(!t)return 0;for(s=0,n=t.length;s<n;++s)r=a.resolveDataElementOptions(s),"inner"!==r.borderAlign&&(e=Math.max(e,r.borderWidth||0,r.hoverBorderWidth||0));return e}getMaxOffset(t){let e=0;for(let i=0,s=t.length;i<s;++i){const t=this.resolveDataElementOptions(i);e=Math.max(e,t.offset||0,t.hoverOffset||0)}return e}_getRingWeightOffset(t){let e=0;for(let i=0;i<t;++i)this.chart.isDatasetVisible(i)&&(e+=this._getRingWeight(i));return e}_getRingWeight(t){return Math.max(r(this.chart.data.datasets[t].weight,1),0)}_getVisibleDatasetWeightTotal(){return this._getRingWeightOffset(this.chart.data.datasets.length)||1}}DoughnutController.id="doughnut",DoughnutController.defaults={datasetElementType:!1,dataElementType:"arc",animation:{animateRotate:!0,animateScale:!1},animations:{numbers:{type:"number",properties:["circumference","endAngle","innerRadius","outerRadius","startAngle","x","y","offset","borderWidth","spacing"]}},cutout:"50%",rotation:0,circumference:360,radius:"100%",spacing:0,indexAxis:"r"},DoughnutController.descriptors={_scriptable:t=>"spacing"!==t,_indexable:t=>"spacing"!==t},DoughnutController.overrides={aspectRatio:1,plugins:{legend:{labels:{generateLabels(t){const e=t.data;if(e.labels.length&&e.datasets.length){const{labels:{pointStyle:i}}=t.legend.options;return e.labels.map(((e,s)=>{const n=t.getDatasetMeta(0).controller.getStyle(s);return{text:e,fillStyle:n.backgroundColor,strokeStyle:n.borderColor,lineWidth:n.borderWidth,pointStyle:i,hidden:!t.getDataVisibility(s),index:s}}))}return[]}},onClick(t,e,i){i.chart.toggleDataVisibility(e.index),i.chart.update()}},tooltip:{callbacks:{title:()=>"",label(t){let e=t.label;const i=": "+t.formattedValue;return s(e)?(e=e.slice(),e[0]+=i):e+=i,e}}}}};class LineController extends DatasetController{initialize(){this.enableOptionSharing=!0,this.supportsDecimation=!0,super.initialize()}update(t){const e=this._cachedMeta,{dataset:i,data:s=[],_dataset:n}=e,o=this.chart._animationsDisabled;let{start:a,count:r}=gt(e,s,o);this._drawStart=a,this._drawCount=r,pt(e)&&(a=0,r=s.length),i._chart=this.chart,i._datasetIndex=this.index,i._decimated=!!n._decimated,i.points=s;const l=this.resolveDatasetElementOptions(t);this.options.showLine||(l.borderWidth=0),l.segment=this.options.segment,this.updateElement(i,void 0,{animated:!o,options:l},t),this.updateElements(s,a,r,t)}updateElements(t,e,s,n){const o="reset"===n,{iScale:a,vScale:r,_stacked:l,_dataset:h}=this._cachedMeta,{sharedOptions:c,includeOptions:d}=this._getSharedOptions(e,n),u=a.axis,f=r.axis,{spanGaps:g,segment:p}=this.options,m=V(g)?g:Number.POSITIVE_INFINITY,b=this.chart._animationsDisabled||o||"none"===n;let x=e>0&&this.getParsed(e-1);for(let _=e;_<e+s;++_){const e=t[_],s=this.getParsed(_),g=b?e:{},y=i(s[f]),v=g[u]=a.getPixelForValue(s[u],_),w=g[f]=o||y?r.getBasePixel():r.getPixelForValue(l?this.applyStack(r,s,l):s[f],_);g.skip=isNaN(v)||isNaN(w)||y,g.stop=_>0&&Math.abs(s[u]-x[u])>m,p&&(g.parsed=s,g.raw=h.data[_]),d&&(g.options=c||this.resolveDataElementOptions(_,e.active?"active":n)),b||this.updateElement(e,_,g,n),x=s}}getMaxOverflow(){const t=this._cachedMeta,e=t.dataset,i=e.options&&e.options.borderWidth||0,s=t.data||[];if(!s.length)return i;const n=s[0].size(this.resolveDataElementOptions(0)),o=s[s.length-1].size(this.resolveDataElementOptions(s.length-1));return Math.max(i,n,o)/2}draw(){const t=this._cachedMeta;t.dataset.updateControlPoints(this.chart.chartArea,t.iScale.axis),super.draw()}}LineController.id="line",LineController.defaults={datasetElementType:"line",dataElementType:"point",showLine:!0,spanGaps:!1},LineController.overrides={scales:{_index_:{type:"category"},_value_:{type:"linear"}}};class PolarAreaController extends DatasetController{constructor(t,e){super(t,e),this.innerRadius=void 0,this.outerRadius=void 0}getLabelAndValue(t){const e=this._cachedMeta,i=this.chart,s=i.data.labels||[],n=ri(e._parsed[t].r,i.options.locale);return{label:s[t]||"",value:n}}parseObjectData(t,e,i,s){return Ye.bind(this)(t,e,i,s)}update(t){const e=this._cachedMeta.data;this._updateRadius(),this.updateElements(e,0,e.length,t)}getMinMax(){const t=this._cachedMeta,e={min:Number.POSITIVE_INFINITY,max:Number.NEGATIVE_INFINITY};return t.data.forEach(((t,i)=>{const s=this.getParsed(i).r;!isNaN(s)&&this.chart.getDataVisibility(i)&&(s<e.min&&(e.min=s),s>e.max&&(e.max=s))})),e}_updateRadius(){const t=this.chart,e=t.chartArea,i=t.options,s=Math.min(e.right-e.left,e.bottom-e.top),n=Math.max(s/2,0),o=(n-Math.max(i.cutoutPercentage?n/100*i.cutoutPercentage:1,0))/t.getVisibleDatasetCount();this.outerRadius=n-o*this.index,this.innerRadius=this.outerRadius-o}updateElements(t,e,i,s){const n="reset"===s,o=this.chart,a=o.options.animation,r=this._cachedMeta.rScale,l=r.xCenter,h=r.yCenter,c=r.getIndexAngle(0)-.5*C;let d,u=c;const f=360/this.countVisibleElements();for(d=0;d<e;++d)u+=this._computeAngle(d,s,f);for(d=e;d<e+i;d++){const e=t[d];let i=u,g=u+this._computeAngle(d,s,f),p=o.getDataVisibility(d)?r.getDistanceFromCenterForValue(this.getParsed(d).r):0;u=g,n&&(a.animateScale&&(p=0),a.animateRotate&&(i=g=c));const m={x:l,y:h,innerRadius:0,outerRadius:p,startAngle:i,endAngle:g,options:this.resolveDataElementOptions(d,e.active?"active":s)};this.updateElement(e,d,m,s)}}countVisibleElements(){const t=this._cachedMeta;let e=0;return t.data.forEach(((t,i)=>{!isNaN(this.getParsed(i).r)&&this.chart.getDataVisibility(i)&&e++})),e}_computeAngle(t,e,i){return this.chart.getDataVisibility(t)?j(this.resolveDataElementOptions(t,e).angle||i):0}}PolarAreaController.id="polarArea",PolarAreaController.defaults={dataElementType:"arc",animation:{animateRotate:!0,animateScale:!0},animations:{numbers:{type:"number",properties:["x","y","startAngle","endAngle","innerRadius","outerRadius"]}},indexAxis:"r",startAngle:0},PolarAreaController.overrides={aspectRatio:1,plugins:{legend:{labels:{generateLabels(t){const e=t.data;if(e.labels.length&&e.datasets.length){const{labels:{pointStyle:i}}=t.legend.options;return e.labels.map(((e,s)=>{const n=t.getDatasetMeta(0).controller.getStyle(s);return{text:e,fillStyle:n.backgroundColor,strokeStyle:n.borderColor,lineWidth:n.borderWidth,pointStyle:i,hidden:!t.getDataVisibility(s),index:s}}))}return[]}},onClick(t,e,i){i.chart.toggleDataVisibility(e.index),i.chart.update()}},tooltip:{callbacks:{title:()=>"",label:t=>t.chart.data.labels[t.dataIndex]+": "+t.formattedValue}}},scales:{r:{type:"radialLinear",angleLines:{display:!1},beginAtZero:!0,grid:{circular:!0},pointLabels:{display:!1},startAngle:0}}};class PieController extends DoughnutController{}PieController.id="pie",PieController.defaults={cutout:0,rotation:0,circumference:360,radius:"100%"};class RadarController extends DatasetController{getLabelAndValue(t){const e=this._cachedMeta.vScale,i=this.getParsed(t);return{label:e.getLabels()[t],value:""+e.getLabelForValue(i[e.axis])}}parseObjectData(t,e,i,s){return Ye.bind(this)(t,e,i,s)}update(t){const e=this._cachedMeta,i=e.dataset,s=e.data||[],n=e.iScale.getLabels();if(i.points=s,"resize"!==t){const e=this.resolveDatasetElementOptions(t);this.options.showLine||(e.borderWidth=0);const o={_loop:!0,_fullLoop:n.length===s.length,options:e};this.updateElement(i,void 0,o,t)}this.updateElements(s,0,s.length,t)}updateElements(t,e,i,s){const n=this._cachedMeta.rScale,o="reset"===s;for(let a=e;a<e+i;a++){const e=t[a],i=this.resolveDataElementOptions(a,e.active?"active":s),r=n.getPointPositionForValue(a,this.getParsed(a).r),l=o?n.xCenter:r.x,h=o?n.yCenter:r.y,c={x:l,y:h,angle:r.angle,skip:isNaN(l)||isNaN(h),options:i};this.updateElement(e,a,c,s)}}}RadarController.id="radar",RadarController.defaults={datasetElementType:"line",dataElementType:"point",indexAxis:"r",showLine:!0,elements:{line:{fill:"start"}}},RadarController.overrides={aspectRatio:1,scales:{r:{type:"radialLinear"}}};class ScatterController extends DatasetController{update(t){const e=this._cachedMeta,{data:i=[]}=e,s=this.chart._animationsDisabled;let{start:n,count:o}=gt(e,i,s);if(this._drawStart=n,this._drawCount=o,pt(e)&&(n=0,o=i.length),this.options.showLine){const{dataset:n,_dataset:o}=e;n._chart=this.chart,n._datasetIndex=this.index,n._decimated=!!o._decimated,n.points=i;const a=this.resolveDatasetElementOptions(t);a.segment=this.options.segment,this.updateElement(n,void 0,{animated:!s,options:a},t)}this.updateElements(i,n,o,t)}addElements(){const{showLine:t}=this.options;!this.datasetElementType&&t&&(this.datasetElementType=Fs.getElement("line")),super.addElements()}updateElements(t,e,s,n){const o="reset"===n,{iScale:a,vScale:r,_stacked:l,_dataset:h}=this._cachedMeta,c=this.resolveDataElementOptions(e,n),d=this.getSharedOptions(c),u=this.includeOptions(n,d),f=a.axis,g=r.axis,{spanGaps:p,segment:m}=this.options,b=V(p)?p:Number.POSITIVE_INFINITY,x=this.chart._animationsDisabled||o||"none"===n;let _=e>0&&this.getParsed(e-1);for(let y=e;y<e+s;++y){const e=t[y],s=this.getParsed(y),c=x?e:{},p=i(s[g]),v=c[f]=a.getPixelForValue(s[f],y),w=c[g]=o||p?r.getBasePixel():r.getPixelForValue(l?this.applyStack(r,s,l):s[g],y);c.skip=isNaN(v)||isNaN(w)||p,c.stop=y>0&&Math.abs(s[f]-_[f])>b,m&&(c.parsed=s,c.raw=h.data[y]),u&&(c.options=d||this.resolveDataElementOptions(y,e.active?"active":n)),x||this.updateElement(e,y,c,n),_=s}this.updateSharedOptions(d,n,c)}getMaxOverflow(){const t=this._cachedMeta,e=t.data||[];if(!this.options.showLine){let t=0;for(let i=e.length-1;i>=0;--i)t=Math.max(t,e[i].size(this.resolveDataElementOptions(i))/2);return t>0&&t}const i=t.dataset,s=i.options&&i.options.borderWidth||0;if(!e.length)return s;const n=e[0].size(this.resolveDataElementOptions(0)),o=e[e.length-1].size(this.resolveDataElementOptions(e.length-1));return Math.max(s,n,o)/2}}ScatterController.id="scatter",ScatterController.defaults={datasetElementType:!1,dataElementType:"point",showLine:!1,fill:!1},ScatterController.overrides={interaction:{mode:"point"},plugins:{tooltip:{callbacks:{title:()=>"",label:t=>"("+t.label+", "+t.formattedValue+")"}}},scales:{x:{type:"linear"},y:{type:"linear"}}};var xn=Object.freeze({__proto__:null,BarController:BarController,BubbleController:BubbleController,DoughnutController:DoughnutController,LineController:LineController,PolarAreaController:PolarAreaController,PieController:PieController,RadarController:RadarController,ScatterController:ScatterController});function _n(t,e,i){const{startAngle:s,pixelMargin:n,x:o,y:a,outerRadius:r,innerRadius:l}=e;let h=n/r;t.beginPath(),t.arc(o,a,r,s-h,i+h),l>n?(h=n/l,t.arc(o,a,l,i+h,s-h,!0)):t.arc(o,a,n,i+L,s-L),t.closePath(),t.clip()}function yn(t,e,i,s){const n=di(t.options.borderRadius,["outerStart","outerEnd","innerStart","innerEnd"]);const o=(i-e)/2,a=Math.min(o,s*e/2),r=t=>{const e=(i-Math.min(o,t))*s/2;return Z(t,0,Math.min(o,e))};return{outerStart:r(n.outerStart),outerEnd:r(n.outerEnd),innerStart:Z(n.innerStart,0,a),innerEnd:Z(n.innerEnd,0,a)}}function vn(t,e,i,s){return{x:i+t*Math.cos(e),y:s+t*Math.sin(e)}}function wn(t,e,i,s,n,o){const{x:a,y:r,startAngle:l,pixelMargin:h,innerRadius:c}=e,d=Math.max(e.outerRadius+s+i-h,0),u=c>0?c+s+i+h:0;let f=0;const g=n-l;if(s){const t=((c>0?c-s:0)+(d>0?d-s:0))/2;f=(g-(0!==t?g*t/(t+s):g))/2}const p=(g-Math.max(.001,g*d-i/C)/d)/2,m=l+p+f,b=n-p-f,{outerStart:x,outerEnd:_,innerStart:y,innerEnd:v}=yn(e,u,d,b-m),w=d-x,M=d-_,k=m+x/w,S=b-_/M,P=u+y,D=u+v,A=m+y/P,O=b-v/D;if(t.beginPath(),o){if(t.arc(a,r,d,k,S),_>0){const e=vn(M,S,a,r);t.arc(e.x,e.y,_,S,b+L)}const e=vn(D,b,a,r);if(t.lineTo(e.x,e.y),v>0){const e=vn(D,O,a,r);t.arc(e.x,e.y,v,b+L,O+Math.PI)}if(t.arc(a,r,u,b-v/u,m+y/u,!0),y>0){const e=vn(P,A,a,r);t.arc(e.x,e.y,y,A+Math.PI,m-L)}const i=vn(w,m,a,r);if(t.lineTo(i.x,i.y),x>0){const e=vn(w,k,a,r);t.arc(e.x,e.y,x,m-L,k)}}else{t.moveTo(a,r);const e=Math.cos(k)*d+a,i=Math.sin(k)*d+r;t.lineTo(e,i);const s=Math.cos(S)*d+a,n=Math.sin(S)*d+r;t.lineTo(s,n)}t.closePath()}function Mn(t,e,i,s,n,o){const{options:a}=e,{borderWidth:r,borderJoinStyle:l}=a,h="inner"===a.borderAlign;r&&(h?(t.lineWidth=2*r,t.lineJoin=l||"round"):(t.lineWidth=r,t.lineJoin=l||"bevel"),e.fullCircles&&function(t,e,i){const{x:s,y:n,startAngle:o,pixelMargin:a,fullCircles:r}=e,l=Math.max(e.outerRadius-a,0),h=e.innerRadius+a;let c;for(i&&_n(t,e,o+D),t.beginPath(),t.arc(s,n,h,o+D,o,!0),c=0;c<r;++c)t.stroke();for(t.beginPath(),t.arc(s,n,l,o,o+D),c=0;c<r;++c)t.stroke()}(t,e,h),h&&_n(t,e,n),wn(t,e,i,s,n,o),t.stroke())}class ArcElement extends Element{constructor(t){super(),this.options=void 0,this.circumference=void 0,this.startAngle=void 0,this.endAngle=void 0,this.innerRadius=void 0,this.outerRadius=void 0,this.pixelMargin=0,this.fullCircles=0,t&&Object.assign(this,t)}inRange(t,e,i){const s=this.getProps(["x","y"],i),{angle:n,distance:o}=U(s,{x:t,y:e}),{startAngle:a,endAngle:l,innerRadius:h,outerRadius:c,circumference:d}=this.getProps(["startAngle","endAngle","innerRadius","outerRadius","circumference"],i),u=this.options.spacing/2,f=r(d,l-a)>=D||G(n,a,l),g=Q(o,h+u,c+u);return f&&g}getCenterPoint(t){const{x:e,y:i,startAngle:s,endAngle:n,innerRadius:o,outerRadius:a}=this.getProps(["x","y","startAngle","endAngle","innerRadius","outerRadius","circumference"],t),{offset:r,spacing:l}=this.options,h=(s+n)/2,c=(o+a+l+r)/2;return{x:e+Math.cos(h)*c,y:i+Math.sin(h)*c}}tooltipPosition(t){return this.getCenterPoint(t)}draw(t){const{options:e,circumference:i}=this,s=(e.offset||0)/2,n=(e.spacing||0)/2,o=e.circular;if(this.pixelMargin="inner"===e.borderAlign?.33:0,this.fullCircles=i>D?Math.floor(i/D):0,0===i||this.innerRadius<0||this.outerRadius<0)return;t.save();let a=0;if(s){a=s/2;const e=(this.startAngle+this.endAngle)/2;t.translate(Math.cos(e)*a,Math.sin(e)*a),this.circumference>=C&&(a=s)}t.fillStyle=e.backgroundColor,t.strokeStyle=e.borderColor;const r=function(t,e,i,s,n){const{fullCircles:o,startAngle:a,circumference:r}=e;let l=e.endAngle;if(o){wn(t,e,i,s,a+D,n);for(let e=0;e<o;++e)t.fill();isNaN(r)||(l=a+r%D,r%D==0&&(l+=D))}return wn(t,e,i,s,l,n),t.fill(),l}(t,this,a,n,o);Mn(t,this,a,n,r,o),t.restore()}}function kn(t,e,i=e){t.lineCap=r(i.borderCapStyle,e.borderCapStyle),t.setLineDash(r(i.borderDash,e.borderDash)),t.lineDashOffset=r(i.borderDashOffset,e.borderDashOffset),t.lineJoin=r(i.borderJoinStyle,e.borderJoinStyle),t.lineWidth=r(i.borderWidth,e.borderWidth),t.strokeStyle=r(i.borderColor,e.borderColor)}function Sn(t,e,i){t.lineTo(i.x,i.y)}function Pn(t,e,i={}){const s=t.length,{start:n=0,end:o=s-1}=i,{start:a,end:r}=e,l=Math.max(n,a),h=Math.min(o,r),c=n<a&&o<a||n>r&&o>r;return{count:s,start:l,loop:e.loop,ilen:h<l&&!c?s+h-l:h-l}}function Cn(t,e,i,s){const{points:n,options:o}=e,{count:a,start:r,loop:l,ilen:h}=Pn(n,i,s),c=function(t){return t.stepped?Ce:t.tension||"monotone"===t.cubicInterpolationMode?De:Sn}(o);let d,u,f,{move:g=!0,reverse:p}=s||{};for(d=0;d<=h;++d)u=n[(r+(p?h-d:d))%a],u.skip||(g?(t.moveTo(u.x,u.y),g=!1):c(t,f,u,p,o.stepped),f=u);return l&&(u=n[(r+(p?h:0))%a],c(t,f,u,p,o.stepped)),!!l}function Dn(t,e,i,s){const n=e.points,{count:o,start:a,ilen:r}=Pn(n,i,s),{move:l=!0,reverse:h}=s||{};let c,d,u,f,g,p,m=0,b=0;const x=t=>(a+(h?r-t:t))%o,_=()=>{f!==g&&(t.lineTo(m,g),t.lineTo(m,f),t.lineTo(m,p))};for(l&&(d=n[x(0)],t.moveTo(d.x,d.y)),c=0;c<=r;++c){if(d=n[x(c)],d.skip)continue;const e=d.x,i=d.y,s=0|e;s===u?(i<f?f=i:i>g&&(g=i),m=(b*m+e)/++b):(_(),t.lineTo(e,i),u=s,b=0,f=g=i),p=i}_()}function An(t){const e=t.options,i=e.borderDash&&e.borderDash.length;return!(t._decimated||t._loop||e.tension||"monotone"===e.cubicInterpolationMode||e.stepped||i)?Dn:Cn}ArcElement.id="arc",ArcElement.defaults={borderAlign:"center",borderColor:"#fff",borderJoinStyle:void 0,borderRadius:0,borderWidth:2,offset:0,spacing:0,angle:void 0,circular:!0},ArcElement.defaultRoutes={backgroundColor:"backgroundColor"};const On="function"==typeof Path2D;function Tn(t,e,i,s){On&&!e.options.segment?function(t,e,i,s){let n=e._path;n||(n=e._path=new Path2D,e.path(n,i,s)&&n.closePath()),kn(t,e.options),t.stroke(n)}(t,e,i,s):function(t,e,i,s){const{segments:n,options:o}=e,a=An(e);for(const r of n)kn(t,o,r.style),t.beginPath(),a(t,e,r,{start:i,end:i+s-1})&&t.closePath(),t.stroke()}(t,e,i,s)}class LineElement extends Element{constructor(t){super(),this.animated=!0,this.options=void 0,this._chart=void 0,this._loop=void 0,this._fullLoop=void 0,this._path=void 0,this._points=void 0,this._segments=void 0,this._decimated=!1,this._pointsUpdated=!1,this._datasetIndex=void 0,t&&Object.assign(this,t)}updateControlPoints(t,e){const i=this.options;if((i.tension||"monotone"===i.cubicInterpolationMode)&&!i.stepped&&!this._pointsUpdated){const s=i.spanGaps?this._loop:this._fullLoop;Je(this._points,i,t,s,e),this._pointsUpdated=!0}}set points(t){this._points=t,delete this._segments,delete this._path,this._pointsUpdated=!1}get points(){return this._points}get segments(){return this._segments||(this._segments=Pi(this,this.options.segment))}first(){const t=this.segments,e=this.points;return t.length&&e[t[0].start]}last(){const t=this.segments,e=this.points,i=t.length;return i&&e[t[i-1].end]}interpolate(t,e){const i=this.options,s=t[e],n=this.points,o=Si(this,{property:e,start:s,end:s});if(!o.length)return;const a=[],r=function(t){return t.stepped?ni:t.tension||"monotone"===t.cubicInterpolationMode?oi:si}(i);let l,h;for(l=0,h=o.length;l<h;++l){const{start:h,end:c}=o[l],d=n[h],u=n[c];if(d===u){a.push(d);continue}const f=r(d,u,Math.abs((s-d[e])/(u[e]-d[e])),i.stepped);f[e]=t[e],a.push(f)}return 1===a.length?a[0]:a}pathSegment(t,e,i){return An(this)(t,this,e,i)}path(t,e,i){const s=this.segments,n=An(this);let o=this._loop;e=e||0,i=i||this.points.length-e;for(const a of s)o&=n(t,this,a,{start:e,end:e+i-1});return!!o}draw(t,e,i,s){const n=this.options||{};(this.points||[]).length&&n.borderWidth&&(t.save(),Tn(t,this,i,s),t.restore()),this.animated&&(this._pointsUpdated=!1,this._path=void 0)}}function Ln(t,e,i,s){const n=t.options,{[i]:o}=t.getProps([i],s);return Math.abs(e-o)<n.radius+n.hitRadius}LineElement.id="line",LineElement.defaults={borderCapStyle:"butt",borderDash:[],borderDashOffset:0,borderJoinStyle:"miter",borderWidth:3,capBezierPoints:!0,cubicInterpolationMode:"default",fill:!1,spanGaps:!1,stepped:!1,tension:0},LineElement.defaultRoutes={backgroundColor:"backgroundColor",borderColor:"borderColor"},LineElement.descriptors={_scriptable:!0,_indexable:t=>"borderDash"!==t&&"fill"!==t};class PointElement extends Element{constructor(t){super(),this.options=void 0,this.parsed=void 0,this.skip=void 0,this.stop=void 0,t&&Object.assign(this,t)}inRange(t,e,i){const s=this.options,{x:n,y:o}=this.getProps(["x","y"],i);return Math.pow(t-n,2)+Math.pow(e-o,2)<Math.pow(s.hitRadius+s.radius,2)}inXRange(t,e){return Ln(this,t,"x",e)}inYRange(t,e){return Ln(this,t,"y",e)}getCenterPoint(t){const{x:e,y:i}=this.getProps(["x","y"],t);return{x:e,y:i}}size(t){let e=(t=t||this.options||{}).radius||0;e=Math.max(e,e&&t.hoverRadius||0);return 2*(e+(e&&t.borderWidth||0))}draw(t,e){const i=this.options;this.skip||i.radius<.1||!ke(this,e,this.size(i)/2)||(t.strokeStyle=i.borderColor,t.lineWidth=i.borderWidth,t.fillStyle=i.backgroundColor,we(t,i,this.x,this.y))}getRange(){const t=this.options||{};return t.radius+t.hitRadius}}function En(t,e){const{x:i,y:s,base:n,width:o,height:a}=t.getProps(["x","y","base","width","height"],e);let r,l,h,c,d;return t.horizontal?(d=a/2,r=Math.min(i,n),l=Math.max(i,n),h=s-d,c=s+d):(d=o/2,r=i-d,l=i+d,h=Math.min(s,n),c=Math.max(s,n)),{left:r,top:h,right:l,bottom:c}}function Rn(t,e,i,s){return t?0:Z(e,i,s)}function In(t){const e=En(t),i=e.right-e.left,s=e.bottom-e.top,o=function(t,e,i){const s=t.options.borderWidth,n=t.borderSkipped,o=ui(s);return{t:Rn(n.top,o.top,0,i),r:Rn(n.right,o.right,0,e),b:Rn(n.bottom,o.bottom,0,i),l:Rn(n.left,o.left,0,e)}}(t,i/2,s/2),a=function(t,e,i){const{enableBorderRadius:s}=t.getProps(["enableBorderRadius"]),o=t.options.borderRadius,a=fi(o),r=Math.min(e,i),l=t.borderSkipped,h=s||n(o);return{topLeft:Rn(!h||l.top||l.left,a.topLeft,0,r),topRight:Rn(!h||l.top||l.right,a.topRight,0,r),bottomLeft:Rn(!h||l.bottom||l.left,a.bottomLeft,0,r),bottomRight:Rn(!h||l.bottom||l.right,a.bottomRight,0,r)}}(t,i/2,s/2);return{outer:{x:e.left,y:e.top,w:i,h:s,radius:a},inner:{x:e.left+o.l,y:e.top+o.t,w:i-o.l-o.r,h:s-o.t-o.b,radius:{topLeft:Math.max(0,a.topLeft-Math.max(o.t,o.l)),topRight:Math.max(0,a.topRight-Math.max(o.t,o.r)),bottomLeft:Math.max(0,a.bottomLeft-Math.max(o.b,o.l)),bottomRight:Math.max(0,a.bottomRight-Math.max(o.b,o.r))}}}}function zn(t,e,i,s){const n=null===e,o=null===i,a=t&&!(n&&o)&&En(t,s);return a&&(n||Q(e,a.left,a.right))&&(o||Q(i,a.top,a.bottom))}function Fn(t,e){t.rect(e.x,e.y,e.w,e.h)}function Bn(t,e,i={}){const s=t.x!==i.x?-e:0,n=t.y!==i.y?-e:0,o=(t.x+t.w!==i.x+i.w?e:0)-s,a=(t.y+t.h!==i.y+i.h?e:0)-n;return{x:t.x+s,y:t.y+n,w:t.w+o,h:t.h+a,radius:t.radius}}PointElement.id="point",PointElement.defaults={borderWidth:1,hitRadius:1,hoverBorderWidth:1,hoverRadius:4,pointStyle:"circle",radius:3,rotation:0},PointElement.defaultRoutes={backgroundColor:"backgroundColor",borderColor:"borderColor"};class BarElement extends Element{constructor(t){super(),this.options=void 0,this.horizontal=void 0,this.base=void 0,this.width=void 0,this.height=void 0,this.inflateAmount=void 0,t&&Object.assign(this,t)}draw(t){const{inflateAmount:e,options:{borderColor:i,backgroundColor:s}}=this,{inner:n,outer:o}=In(this),a=(r=o.radius).topLeft||r.topRight||r.bottomLeft||r.bottomRight?Te:Fn;var r;t.save(),o.w===n.w&&o.h===n.h||(t.beginPath(),a(t,Bn(o,e,n)),t.clip(),a(t,Bn(n,-e,o)),t.fillStyle=i,t.fill("evenodd")),t.beginPath(),a(t,Bn(n,e)),t.fillStyle=s,t.fill(),t.restore()}inRange(t,e,i){return zn(this,t,e,i)}inXRange(t,e){return zn(this,t,null,e)}inYRange(t,e){return zn(this,null,t,e)}getCenterPoint(t){const{x:e,y:i,base:s,horizontal:n}=this.getProps(["x","y","base","horizontal"],t);return{x:n?(e+s)/2:e,y:n?i:(i+s)/2}}getRange(t){return"x"===t?this.width/2:this.height/2}}BarElement.id="bar",BarElement.defaults={borderSkipped:"start",borderWidth:0,borderRadius:0,inflateAmount:"auto",pointStyle:void 0},BarElement.defaultRoutes={backgroundColor:"backgroundColor",borderColor:"borderColor"};var Vn=Object.freeze({__proto__:null,ArcElement:ArcElement,LineElement:LineElement,PointElement:PointElement,BarElement:BarElement});function Nn(t){if(t._decimated){const e=t._data;delete t._decimated,delete t._data,Object.defineProperty(t,"data",{value:e})}}function Wn(t){t.data.datasets.forEach((t=>{Nn(t)}))}var Hn={id:"decimation",defaults:{algorithm:"min-max",enabled:!1},beforeElementsUpdate:(t,e,s)=>{if(!s.enabled)return void Wn(t);const n=t.width;t.data.datasets.forEach(((e,o)=>{const{_data:a,indexAxis:r}=e,l=t.getDatasetMeta(o),h=a||e.data;if("y"===mi([r,t.options.indexAxis]))return;if(!l.controller.supportsDecimation)return;const c=t.scales[l.xAxisID];if("linear"!==c.type&&"time"!==c.type)return;if(t.options.parsing)return;let{start:d,count:u}=function(t,e){const i=e.length;let s,n=0;const{iScale:o}=t,{min:a,max:r,minDefined:l,maxDefined:h}=o.getUserBounds();return l&&(n=Z(et(e,o.axis,a).lo,0,i-1)),s=h?Z(et(e,o.axis,r).hi+1,n,i)-n:i-n,{start:n,count:s}}(l,h);if(u<=(s.threshold||4*n))return void Nn(e);let f;switch(i(a)&&(e._data=h,delete e.data,Object.defineProperty(e,"data",{configurable:!0,enumerable:!0,get:function(){return this._decimated},set:function(t){this._data=t}})),s.algorithm){case"lttb":f=function(t,e,i,s,n){const o=n.samples||s;if(o>=i)return t.slice(e,e+i);const a=[],r=(i-2)/(o-2);let l=0;const h=e+i-1;let c,d,u,f,g,p=e;for(a[l++]=t[p],c=0;c<o-2;c++){let s,n=0,o=0;const h=Math.floor((c+1)*r)+1+e,m=Math.min(Math.floor((c+2)*r)+1,i)+e,b=m-h;for(s=h;s<m;s++)n+=t[s].x,o+=t[s].y;n/=b,o/=b;const x=Math.floor(c*r)+1+e,_=Math.min(Math.floor((c+1)*r)+1,i)+e,{x:y,y:v}=t[p];for(u=f=-1,s=x;s<_;s++)f=.5*Math.abs((y-n)*(t[s].y-v)-(y-t[s].x)*(o-v)),f>u&&(u=f,d=t[s],g=s);a[l++]=d,p=g}return a[l++]=t[h],a}(h,d,u,n,s);break;case"min-max":f=function(t,e,s,n){let o,a,r,l,h,c,d,u,f,g,p=0,m=0;const b=[],x=e+s-1,_=t[e].x,y=t[x].x-_;for(o=e;o<e+s;++o){a=t[o],r=(a.x-_)/y*n,l=a.y;const e=0|r;if(e===h)l<f?(f=l,c=o):l>g&&(g=l,d=o),p=(m*p+a.x)/++m;else{const s=o-1;if(!i(c)&&!i(d)){const e=Math.min(c,d),i=Math.max(c,d);e!==u&&e!==s&&b.push({...t[e],x:p}),i!==u&&i!==s&&b.push({...t[i],x:p})}o>0&&s!==u&&b.push(t[s]),b.push(a),h=e,m=0,f=g=l,c=d=u=o}}return b}(h,d,u,n);break;default:throw new Error(`Unsupported decimation algorithm '${s.algorithm}'`)}e._decimated=f}))},destroy(t){Wn(t)}};function jn(t,e,i,s){if(s)return;let n=e[t],o=i[t];return"angle"===t&&(n=K(n),o=K(o)),{property:t,start:n,end:o}}function $n(t,e,i){for(;e>t;e--){const t=i[e];if(!isNaN(t.x)&&!isNaN(t.y))break}return e}function Yn(t,e,i,s){return t&&e?s(t[i],e[i]):t?t[i]:e?e[i]:0}function Un(t,e){let i=[],n=!1;return s(t)?(n=!0,i=t):i=function(t,e){const{x:i=null,y:s=null}=t||{},n=e.points,o=[];return e.segments.forEach((({start:t,end:e})=>{e=$n(t,e,n);const a=n[t],r=n[e];null!==s?(o.push({x:a.x,y:s}),o.push({x:r.x,y:s})):null!==i&&(o.push({x:i,y:a.y}),o.push({x:i,y:r.y}))})),o}(t,e),i.length?new LineElement({points:i,options:{tension:0},_loop:n,_fullLoop:n}):null}function Xn(t){return t&&!1!==t.fill}function qn(t,e,i){let s=t[e].fill;const n=[e];let a;if(!i)return s;for(;!1!==s&&-1===n.indexOf(s);){if(!o(s))return s;if(a=t[s],!a)return!1;if(a.visible)return s;n.push(s),s=a.fill}return!1}function Kn(t,e,i){const s=function(t){const e=t.options,i=e.fill;let s=r(i&&i.target,i);void 0===s&&(s=!!e.backgroundColor);if(!1===s||null===s)return!1;if(!0===s)return"origin";return s}(t);if(n(s))return!isNaN(s.value)&&s;let a=parseFloat(s);return o(a)&&Math.floor(a)===a?function(t,e,i,s){"-"!==t&&"+"!==t||(i=e+i);if(i===e||i<0||i>=s)return!1;return i}(s[0],e,a,i):["origin","start","end","stack","shape"].indexOf(s)>=0&&s}function Gn(t,e,i){const s=[];for(let n=0;n<i.length;n++){const o=i[n],{first:a,last:r,point:l}=Zn(o,e,"x");if(!(!l||a&&r))if(a)s.unshift(l);else if(t.push(l),!r)break}t.push(...s)}function Zn(t,e,i){const s=t.interpolate(e,i);if(!s)return{};const n=s[i],o=t.segments,a=t.points;let r=!1,l=!1;for(let h=0;h<o.length;h++){const t=o[h],e=a[t.start][i],s=a[t.end][i];if(Q(n,e,s)){r=n===e,l=n===s;break}}return{first:r,last:l,point:s}}class simpleArc{constructor(t){this.x=t.x,this.y=t.y,this.radius=t.radius}pathSegment(t,e,i){const{x:s,y:n,radius:o}=this;return e=e||{start:0,end:D},t.arc(s,n,o,e.end,e.start,!0),!i.bounds}interpolate(t){const{x:e,y:i,radius:s}=this,n=t.angle;return{x:e+Math.cos(n)*s,y:i+Math.sin(n)*s,angle:n}}}function Jn(t){const{chart:e,fill:i,line:s}=t;if(o(i))return function(t,e){const i=t.getDatasetMeta(e),s=i&&t.isDatasetVisible(e);return s?i.dataset:null}(e,i);if("stack"===i)return function(t){const{scale:e,index:i,line:s}=t,n=[],o=s.segments,a=s.points,r=function(t,e){const i=[],s=t.getMatchingVisibleMetas("line");for(let n=0;n<s.length;n++){const t=s[n];if(t.index===e)break;t.hidden||i.unshift(t.dataset)}return i}(e,i);r.push(Un({x:null,y:e.bottom},s));for(let l=0;l<o.length;l++){const t=o[l];for(let e=t.start;e<=t.end;e++)Gn(n,a[e],r)}return new LineElement({points:n,options:{}})}(t);if("shape"===i)return!0;const a=function(t){const e=t.scale||{};if(e.getPointPositionForValue)return function(t){const{scale:e,fill:i}=t,s=e.options,o=e.getLabels().length,a=s.reverse?e.max:e.min,r=function(t,e,i){let s;return s="start"===t?i:"end"===t?e.options.reverse?e.min:e.max:n(t)?t.value:e.getBaseValue(),s}(i,e,a),l=[];if(s.grid.circular){const t=e.getPointPositionForValue(0,a);return new simpleArc({x:t.x,y:t.y,radius:e.getDistanceFromCenterForValue(r)})}for(let n=0;n<o;++n)l.push(e.getPointPositionForValue(n,r));return l}(t);return function(t){const{scale:e={},fill:i}=t,s=function(t,e){let i=null;return"start"===t?i=e.bottom:"end"===t?i=e.top:n(t)?i=e.getPixelForValue(t.value):e.getBasePixel&&(i=e.getBasePixel()),i}(i,e);if(o(s)){const t=e.isHorizontal();return{x:t?s:null,y:t?null:s}}return null}(t)}(t);return a instanceof simpleArc?a:Un(a,s)}function Qn(t,e,i){const s=Jn(e),{line:n,scale:o,axis:a}=e,r=n.options,l=r.fill,h=r.backgroundColor,{above:c=h,below:d=h}=l||{};s&&n.points.length&&(Se(t,i),function(t,e){const{line:i,target:s,above:n,below:o,area:a,scale:r}=e,l=i._loop?"angle":e.axis;t.save(),"x"===l&&o!==n&&(to(t,s,a.top),eo(t,{line:i,target:s,color:n,scale:r,property:l}),t.restore(),t.save(),to(t,s,a.bottom));eo(t,{line:i,target:s,color:o,scale:r,property:l}),t.restore()}(t,{line:n,target:s,above:c,below:d,area:i,scale:o,axis:a}),Pe(t))}function to(t,e,i){const{segments:s,points:n}=e;let o=!0,a=!1;t.beginPath();for(const r of s){const{start:s,end:l}=r,h=n[s],c=n[$n(s,l,n)];o?(t.moveTo(h.x,h.y),o=!1):(t.lineTo(h.x,i),t.lineTo(h.x,h.y)),a=!!e.pathSegment(t,r,{move:a}),a?t.closePath():t.lineTo(c.x,i)}t.lineTo(e.first().x,i),t.closePath(),t.clip()}function eo(t,e){const{line:i,target:s,property:n,color:o,scale:a}=e,r=function(t,e,i){const s=t.segments,n=t.points,o=e.points,a=[];for(const r of s){let{start:t,end:s}=r;s=$n(t,s,n);const l=jn(i,n[t],n[s],r.loop);if(!e.segments){a.push({source:r,target:l,start:n[t],end:n[s]});continue}const h=Si(e,l);for(const e of h){const t=jn(i,o[e.start],o[e.end],e.loop),s=ki(r,n,t);for(const n of s)a.push({source:n,target:e,start:{[i]:Yn(l,t,"start",Math.max)},end:{[i]:Yn(l,t,"end",Math.min)}})}}return a}(i,s,n);for(const{source:l,target:h,start:c,end:d}of r){const{style:{backgroundColor:e=o}={}}=l,r=!0!==s;t.save(),t.fillStyle=e,io(t,a,r&&jn(n,c,d)),t.beginPath();const u=!!i.pathSegment(t,l);let f;if(r){u?t.closePath():so(t,s,d,n);const e=!!s.pathSegment(t,h,{move:u,reverse:!0});f=u&&e,f||so(t,s,c,n)}t.closePath(),t.fill(f?"evenodd":"nonzero"),t.restore()}}function io(t,e,i){const{top:s,bottom:n}=e.chart.chartArea,{property:o,start:a,end:r}=i||{};"x"===o&&(t.beginPath(),t.rect(a,s,r-a,n-s),t.clip())}function so(t,e,i,s){const n=e.interpolate(i,s);n&&t.lineTo(n.x,n.y)}var no={id:"filler",afterDatasetsUpdate(t,e,i){const s=(t.data.datasets||[]).length,n=[];let o,a,r,l;for(a=0;a<s;++a)o=t.getDatasetMeta(a),r=o.dataset,l=null,r&&r.options&&r instanceof LineElement&&(l={visible:t.isDatasetVisible(a),index:a,fill:Kn(r,a,s),chart:t,axis:o.controller.options.indexAxis,scale:o.vScale,line:r}),o.$filler=l,n.push(l);for(a=0;a<s;++a)l=n[a],l&&!1!==l.fill&&(l.fill=qn(n,a,i.propagate))},beforeDraw(t,e,i){const s="beforeDraw"===i.drawTime,n=t.getSortedVisibleDatasetMetas(),o=t.chartArea;for(let a=n.length-1;a>=0;--a){const e=n[a].$filler;e&&(e.line.updateControlPoints(o,e.axis),s&&e.fill&&Qn(t.ctx,e,o))}},beforeDatasetsDraw(t,e,i){if("beforeDatasetsDraw"!==i.drawTime)return;const s=t.getSortedVisibleDatasetMetas();for(let n=s.length-1;n>=0;--n){const e=s[n].$filler;Xn(e)&&Qn(t.ctx,e,t.chartArea)}},beforeDatasetDraw(t,e,i){const s=e.meta.$filler;Xn(s)&&"beforeDatasetDraw"===i.drawTime&&Qn(t.ctx,s,t.chartArea)},defaults:{propagate:!0,drawTime:"beforeDatasetDraw"}};const oo=(t,e)=>{let{boxHeight:i=e,boxWidth:s=e}=t;return t.usePointStyle&&(i=Math.min(i,e),s=t.pointStyleWidth||Math.min(s,e)),{boxWidth:s,boxHeight:i,itemHeight:Math.max(e,i)}};class Legend extends Element{constructor(t){super(),this._added=!1,this.legendHitBoxes=[],this._hoveredItem=null,this.doughnutMode=!1,this.chart=t.chart,this.options=t.options,this.ctx=t.ctx,this.legendItems=void 0,this.columnSizes=void 0,this.lineWidths=void 0,this.maxHeight=void 0,this.maxWidth=void 0,this.top=void 0,this.bottom=void 0,this.left=void 0,this.right=void 0,this.height=void 0,this.width=void 0,this._margins=void 0,this.position=void 0,this.weight=void 0,this.fullSize=void 0}update(t,e,i){this.maxWidth=t,this.maxHeight=e,this._margins=i,this.setDimensions(),this.buildLabels(),this.fit()}setDimensions(){this.isHorizontal()?(this.width=this.maxWidth,this.left=this._margins.left,this.right=this.width):(this.height=this.maxHeight,this.top=this._margins.top,this.bottom=this.height)}buildLabels(){const t=this.options.labels||{};let e=c(t.generateLabels,[this.chart],this)||[];t.filter&&(e=e.filter((e=>t.filter(e,this.chart.data)))),t.sort&&(e=e.sort(((e,i)=>t.sort(e,i,this.chart.data)))),this.options.reverse&&e.reverse(),this.legendItems=e}fit(){const{options:t,ctx:e}=this;if(!t.display)return void(this.width=this.height=0);const i=t.labels,s=pi(i.font),n=s.size,o=this._computeTitleHeight(),{boxWidth:a,itemHeight:r}=oo(i,n);let l,h;e.font=s.string,this.isHorizontal()?(l=this.maxWidth,h=this._fitRows(o,n,a,r)+10):(h=this.maxHeight,l=this._fitCols(o,n,a,r)+10),this.width=Math.min(l,t.maxWidth||this.maxWidth),this.height=Math.min(h,t.maxHeight||this.maxHeight)}_fitRows(t,e,i,s){const{ctx:n,maxWidth:o,options:{labels:{padding:a}}}=this,r=this.legendHitBoxes=[],l=this.lineWidths=[0],h=s+a;let c=t;n.textAlign="left",n.textBaseline="middle";let d=-1,u=-h;return this.legendItems.forEach(((t,f)=>{const g=i+e/2+n.measureText(t.text).width;(0===f||l[l.length-1]+g+2*a>o)&&(c+=h,l[l.length-(f>0?0:1)]=0,u+=h,d++),r[f]={left:0,top:u,row:d,width:g,height:s},l[l.length-1]+=g+a})),c}_fitCols(t,e,i,s){const{ctx:n,maxHeight:o,options:{labels:{padding:a}}}=this,r=this.legendHitBoxes=[],l=this.columnSizes=[],h=o-t;let c=a,d=0,u=0,f=0,g=0;return this.legendItems.forEach(((t,o)=>{const p=i+e/2+n.measureText(t.text).width;o>0&&u+s+2*a>h&&(c+=d+a,l.push({width:d,height:u}),f+=d+a,g++,d=u=0),r[o]={left:f,top:u,col:g,width:p,height:s},d=Math.max(d,p),u+=s+a})),c+=d,l.push({width:d,height:u}),c}adjustHitBoxes(){if(!this.options.display)return;const t=this._computeTitleHeight(),{legendHitBoxes:e,options:{align:i,labels:{padding:s},rtl:n}}=this,o=_i(n,this.left,this.width);if(this.isHorizontal()){let n=0,a=ut(i,this.left+s,this.right-this.lineWidths[n]);for(const r of e)n!==r.row&&(n=r.row,a=ut(i,this.left+s,this.right-this.lineWidths[n])),r.top+=this.top+t+s,r.left=o.leftForLtr(o.x(a),r.width),a+=r.width+s}else{let n=0,a=ut(i,this.top+t+s,this.bottom-this.columnSizes[n].height);for(const r of e)r.col!==n&&(n=r.col,a=ut(i,this.top+t+s,this.bottom-this.columnSizes[n].height)),r.top=a,r.left+=this.left+s,r.left=o.leftForLtr(o.x(r.left),r.width),a+=r.height+s}}isHorizontal(){return"top"===this.options.position||"bottom"===this.options.position}draw(){if(this.options.display){const t=this.ctx;Se(t,this),this._draw(),Pe(t)}}_draw(){const{options:t,columnSizes:e,lineWidths:i,ctx:s}=this,{align:n,labels:o}=t,a=se.color,l=_i(t.rtl,this.left,this.width),h=pi(o.font),{color:c,padding:d}=o,u=h.size,f=u/2;let g;this.drawTitle(),s.textAlign=l.textAlign("left"),s.textBaseline="middle",s.lineWidth=.5,s.font=h.string;const{boxWidth:p,boxHeight:m,itemHeight:b}=oo(o,u),x=this.isHorizontal(),_=this._computeTitleHeight();g=x?{x:ut(n,this.left+d,this.right-i[0]),y:this.top+d+_,line:0}:{x:this.left+d,y:ut(n,this.top+_+d,this.bottom-e[0].height),line:0},yi(this.ctx,t.textDirection);const y=b+d;this.legendItems.forEach(((v,w)=>{s.strokeStyle=v.fontColor||c,s.fillStyle=v.fontColor||c;const M=s.measureText(v.text).width,k=l.textAlign(v.textAlign||(v.textAlign=o.textAlign)),S=p+f+M;let P=g.x,C=g.y;l.setWidth(this.width),x?w>0&&P+S+d>this.right&&(C=g.y+=y,g.line++,P=g.x=ut(n,this.left+d,this.right-i[g.line])):w>0&&C+y>this.bottom&&(P=g.x=P+e[g.line].width+d,g.line++,C=g.y=ut(n,this.top+_+d,this.bottom-e[g.line].height));!function(t,e,i){if(isNaN(p)||p<=0||isNaN(m)||m<0)return;s.save();const n=r(i.lineWidth,1);if(s.fillStyle=r(i.fillStyle,a),s.lineCap=r(i.lineCap,"butt"),s.lineDashOffset=r(i.lineDashOffset,0),s.lineJoin=r(i.lineJoin,"miter"),s.lineWidth=n,s.strokeStyle=r(i.strokeStyle,a),s.setLineDash(r(i.lineDash,[])),o.usePointStyle){const a={radius:m*Math.SQRT2/2,pointStyle:i.pointStyle,rotation:i.rotation,borderWidth:n},r=l.xPlus(t,p/2);Me(s,a,r,e+f,o.pointStyleWidth&&p)}else{const o=e+Math.max((u-m)/2,0),a=l.leftForLtr(t,p),r=fi(i.borderRadius);s.beginPath(),Object.values(r).some((t=>0!==t))?Te(s,{x:a,y:o,w:p,h:m,radius:r}):s.rect(a,o,p,m),s.fill(),0!==n&&s.stroke()}s.restore()}(l.x(P),C,v),P=ft(k,P+p+f,x?P+S:this.right,t.rtl),function(t,e,i){Ae(s,i.text,t,e+b/2,h,{strikethrough:i.hidden,textAlign:l.textAlign(i.textAlign)})}(l.x(P),C,v),x?g.x+=S+d:g.y+=y})),vi(this.ctx,t.textDirection)}drawTitle(){const t=this.options,e=t.title,i=pi(e.font),s=gi(e.padding);if(!e.display)return;const n=_i(t.rtl,this.left,this.width),o=this.ctx,a=e.position,r=i.size/2,l=s.top+r;let h,c=this.left,d=this.width;if(this.isHorizontal())d=Math.max(...this.lineWidths),h=this.top+l,c=ut(t.align,c,this.right-d);else{const e=this.columnSizes.reduce(((t,e)=>Math.max(t,e.height)),0);h=l+ut(t.align,this.top,this.bottom-e-t.labels.padding-this._computeTitleHeight())}const u=ut(a,c,c+d);o.textAlign=n.textAlign(dt(a)),o.textBaseline="middle",o.strokeStyle=e.color,o.fillStyle=e.color,o.font=i.string,Ae(o,e.text,u,h,i)}_computeTitleHeight(){const t=this.options.title,e=pi(t.font),i=gi(t.padding);return t.display?e.lineHeight+i.height:0}_getLegendItemAt(t,e){let i,s,n;if(Q(t,this.left,this.right)&&Q(e,this.top,this.bottom))for(n=this.legendHitBoxes,i=0;i<n.length;++i)if(s=n[i],Q(t,s.left,s.left+s.width)&&Q(e,s.top,s.top+s.height))return this.legendItems[i];return null}handleEvent(t){const e=this.options;if(!function(t,e){if(("mousemove"===t||"mouseout"===t)&&(e.onHover||e.onLeave))return!0;if(e.onClick&&("click"===t||"mouseup"===t))return!0;return!1}(t.type,e))return;const i=this._getLegendItemAt(t.x,t.y);if("mousemove"===t.type||"mouseout"===t.type){const o=this._hoveredItem,a=(n=i,null!==(s=o)&&null!==n&&s.datasetIndex===n.datasetIndex&&s.index===n.index);o&&!a&&c(e.onLeave,[t,o,this],this),this._hoveredItem=i,i&&!a&&c(e.onHover,[t,i,this],this)}else i&&c(e.onClick,[t,i,this],this);var s,n}}var ao={id:"legend",_element:Legend,start(t,e,i){const s=t.legend=new Legend({ctx:t.ctx,options:i,chart:t});Gi.configure(t,s,i),Gi.addBox(t,s)},stop(t){Gi.removeBox(t,t.legend),delete t.legend},beforeUpdate(t,e,i){const s=t.legend;Gi.configure(t,s,i),s.options=i},afterUpdate(t){const e=t.legend;e.buildLabels(),e.adjustHitBoxes()},afterEvent(t,e){e.replay||t.legend.handleEvent(e.event)},defaults:{display:!0,position:"top",align:"center",fullSize:!0,reverse:!1,weight:1e3,onClick(t,e,i){const s=e.datasetIndex,n=i.chart;n.isDatasetVisible(s)?(n.hide(s),e.hidden=!0):(n.show(s),e.hidden=!1)},onHover:null,onLeave:null,labels:{color:t=>t.chart.options.color,boxWidth:40,padding:10,generateLabels(t){const e=t.data.datasets,{labels:{usePointStyle:i,pointStyle:s,textAlign:n,color:o}}=t.legend.options;return t._getSortedDatasetMetas().map((t=>{const a=t.controller.getStyle(i?0:void 0),r=gi(a.borderWidth);return{text:e[t.index].label,fillStyle:a.backgroundColor,fontColor:o,hidden:!t.visible,lineCap:a.borderCapStyle,lineDash:a.borderDash,lineDashOffset:a.borderDashOffset,lineJoin:a.borderJoinStyle,lineWidth:(r.width+r.height)/4,strokeStyle:a.borderColor,pointStyle:s||a.pointStyle,rotation:a.rotation,textAlign:n||a.textAlign,borderRadius:0,datasetIndex:t.index}}),this)}},title:{color:t=>t.chart.options.color,display:!1,position:"center",text:""}},descriptors:{_scriptable:t=>!t.startsWith("on"),labels:{_scriptable:t=>!["generateLabels","filter","sort"].includes(t)}}};class Title extends Element{constructor(t){super(),this.chart=t.chart,this.options=t.options,this.ctx=t.ctx,this._padding=void 0,this.top=void 0,this.bottom=void 0,this.left=void 0,this.right=void 0,this.width=void 0,this.height=void 0,this.position=void 0,this.weight=void 0,this.fullSize=void 0}update(t,e){const i=this.options;if(this.left=0,this.top=0,!i.display)return void(this.width=this.height=this.right=this.bottom=0);this.width=this.right=t,this.height=this.bottom=e;const n=s(i.text)?i.text.length:1;this._padding=gi(i.padding);const o=n*pi(i.font).lineHeight+this._padding.height;this.isHorizontal()?this.height=o:this.width=o}isHorizontal(){const t=this.options.position;return"top"===t||"bottom"===t}_drawArgs(t){const{top:e,left:i,bottom:s,right:n,options:o}=this,a=o.align;let r,l,h,c=0;return this.isHorizontal()?(l=ut(a,i,n),h=e+t,r=n-i):("left"===o.position?(l=i+t,h=ut(a,s,e),c=-.5*C):(l=n-t,h=ut(a,e,s),c=.5*C),r=s-e),{titleX:l,titleY:h,maxWidth:r,rotation:c}}draw(){const t=this.ctx,e=this.options;if(!e.display)return;const i=pi(e.font),s=i.lineHeight/2+this._padding.top,{titleX:n,titleY:o,maxWidth:a,rotation:r}=this._drawArgs(s);Ae(t,e.text,0,0,i,{color:e.color,maxWidth:a,rotation:r,textAlign:dt(e.align),textBaseline:"middle",translation:[n,o]})}}var ro={id:"title",_element:Title,start(t,e,i){!function(t,e){const i=new Title({ctx:t.ctx,options:e,chart:t});Gi.configure(t,i,e),Gi.addBox(t,i),t.titleBlock=i}(t,i)},stop(t){const e=t.titleBlock;Gi.removeBox(t,e),delete t.titleBlock},beforeUpdate(t,e,i){const s=t.titleBlock;Gi.configure(t,s,i),s.options=i},defaults:{align:"center",display:!1,font:{weight:"bold"},fullSize:!0,padding:10,position:"top",text:"",weight:2e3},defaultRoutes:{color:"color"},descriptors:{_scriptable:!0,_indexable:!1}};const lo=new WeakMap;var ho={id:"subtitle",start(t,e,i){const s=new Title({ctx:t.ctx,options:i,chart:t});Gi.configure(t,s,i),Gi.addBox(t,s),lo.set(t,s)},stop(t){Gi.removeBox(t,lo.get(t)),lo.delete(t)},beforeUpdate(t,e,i){const s=lo.get(t);Gi.configure(t,s,i),s.options=i},defaults:{align:"center",display:!1,font:{weight:"normal"},fullSize:!0,padding:0,position:"top",text:"",weight:1500},defaultRoutes:{color:"color"},descriptors:{_scriptable:!0,_indexable:!1}};const co={average(t){if(!t.length)return!1;let e,i,s=0,n=0,o=0;for(e=0,i=t.length;e<i;++e){const i=t[e].element;if(i&&i.hasValue()){const t=i.tooltipPosition();s+=t.x,n+=t.y,++o}}return{x:s/o,y:n/o}},nearest(t,e){if(!t.length)return!1;let i,s,n,o=e.x,a=e.y,r=Number.POSITIVE_INFINITY;for(i=0,s=t.length;i<s;++i){const s=t[i].element;if(s&&s.hasValue()){const t=X(e,s.getCenterPoint());t<r&&(r=t,n=s)}}if(n){const t=n.tooltipPosition();o=t.x,a=t.y}return{x:o,y:a}}};function uo(t,e){return e&&(s(e)?Array.prototype.push.apply(t,e):t.push(e)),t}function fo(t){return("string"==typeof t||t instanceof String)&&t.indexOf("\n")>-1?t.split("\n"):t}function go(t,e){const{element:i,datasetIndex:s,index:n}=e,o=t.getDatasetMeta(s).controller,{label:a,value:r}=o.getLabelAndValue(n);return{chart:t,label:a,parsed:o.getParsed(n),raw:t.data.datasets[s].data[n],formattedValue:r,dataset:o.getDataset(),dataIndex:n,datasetIndex:s,element:i}}function po(t,e){const i=t.chart.ctx,{body:s,footer:n,title:o}=t,{boxWidth:a,boxHeight:r}=e,l=pi(e.bodyFont),h=pi(e.titleFont),c=pi(e.footerFont),u=o.length,f=n.length,g=s.length,p=gi(e.padding);let m=p.height,b=0,x=s.reduce(((t,e)=>t+e.before.length+e.lines.length+e.after.length),0);if(x+=t.beforeBody.length+t.afterBody.length,u&&(m+=u*h.lineHeight+(u-1)*e.titleSpacing+e.titleMarginBottom),x){m+=g*(e.displayColors?Math.max(r,l.lineHeight):l.lineHeight)+(x-g)*l.lineHeight+(x-1)*e.bodySpacing}f&&(m+=e.footerMarginTop+f*c.lineHeight+(f-1)*e.footerSpacing);let _=0;const y=function(t){b=Math.max(b,i.measureText(t).width+_)};return i.save(),i.font=h.string,d(t.title,y),i.font=l.string,d(t.beforeBody.concat(t.afterBody),y),_=e.displayColors?a+2+e.boxPadding:0,d(s,(t=>{d(t.before,y),d(t.lines,y),d(t.after,y)})),_=0,i.font=c.string,d(t.footer,y),i.restore(),b+=p.width,{width:b,height:m}}function mo(t,e,i,s){const{x:n,width:o}=i,{width:a,chartArea:{left:r,right:l}}=t;let h="center";return"center"===s?h=n<=(r+l)/2?"left":"right":n<=o/2?h="left":n>=a-o/2&&(h="right"),function(t,e,i,s){const{x:n,width:o}=s,a=i.caretSize+i.caretPadding;return"left"===t&&n+o+a>e.width||"right"===t&&n-o-a<0||void 0}(h,t,e,i)&&(h="center"),h}function bo(t,e,i){const s=i.yAlign||e.yAlign||function(t,e){const{y:i,height:s}=e;return i<s/2?"top":i>t.height-s/2?"bottom":"center"}(t,i);return{xAlign:i.xAlign||e.xAlign||mo(t,e,i,s),yAlign:s}}function xo(t,e,i,s){const{caretSize:n,caretPadding:o,cornerRadius:a}=t,{xAlign:r,yAlign:l}=i,h=n+o,{topLeft:c,topRight:d,bottomLeft:u,bottomRight:f}=fi(a);let g=function(t,e){let{x:i,width:s}=t;return"right"===e?i-=s:"center"===e&&(i-=s/2),i}(e,r);const p=function(t,e,i){let{y:s,height:n}=t;return"top"===e?s+=i:s-="bottom"===e?n+i:n/2,s}(e,l,h);return"center"===l?"left"===r?g+=h:"right"===r&&(g-=h):"left"===r?g-=Math.max(c,u)+n:"right"===r&&(g+=Math.max(d,f)+n),{x:Z(g,0,s.width-e.width),y:Z(p,0,s.height-e.height)}}function _o(t,e,i){const s=gi(i.padding);return"center"===e?t.x+t.width/2:"right"===e?t.x+t.width-s.right:t.x+s.left}function yo(t){return uo([],fo(t))}function vo(t,e){const i=e&&e.dataset&&e.dataset.tooltip&&e.dataset.tooltip.callbacks;return i?t.override(i):t}class Tooltip extends Element{constructor(t){super(),this.opacity=0,this._active=[],this._eventPosition=void 0,this._size=void 0,this._cachedAnimations=void 0,this._tooltipItems=[],this.$animations=void 0,this.$context=void 0,this.chart=t.chart||t._chart,this._chart=this.chart,this.options=t.options,this.dataPoints=void 0,this.title=void 0,this.beforeBody=void 0,this.body=void 0,this.afterBody=void 0,this.footer=void 0,this.xAlign=void 0,this.yAlign=void 0,this.x=void 0,this.y=void 0,this.height=void 0,this.width=void 0,this.caretX=void 0,this.caretY=void 0,this.labelColors=void 0,this.labelPointStyles=void 0,this.labelTextColors=void 0}initialize(t){this.options=t,this._cachedAnimations=void 0,this.$context=void 0}_resolveAnimations(){const t=this._cachedAnimations;if(t)return t;const e=this.chart,i=this.options.setContext(this.getContext()),s=i.enabled&&e.options.animation&&i.animations,n=new Animations(this.chart,s);return s._cacheable&&(this._cachedAnimations=Object.freeze(n)),n}getContext(){return this.$context||(this.$context=(t=this.chart.getContext(),e=this,i=this._tooltipItems,xi(t,{tooltip:e,tooltipItems:i,type:"tooltip"})));var t,e,i}getTitle(t,e){const{callbacks:i}=e,s=i.beforeTitle.apply(this,[t]),n=i.title.apply(this,[t]),o=i.afterTitle.apply(this,[t]);let a=[];return a=uo(a,fo(s)),a=uo(a,fo(n)),a=uo(a,fo(o)),a}getBeforeBody(t,e){return yo(e.callbacks.beforeBody.apply(this,[t]))}getBody(t,e){const{callbacks:i}=e,s=[];return d(t,(t=>{const e={before:[],lines:[],after:[]},n=vo(i,t);uo(e.before,fo(n.beforeLabel.call(this,t))),uo(e.lines,n.label.call(this,t)),uo(e.after,fo(n.afterLabel.call(this,t))),s.push(e)})),s}getAfterBody(t,e){return yo(e.callbacks.afterBody.apply(this,[t]))}getFooter(t,e){const{callbacks:i}=e,s=i.beforeFooter.apply(this,[t]),n=i.footer.apply(this,[t]),o=i.afterFooter.apply(this,[t]);let a=[];return a=uo(a,fo(s)),a=uo(a,fo(n)),a=uo(a,fo(o)),a}_createItems(t){const e=this._active,i=this.chart.data,s=[],n=[],o=[];let a,r,l=[];for(a=0,r=e.length;a<r;++a)l.push(go(this.chart,e[a]));return t.filter&&(l=l.filter(((e,s,n)=>t.filter(e,s,n,i)))),t.itemSort&&(l=l.sort(((e,s)=>t.itemSort(e,s,i)))),d(l,(e=>{const i=vo(t.callbacks,e);s.push(i.labelColor.call(this,e)),n.push(i.labelPointStyle.call(this,e)),o.push(i.labelTextColor.call(this,e))})),this.labelColors=s,this.labelPointStyles=n,this.labelTextColors=o,this.dataPoints=l,l}update(t,e){const i=this.options.setContext(this.getContext()),s=this._active;let n,o=[];if(s.length){const t=co[i.position].call(this,s,this._eventPosition);o=this._createItems(i),this.title=this.getTitle(o,i),this.beforeBody=this.getBeforeBody(o,i),this.body=this.getBody(o,i),this.afterBody=this.getAfterBody(o,i),this.footer=this.getFooter(o,i);const e=this._size=po(this,i),a=Object.assign({},t,e),r=bo(this.chart,i,a),l=xo(i,a,r,this.chart);this.xAlign=r.xAlign,this.yAlign=r.yAlign,n={opacity:1,x:l.x,y:l.y,width:e.width,height:e.height,caretX:t.x,caretY:t.y}}else 0!==this.opacity&&(n={opacity:0});this._tooltipItems=o,this.$context=void 0,n&&this._resolveAnimations().update(this,n),t&&i.external&&i.external.call(this,{chart:this.chart,tooltip:this,replay:e})}drawCaret(t,e,i,s){const n=this.getCaretPosition(t,i,s);e.lineTo(n.x1,n.y1),e.lineTo(n.x2,n.y2),e.lineTo(n.x3,n.y3)}getCaretPosition(t,e,i){const{xAlign:s,yAlign:n}=this,{caretSize:o,cornerRadius:a}=i,{topLeft:r,topRight:l,bottomLeft:h,bottomRight:c}=fi(a),{x:d,y:u}=t,{width:f,height:g}=e;let p,m,b,x,_,y;return"center"===n?(_=u+g/2,"left"===s?(p=d,m=p-o,x=_+o,y=_-o):(p=d+f,m=p+o,x=_-o,y=_+o),b=p):(m="left"===s?d+Math.max(r,h)+o:"right"===s?d+f-Math.max(l,c)-o:this.caretX,"top"===n?(x=u,_=x-o,p=m-o,b=m+o):(x=u+g,_=x+o,p=m+o,b=m-o),y=x),{x1:p,x2:m,x3:b,y1:x,y2:_,y3:y}}drawTitle(t,e,i){const s=this.title,n=s.length;let o,a,r;if(n){const l=_i(i.rtl,this.x,this.width);for(t.x=_o(this,i.titleAlign,i),e.textAlign=l.textAlign(i.titleAlign),e.textBaseline="middle",o=pi(i.titleFont),a=i.titleSpacing,e.fillStyle=i.titleColor,e.font=o.string,r=0;r<n;++r)e.fillText(s[r],l.x(t.x),t.y+o.lineHeight/2),t.y+=o.lineHeight+a,r+1===n&&(t.y+=i.titleMarginBottom-a)}}_drawColorBox(t,e,i,s,o){const a=this.labelColors[i],r=this.labelPointStyles[i],{boxHeight:l,boxWidth:h,boxPadding:c}=o,d=pi(o.bodyFont),u=_o(this,"left",o),f=s.x(u),g=l<d.lineHeight?(d.lineHeight-l)/2:0,p=e.y+g;if(o.usePointStyle){const e={radius:Math.min(h,l)/2,pointStyle:r.pointStyle,rotation:r.rotation,borderWidth:1},i=s.leftForLtr(f,h)+h/2,n=p+l/2;t.strokeStyle=o.multiKeyBackground,t.fillStyle=o.multiKeyBackground,we(t,e,i,n),t.strokeStyle=a.borderColor,t.fillStyle=a.backgroundColor,we(t,e,i,n)}else{t.lineWidth=n(a.borderWidth)?Math.max(...Object.values(a.borderWidth)):a.borderWidth||1,t.strokeStyle=a.borderColor,t.setLineDash(a.borderDash||[]),t.lineDashOffset=a.borderDashOffset||0;const e=s.leftForLtr(f,h-c),i=s.leftForLtr(s.xPlus(f,1),h-c-2),r=fi(a.borderRadius);Object.values(r).some((t=>0!==t))?(t.beginPath(),t.fillStyle=o.multiKeyBackground,Te(t,{x:e,y:p,w:h,h:l,radius:r}),t.fill(),t.stroke(),t.fillStyle=a.backgroundColor,t.beginPath(),Te(t,{x:i,y:p+1,w:h-2,h:l-2,radius:r}),t.fill()):(t.fillStyle=o.multiKeyBackground,t.fillRect(e,p,h,l),t.strokeRect(e,p,h,l),t.fillStyle=a.backgroundColor,t.fillRect(i,p+1,h-2,l-2))}t.fillStyle=this.labelTextColors[i]}drawBody(t,e,i){const{body:s}=this,{bodySpacing:n,bodyAlign:o,displayColors:a,boxHeight:r,boxWidth:l,boxPadding:h}=i,c=pi(i.bodyFont);let u=c.lineHeight,f=0;const g=_i(i.rtl,this.x,this.width),p=function(i){e.fillText(i,g.x(t.x+f),t.y+u/2),t.y+=u+n},m=g.textAlign(o);let b,x,_,y,v,w,M;for(e.textAlign=o,e.textBaseline="middle",e.font=c.string,t.x=_o(this,m,i),e.fillStyle=i.bodyColor,d(this.beforeBody,p),f=a&&"right"!==m?"center"===o?l/2+h:l+2+h:0,y=0,w=s.length;y<w;++y){for(b=s[y],x=this.labelTextColors[y],e.fillStyle=x,d(b.before,p),_=b.lines,a&&_.length&&(this._drawColorBox(e,t,y,g,i),u=Math.max(c.lineHeight,r)),v=0,M=_.length;v<M;++v)p(_[v]),u=c.lineHeight;d(b.after,p)}f=0,u=c.lineHeight,d(this.afterBody,p),t.y-=n}drawFooter(t,e,i){const s=this.footer,n=s.length;let o,a;if(n){const r=_i(i.rtl,this.x,this.width);for(t.x=_o(this,i.footerAlign,i),t.y+=i.footerMarginTop,e.textAlign=r.textAlign(i.footerAlign),e.textBaseline="middle",o=pi(i.footerFont),e.fillStyle=i.footerColor,e.font=o.string,a=0;a<n;++a)e.fillText(s[a],r.x(t.x),t.y+o.lineHeight/2),t.y+=o.lineHeight+i.footerSpacing}}drawBackground(t,e,i,s){const{xAlign:n,yAlign:o}=this,{x:a,y:r}=t,{width:l,height:h}=i,{topLeft:c,topRight:d,bottomLeft:u,bottomRight:f}=fi(s.cornerRadius);e.fillStyle=s.backgroundColor,e.strokeStyle=s.borderColor,e.lineWidth=s.borderWidth,e.beginPath(),e.moveTo(a+c,r),"top"===o&&this.drawCaret(t,e,i,s),e.lineTo(a+l-d,r),e.quadraticCurveTo(a+l,r,a+l,r+d),"center"===o&&"right"===n&&this.drawCaret(t,e,i,s),e.lineTo(a+l,r+h-f),e.quadraticCurveTo(a+l,r+h,a+l-f,r+h),"bottom"===o&&this.drawCaret(t,e,i,s),e.lineTo(a+u,r+h),e.quadraticCurveTo(a,r+h,a,r+h-u),"center"===o&&"left"===n&&this.drawCaret(t,e,i,s),e.lineTo(a,r+c),e.quadraticCurveTo(a,r,a+c,r),e.closePath(),e.fill(),s.borderWidth>0&&e.stroke()}_updateAnimationTarget(t){const e=this.chart,i=this.$animations,s=i&&i.x,n=i&&i.y;if(s||n){const i=co[t.position].call(this,this._active,this._eventPosition);if(!i)return;const o=this._size=po(this,t),a=Object.assign({},i,this._size),r=bo(e,t,a),l=xo(t,a,r,e);s._to===l.x&&n._to===l.y||(this.xAlign=r.xAlign,this.yAlign=r.yAlign,this.width=o.width,this.height=o.height,this.caretX=i.x,this.caretY=i.y,this._resolveAnimations().update(this,l))}}_willRender(){return!!this.opacity}draw(t){const e=this.options.setContext(this.getContext());let i=this.opacity;if(!i)return;this._updateAnimationTarget(e);const s={width:this.width,height:this.height},n={x:this.x,y:this.y};i=Math.abs(i)<.001?0:i;const o=gi(e.padding),a=this.title.length||this.beforeBody.length||this.body.length||this.afterBody.length||this.footer.length;e.enabled&&a&&(t.save(),t.globalAlpha=i,this.drawBackground(n,t,s,e),yi(t,e.textDirection),n.y+=o.top,this.drawTitle(n,t,e),this.drawBody(n,t,e),this.drawFooter(n,t,e),vi(t,e.textDirection),t.restore())}getActiveElements(){return this._active||[]}setActiveElements(t,e){const i=this._active,s=t.map((({datasetIndex:t,index:e})=>{const i=this.chart.getDatasetMeta(t);if(!i)throw new Error("Cannot find a dataset at index "+t);return{datasetIndex:t,element:i.data[e],index:e}})),n=!u(i,s),o=this._positionChanged(s,e);(n||o)&&(this._active=s,this._eventPosition=e,this._ignoreReplayEvents=!0,this.update(!0))}handleEvent(t,e,i=!0){if(e&&this._ignoreReplayEvents)return!1;this._ignoreReplayEvents=!1;const s=this.options,n=this._active||[],o=this._getActiveElements(t,n,e,i),a=this._positionChanged(o,t),r=e||!u(o,n)||a;return r&&(this._active=o,(s.enabled||s.external)&&(this._eventPosition={x:t.x,y:t.y},this.update(!0,e))),r}_getActiveElements(t,e,i,s){const n=this.options;if("mouseout"===t.type)return[];if(!s)return e;const o=this.chart.getElementsAtEventForMode(t,n.mode,n,i);return n.reverse&&o.reverse(),o}_positionChanged(t,e){const{caretX:i,caretY:s,options:n}=this,o=co[n.position].call(this,t,e);return!1!==o&&(i!==o.x||s!==o.y)}}Tooltip.positioners=co;var wo={id:"tooltip",_element:Tooltip,positioners:co,afterInit(t,e,i){i&&(t.tooltip=new Tooltip({chart:t,options:i}))},beforeUpdate(t,e,i){t.tooltip&&t.tooltip.initialize(i)},reset(t,e,i){t.tooltip&&t.tooltip.initialize(i)},afterDraw(t){const e=t.tooltip;if(e&&e._willRender()){const i={tooltip:e};if(!1===t.notifyPlugins("beforeTooltipDraw",i))return;e.draw(t.ctx),t.notifyPlugins("afterTooltipDraw",i)}},afterEvent(t,e){if(t.tooltip){const i=e.replay;t.tooltip.handleEvent(e.event,i,e.inChartArea)&&(e.changed=!0)}},defaults:{enabled:!0,external:null,position:"average",backgroundColor:"rgba(0,0,0,0.8)",titleColor:"#fff",titleFont:{weight:"bold"},titleSpacing:2,titleMarginBottom:6,titleAlign:"left",bodyColor:"#fff",bodySpacing:2,bodyFont:{},bodyAlign:"left",footerColor:"#fff",footerSpacing:2,footerMarginTop:6,footerFont:{weight:"bold"},footerAlign:"left",padding:6,caretPadding:2,caretSize:5,cornerRadius:6,boxHeight:(t,e)=>e.bodyFont.size,boxWidth:(t,e)=>e.bodyFont.size,multiKeyBackground:"#fff",displayColors:!0,boxPadding:0,borderColor:"rgba(0,0,0,0)",borderWidth:0,animation:{duration:400,easing:"easeOutQuart"},animations:{numbers:{type:"number",properties:["x","y","width","height","caretX","caretY"]},opacity:{easing:"linear",duration:200}},callbacks:{beforeTitle:t,title(t){if(t.length>0){const e=t[0],i=e.chart.data.labels,s=i?i.length:0;if(this&&this.options&&"dataset"===this.options.mode)return e.dataset.label||"";if(e.label)return e.label;if(s>0&&e.dataIndex<s)return i[e.dataIndex]}return""},afterTitle:t,beforeBody:t,beforeLabel:t,label(t){if(this&&this.options&&"dataset"===this.options.mode)return t.label+": "+t.formattedValue||t.formattedValue;let e=t.dataset.label||"";e&&(e+=": ");const s=t.formattedValue;return i(s)||(e+=s),e},labelColor(t){const e=t.chart.getDatasetMeta(t.datasetIndex).controller.getStyle(t.dataIndex);return{borderColor:e.borderColor,backgroundColor:e.backgroundColor,borderWidth:e.borderWidth,borderDash:e.borderDash,borderDashOffset:e.borderDashOffset,borderRadius:0}},labelTextColor(){return this.options.bodyColor},labelPointStyle(t){const e=t.chart.getDatasetMeta(t.datasetIndex).controller.getStyle(t.dataIndex);return{pointStyle:e.pointStyle,rotation:e.rotation}},afterLabel:t,afterBody:t,beforeFooter:t,footer:t,afterFooter:t}},defaultRoutes:{bodyFont:"font",footerFont:"font",titleFont:"font"},descriptors:{_scriptable:t=>"filter"!==t&&"itemSort"!==t&&"external"!==t,_indexable:!1,callbacks:{_scriptable:!1,_indexable:!1},animation:{_fallback:!1},animations:{_fallback:"animation"}},additionalOptionScopes:["interaction"]},Mo=Object.freeze({__proto__:null,Decimation:Hn,Filler:no,Legend:ao,SubTitle:ho,Title:ro,Tooltip:wo});function ko(t,e,i,s){const n=t.indexOf(e);if(-1===n)return((t,e,i,s)=>("string"==typeof e?(i=t.push(e)-1,s.unshift({index:i,label:e})):isNaN(e)&&(i=null),i))(t,e,i,s);return n!==t.lastIndexOf(e)?i:n}class CategoryScale extends Scale{constructor(t){super(t),this._startValue=void 0,this._valueRange=0,this._addedLabels=[]}init(t){const e=this._addedLabels;if(e.length){const t=this.getLabels();for(const{index:i,label:s}of e)t[i]===s&&t.splice(i,1);this._addedLabels=[]}super.init(t)}parse(t,e){if(i(t))return null;const s=this.getLabels();return((t,e)=>null===t?null:Z(Math.round(t),0,e))(e=isFinite(e)&&s[e]===t?e:ko(s,t,r(e,t),this._addedLabels),s.length-1)}determineDataLimits(){const{minDefined:t,maxDefined:e}=this.getUserBounds();let{min:i,max:s}=this.getMinMax(!0);"ticks"===this.options.bounds&&(t||(i=0),e||(s=this.getLabels().length-1)),this.min=i,this.max=s}buildTicks(){const t=this.min,e=this.max,i=this.options.offset,s=[];let n=this.getLabels();n=0===t&&e===n.length-1?n:n.slice(t,e+1),this._valueRange=Math.max(n.length-(i?0:1),1),this._startValue=this.min-(i?.5:0);for(let o=t;o<=e;o++)s.push({value:o});return s}getLabelForValue(t){const e=this.getLabels();return t>=0&&t<e.length?e[t]:t}configure(){super.configure(),this.isHorizontal()||(this._reversePixels=!this._reversePixels)}getPixelForValue(t){return"number"!=typeof t&&(t=this.parse(t)),null===t?NaN:this.getPixelForDecimal((t-this._startValue)/this._valueRange)}getPixelForTick(t){const e=this.ticks;return t<0||t>e.length-1?null:this.getPixelForValue(e[t].value)}getValueForPixel(t){return Math.round(this._startValue+this.getDecimalForPixel(t)*this._valueRange)}getBasePixel(){return this.bottom}}function So(t,e,{horizontal:i,minRotation:s}){const n=j(s),o=(i?Math.sin(n):Math.cos(n))||.001,a=.75*e*(""+t).length;return Math.min(e/o,a)}CategoryScale.id="category",CategoryScale.defaults={ticks:{callback:CategoryScale.prototype.getLabelForValue}};class LinearScaleBase extends Scale{constructor(t){super(t),this.start=void 0,this.end=void 0,this._startValue=void 0,this._endValue=void 0,this._valueRange=0}parse(t,e){return i(t)||("number"==typeof t||t instanceof Number)&&!isFinite(+t)?null:+t}handleTickRangeOptions(){const{beginAtZero:t}=this.options,{minDefined:e,maxDefined:i}=this.getUserBounds();let{min:s,max:n}=this;const o=t=>s=e?s:t,a=t=>n=i?n:t;if(t){const t=z(s),e=z(n);t<0&&e<0?a(0):t>0&&e>0&&o(0)}if(s===n){let e=1;(n>=Number.MAX_SAFE_INTEGER||s<=Number.MIN_SAFE_INTEGER)&&(e=Math.abs(.05*n)),a(n+e),t||o(s-e)}this.min=s,this.max=n}getTickLimit(){const t=this.options.ticks;let e,{maxTicksLimit:i,stepSize:s}=t;return s?(e=Math.ceil(this.max/s)-Math.floor(this.min/s)+1,e>1e3&&(console.warn(`scales.${this.id}.ticks.stepSize: ${s} would result generating up to ${e} ticks. Limiting to 1000.`),e=1e3)):(e=this.computeTickLimit(),i=i||11),i&&(e=Math.min(i,e)),e}computeTickLimit(){return Number.POSITIVE_INFINITY}buildTicks(){const t=this.options,e=t.ticks;let s=this.getTickLimit();s=Math.max(2,s);const n=function(t,e){const s=[],{bounds:n,step:o,min:a,max:r,precision:l,count:h,maxTicks:c,maxDigits:d,includeBounds:u}=t,f=o||1,g=c-1,{min:p,max:m}=e,b=!i(a),x=!i(r),_=!i(h),y=(m-p)/(d+1);let v,w,M,k,S=F((m-p)/g/f)*f;if(S<1e-14&&!b&&!x)return[{value:p},{value:m}];k=Math.ceil(m/S)-Math.floor(p/S),k>g&&(S=F(k*S/g/f)*f),i(l)||(v=Math.pow(10,l),S=Math.ceil(S*v)/v),"ticks"===n?(w=Math.floor(p/S)*S,M=Math.ceil(m/S)*S):(w=p,M=m),b&&x&&o&&W((r-a)/o,S/1e3)?(k=Math.round(Math.min((r-a)/S,c)),S=(r-a)/k,w=a,M=r):_?(w=b?a:w,M=x?r:M,k=h-1,S=(M-w)/k):(k=(M-w)/S,k=N(k,Math.round(k),S/1e3)?Math.round(k):Math.ceil(k));const P=Math.max(Y(S),Y(w));v=Math.pow(10,i(l)?P:l),w=Math.round(w*v)/v,M=Math.round(M*v)/v;let C=0;for(b&&(u&&w!==a?(s.push({value:a}),w<a&&C++,N(Math.round((w+C*S)*v)/v,a,So(a,y,t))&&C++):w<a&&C++);C<k;++C)s.push({value:Math.round((w+C*S)*v)/v});return x&&u&&M!==r?s.length&&N(s[s.length-1].value,r,So(r,y,t))?s[s.length-1].value=r:s.push({value:r}):x&&M!==r||s.push({value:M}),s}({maxTicks:s,bounds:t.bounds,min:t.min,max:t.max,precision:e.precision,step:e.stepSize,count:e.count,maxDigits:this._maxDigits(),horizontal:this.isHorizontal(),minRotation:e.minRotation||0,includeBounds:!1!==e.includeBounds},this._range||this);return"ticks"===t.bounds&&H(n,this,"value"),t.reverse?(n.reverse(),this.start=this.max,this.end=this.min):(this.start=this.min,this.end=this.max),n}configure(){const t=this.ticks;let e=this.min,i=this.max;if(super.configure(),this.options.offset&&t.length){const s=(i-e)/Math.max(t.length-1,1)/2;e-=s,i+=s}this._startValue=e,this._endValue=i,this._valueRange=i-e}getLabelForValue(t){return ri(t,this.chart.options.locale,this.options.ticks.format)}}class LinearScale extends LinearScaleBase{determineDataLimits(){const{min:t,max:e}=this.getMinMax(!0);this.min=o(t)?t:0,this.max=o(e)?e:1,this.handleTickRangeOptions()}computeTickLimit(){const t=this.isHorizontal(),e=t?this.width:this.height,i=j(this.options.ticks.minRotation),s=(t?Math.sin(i):Math.cos(i))||.001,n=this._resolveTickFontOptions(0);return Math.ceil(e/Math.min(40,n.lineHeight/s))}getPixelForValue(t){return null===t?NaN:this.getPixelForDecimal((t-this._startValue)/this._valueRange)}getValueForPixel(t){return this._startValue+this.getDecimalForPixel(t)*this._valueRange}}function Po(t){return 1===t/Math.pow(10,Math.floor(I(t)))}LinearScale.id="linear",LinearScale.defaults={ticks:{callback:Ds.formatters.numeric}};class LogarithmicScale extends Scale{constructor(t){super(t),this.start=void 0,this.end=void 0,this._startValue=void 0,this._valueRange=0}parse(t,e){const i=LinearScaleBase.prototype.parse.apply(this,[t,e]);if(0!==i)return o(i)&&i>0?i:null;this._zero=!0}determineDataLimits(){const{min:t,max:e}=this.getMinMax(!0);this.min=o(t)?Math.max(0,t):null,this.max=o(e)?Math.max(0,e):null,this.options.beginAtZero&&(this._zero=!0),this.handleTickRangeOptions()}handleTickRangeOptions(){const{minDefined:t,maxDefined:e}=this.getUserBounds();let i=this.min,s=this.max;const n=e=>i=t?i:e,o=t=>s=e?s:t,a=(t,e)=>Math.pow(10,Math.floor(I(t))+e);i===s&&(i<=0?(n(1),o(10)):(n(a(i,-1)),o(a(s,1)))),i<=0&&n(a(s,-1)),s<=0&&o(a(i,1)),this._zero&&this.min!==this._suggestedMin&&i===a(this.min,0)&&n(a(i,-1)),this.min=i,this.max=s}buildTicks(){const t=this.options,e=function(t,e){const i=Math.floor(I(e.max)),s=Math.ceil(e.max/Math.pow(10,i)),n=[];let o=a(t.min,Math.pow(10,Math.floor(I(e.min)))),r=Math.floor(I(o)),l=Math.floor(o/Math.pow(10,r)),h=r<0?Math.pow(10,Math.abs(r)):1;do{n.push({value:o,major:Po(o)}),++l,10===l&&(l=1,++r,h=r>=0?1:h),o=Math.round(l*Math.pow(10,r)*h)/h}while(r<i||r===i&&l<s);const c=a(t.max,o);return n.push({value:c,major:Po(o)}),n}({min:this._userMin,max:this._userMax},this);return"ticks"===t.bounds&&H(e,this,"value"),t.reverse?(e.reverse(),this.start=this.max,this.end=this.min):(this.start=this.min,this.end=this.max),e}getLabelForValue(t){return void 0===t?"0":ri(t,this.chart.options.locale,this.options.ticks.format)}configure(){const t=this.min;super.configure(),this._startValue=I(t),this._valueRange=I(this.max)-I(t)}getPixelForValue(t){return void 0!==t&&0!==t||(t=this.min),null===t||isNaN(t)?NaN:this.getPixelForDecimal(t===this.min?0:(I(t)-this._startValue)/this._valueRange)}getValueForPixel(t){const e=this.getDecimalForPixel(t);return Math.pow(10,this._startValue+e*this._valueRange)}}function Co(t){const e=t.ticks;if(e.display&&t.display){const t=gi(e.backdropPadding);return r(e.font&&e.font.size,se.font.size)+t.height}return 0}function Do(t,e,i,s,n){return t===s||t===n?{start:e-i/2,end:e+i/2}:t<s||t>n?{start:e-i,end:e}:{start:e,end:e+i}}function Ao(t){const e={l:t.left+t._padding.left,r:t.right-t._padding.right,t:t.top+t._padding.top,b:t.bottom-t._padding.bottom},i=Object.assign({},e),n=[],o=[],a=t._pointLabels.length,r=t.options.pointLabels,l=r.centerPointLabels?C/a:0;for(let u=0;u<a;u++){const a=r.setContext(t.getPointLabelContext(u));o[u]=a.padding;const f=t.getPointPosition(u,t.drawingArea+o[u],l),g=pi(a.font),p=(h=t.ctx,c=g,d=s(d=t._pointLabels[u])?d:[d],{w:_e(h,c.string,d),h:d.length*c.lineHeight});n[u]=p;const m=K(t.getIndexAngle(u)+l),b=Math.round($(m));Oo(i,e,m,Do(b,f.x,p.w,0,180),Do(b,f.y,p.h,90,270))}var h,c,d;t.setCenterPoint(e.l-i.l,i.r-e.r,e.t-i.t,i.b-e.b),t._pointLabelItems=function(t,e,i){const s=[],n=t._pointLabels.length,o=t.options,a=Co(o)/2,r=t.drawingArea,l=o.pointLabels.centerPointLabels?C/n:0;for(let h=0;h<n;h++){const n=t.getPointPosition(h,r+a+i[h],l),o=Math.round($(K(n.angle+L))),c=e[h],d=Eo(n.y,c.h,o),u=To(o),f=Lo(n.x,c.w,u);s.push({x:n.x,y:d,textAlign:u,left:f,top:d,right:f+c.w,bottom:d+c.h})}return s}(t,n,o)}function Oo(t,e,i,s,n){const o=Math.abs(Math.sin(i)),a=Math.abs(Math.cos(i));let r=0,l=0;s.start<e.l?(r=(e.l-s.start)/o,t.l=Math.min(t.l,e.l-r)):s.end>e.r&&(r=(s.end-e.r)/o,t.r=Math.max(t.r,e.r+r)),n.start<e.t?(l=(e.t-n.start)/a,t.t=Math.min(t.t,e.t-l)):n.end>e.b&&(l=(n.end-e.b)/a,t.b=Math.max(t.b,e.b+l))}function To(t){return 0===t||180===t?"center":t<180?"left":"right"}function Lo(t,e,i){return"right"===i?t-=e:"center"===i&&(t-=e/2),t}function Eo(t,e,i){return 90===i||270===i?t-=e/2:(i>270||i<90)&&(t-=e),t}function Ro(t,e,i,s){const{ctx:n}=t;if(i)n.arc(t.xCenter,t.yCenter,e,0,D);else{let i=t.getPointPosition(0,e);n.moveTo(i.x,i.y);for(let o=1;o<s;o++)i=t.getPointPosition(o,e),n.lineTo(i.x,i.y)}}LogarithmicScale.id="logarithmic",LogarithmicScale.defaults={ticks:{callback:Ds.formatters.logarithmic,major:{enabled:!0}}};class RadialLinearScale extends LinearScaleBase{constructor(t){super(t),this.xCenter=void 0,this.yCenter=void 0,this.drawingArea=void 0,this._pointLabels=[],this._pointLabelItems=[]}setDimensions(){const t=this._padding=gi(Co(this.options)/2),e=this.width=this.maxWidth-t.width,i=this.height=this.maxHeight-t.height;this.xCenter=Math.floor(this.left+e/2+t.left),this.yCenter=Math.floor(this.top+i/2+t.top),this.drawingArea=Math.floor(Math.min(e,i)/2)}determineDataLimits(){const{min:t,max:e}=this.getMinMax(!1);this.min=o(t)&&!isNaN(t)?t:0,this.max=o(e)&&!isNaN(e)?e:0,this.handleTickRangeOptions()}computeTickLimit(){return Math.ceil(this.drawingArea/Co(this.options))}generateTickLabels(t){LinearScaleBase.prototype.generateTickLabels.call(this,t),this._pointLabels=this.getLabels().map(((t,e)=>{const i=c(this.options.pointLabels.callback,[t,e],this);return i||0===i?i:""})).filter(((t,e)=>this.chart.getDataVisibility(e)))}fit(){const t=this.options;t.display&&t.pointLabels.display?Ao(this):this.setCenterPoint(0,0,0,0)}setCenterPoint(t,e,i,s){this.xCenter+=Math.floor((t-e)/2),this.yCenter+=Math.floor((i-s)/2),this.drawingArea-=Math.min(this.drawingArea/2,Math.max(t,e,i,s))}getIndexAngle(t){return K(t*(D/(this._pointLabels.length||1))+j(this.options.startAngle||0))}getDistanceFromCenterForValue(t){if(i(t))return NaN;const e=this.drawingArea/(this.max-this.min);return this.options.reverse?(this.max-t)*e:(t-this.min)*e}getValueForDistanceFromCenter(t){if(i(t))return NaN;const e=t/(this.drawingArea/(this.max-this.min));return this.options.reverse?this.max-e:this.min+e}getPointLabelContext(t){const e=this._pointLabels||[];if(t>=0&&t<e.length){const i=e[t];return function(t,e,i){return xi(t,{label:i,index:e,type:"pointLabel"})}(this.getContext(),t,i)}}getPointPosition(t,e,i=0){const s=this.getIndexAngle(t)-L+i;return{x:Math.cos(s)*e+this.xCenter,y:Math.sin(s)*e+this.yCenter,angle:s}}getPointPositionForValue(t,e){return this.getPointPosition(t,this.getDistanceFromCenterForValue(e))}getBasePosition(t){return this.getPointPositionForValue(t||0,this.getBaseValue())}getPointLabelPosition(t){const{left:e,top:i,right:s,bottom:n}=this._pointLabelItems[t];return{left:e,top:i,right:s,bottom:n}}drawBackground(){const{backgroundColor:t,grid:{circular:e}}=this.options;if(t){const i=this.ctx;i.save(),i.beginPath(),Ro(this,this.getDistanceFromCenterForValue(this._endValue),e,this._pointLabels.length),i.closePath(),i.fillStyle=t,i.fill(),i.restore()}}drawGrid(){const t=this.ctx,e=this.options,{angleLines:s,grid:n}=e,o=this._pointLabels.length;let a,r,l;if(e.pointLabels.display&&function(t,e){const{ctx:s,options:{pointLabels:n}}=t;for(let o=e-1;o>=0;o--){const e=n.setContext(t.getPointLabelContext(o)),a=pi(e.font),{x:r,y:l,textAlign:h,left:c,top:d,right:u,bottom:f}=t._pointLabelItems[o],{backdropColor:g}=e;if(!i(g)){const t=fi(e.borderRadius),i=gi(e.backdropPadding);s.fillStyle=g;const n=c-i.left,o=d-i.top,a=u-c+i.width,r=f-d+i.height;Object.values(t).some((t=>0!==t))?(s.beginPath(),Te(s,{x:n,y:o,w:a,h:r,radius:t}),s.fill()):s.fillRect(n,o,a,r)}Ae(s,t._pointLabels[o],r,l+a.lineHeight/2,a,{color:e.color,textAlign:h,textBaseline:"middle"})}}(this,o),n.display&&this.ticks.forEach(((t,e)=>{if(0!==e){r=this.getDistanceFromCenterForValue(t.value);!function(t,e,i,s){const n=t.ctx,o=e.circular,{color:a,lineWidth:r}=e;!o&&!s||!a||!r||i<0||(n.save(),n.strokeStyle=a,n.lineWidth=r,n.setLineDash(e.borderDash),n.lineDashOffset=e.borderDashOffset,n.beginPath(),Ro(t,i,o,s),n.closePath(),n.stroke(),n.restore())}(this,n.setContext(this.getContext(e-1)),r,o)}})),s.display){for(t.save(),a=o-1;a>=0;a--){const i=s.setContext(this.getPointLabelContext(a)),{color:n,lineWidth:o}=i;o&&n&&(t.lineWidth=o,t.strokeStyle=n,t.setLineDash(i.borderDash),t.lineDashOffset=i.borderDashOffset,r=this.getDistanceFromCenterForValue(e.ticks.reverse?this.min:this.max),l=this.getPointPosition(a,r),t.beginPath(),t.moveTo(this.xCenter,this.yCenter),t.lineTo(l.x,l.y),t.stroke())}t.restore()}}drawBorder(){}drawLabels(){const t=this.ctx,e=this.options,i=e.ticks;if(!i.display)return;const s=this.getIndexAngle(0);let n,o;t.save(),t.translate(this.xCenter,this.yCenter),t.rotate(s),t.textAlign="center",t.textBaseline="middle",this.ticks.forEach(((s,a)=>{if(0===a&&!e.reverse)return;const r=i.setContext(this.getContext(a)),l=pi(r.font);if(n=this.getDistanceFromCenterForValue(this.ticks[a].value),r.showLabelBackdrop){t.font=l.string,o=t.measureText(s.label).width,t.fillStyle=r.backdropColor;const e=gi(r.backdropPadding);t.fillRect(-o/2-e.left,-n-l.size/2-e.top,o+e.width,l.size+e.height)}Ae(t,s.label,0,-n,l,{color:r.color})})),t.restore()}drawTitle(){}}RadialLinearScale.id="radialLinear",RadialLinearScale.defaults={display:!0,animate:!0,position:"chartArea",angleLines:{display:!0,lineWidth:1,borderDash:[],borderDashOffset:0},grid:{circular:!1},startAngle:0,ticks:{showLabelBackdrop:!0,callback:Ds.formatters.numeric},pointLabels:{backdropColor:void 0,backdropPadding:2,display:!0,font:{size:10},callback:t=>t,padding:5,centerPointLabels:!1}},RadialLinearScale.defaultRoutes={"angleLines.color":"borderColor","pointLabels.color":"color","ticks.color":"color"},RadialLinearScale.descriptors={angleLines:{_fallback:"grid"}};const Io={millisecond:{common:!0,size:1,steps:1e3},second:{common:!0,size:1e3,steps:60},minute:{common:!0,size:6e4,steps:60},hour:{common:!0,size:36e5,steps:24},day:{common:!0,size:864e5,steps:30},week:{common:!1,size:6048e5,steps:4},month:{common:!0,size:2628e6,steps:12},quarter:{common:!1,size:7884e6,steps:4},year:{common:!0,size:3154e7}},zo=Object.keys(Io);function Fo(t,e){return t-e}function Bo(t,e){if(i(e))return null;const s=t._adapter,{parser:n,round:a,isoWeekday:r}=t._parseOpts;let l=e;return"function"==typeof n&&(l=n(l)),o(l)||(l="string"==typeof n?s.parse(l,n):s.parse(l)),null===l?null:(a&&(l="week"!==a||!V(r)&&!0!==r?s.startOf(l,a):s.startOf(l,"isoWeek",r)),+l)}function Vo(t,e,i,s){const n=zo.length;for(let o=zo.indexOf(t);o<n-1;++o){const t=Io[zo[o]],n=t.steps?t.steps:Number.MAX_SAFE_INTEGER;if(t.common&&Math.ceil((i-e)/(n*t.size))<=s)return zo[o]}return zo[n-1]}function No(t,e,i){if(i){if(i.length){const{lo:s,hi:n}=tt(i,e);t[i[s]>=e?i[s]:i[n]]=!0}}else t[e]=!0}function Wo(t,e,i){const s=[],n={},o=e.length;let a,r;for(a=0;a<o;++a)r=e[a],n[r]=a,s.push({value:r,major:!1});return 0!==o&&i?function(t,e,i,s){const n=t._adapter,o=+n.startOf(e[0].value,s),a=e[e.length-1].value;let r,l;for(r=o;r<=a;r=+n.add(r,1,s))l=i[r],l>=0&&(e[l].major=!0);return e}(t,s,n,i):s}class TimeScale extends Scale{constructor(t){super(t),this._cache={data:[],labels:[],all:[]},this._unit="day",this._majorUnit=void 0,this._offsets={},this._normalized=!1,this._parseOpts=void 0}init(t,e){const i=t.time||(t.time={}),s=this._adapter=new hn._date(t.adapters.date);s.init(e),b(i.displayFormats,s.formats()),this._parseOpts={parser:i.parser,round:i.round,isoWeekday:i.isoWeekday},super.init(t),this._normalized=e.normalized}parse(t,e){return void 0===t?null:Bo(this,t)}beforeLayout(){super.beforeLayout(),this._cache={data:[],labels:[],all:[]}}determineDataLimits(){const t=this.options,e=this._adapter,i=t.time.unit||"day";let{min:s,max:n,minDefined:a,maxDefined:r}=this.getUserBounds();function l(t){a||isNaN(t.min)||(s=Math.min(s,t.min)),r||isNaN(t.max)||(n=Math.max(n,t.max))}a&&r||(l(this._getLabelBounds()),"ticks"===t.bounds&&"labels"===t.ticks.source||l(this.getMinMax(!1))),s=o(s)&&!isNaN(s)?s:+e.startOf(Date.now(),i),n=o(n)&&!isNaN(n)?n:+e.endOf(Date.now(),i)+1,this.min=Math.min(s,n-1),this.max=Math.max(s+1,n)}_getLabelBounds(){const t=this.getLabelTimestamps();let e=Number.POSITIVE_INFINITY,i=Number.NEGATIVE_INFINITY;return t.length&&(e=t[0],i=t[t.length-1]),{min:e,max:i}}buildTicks(){const t=this.options,e=t.time,i=t.ticks,s="labels"===i.source?this.getLabelTimestamps():this._generate();"ticks"===t.bounds&&s.length&&(this.min=this._userMin||s[0],this.max=this._userMax||s[s.length-1]);const n=this.min,o=st(s,n,this.max);return this._unit=e.unit||(i.autoSkip?Vo(e.minUnit,this.min,this.max,this._getLabelCapacity(n)):function(t,e,i,s,n){for(let o=zo.length-1;o>=zo.indexOf(i);o--){const i=zo[o];if(Io[i].common&&t._adapter.diff(n,s,i)>=e-1)return i}return zo[i?zo.indexOf(i):0]}(this,o.length,e.minUnit,this.min,this.max)),this._majorUnit=i.major.enabled&&"year"!==this._unit?function(t){for(let e=zo.indexOf(t)+1,i=zo.length;e<i;++e)if(Io[zo[e]].common)return zo[e]}(this._unit):void 0,this.initOffsets(s),t.reverse&&o.reverse(),Wo(this,o,this._majorUnit)}afterAutoSkip(){this.options.offsetAfterAutoskip&&this.initOffsets(this.ticks.map((t=>+t.value)))}initOffsets(t){let e,i,s=0,n=0;this.options.offset&&t.length&&(e=this.getDecimalForValue(t[0]),s=1===t.length?1-e:(this.getDecimalForValue(t[1])-e)/2,i=this.getDecimalForValue(t[t.length-1]),n=1===t.length?i:(i-this.getDecimalForValue(t[t.length-2]))/2);const o=t.length<3?.5:.25;s=Z(s,0,o),n=Z(n,0,o),this._offsets={start:s,end:n,factor:1/(s+1+n)}}_generate(){const t=this._adapter,e=this.min,i=this.max,s=this.options,n=s.time,o=n.unit||Vo(n.minUnit,e,i,this._getLabelCapacity(e)),a=r(n.stepSize,1),l="week"===o&&n.isoWeekday,h=V(l)||!0===l,c={};let d,u,f=e;if(h&&(f=+t.startOf(f,"isoWeek",l)),f=+t.startOf(f,h?"day":o),t.diff(i,e,o)>1e5*a)throw new Error(e+" and "+i+" are too far apart with stepSize of "+a+" "+o);const g="data"===s.ticks.source&&this.getDataTimestamps();for(d=f,u=0;d<i;d=+t.add(d,a,o),u++)No(c,d,g);return d!==i&&"ticks"!==s.bounds&&1!==u||No(c,d,g),Object.keys(c).sort(((t,e)=>t-e)).map((t=>+t))}getLabelForValue(t){const e=this._adapter,i=this.options.time;return i.tooltipFormat?e.format(t,i.tooltipFormat):e.format(t,i.displayFormats.datetime)}_tickFormatFunction(t,e,i,s){const n=this.options,o=n.time.displayFormats,a=this._unit,r=this._majorUnit,l=a&&o[a],h=r&&o[r],d=i[e],u=r&&h&&d&&d.major,f=this._adapter.format(t,s||(u?h:l)),g=n.ticks.callback;return g?c(g,[f,e,i],this):f}generateTickLabels(t){let e,i,s;for(e=0,i=t.length;e<i;++e)s=t[e],s.label=this._tickFormatFunction(s.value,e,t)}getDecimalForValue(t){return null===t?NaN:(t-this.min)/(this.max-this.min)}getPixelForValue(t){const e=this._offsets,i=this.getDecimalForValue(t);return this.getPixelForDecimal((e.start+i)*e.factor)}getValueForPixel(t){const e=this._offsets,i=this.getDecimalForPixel(t)/e.factor-e.end;return this.min+i*(this.max-this.min)}_getLabelSize(t){const e=this.options.ticks,i=this.ctx.measureText(t).width,s=j(this.isHorizontal()?e.maxRotation:e.minRotation),n=Math.cos(s),o=Math.sin(s),a=this._resolveTickFontOptions(0).size;return{w:i*n+a*o,h:i*o+a*n}}_getLabelCapacity(t){const e=this.options.time,i=e.displayFormats,s=i[e.unit]||i.millisecond,n=this._tickFormatFunction(t,0,Wo(this,[t],this._majorUnit),s),o=this._getLabelSize(n),a=Math.floor(this.isHorizontal()?this.width/o.w:this.height/o.h)-1;return a>0?a:1}getDataTimestamps(){let t,e,i=this._cache.data||[];if(i.length)return i;const s=this.getMatchingVisibleMetas();if(this._normalized&&s.length)return this._cache.data=s[0].controller.getAllParsedValues(this);for(t=0,e=s.length;t<e;++t)i=i.concat(s[t].controller.getAllParsedValues(this));return this._cache.data=this.normalize(i)}getLabelTimestamps(){const t=this._cache.labels||[];let e,i;if(t.length)return t;const s=this.getLabels();for(e=0,i=s.length;e<i;++e)t.push(Bo(this,s[e]));return this._cache.labels=this._normalized?t:this.normalize(t)}normalize(t){return rt(t.sort(Fo))}}function Ho(t,e,i){let s,n,o,a,r=0,l=t.length-1;i?(e>=t[r].pos&&e<=t[l].pos&&({lo:r,hi:l}=et(t,"pos",e)),({pos:s,time:o}=t[r]),({pos:n,time:a}=t[l])):(e>=t[r].time&&e<=t[l].time&&({lo:r,hi:l}=et(t,"time",e)),({time:s,pos:o}=t[r]),({time:n,pos:a}=t[l]));const h=n-s;return h?o+(a-o)*(e-s)/h:o}TimeScale.id="time",TimeScale.defaults={bounds:"data",adapters:{},time:{parser:!1,unit:!1,round:!1,isoWeekday:!1,minUnit:"millisecond",displayFormats:{}},ticks:{source:"auto",major:{enabled:!1}}};class TimeSeriesScale extends TimeScale{constructor(t){super(t),this._table=[],this._minPos=void 0,this._tableRange=void 0}initOffsets(){const t=this._getTimestampsForTable(),e=this._table=this.buildLookupTable(t);this._minPos=Ho(e,this.min),this._tableRange=Ho(e,this.max)-this._minPos,super.initOffsets(t)}buildLookupTable(t){const{min:e,max:i}=this,s=[],n=[];let o,a,r,l,h;for(o=0,a=t.length;o<a;++o)l=t[o],l>=e&&l<=i&&s.push(l);if(s.length<2)return[{time:e,pos:0},{time:i,pos:1}];for(o=0,a=s.length;o<a;++o)h=s[o+1],r=s[o-1],l=s[o],Math.round((h+r)/2)!==l&&n.push({time:l,pos:o/(a-1)});return n}_getTimestampsForTable(){let t=this._cache.all||[];if(t.length)return t;const e=this.getDataTimestamps(),i=this.getLabelTimestamps();return t=e.length&&i.length?this.normalize(e.concat(i)):e.length?e:i,t=this._cache.all=t,t}getDecimalForValue(t){return(Ho(this._table,t)-this._minPos)/this._tableRange}getValueForPixel(t){const e=this._offsets,i=this.getDecimalForPixel(t)/e.factor-e.end;return Ho(this._table,i*this._tableRange+this._minPos,!0)}}TimeSeriesScale.id="timeseries",TimeSeriesScale.defaults=TimeScale.defaults;var jo=Object.freeze({__proto__:null,CategoryScale:CategoryScale,LinearScale:LinearScale,LogarithmicScale:LogarithmicScale,RadialLinearScale:RadialLinearScale,TimeScale:TimeScale,TimeSeriesScale:TimeSeriesScale});return Chart.register(xn,jo,Vn,Mo),Chart.helpers={...Oi},Chart._adapters=hn,Chart.Animation=Animation,Chart.Animations=Animations,Chart.animator=mt,Chart.controllers=Fs.controllers.items,Chart.DatasetController=DatasetController,Chart.Element=Element,Chart.elements=Vn,Chart.Interaction=Fi,Chart.layouts=Gi,Chart.platforms=us,Chart.Scale=Scale,Chart.Ticks=Ds,Object.assign(Chart,xn,jo,Vn,Mo,us),Chart.Chart=Chart,"undefined"!=typeof window&&(window.Chart=Chart),Chart}));(function(t){'use strict';t.fn.aviaChart=function(n){if(!this.length){return};return this.each(function(){var n=t(this),a=n.data('chart_config'),i=n.find('.avia-chart').first(),r=null;if(!i.length||'undefined'==typeof(a)){return};r=new Chart(i,a)})};t(function(){t('.avia-chart-container').aviaChart()})}(jQuery));(function(a){a.fn.avia_ajax_form=function(r){var t={sendPath:'send.php',responseContainer:'.ajaxresponse'};var e=a.extend(t,r);return this.each(function(){var t=a(this),i=!1,o=t.data('fields-with-error'),r={formElements:t.find('textarea, select, input[type=text], input[type=checkbox], input[type=hidden]'),validationError:!1,button:t.find('input:submit'),dataObj:{},withError:[]},s=t.next(e.responseContainer).eq(0);r.button.on('click',l);if(a.avia_utilities.isMobile){r.formElements.each(function(r){var e=a(this),t=e.hasClass('is_email');if(t)e.attr('type','email')})};function l(e){r.validationError=!1;r.datastring='ajax=true';r.formElements=t.find('textarea, select, input[type=text], input[type=checkbox], input[type=hidden], input[type=email]');r.formElements.each(function(n){var d=a(this),e=d.parent(),s=d.val(),l=e.find('label').text().replace(/\*/g,'').trim(),c=d.attr('name'),i=d.attr('class'),o=!0;if(d.is(':checkbox')){if(d.is(':checked')){s=!0}
else{s=''}};r.dataObj[c]=encodeURIComponent(s);if(i&&i.match(/is_empty/)){if(s==''||s==null){e.removeClass('valid error ajax_alert').addClass('error');r.validationError=!0;r.withError.push(l)}
else{e.removeClass('valid error ajax_alert').addClass('valid')};o=!1};if(i&&i.match(/is_email/)){if(!s.match(/^[\w|\.|\-]+@\w[\w|\.|\-]*\.[a-zA-Z]{2,20}$/)){e.removeClass('valid error ajax_alert').addClass('error');r.validationError=!0;r.withError.push(l)}
else{e.removeClass('valid error ajax_alert').addClass('valid')};o=!1};if(i&&i.match(/is_ext_email/)){if(!s.match(/^[\w\.\-ÄÖÜäöü]+@\w[\w\.\-ÄÖÜäöü]*\.[a-zA-Z]{2,20}$/)){e.removeClass('valid error ajax_alert').addClass('error');r.validationError=!0;r.withError.push(l)}
else{e.removeClass('valid error ajax_alert').addClass('valid')};o=!1};if(i&&i.match(/is_special_email/)){if(!s.match(/^[a-zA-Z0-9.!#$%&'*+\-\/=?^_`{|}~ÄÖÜäöü]+@\w[\w\.\-ÄÖÜäöü]*\.[a-zA-Z]{2,20}$/)){e.removeClass('valid error ajax_alert').addClass('error');r.validationError=!0;r.withError.push(l)}
else{e.removeClass('valid error ajax_alert').addClass('valid')};o=!1};if(i&&i.match(/is_phone/)){if(!s.match(/^(\d|\s|\-|\/|\(|\)|\[|\]|e|x|t|ension|\.|\+|\_|\,|\:|\;){3,}$/)){e.removeClass('valid error ajax_alert').addClass('error');r.validationError=!0;r.withError.push(l)}
else{e.removeClass('valid error ajax_alert').addClass('valid')};o=!1};if(i&&i.match(/is_number/)){if(!s.match(/^-?\s*(0|[1-9]\d*)([\.,]\d+)?$/)){e.removeClass('valid error ajax_alert').addClass('error');r.validationError=!0;r.withError.push(l)}
else{e.removeClass('valid error ajax_alert').addClass('valid')};o=!1};if(i&&i.match(/is_positiv_number/)){if(!(v(s))||s==''||s<0){e.removeClass('valid error ajax_alert').addClass('error');r.validationError=!0;r.withError.push(l)}
else{e.removeClass('valid error ajax_alert').addClass('valid')};o=!1};if(i&&i.match(/captcha/)&&!i.match(/recaptcha/)){var f=t.find('#'+c+'_verifier').val(),m=f.charAt(f.length-1),h=f.charAt(m);if(s!=h){e.removeClass('valid error ajax_alert').addClass('error');r.validationError=!0}
else{e.removeClass('valid error ajax_alert').addClass('valid')};o=!1};if(o&&s!=''){e.removeClass('valid error ajax_alert').addClass('valid')}});t.find('.av-fields-with-error').remove();if(r.validationError==!1){if(t.data('av-custom-send')){d()}
else{n()}}
else{if(t.is('.av-show-form-errors')&&r.withError.length>0){var i=r.withError.join(', '),s=a('<p class="av-fields-with-error"></p>').insertAfter(a(r.button).parent());let msg=o?o+' ':'Found errors in the following field(s): ';s.text(msg+i);r.withError=[]}};return!1};function n(){if(i){return!1};if(r.button.hasClass('avia_button_inactive')){return!1};i=!0;r.button.addClass('av-sending-button');r.button.val(r.button.data('sending-label'));var o=t.data('avia-redirect')||!1,l=t.attr('action'),n=t.is('.av-form-labels-style');if(n){return};s.load(l+' '+e.responseContainer,r.dataObj,function(){if(o&&l!=o){t.attr('action',o);location.href=o}
else{s.removeClass('hidden').css({display:'block'});t.slideUp(400,function(){s.slideDown(400,function(){a('body').trigger('av_resize_finished')});r.formElements.val('')})}})};function d(){if(i){return!1};i=!0;var v=r.button.val();r.button.addClass('av-sending-button');r.button.val(r.button.data('sending-label'));r.dataObj.ajax_mailchimp=!0;var o=t.data('avia-redirect')||!1,n=t.attr('action'),l=t.find('.av-form-error-container'),d=t.data('avia-form-id');a.ajax({url:n,type:'POST',data:r.dataObj,beforeSend:function(){if(l.length){l.slideUp(400,function(){l.remove();a('body').trigger('av_resize_finished')})}},success:function(l){var c=jQuery('<div>').append(jQuery.parseHTML(l)),f=c.find('.av-form-error-container');if(f.length){i=!1;t.prepend(f);f.css({display:'none'}).slideDown(400,function(){a('body').trigger('av_resize_finished')});r.button.removeClass('av-sending-button');r.button.val(v)}
else{if(o&&n!=o){t.attr('action',o);location.href=o}
else{var m=c.find(e.responseContainer+'_'+d);s.html(m).removeClass('hidden').css({display:'block'});t.slideUp(400,function(){s.slideDown(400,function(){a('body').trigger('av_resize_finished')});r.formElements.val('')})}}},error:function(){},complete:function(){}})};function v(a){var r=typeof a;return(r==='number'||r==='string')&&!isNaN(a-parseFloat(a))}})}})(jQuery);(function(i){'use strict';i.AviaSlider=function(s,t){var e=this;this.$win=i(window);this.$slider=i(t);this.isMobile=i.avia_utilities.isMobile;this.isTouchDevice=i.avia_utilities.isTouchDevice,this._prepareSlides(s);i.avia_utilities.preload({container:this.$slider,single_callback:function(){e._init(s)}})};i.AviaSlider.defaults={interval:5,autoplay:!1,autoplay_stopper:!1,loop_autoplay:'once',loop_manual:'manual-endless',stopinfiniteloop:!1,noNavigation:!1,animation:'slide',transitionSpeed:900,easing:'easeInOutQuart',wrapElement:'>ul',slideElement:'>li',hoverpause:!1,bg_slider:!1,show_slide_delay:0,fullfade:!1,keep_padding:!1,carousel:'no',carouselSlidesToShow:3,carouselSlidesToScroll:1,carouselResponsive:[]};i.AviaSlider.prototype={_init:function(s){this.options=this._setOptions(s);this.$sliderUl=this.$slider.find(this.options.wrapElement);this.$slides=this.$sliderUl.find(this.options.slideElement);this.slide_arrows=this.$slider.find('.avia-slideshow-arrows');this.gotoButtons=this.$slider.find('.avia-slideshow-dots a');this.permaCaption=this.$slider.find('>.av-slideshow-caption');this.itemsCount=this.$slides.length;this.current=0;this.currentCarousel=0;this.slideWidthCarousel='240';this.loopCount=0;this.isAnimating=!1;this.browserPrefix=i.avia_utilities.supports('transition');this.cssActive=this.browserPrefix!==!1?!0:!1;this.css3DActive=document.documentElement.className.indexOf('avia_transform3d')!==-1?!0:!1;if(this.options.bg_slider==!0){this.imageUrls=[];this.loader=i.avia_utilities.loading(this.$slider);this._bgPreloadImages()}
else{this._kickOff()};if(this.options.carousel==='yes'){this.options.animation='carouselslide'}},_setOptions:function(s){var o=this.$slider.data('slideshow-options');if('object'==typeof o){var t=i.extend({},i.AviaSlider.defaults,s,o);if('undefined'!=typeof t.transition_speed){t.transitionSpeed=t.transition_speed};return t};var t=i.extend(!0,{},i.AviaSlider.defaults,s),a=this.$slider.data();for(var e in a){var n=('transition_speed'!=e)?e:'transitionSpeed';if(typeof a[e]==='string'||typeof a[e]==='number'||typeof a[e]==='boolean'){t[n]=a[e]};if('undefined'!=typeof t.autoplay_stopper&&t.autoplay_stopper==1){t.autoplay_stopper=!0}};return t},_prepareSlides:function(s){var t=this.$slider.find('.avia-multi-slideshow-button');if(t.length){t.on('click',function(s){s.stopPropagation();var t=i.avia_utilities.loading(i(this));t.show()})};if(this.isMobile){var e=this.$slider.find('.av-mobile-fallback-image');e.each(function(){var t=i(this).removeClass('av-video-slide').data({'avia_video_events':!0,'video-ratio':0}),n=t.data('mobile-img'),e=t.data('fallback-link'),a=t.find('.avia-slide-wrap');t.find('.av-click-overlay, .mejs-mediaelement, .mejs-container').remove();if(!n){i('<p class="av-fallback-message"><span>Please set a mobile device fallback image for this video in your wordpress backend</span></p>').appendTo(a)};if(s&&s.bg_slider){t.data('img-url',n);if(e!=''){if(a.is('a')){a.attr('href',e)}
else{a.replaceWith(function(){var s=i(this);return i('<a>').attr({'data-rel':s.data('rel'),'class':s.attr('class'),'href':e}).append(i(this).contents())});a=t.find('.avia-slide-wrap')};if(i.fn.avia_activate_lightbox){t.parents('#main').avia_activate_lightbox()}}}
else{var o='<img src="'+n+'" alt="" title="" />',l=!1;if('string'==typeof e&&e.trim()!=''){if(a.is('a')){a.attr('href',e)}
else{var r=e.match(/\.(jpg|jpeg|gif|png)$/i)!=null?' rel="lightbox" ':'';o='<a href="'+e.trim()+'"'+r+'>'+o+'</a>'};l=!0};t.find('.avia-slide-wrap').append(o);if(l&&i.fn.avia_activate_lightbox){t.parents('#main').avia_activate_lightbox()}}})};if(i('html').is('.pointer-device-fine')){if(i('body').is('.avia-slider-video-controls-fix-support')){avia_slider_video_controls_fix(this)}}},_bgPreloadImages:function(i){this._getImageURLS();this._preloadSingle(0,function(){this._kickOff();this._preloadNext(1)})},_getImageURLS:function(){var s=this;this.$slides.each(function(t){s.imageUrls[t]=[];s.imageUrls[t]['url']=i(this).data('img-url');if(typeof s.imageUrls[t]['url']=='string'){s.imageUrls[t]['status']=!1}
else{s.imageUrls[t]['status']=!0}})},_preloadSingle:function(s,t){var e=this,a=new Image();if(typeof e.imageUrls[s]['url']=='string'){i(a).on('load error',function(){e.imageUrls[s]['status']=!0;e.$slides.eq(s).css('background-image','url('+e.imageUrls[s]['url']+')');if(typeof t=='function'){t.apply(e,[a,s])}});if(e.imageUrls[s]['url']!=''){a.src=e.imageUrls[s]['url']}
else{i(a).trigger('error')}}
else{if(typeof t=='function'){t.apply(e,[a,s])}}},_preloadNext:function(i){if(typeof this.imageUrls[i]!='undefined'){this._preloadSingle(i,function(){this._preloadNext(i+1)})}},_bindEvents:function(){var t=this,s=i(window);this.$slider.on('click','.next-slide',this.next.bind(this));this.$slider.on('click','.prev-slide',this.previous.bind(this));this.$slider.on('click','.goto-slide',this.go2.bind(this));if(this.options.hoverpause){this.$slider.on('mouseenter',this.pause.bind(this));this.$slider.on('mouseleave',this.resume.bind(this))};if(this.permaCaption.length){this.permaCaption.on('click',this._routePermaCaptionClick);this.$slider.on('avia_slider_first_slide avia_slider_last_slide avia_slider_navigate_slide',this._setPermaCaptionPointer.bind(this))};if(this.options.stopinfiniteloop&&this.options.autoplay){if(this.options.stopinfiniteloop=='last'){this.$slider.on('avia_slider_last_slide',this._stopSlideshow.bind(this))}
else if(this.options.stopinfiniteloop=='first'){this.$slider.on('avia_slider_first_slide',this._stopSlideshow.bind(this))}};if(this.options.carousel==='yes'){if(!this.isMobile){s.on('debouncedresize',this._buildCarousel.bind(this))}}
else{s.on('debouncedresize.aviaSlider',this._setSize.bind(this))};if(!this.options.noNavigation){if(!this.isMobile){this.$slider.avia_keyboard_controls()};if(this.isMobile||this.isTouchDevice){this.$slider.avia_swipe_trigger()}};t._attach_video_events()},_kickOff:function(){var s=this,t=s.$slides.eq(0),e=t.data('video-ratio');s._bindEvents();s._set_slide_arrows_visibility();this.$slider.removeClass('av-default-height-applied');if(e){s._setSize(!0)}
else{if(this.options.keep_padding!=!0){s.$sliderUl.css('padding',0);s.$win.trigger('av-height-change')}};s._setCenter();if(this.options.carousel==='no'){t.addClass('next-active-slide');t.css({visibility:'visible',opacity:0}).avia_animate({opacity:1},function(){var t=i(this).addClass('active-slide');if(s.permaCaption.length){s.permaCaption.addClass('active-slide')}})};s.$slider.trigger('avia_slider_first_slide');if(s.options.autoplay){s._startSlideshow()};if(s.options.carousel==='yes'){s._buildCarousel()};s.$slider.trigger('_kickOff')},_set_slide_arrows_visibility:function(){if(this.options.carousel=='yes'){if(0==this.currentCarousel){this.slide_arrows.removeClass('av-visible-prev');this.slide_arrows.addClass('av-visible-next')}
else if(this.currentCarousel+this.options.carouselSlidesToShow>=this.itemsCount){this.slide_arrows.addClass('av-visible-prev');this.slide_arrows.removeClass('av-visible-next')}
else{this.slide_arrows.addClass('av-visible-prev');this.slide_arrows.addClass('av-visible-next')};return};if('endless'==this.options.loop_autoplay||'manual-endless'==this.options.loop_manual){this.slide_arrows.addClass('av-visible-prev');this.slide_arrows.addClass('av-visible-next')}
else if(0==this.current){this.slide_arrows.removeClass('av-visible-prev');this.slide_arrows.addClass('av-visible-next')}
else if(this.current+1>=this.itemsCount){this.slide_arrows.addClass('av-visible-prev');this.slide_arrows.removeClass('av-visible-next')}
else{this.slide_arrows.addClass('av-visible-prev');this.slide_arrows.addClass('av-visible-next')}},_buildCarousel:function(){var r=this,a=this.$slider.outerWidth(),s=parseInt(a/this.options.carouselSlidesToShow),l=window.innerWidth||i(window).width();if(this.options.carouselResponsive&&this.options.carouselResponsive.length&&this.options.carouselResponsive!==null){for(var e in this.options.carouselResponsive){var n=this.options.carouselResponsive[e]['breakpoint'],t=this.options.carouselResponsive[e]['settings']['carouselSlidesToShow'];if(n>=l){s=parseInt(a/t);this.options.carouselSlidesToShow=t}}};this.slideWidthCarousel=s;this.$slides.each(function(t){i(this).width(s)});var o=s*this.itemsCount;this.$sliderUl.width(o).css('transform','translateX(0px)');if(this.options.carouselSlidesToShow>=this.itemsCount){this.$slider.find('.av-timeline-nav').hide()}},_navigate:function(i,s){if(this.isAnimating||this.itemsCount<2 ||!this.$slider.is(':visible')){return!1};this.isAnimating=!0;this.prev=this.current;if(s!==undefined){this.current=s;i=this.current>this.prev?'next':'prev'}
else if(i==='next'){this.current=this.current<this.itemsCount-1?this.current+1:0;if(this.current===0&&this.options.autoplay_stopper&&this.options.autoplay){this.isAnimating=!1;this.current=this.prev;this._stopSlideshow();return!1};if(0===this.current){if('endless'!=this.options.loop_autoplay&&'manual-endless'!=this.options.loop_manual){this.isAnimating=!1;this.current=this.prev;return!1}}}
else if(i==='prev'){this.current=this.current>0?this.current-1:this.itemsCount-1;if(this.itemsCount-1===this.current){if('endless'!=this.options.loop_autoplay&&'manual-endless'!=this.options.loop_manual){this.isAnimating=!1;this.current=this.prev;return!1}}};this.gotoButtons.removeClass('active').eq(this.current).addClass('active');this._set_slide_arrows_visibility();if(this.options.carousel==='no'){this._setSize()};if(this.options.bg_slider==!0){if(this.imageUrls[this.current]['status']==!0){this['_'+this.options.animation].call(this,i)}
else{this.loader.show();this._preloadSingle(this.current,function(){this['_'+this.options.animation].call(this,i);this.loader.hide()})}}
else{this['_'+this.options.animation].call(this,i)};if(this.current==0){this.loopCount++;this.$slider.trigger('avia_slider_first_slide')}
else if(this.current==this.itemsCount-1){this.$slider.trigger('avia_slider_last_slide')}
else{this.$slider.trigger('avia_slider_navigate_slide')}},_setSize:function(i){if(this.options.bg_slider==!0){return};var n=this,s=this.$slides.eq(this.current),r=s.find('img'),a=Math.floor(this.$sliderUl.height()),o=s.data('video-ratio'),t=o?this.$sliderUl.width()/o:Math.floor(s.height()),e=s.data('video-height'),l=s.data('video-toppos');this.$sliderUl.height(a).css('padding',0);if(t!=a){if(i==!0){this.$sliderUl.css({height:t});this.$win.trigger('av-height-change')}
else{this.$sliderUl.avia_animate({height:t},function(){n.$win.trigger('av-height-change')})}};this._setCenter();if(e&&e!='set'){s.find('iframe, embed, video, object, .av_youtube_frame').css({height:e+'%',top:l+'%'});s.data('video-height','set')}},_setCenter:function(){var e=this.$slides.eq(this.current),o=e.find('img'),i=parseInt(o.css('min-width'),10),s=e.width(),a=e.find('.av-slideshow-caption'),t=((s-i)/2);if(a.length){if(a.is('.caption_left')){t=((s-i)/1.5)}
else if(a.is('.caption_right')){t=((s-i)/2.5)}};if(s>=i){t=0};o.css({left:t})},_carouselmove:function(){var i=this.slideWidthCarousel*this.currentCarousel;this.$sliderUl.css('transform','translateX(-'+i+'px)')},_carouselslide:function(i){console.log('_carouselslide:',i,this.currentCarousel);if(i==='next'){if(this.options.carouselSlidesToShow+this.currentCarousel<this.itemsCount){this.currentCarousel++;this._carouselmove()}}
else if(i==='prev'){if(this.currentCarousel>0){this.currentCarousel--;this._carouselmove()}};this._set_slide_arrows_visibility();this.isAnimating=!1},_slide:function(i){var l=!1,h=l==!0?2:1,r=this.$slider.width(),d=i==='next'?-1:1,s=this.browserPrefix+'transform',a={},t={},e={},o=(r*d*-1),n=(r*d)/h;if(this.cssActive){s=this.browserPrefix+'transform';if(this.css3DActive){a[s]='translate3d('+o+'px, 0, 0)';t[s]='translate3d('+n+'px, 0, 0)';e[s]='translate3d(0,0,0)'}
else{a[s]='translate('+o+'px,0)';t[s]='translate('+n+'px,0)';e[s]='translate(0,0)'}}
else{a.left=o;t.left=n;e.left=0};if(l){t['z-index']='1';e['z-index']='2'};this._slide_animate(a,t,e)},_slide_up:function(i){var l=!0,h=l==!0?2:1,r=this.$slider.height(),d=i==='next'?-1:1,s=this.browserPrefix+'transform',a={},t={},e={},o=(r*d*-1),n=(r*d)/h;if(this.cssActive){s=this.browserPrefix+'transform';if(this.css3DActive){a[s]='translate3d( 0,'+o+'px, 0)';t[s]='translate3d( 0,'+n+'px, 0)';e[s]='translate3d(0,0,0)'}
else{a[s]='translate( 0,'+o+'px)';t[s]='translate( 0,'+n+'px)';e[s]='translate(0,0)'}}
else{a.top=o;t.top=n;e.top=0};if(l){t['z-index']='1';e['z-index']='2'};this._slide_animate(a,t,e)},_slide_animate:function(i,e,a){var t=this,s=this.$slides.eq(this.current),o=this.$slides.eq(this.prev);o.trigger('pause');if(!s.data('disableAutoplay')){if(s.hasClass('av-video-lazyload')&&!s.hasClass('av-video-lazyload-complete')){s.find('.av-click-to-play-overlay').trigger('click')}
else{s.trigger('play')}};s.css({visibility:'visible',zIndex:4,opacity:1,left:0,top:0});s.css(i);o.avia_animate(e,this.options.transitionSpeed,this.options.easing);var n=function(){t.isAnimating=!1;s.addClass('active-slide');o.css({visibility:'hidden'}).removeClass('active-slide next-active-slide');t.$slider.trigger('avia-transition-done')};if(t.options.show_slide_delay>0){setTimeout(function(){s.addClass('next-active-slide');s.avia_animate(a,t.options.transitionSpeed,t.options.easing,n)},t.options.show_slide_delay)}
else{s.addClass('next-active-slide');s.avia_animate(a,t.options.transitionSpeed,t.options.easing,n)}},_fade:function(){var s=this,i=this.$slides.eq(this.current),t=this.$slides.eq(this.prev),e={visibility:'visible',zIndex:3,opacity:0},a=function(){s.isAnimating=!1;i.addClass('active-slide');t.css({visibility:'hidden',zIndex:2}).removeClass('active-slide next-active-slide');s.$slider.trigger('avia-transition-done')};t.trigger('pause');if(!i.data('disableAutoplay')){if(i.hasClass('av-video-lazyload')&&!i.hasClass('av-video-lazyload-complete')){i.find('.av-click-to-play-overlay').trigger('click')}
else{i.trigger('play')}};i.addClass('next-active-slide');if(s.options.fullfade==!0){t.avia_animate({opacity:0},200,'linear',function(){i.css(e).avia_animate({opacity:1},s.options.transitionSpeed,'linear',a)})}
else{if(s.current===0){t.avia_animate({opacity:0},s.options.transitionSpeed/2,'linear');i.css(e).avia_animate({opacity:1},s.options.transitionSpeed/2,'linear',a)}
else{i.css(e).avia_animate({opacity:1},s.options.transitionSpeed/2,'linear',function(){t.avia_animate({opacity:0},200,'linear',a)})}}},_attach_video_events:function(){var s=this,t=i('html');s.$slides.each(function(t){var n=i(this),r=n.find('.caption_fullwidth, .av-click-overlay'),d=n.find('.mejs-mediaelement'),l=n.hasClass('av-video-lazyload')?!0:!1;if(n.data('avia_video_events')!=!0){n.data('avia_video_events',!0);n.on('av-video-events-bound',{slide:n,wrap:d,iteration:t,self:s,lazyload:l},e);n.on('av-video-ended',{slide:n,self:s},a);n.on('av-video-play-executed',function(){setTimeout(function(){s.pause()},100)});r.on('click',{slide:n},o);if(n.is('.av-video-events-bound')){n.trigger('av-video-events-bound')};if(l&&t===0&&!n.data('disableAutoplay')){n.find('.av-click-to-play-overlay').trigger('click')}}});function e(i){if(i.data.iteration===0){i.data.wrap.css('opacity',0);if(!i.data.self.isMobile&&!i.data.slide.data('disableAutoplay')){i.data.slide.trigger('play')}; ;setTimeout(function(){i.data.wrap.avia_animate({opacity:1},400)},50)}
else if(t.is('.avia-msie')&&!i.data.slide.is('.av-video-service-html5')){if(!i.data.slide.data('disableAutoplay')){i.data.slide.trigger('play')}};if(i.data.slide.is('.av-video-service-html5')&&i.data.iteration!==0){i.data.slide.trigger('pause')};if(i.data.lazyload){i.data.slide.addClass('av-video-lazyload-complete');i.data.slide.trigger('play')}};function a(i){if(!i.data.slide.is('.av-single-slide')&&!i.data.slide.is('.av-loop-video')){i.data.slide.trigger('reset');s._navigate('next');s.resume()};if(i.data.slide.is('.av-loop-video')&&i.data.slide.is('.av-video-service-html5')){if(t.is('.avia-safari-8')){setTimeout(function(){i.data.slide.trigger('play')},1)}}};function o(i){if(i.target.tagName!='A'){i.data.slide.trigger('toggle')}}},_timer:function(i,s,o){var t=this,e,a=s;t.timerId=0;this.pause=function(){window.clearTimeout(t.timerId);a-=new Date()-e};this.resume=function(){e=new Date();t.timerId=window.setTimeout(i,a)};this.destroy=function(){window.clearTimeout(t.timerId)};this.resume(!0)},_startSlideshow:function(){var i=this;this.isPlaying=!0;this.slideshow=new this._timer(function(){i._navigate('next');if(i.options.autoplay){i._startSlideshow()}},(this.options.interval*1000))},_stopSlideshow:function(){if(this.options.autoplay){this.slideshow.destroy();this.isPlaying=!1;this.options.autoplay=!1};this.options.autoplay=!1;this.options.loop_autoplay='once';this.$slider.removeClass('av-slideshow-autoplay').addClass('av-slideshow-manual');this.$slider.removeClass('av-loop-endless').addClass('av-loop-once')},_setPermaCaptionPointer:function(s){if(!this.permaCaption.length){return};var t=i(this.$slides[this.current]).find('a').length;this.permaCaption.css('cursor',t?'pointer':'default')},_routePermaCaptionClick:function(s){var t=i(this).siblings('.avia-slideshow-inner').find('>.active-slide a');if(t.length){s.preventDefault();t[0].click()}},next:function(i){i.preventDefault();this._stopSlideshow();this._navigate('next')},previous:function(i){i.preventDefault();this._stopSlideshow();this._navigate('prev')},go2:function(i){if(isNaN(i)){i.preventDefault();i=i.currentTarget.hash.replace('#','')};i-=1;if(i===this.current||i>=this.itemsCount||i<0){return!1};this._stopSlideshow();this._navigate(!1,i)},play:function(){if(!this.isPlaying){this.isPlaying=!0;this._navigate('next');this.options.autoplay=!0;this._startSlideshow()}},pause:function(){if(this.isPlaying){this.slideshow.pause()}},resume:function(){if(this.isPlaying){this.slideshow.resume()}},destroy:function(i){this.slideshow.destroy(i)}};i.fn.aviaSlider=function(s){return this.each(function(){var t=i.data(this,'aviaSlider');if(!t){t=i.data(this,'aviaSlider',new i.AviaSlider(s,this))}})}})(jQuery);;var aviaJS=aviaJS||{};(function(e){'use strict';var t=['years','months','weeks','days','hours','minutes','seconds'],r=1000,a=r*60,n=a*60,o=n*24,d=o*7,l=function(t,e){return new Date(e,t,0).getDate()},m=function(t){var e={year:t.getFullYear(),month:t.getMonth()+1,day:t.getDate(),hours:t.getHours(),minutes:t.getMinutes(),seconds:t.getSeconds()};return e},c=function(t,e){var a=e.getFullYear()-t.year;if(a>0){var i=new Date(t.year+a,t.month-1,t.day,t.hours,t.minutes,t.seconds);if(i>e){a--}};return(a>=0)?a:0},f=function(t,e){var i=e.getMonth()+1,a=i-t.month;if(a<0){a=12-t.month+i};if(a>0){var n=new Date(t.year,t.month-1+a,t.day,t.hours,t.minutes,t.seconds);if(n>e){a--}};return(a>=0)?a:0},p=function(t,e){var i=e.getDate(),a=i-t.day;if(a<0){a=l(t.month,t.year)-t.day+i};if(a>0){var n=new Date(t.year,t.month-1,t.day+a,t.hours,t.minutes,t.seconds);if(n>e){a--}};return(a>=0)?a:0},h=function(t,a){var i=m(t),e={years:0,year_months:0,month_months:0,days:0};e.years=c(i,a);i.year+=e.years;e.year_months=f(i,a);i.month+=e.year_months;e.days=p(i,a);i.day+=e.days;e.month_months=e.years*12+e.year_months;return e},u=function(t,e){if(!0===e){for(let i in t.time){if(typeof t.update[i]=='object'&&t.update[i].label_container.length){t.update[i].label_container.css({'min-width':''})}};t.labelMinWidth=0;return};let newMin=t.labelMinWidth;for(let i in t.time){if(typeof t.update[i]=='object'&&t.update[i].label_container.length){let curr=t.update[i].label_container.outerWidth(!0);if(newMin<curr){newMin=curr}}};if(newMin>t.labelMinWidth){for(let i in t.time){if(typeof t.update[i]=='object'&&t.update[i].label_container.length){t.update[i].label_container.css({'min-width':newMin+'px'})}};t.labelMinWidth=newMin}},s=function(t){var m=new Date(),c=new Date(m.getTime()+m.getTimezoneOffset()*60000),s=t.end-c;if(s<=0){if(t.firstrun&&!t.container.hasClass('av-finished-msg')){s=0}
else{t.container.addClass('av-countdown-finished');clearInterval(t.countdown);return}};t.time.years=0;t.time.months=0;t.time.weeks=Math.floor(s/d);t.time.days=Math.floor((s%d)/o);t.time.hours=Math.floor((s%o)/n);t.time.minutes=Math.floor((s%n)/a);t.time.seconds=Math.floor((s%a)/r);var l=h(c,t.end);switch(t.data.maximum){case 1:t.time.seconds=Math.floor(s/r);break;case 2:t.time.minutes=Math.floor(s/a);break;case 3:t.time.hours=Math.floor(s/n);break;case 4:t.time.days=Math.floor(s/o);break;case 6:t.time.days=l.days;t.time.months=l.month_months;break;case 7:t.time.days=l.days;t.time.months=l.year_months;t.time.years=l.years;break};for(let i in t.time){if(typeof t.update[i]=='object'&&t.update[i].label_container.length){if(t.firstrun||t.oldtime[i]!=t.time[i]){let labelkey=(t.time[i]===1)?'single':'multi',new_label=t.update[i][labelkey],old_label=t.update[i].label_container.text();if(old_label!=new_label){t.update[i].label_container.text(new_label)};if(t.isFlipNumbers){if(t.update[i].unitContainer.length){if(!t.firstrun){t.update[i].backCard.attr('data-value',t.oldtime[i]);t.update[i].bottomCard.attr('data-value',t.oldtime[i])};t.update[i].topCard.text(t.time[i]);t.update[i].backBottomCard.attr('data-value',t.time[i]);t.update[i].unitContainer.removeClass('flip');void t.update[i].unitContainer[0].offsetWidth;t.update[i].unitContainer.addClass('flip')}}
else if(t.isFlipClock){if(t.update[i].unitContainer.length){if(!t.firstrun){t.update[i].currentTop.text(t.oldtime[i]);t.update[i].currentBottom.text(t.oldtime[i])};t.update[i].nextTop.text(t.time[i]);t.update[i].nextBottom.text(t.time[i]);t.update[i].unitContainer.removeClass('flip');void t.update[i].unitContainer[0].offsetWidth;t.update[i].unitContainer.addClass('flip')}}
else{t.update[i].time_container.text(t.time[i])}}}};if(t.firstrun){t.container.addClass('av-countdown-active')};t.oldtime=e.extend({},t.time);t.firstrun=!1;if((t.isFlipNumbers||t.isFlipClock)&&t.number_space){setTimeout(function(){u(t)},50)}};e.fn.aviaCountdown=function(a){if(!this.length){return};return this.each(function(){var a={};a.update={};a.time={};a.oldtime={};a.firstrun=!0;a.container=e(this);a.data=a.container.data();a.end=new Date(a.data.year,a.data.month,a.data.day,a.data.hour,a.data.minute);a.isFlipNumbers=a.container.hasClass('av-flip-numbers');a.isFlipClock=a.container.hasClass('av-flip-clock');a.number_space=a.container.hasClass('av-number-space-equal');a.labelMinWidth=0;var n=function(t){if(a.number_space){u(a,!0)}};if(a.data.timezone!='0'){a.end=new Date(a.end.getTime()-a.data.timezone*60000)};for(var i in t){let unitContainer=a.container.find('.av-countdown-'+t[i]);a.update[t[i]]={unitContainer:unitContainer,time_container:a.container.find('.av-countdown-'+t[i]+' .av-countdown-time'),label_container:a.container.find('.av-countdown-'+t[i]+' .av-countdown-time-label')};if(a.update[t[i]].label_container.length){a.update[t[i]].single=a.update[t[i]].label_container.data('label');a.update[t[i]].multi=a.update[t[i]].label_container.data('label-multi')};if(a.isFlipNumbers){a.update[t[i]].topCard=unitContainer.find('.card__top');a.update[t[i]].bottomCard=unitContainer.find('.card__bottom');a.update[t[i]].backCard=unitContainer.find('.card__back');a.update[t[i]].backBottomCard=unitContainer.find('.card__back .card__bottom')}
else if(a.isFlipClock){a.update[t[i]].currentTop=unitContainer.find('.curr.top');a.update[t[i]].nextTop=unitContainer.find('.next.top');a.update[t[i]].nextBottom=unitContainer.find('.next.bottom');a.update[t[i]].currentBottom=unitContainer.find('.curr.bottom')}};s(a);a.countdown=setInterval(function(){s(a)},1000);window.addEventListener('resize',aviaJS.aviaJSHelpers.debounce(n.bind(this),50))})}}(jQuery));(function(e){'use strict';e.fn.avia_sc_gallery=function(a){return this.each(function(){var t=e(this),r=t.find('img'),a=t.find('.avia-gallery-big'),s=t.find('.avia-slideshow-arrows .prev-slide'),n=t.find('.avia-slideshow-arrows .next-slide'),i=t.find('.avia-gallery-thumb a'),o=t.hasClass('no-hover-effect');if(n.length){t.avia_swipe_trigger({prev:'.prev-slide',next:'.next-slide'})};t.on('avia_start_animation',function(){r.each(function(a){var t=e(this);setTimeout(function(){t.addClass('avia_start_animation')},(a*110))})});if(t.hasClass('deactivate_avia_lazyload')){t.trigger('avia_start_animation')};if(a.length){t.on('mouseenter','.avia-gallery-thumb a',function(){var i=e(this),c=i.attr('data-prev-img'),r=a.find('img'),l=r.attr('src');if(o){if(!t.hasClass('av-force-img-change')){return}};t.removeClass('av-force-img-change');if(c==l){return};a.height(a.height());a.attr('data-onclick',i.attr('data-onclick'));a.attr('href',i.attr('href'));a.attr('title',i.attr('title'));if('undefined'==typeof i.data('srcset')){a.removeAttr('data-srcset');a.removeData('srcset')}
else{a.data('srcset',i.data('srcset'));a.attr('data-srcset',i.data('srcset'))};if('undefined'==typeof i.data('sizes')){a.removeAttr('data-sizes');a.removeData('sizes')}
else{a.data('sizes',i.data('sizes'));a.attr('data-sizes',i.data('sizes'))};var n=i.find('.big-prev-fake img').clone(!0);if(n.length==0){var s=new Image();s.src=c;n=e(s)};if(a.hasClass('avia-gallery-big-no-crop-thumb')){n.css({'height':'auto','width':'auto','max-height':'100%','max-width':'100%'})};a.stop().animate({opacity:0},function(){n.insertAfter(r);r.remove();a.animate({opacity:1})})});n.on('click',function(n){n.preventDefault();if(!a.length){return};let current=a[0].dataset.onclick,next_index=current;if(next_index>=i.length){next_index=0};t.addClass('av-force-img-change');e(i[next_index]).trigger('mouseenter')});s.on('click',function(n){n.preventDefault();if(!a.length){return};let current=a[0].dataset.onclick,prev_index=current-2;if(prev_index<0){prev_index=i.length-1};t.addClass('av-force-img-change');e(i[prev_index]).trigger('mouseenter')});a.on('click',function(a){a.preventDefault();var e=t.find('.avia-gallery-thumb a').eq(this.getAttribute('data-onclick')-1);if(e&&!e.hasClass('aviaopeninbrowser')){e.trigger('click')}
else if(e){var i=e.attr('href'),n=e.hasClass('custom_link')?'noopener,noreferrer':'';if(e.hasClass('aviablank')&&i!=''){window.open(i,'_blank',n)}
else if(i!=''){window.open(i,'_self',n)}};return!1});e(window).on('debouncedresize',function(){a.height('auto')})}})}}(jQuery));(function(a){'use strict';a.fn.avia_hor_gallery=function(e){var d={slide_container:'.av-horizontal-gallery-inner',slide_element:'.av-horizontal-gallery-slider',slide_content:'.av-horizontal-gallery-wrap',slide_arrows:'.avia-slideshow-arrows',slide_dots:'.avia-slideshow-dots',active:'av-active-gal-item',slide_controls:'.avia-slideshow-controls',prev:'.av-horizontal-gallery-prev',next:'.av-horizontal-gallery-next'};var e=a.extend(d,e),n=a(window),r=a.avia_utilities.supports('transition'),s=this.browserPrefix!==!1?!0:!1,l=a.avia_utilities.isMobile,t=a.avia_utilities.isTouchDevice,o=document.documentElement.className.indexOf('avia_transform3d')!==-1?!0:!1,i={};return this.each(function(){var r=a(this),y=r.find(e.slide_container),C=r.find(e.slide_element),u=r.find(e.slide_content),D=r.find(e.slide_controls),f=r.find(e.slide_arrows),w=r.find(e.slide_dots),z=w.find('a'),q=r.find(e.prev),T=r.find(e.next),N=r.find('img'),p=0,v=!1,d={animation:'av-tab-slide-transition',autoplay:!1,loop_autoplay:'once',interval:5,loop_manual:'manual-endless',autoplay_stopper:!1,noNavigation:!1,initial:null,enlarge:1},I=r.data('slideshow-data'),g=null;if('undefined'!=typeof I){d=a.extend({},d,I)};var x=function(){var e=(y.width()/100)*y.data('av-height');y.css({'padding':0}).height(e);N.css('display','inline-block');setTimeout(function(){N.css('display','block')},10);p=0;u.each(function(){p+=a(this).outerWidth(!0)});C.css('min-width',p);if(v!==!1){c(v)}},c=function(a){var n=C.find(e.slide_content).eq(a),t=y.width(),r=d.enlarge>1&&v==a?d.enlarge:1,u=n.outerWidth(!0)*r,f=parseInt(n.css('margin-right'),10)/2,l=t<p?(n.position().left*-1)-(u/2)+(t/2):0;l=l+f;if(l+p<t){l=(p-t-parseInt(n.css('margin-right'),10))*-1};if(l>0){l=0};if(s){i['transform']=o?'translate3d( '+l+'px, 0, 0 )':'translate( '+l+'px, 0 )';i['left']='0px';C.css(i)}
else{C.css('left',l)};y.find('.'+e.active).removeClass(e.active);n.addClass(e.active);v=a;b();k()},h=function(){if(typeof g==='number'){clearTimeout(g)};g=null},m=function(){if(!0!==d.autoplay){r.removeClass('av-slideshow-autoplay').addClass('av-slideshow-manual')};if('undefined'==typeof d.loop_autoplay||'endless'!=d.loop_autoplay){d.loop_autoplay='once'};if('undefined'==typeof d.interval){d.interval=5};if('undefined'==typeof d.autoplay||!0!==d.autoplay){d.autoplay=!1;r.removeClass('av-slideshow-autoplay').addClass('av-slideshow-manual');return};h();g=setTimeout(function(){W()},d.interval*1000)},W=function(){g=null;if('endless'!=d.loop_autoplay){var a=!1;if(v===!1){if(u.length==0){a=!0}}
else{a=v+1>=u.length};if(a){d.autoplay=!1;d.loop_autoplay='manual';r.removeClass('av-slideshow-autoplay').addClass('av-slideshow-manual');r.removeClass('av-loop-endless').addClass('av-loop-once');return}};T.trigger('click')},b=function(){if('endless'==d.loop_autoplay||'manual-endless'==d.loop_manual||!1===v){f.addClass('av-visible-prev');f.addClass('av-visible-next')}
else if(0==v){f.removeClass('av-visible-prev');f.addClass('av-visible-next')}
else if(v+1>=u.length){f.addClass('av-visible-prev');f.removeClass('av-visible-next')}
else{f.addClass('av-visible-prev');f.addClass('av-visible-next')}},k=function(){w.find('a').removeClass('active');var a=!1!==v?v:0;w.find('a').eq(a).addClass('active')};u.on('click',function(e){var l=a(this),i=u.index(l);if(v===i){return};h();c(i);m()});q.on('click',function(a){var e=v!==!1?v-1:0;if(e<0){if('endless'!=d.loop_autoplay&&'manual-endless'!=d.loop_manual){return};e=u.length-1};h();c(e);m()});T.on('click',function(a){var e=v!==!1?v+1:0;if(e>=u.length){if('endless'!=d.loop_autoplay&&'manual-endless'!=d.loop_manual){return};e=0};h();c(e);m()});z.on('click',function(e){var i=a(this),l=z.index(i);h();c(l);m()});a.avia_utilities.preload({container:r,global_callback:function(){x();if(d.initial){var a=parseInt(d.initial,10);if(isNaN(a)||a<1){a=1}
else if(a>u.length){a=u.length};c(a-1)};b();k();m();setTimeout(function(){r.addClass('av-horizontal-gallery-animated')},10);n.on('debouncedresize',x)}});if(!r.hasClass('av-control-hidden')){if(!l){r.avia_keyboard_controls({37:e.prev,39:e.next})};if(l||t){r.avia_swipe_trigger({prev:e.prev,next:e.next})}}})}}(jQuery));(function(t){'use strict';t.AviaTextRotator=function(i,e){this.$win=t(window);this.$slider=t(e);this.$inner=this.$slider.find('.av-rotator-text');this.$slides=this.$inner.find('.av-rotator-text-single');this.$current=this.$slides.eq(0);this.open=0;this.count=this.$slides.length;if(t.avia_utilities.supported.transition===undefined){t.avia_utilities.supported.transition=t.avia_utilities.supports('transition')};this.browserPrefix=t.avia_utilities.supported.transition;this.cssActive=this.browserPrefix!==!1?!0:!1;this.property=this.browserPrefix+'transform',this._init(i)};t.AviaTextRotator.prototype={_init:function(i){var e=this;if(this.count<=1)return;e.options=t.extend({},i,this.$slider.data());e.$inner.addClass('av-rotation-active');e._autoplay();if(e.options.animation=='typewriter'){e.$slider.addClass('av-caret av-blinking-caret')}},_autoplay:function(){var t=this;t.autoplay=setTimeout(function(){t.open=t.open===!1?0:t.open+1;if(t.open>=t.count)t.open=0;if(t.options.animation!='typewriter'){t._move({},t.open);t._autoplay()}
else{t._typewriter()}},t.options.interval*1000)},_typewriter:function(i){var t=this;t.$current.css('background-color',t.$current.css('color'));t.$slider.removeClass('av-caret av-blinking-caret').addClass('av-marked-text');setTimeout(function(){t.$slider.addClass('av-caret av-blinking-caret').removeClass('av-marked-text');t.$current.data('av_typewriter_text',t.$current.html());t.$current.css('background-color','transparent');t.$current.html('')},800);setTimeout(function(){t.$slider.removeClass('av-blinking-caret');t.$next=t.$slides.eq(t.open);var i=t.$next.data('av_typewriter_text')||t.$next.html();i=i.replace(/&amp;/g,'&');t.$current.css({display:'none'});t.$next.css({display:'inline'});t.$next.html('');var e=0,n=50;function a(){if(e<i.length){t.$next[0].innerHTML+=i.charAt(e);e++;setTimeout(a,n+Math.floor(Math.random()*100))}
else{t.$slider.addClass('av-caret av-blinking-caret');t.$current=t.$slides.eq(t.open);t._autoplay()}};a()},1500)},_move:function(i){var t=this,e=30*t.options.animation,a={opacity:0},n={display:'inline-block',opacity:0},r={opacity:1};this.$next=t.$slides.eq(this.open);if(this.cssActive){a[t.property]='translate(0px,'+e+'px)';n[t.property]='translate(0px,'+(e*-1)+'px)';r[t.property]='translate(0px,0px)'}
else{a['top']=e;n['top']=(e*-1);r['top']=0};t.$current.avia_animate(a,function(){t.$current.css({display:'none'});t.$next.css(n).avia_animate(r,function(){t.$current=t.$slides.eq(t.open)})})}};t.fn.avia_textrotator=function(i){return this.each(function(){var e=t.data(this,'AviaTextRotator');if(!e){t.data(this,'AviaTextRotator',1);new t.AviaTextRotator(i,this)}})}}(jQuery));(function(a){'use strict';a.fn.aviaIconCircles=function(i){return this.each(function(){var i=a(this),e=i.find('.avia-icon-circles-icon'),t=i.find('.avia-icon-circles-icon-text');i.on('avia_start_animation',function(){if(i.hasClass('avia_animation_finished')){return};i.addClass('avia_start_animation');setTimeout(function(){i.addClass('avia_animation_finished');if(i.hasClass('avia-active-icon')){setTimeout(function(){var a=e.filter('.av-first-active');if(a.length&&!e.filter('.active').length){a.addClass('active');a.next().addClass('active');i.addClass('active-container')}},800)}},2000);e.on('mouseenter',function(){e.removeClass('active');t.removeClass('active');var n=a(this).addClass('active');n.next().addClass('active');i.addClass('active-container')});i.on('mouseleave',function(){e.removeClass('active');t.removeClass('active');i.removeClass('active-container')})})})}}(jQuery));(function(i){'use strict';i.fn.avia_sc_icongrid=function(a){return this.each(function(){var e=i(this),a=e.find('.avia-icongrid'),t=a.find('.av-icon-cell-item'),r='#'+a.attr('id'),o=e.data('min-height'),n={};t.on('touchend',function(a){var n=i(this),o=n.closest('.avia-icongrid');if(n.hasClass('avia-hover')){o.find('.av-icon-cell-item').removeClass('avia-hover')}
else{o.find('.av-icon-cell-item').removeClass('avia-hover');n.addClass('avia-hover')};var e=n.find('a');if(e.length>0){e.off('touchend.aviaIconGridLink').on('touchend.aviaIconGridLink',function(a){a.preventDefault();var n=i(this),e=n.closest('.av-icon-cell-item');if(!e.hasClass('avia-hover')){return};a.stopImmediatePropagation();n.css('opacity',0.5);window.location.href=n.attr('href')})};a.preventDefault();a.stopImmediatePropagation()});if(a.hasClass('avia_flip_force_close')){i('body').on('touchend',function(a){var n=i('.avia-icongrid.avia_flip_force_close');n.each(function(){var a=i(this);a.find('.av-icon-cell-item').removeClass('avia-hover')})})};n={buildIconGrid:function(){this.setMinHeight(i(r+' li article'))},setMinHeight:function(n){if(n.length<2){return};var e=[],t=[],r=[];n.css('min-height','0').each(function(n){var o=i(this);if(a.hasClass('avia-icongrid-flipbox')){t=o.find('.avia-icongrid-front .avia-icongrid-inner');r=o.find('.avia-icongrid-flipback .avia-icongrid-inner')}
else{t=o.find('.avia-icongrid-front .avia-icongrid-inner');r=o.find('.avia-icongrid-content');e.push(o.outerHeight(!0))};if(t.length){e.push(t.outerHeight(!0))};if(r.length){e.push(r.outerHeight(!0))}});if('undefined'!=typeof(o)){var f=parseInt(o);if(!isNaN(f)){e.push(f)}};var s=Math.max.apply(null,e);n.css('min-height',s);if(a.hasClass('avia-icongrid-tooltip')){var c=n.first().outerWidth(!0);if(s>c){n.css('min-height',c)}}}};n.buildIconGrid();i(window).on('debouncedresize',function(){n.buildIconGrid()})})}}(jQuery));(function(i){'use strict';i.fn.avia_sc_iconlist=function(n){return this.each(function(){var n=i(this),t=n.find('>li');n.on('avia_start_animation',function(){t.each(function(n){var t=i(this);setTimeout(function(){t.addClass('avia_start_animation')},(n*350))})})})}}(jQuery));/*! This file is auto-generated */
!function(n,t){var r,e;"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define("underscore",t):(n="undefined"!=typeof globalThis?globalThis:n||self,r=n._,(e=n._=t()).noConflict=function(){return n._=r,e})}(this,function(){var n="1.13.7",t="object"==typeof self&&self.self===self&&self||"object"==typeof global&&global.global===global&&global||Function("return this")()||{},e=Array.prototype,V=Object.prototype,F="undefined"!=typeof Symbol?Symbol.prototype:null,P=e.push,f=e.slice,s=V.toString,q=V.hasOwnProperty,r="undefined"!=typeof ArrayBuffer,u="undefined"!=typeof DataView,U=Array.isArray,W=Object.keys,z=Object.create,L=r&&ArrayBuffer.isView,$=isNaN,C=isFinite,K=!{toString:null}.propertyIsEnumerable("toString"),J=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"],G=Math.pow(2,53)-1;function l(u,o){return o=null==o?u.length-1:+o,function(){for(var n=Math.max(arguments.length-o,0),t=Array(n),r=0;r<n;r++)t[r]=arguments[r+o];switch(o){case 0:return u.call(this,t);case 1:return u.call(this,arguments[0],t);case 2:return u.call(this,arguments[0],arguments[1],t)}for(var e=Array(o+1),r=0;r<o;r++)e[r]=arguments[r];return e[o]=t,u.apply(this,e)}}function o(n){var t=typeof n;return"function"==t||"object"==t&&!!n}function H(n){return void 0===n}function Q(n){return!0===n||!1===n||"[object Boolean]"===s.call(n)}function i(n){var t="[object "+n+"]";return function(n){return s.call(n)===t}}var X=i("String"),Y=i("Number"),Z=i("Date"),nn=i("RegExp"),tn=i("Error"),rn=i("Symbol"),en=i("ArrayBuffer"),a=i("Function"),t=t.document&&t.document.childNodes,p=a="function"!=typeof/./&&"object"!=typeof Int8Array&&"function"!=typeof t?function(n){return"function"==typeof n||!1}:a,t=i("Object"),un=u&&(!/\[native code\]/.test(String(DataView))||t(new DataView(new ArrayBuffer(8)))),a="undefined"!=typeof Map&&t(new Map),u=i("DataView");var h=un?function(n){return null!=n&&p(n.getInt8)&&en(n.buffer)}:u,v=U||i("Array");function y(n,t){return null!=n&&q.call(n,t)}var on=i("Arguments"),an=(!function(){on(arguments)||(on=function(n){return y(n,"callee")})}(),on);function fn(n){return Y(n)&&$(n)}function cn(n){return function(){return n}}function ln(t){return function(n){n=t(n);return"number"==typeof n&&0<=n&&n<=G}}function sn(t){return function(n){return null==n?void 0:n[t]}}var d=sn("byteLength"),pn=ln(d),hn=/\[object ((I|Ui)nt(8|16|32)|Float(32|64)|Uint8Clamped|Big(I|Ui)nt64)Array\]/;var vn=r?function(n){return L?L(n)&&!h(n):pn(n)&&hn.test(s.call(n))}:cn(!1),g=sn("length");function yn(n,t){t=function(t){for(var r={},n=t.length,e=0;e<n;++e)r[t[e]]=!0;return{contains:function(n){return!0===r[n]},push:function(n){return r[n]=!0,t.push(n)}}}(t);var r=J.length,e=n.constructor,u=p(e)&&e.prototype||V,o="constructor";for(y(n,o)&&!t.contains(o)&&t.push(o);r--;)(o=J[r])in n&&n[o]!==u[o]&&!t.contains(o)&&t.push(o)}function b(n){if(!o(n))return[];if(W)return W(n);var t,r=[];for(t in n)y(n,t)&&r.push(t);return K&&yn(n,r),r}function dn(n,t){var r=b(t),e=r.length;if(null==n)return!e;for(var u=Object(n),o=0;o<e;o++){var i=r[o];if(t[i]!==u[i]||!(i in u))return!1}return!0}function m(n){return n instanceof m?n:this instanceof m?void(this._wrapped=n):new m(n)}function gn(n){return new Uint8Array(n.buffer||n,n.byteOffset||0,d(n))}m.VERSION=n,m.prototype.valueOf=m.prototype.toJSON=m.prototype.value=function(){return this._wrapped},m.prototype.toString=function(){return String(this._wrapped)};var bn="[object DataView]";function mn(n,t,r,e){var u;return n===t?0!==n||1/n==1/t:null!=n&&null!=t&&(n!=n?t!=t:("function"==(u=typeof n)||"object"==u||"object"==typeof t)&&function n(t,r,e,u){t instanceof m&&(t=t._wrapped);r instanceof m&&(r=r._wrapped);var o=s.call(t);if(o!==s.call(r))return!1;if(un&&"[object Object]"==o&&h(t)){if(!h(r))return!1;o=bn}switch(o){case"[object RegExp]":case"[object String]":return""+t==""+r;case"[object Number]":return+t!=+t?+r!=+r:0==+t?1/+t==1/r:+t==+r;case"[object Date]":case"[object Boolean]":return+t==+r;case"[object Symbol]":return F.valueOf.call(t)===F.valueOf.call(r);case"[object ArrayBuffer]":case bn:return n(gn(t),gn(r),e,u)}o="[object Array]"===o;if(!o&&vn(t)){var i=d(t);if(i!==d(r))return!1;if(t.buffer===r.buffer&&t.byteOffset===r.byteOffset)return!0;o=!0}if(!o){if("object"!=typeof t||"object"!=typeof r)return!1;var i=t.constructor,a=r.constructor;if(i!==a&&!(p(i)&&i instanceof i&&p(a)&&a instanceof a)&&"constructor"in t&&"constructor"in r)return!1}e=e||[];u=u||[];var f=e.length;for(;f--;)if(e[f]===t)return u[f]===r;e.push(t);u.push(r);if(o){if((f=t.length)!==r.length)return!1;for(;f--;)if(!mn(t[f],r[f],e,u))return!1}else{var c,l=b(t);if(f=l.length,b(r).length!==f)return!1;for(;f--;)if(c=l[f],!y(r,c)||!mn(t[c],r[c],e,u))return!1}e.pop();u.pop();return!0}(n,t,r,e))}function c(n){if(!o(n))return[];var t,r=[];for(t in n)r.push(t);return K&&yn(n,r),r}function jn(e){var u=g(e);return function(n){if(null==n)return!1;var t=c(n);if(g(t))return!1;for(var r=0;r<u;r++)if(!p(n[e[r]]))return!1;return e!==_n||!p(n[wn])}}var wn="forEach",t=["clear","delete"],u=["get","has","set"],U=t.concat(wn,u),_n=t.concat(u),r=["add"].concat(t,wn,"has"),u=a?jn(U):i("Map"),t=a?jn(_n):i("WeakMap"),U=a?jn(r):i("Set"),a=i("WeakSet");function j(n){for(var t=b(n),r=t.length,e=Array(r),u=0;u<r;u++)e[u]=n[t[u]];return e}function An(n){for(var t={},r=b(n),e=0,u=r.length;e<u;e++)t[n[r[e]]]=r[e];return t}function xn(n){var t,r=[];for(t in n)p(n[t])&&r.push(t);return r.sort()}function Sn(f,c){return function(n){var t=arguments.length;if(c&&(n=Object(n)),!(t<2||null==n))for(var r=1;r<t;r++)for(var e=arguments[r],u=f(e),o=u.length,i=0;i<o;i++){var a=u[i];c&&void 0!==n[a]||(n[a]=e[a])}return n}}var On=Sn(c),w=Sn(b),Mn=Sn(c,!0);function En(n){var t;return o(n)?z?z(n):((t=function(){}).prototype=n,n=new t,t.prototype=null,n):{}}function Bn(n){return v(n)?n:[n]}function _(n){return m.toPath(n)}function Nn(n,t){for(var r=t.length,e=0;e<r;e++){if(null==n)return;n=n[t[e]]}return r?n:void 0}function In(n,t,r){n=Nn(n,_(t));return H(n)?r:n}function Tn(n){return n}function A(t){return t=w({},t),function(n){return dn(n,t)}}function kn(t){return t=_(t),function(n){return Nn(n,t)}}function x(u,o,n){if(void 0===o)return u;switch(null==n?3:n){case 1:return function(n){return u.call(o,n)};case 3:return function(n,t,r){return u.call(o,n,t,r)};case 4:return function(n,t,r,e){return u.call(o,n,t,r,e)}}return function(){return u.apply(o,arguments)}}function Dn(n,t,r){return null==n?Tn:p(n)?x(n,t,r):(o(n)&&!v(n)?A:kn)(n)}function Rn(n,t){return Dn(n,t,1/0)}function S(n,t,r){return m.iteratee!==Rn?m.iteratee(n,t):Dn(n,t,r)}function Vn(){}function Fn(n,t){return null==t&&(t=n,n=0),n+Math.floor(Math.random()*(t-n+1))}m.toPath=Bn,m.iteratee=Rn;var O=Date.now||function(){return(new Date).getTime()};function Pn(t){function r(n){return t[n]}var n="(?:"+b(t).join("|")+")",e=RegExp(n),u=RegExp(n,"g");return function(n){return e.test(n=null==n?"":""+n)?n.replace(u,r):n}}var r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},qn=Pn(r),r=Pn(An(r)),Un=m.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g},Wn=/(.)^/,zn={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},Ln=/\\|'|\r|\n|\u2028|\u2029/g;function $n(n){return"\\"+zn[n]}var Cn=/^\s*(\w|\$)+\s*$/;var Kn=0;function Jn(n,t,r,e,u){return e instanceof t?(e=En(n.prototype),o(t=n.apply(e,u))?t:e):n.apply(r,u)}var M=l(function(u,o){function i(){for(var n=0,t=o.length,r=Array(t),e=0;e<t;e++)r[e]=o[e]===a?arguments[n++]:o[e];for(;n<arguments.length;)r.push(arguments[n++]);return Jn(u,i,this,this,r)}var a=M.placeholder;return i}),Gn=(M.placeholder=m,l(function(t,r,e){var u;if(p(t))return u=l(function(n){return Jn(t,u,r,this,e.concat(n))});throw new TypeError("Bind must be called on a function")})),E=ln(g);function B(n,t,r,e){if(e=e||[],t||0===t){if(t<=0)return e.concat(n)}else t=1/0;for(var u=e.length,o=0,i=g(n);o<i;o++){var a=n[o];if(E(a)&&(v(a)||an(a)))if(1<t)B(a,t-1,r,e),u=e.length;else for(var f=0,c=a.length;f<c;)e[u++]=a[f++];else r||(e[u++]=a)}return e}var Hn=l(function(n,t){var r=(t=B(t,!1,!1)).length;if(r<1)throw new Error("bindAll must be passed function names");for(;r--;){var e=t[r];n[e]=Gn(n[e],n)}return n});var Qn=l(function(n,t,r){return setTimeout(function(){return n.apply(null,r)},t)}),Xn=M(Qn,m,1);function Yn(n){return function(){return!n.apply(this,arguments)}}function Zn(n,t){var r;return function(){return 0<--n&&(r=t.apply(this,arguments)),n<=1&&(t=null),r}}var nt=M(Zn,2);function tt(n,t,r){t=S(t,r);for(var e,u=b(n),o=0,i=u.length;o<i;o++)if(t(n[e=u[o]],e,n))return e}function rt(o){return function(n,t,r){t=S(t,r);for(var e=g(n),u=0<o?0:e-1;0<=u&&u<e;u+=o)if(t(n[u],u,n))return u;return-1}}var et=rt(1),ut=rt(-1);function ot(n,t,r,e){for(var u=(r=S(r,e,1))(t),o=0,i=g(n);o<i;){var a=Math.floor((o+i)/2);r(n[a])<u?o=a+1:i=a}return o}function it(o,i,a){return function(n,t,r){var e=0,u=g(n);if("number"==typeof r)0<o?e=0<=r?r:Math.max(r+u,e):u=0<=r?Math.min(r+1,u):r+u+1;else if(a&&r&&u)return n[r=a(n,t)]===t?r:-1;if(t!=t)return 0<=(r=i(f.call(n,e,u),fn))?r+e:-1;for(r=0<o?e:u-1;0<=r&&r<u;r+=o)if(n[r]===t)return r;return-1}}var at=it(1,et,ot),ft=it(-1,ut);function ct(n,t,r){t=(E(n)?et:tt)(n,t,r);if(void 0!==t&&-1!==t)return n[t]}function N(n,t,r){if(t=x(t,r),E(n))for(u=0,o=n.length;u<o;u++)t(n[u],u,n);else for(var e=b(n),u=0,o=e.length;u<o;u++)t(n[e[u]],e[u],n);return n}function I(n,t,r){t=S(t,r);for(var e=!E(n)&&b(n),u=(e||n).length,o=Array(u),i=0;i<u;i++){var a=e?e[i]:i;o[i]=t(n[a],a,n)}return o}function lt(p){return function(n,t,r,e){var u=3<=arguments.length,o=n,i=x(t,e,4),a=r,f=!E(o)&&b(o),c=(f||o).length,l=0<p?0:c-1;for(u||(a=o[f?f[l]:l],l+=p);0<=l&&l<c;l+=p){var s=f?f[l]:l;a=i(a,o[s],s,o)}return a}}var st=lt(1),pt=lt(-1);function T(n,e,t){var u=[];return e=S(e,t),N(n,function(n,t,r){e(n,t,r)&&u.push(n)}),u}function ht(n,t,r){t=S(t,r);for(var e=!E(n)&&b(n),u=(e||n).length,o=0;o<u;o++){var i=e?e[o]:o;if(!t(n[i],i,n))return!1}return!0}function vt(n,t,r){t=S(t,r);for(var e=!E(n)&&b(n),u=(e||n).length,o=0;o<u;o++){var i=e?e[o]:o;if(t(n[i],i,n))return!0}return!1}function k(n,t,r,e){return E(n)||(n=j(n)),0<=at(n,t,r="number"==typeof r&&!e?r:0)}var yt=l(function(n,r,e){var u,o;return p(r)?o=r:(r=_(r),u=r.slice(0,-1),r=r[r.length-1]),I(n,function(n){var t=o;if(!t){if(null==(n=u&&u.length?Nn(n,u):n))return;t=n[r]}return null==t?t:t.apply(n,e)})});function dt(n,t){return I(n,kn(t))}function gt(n,e,t){var r,u,o=-1/0,i=-1/0;if(null==e||"number"==typeof e&&"object"!=typeof n[0]&&null!=n)for(var a=0,f=(n=E(n)?n:j(n)).length;a<f;a++)null!=(r=n[a])&&o<r&&(o=r);else e=S(e,t),N(n,function(n,t,r){u=e(n,t,r),(i<u||u===-1/0&&o===-1/0)&&(o=n,i=u)});return o}var bt=/[^\ud800-\udfff]|[\ud800-\udbff][\udc00-\udfff]|[\ud800-\udfff]/g;function mt(n){return n?v(n)?f.call(n):X(n)?n.match(bt):E(n)?I(n,Tn):j(n):[]}function jt(n,t,r){if(null==t||r)return(n=E(n)?n:j(n))[Fn(n.length-1)];for(var e=mt(n),r=g(e),u=(t=Math.max(Math.min(t,r),0),r-1),o=0;o<t;o++){var i=Fn(o,u),a=e[o];e[o]=e[i],e[i]=a}return e.slice(0,t)}function D(o,t){return function(r,e,n){var u=t?[[],[]]:{};return e=S(e,n),N(r,function(n,t){t=e(n,t,r);o(u,n,t)}),u}}var wt=D(function(n,t,r){y(n,r)?n[r].push(t):n[r]=[t]}),_t=D(function(n,t,r){n[r]=t}),At=D(function(n,t,r){y(n,r)?n[r]++:n[r]=1}),xt=D(function(n,t,r){n[r?0:1].push(t)},!0);function St(n,t,r){return t in r}var Ot=l(function(n,t){var r={},e=t[0];if(null!=n){p(e)?(1<t.length&&(e=x(e,t[1])),t=c(n)):(e=St,t=B(t,!1,!1),n=Object(n));for(var u=0,o=t.length;u<o;u++){var i=t[u],a=n[i];e(a,i,n)&&(r[i]=a)}}return r}),Mt=l(function(n,r){var t,e=r[0];return p(e)?(e=Yn(e),1<r.length&&(t=r[1])):(r=I(B(r,!1,!1),String),e=function(n,t){return!k(r,t)}),Ot(n,e,t)});function Et(n,t,r){return f.call(n,0,Math.max(0,n.length-(null==t||r?1:t)))}function Bt(n,t,r){return null==n||n.length<1?null==t||r?void 0:[]:null==t||r?n[0]:Et(n,n.length-t)}function R(n,t,r){return f.call(n,null==t||r?1:t)}var Nt=l(function(n,t){return t=B(t,!0,!0),T(n,function(n){return!k(t,n)})}),It=l(function(n,t){return Nt(n,t)});function Tt(n,t,r,e){Q(t)||(e=r,r=t,t=!1),null!=r&&(r=S(r,e));for(var u=[],o=[],i=0,a=g(n);i<a;i++){var f=n[i],c=r?r(f,i,n):f;t&&!r?(i&&o===c||u.push(f),o=c):r?k(o,c)||(o.push(c),u.push(f)):k(u,f)||u.push(f)}return u}var kt=l(function(n){return Tt(B(n,!0,!0))});function Dt(n){for(var t=n&&gt(n,g).length||0,r=Array(t),e=0;e<t;e++)r[e]=dt(n,e);return r}var Rt=l(Dt);function Vt(n,t){return n._chain?m(t).chain():t}function Ft(r){return N(xn(r),function(n){var t=m[n]=r[n];m.prototype[n]=function(){var n=[this._wrapped];return P.apply(n,arguments),Vt(this,t.apply(m,n))}}),m}N(["pop","push","reverse","shift","sort","splice","unshift"],function(t){var r=e[t];m.prototype[t]=function(){var n=this._wrapped;return null!=n&&(r.apply(n,arguments),"shift"!==t&&"splice"!==t||0!==n.length||delete n[0]),Vt(this,n)}}),N(["concat","join","slice"],function(n){var t=e[n];m.prototype[n]=function(){var n=this._wrapped;return Vt(this,n=null!=n?t.apply(n,arguments):n)}});n=Ft({__proto__:null,VERSION:n,restArguments:l,isObject:o,isNull:function(n){return null===n},isUndefined:H,isBoolean:Q,isElement:function(n){return!(!n||1!==n.nodeType)},isString:X,isNumber:Y,isDate:Z,isRegExp:nn,isError:tn,isSymbol:rn,isArrayBuffer:en,isDataView:h,isArray:v,isFunction:p,isArguments:an,isFinite:function(n){return!rn(n)&&C(n)&&!isNaN(parseFloat(n))},isNaN:fn,isTypedArray:vn,isEmpty:function(n){var t;return null==n||("number"==typeof(t=g(n))&&(v(n)||X(n)||an(n))?0===t:0===g(b(n)))},isMatch:dn,isEqual:function(n,t){return mn(n,t)},isMap:u,isWeakMap:t,isSet:U,isWeakSet:a,keys:b,allKeys:c,values:j,pairs:function(n){for(var t=b(n),r=t.length,e=Array(r),u=0;u<r;u++)e[u]=[t[u],n[t[u]]];return e},invert:An,functions:xn,methods:xn,extend:On,extendOwn:w,assign:w,defaults:Mn,create:function(n,t){return n=En(n),t&&w(n,t),n},clone:function(n){return o(n)?v(n)?n.slice():On({},n):n},tap:function(n,t){return t(n),n},get:In,has:function(n,t){for(var r=(t=_(t)).length,e=0;e<r;e++){var u=t[e];if(!y(n,u))return!1;n=n[u]}return!!r},mapObject:function(n,t,r){t=S(t,r);for(var e=b(n),u=e.length,o={},i=0;i<u;i++){var a=e[i];o[a]=t(n[a],a,n)}return o},identity:Tn,constant:cn,noop:Vn,toPath:Bn,property:kn,propertyOf:function(t){return null==t?Vn:function(n){return In(t,n)}},matcher:A,matches:A,times:function(n,t,r){var e=Array(Math.max(0,n));t=x(t,r,1);for(var u=0;u<n;u++)e[u]=t(u);return e},random:Fn,now:O,escape:qn,unescape:r,templateSettings:Un,template:function(o,n,t){n=Mn({},n=!n&&t?t:n,m.templateSettings);var r,t=RegExp([(n.escape||Wn).source,(n.interpolate||Wn).source,(n.evaluate||Wn).source].join("|")+"|$","g"),i=0,a="__p+='";if(o.replace(t,function(n,t,r,e,u){return a+=o.slice(i,u).replace(Ln,$n),i=u+n.length,t?a+="'+\n((__t=("+t+"))==null?'':_.escape(__t))+\n'":r?a+="'+\n((__t=("+r+"))==null?'':__t)+\n'":e&&(a+="';\n"+e+"\n__p+='"),n}),a+="';\n",t=n.variable){if(!Cn.test(t))throw new Error("variable is not a bare identifier: "+t)}else a="with(obj||{}){\n"+a+"}\n",t="obj";a="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+a+"return __p;\n";try{r=new Function(t,"_",a)}catch(n){throw n.source=a,n}function e(n){return r.call(this,n,m)}return e.source="function("+t+"){\n"+a+"}",e},result:function(n,t,r){var e=(t=_(t)).length;if(!e)return p(r)?r.call(n):r;for(var u=0;u<e;u++){var o=null==n?void 0:n[t[u]];void 0===o&&(o=r,u=e),n=p(o)?o.call(n):o}return n},uniqueId:function(n){var t=++Kn+"";return n?n+t:t},chain:function(n){return(n=m(n))._chain=!0,n},iteratee:Rn,partial:M,bind:Gn,bindAll:Hn,memoize:function(e,u){function o(n){var t=o.cache,r=""+(u?u.apply(this,arguments):n);return y(t,r)||(t[r]=e.apply(this,arguments)),t[r]}return o.cache={},o},delay:Qn,defer:Xn,throttle:function(r,e,u){function o(){l=!1===u.leading?0:O(),i=null,c=r.apply(a,f),i||(a=f=null)}function n(){var n=O(),t=(l||!1!==u.leading||(l=n),e-(n-l));return a=this,f=arguments,t<=0||e<t?(i&&(clearTimeout(i),i=null),l=n,c=r.apply(a,f),i||(a=f=null)):i||!1===u.trailing||(i=setTimeout(o,t)),c}var i,a,f,c,l=0;return u=u||{},n.cancel=function(){clearTimeout(i),l=0,i=a=f=null},n},debounce:function(t,r,e){function u(){var n=O()-i;n<r?o=setTimeout(u,r-n):(o=null,e||(f=t.apply(c,a)),o||(a=c=null))}var o,i,a,f,c,n=l(function(n){return c=this,a=n,i=O(),o||(o=setTimeout(u,r),e&&(f=t.apply(c,a))),f});return n.cancel=function(){clearTimeout(o),o=a=c=null},n},wrap:function(n,t){return M(t,n)},negate:Yn,compose:function(){var r=arguments,e=r.length-1;return function(){for(var n=e,t=r[e].apply(this,arguments);n--;)t=r[n].call(this,t);return t}},after:function(n,t){return function(){if(--n<1)return t.apply(this,arguments)}},before:Zn,once:nt,findKey:tt,findIndex:et,findLastIndex:ut,sortedIndex:ot,indexOf:at,lastIndexOf:ft,find:ct,detect:ct,findWhere:function(n,t){return ct(n,A(t))},each:N,forEach:N,map:I,collect:I,reduce:st,foldl:st,inject:st,reduceRight:pt,foldr:pt,filter:T,select:T,reject:function(n,t,r){return T(n,Yn(S(t)),r)},every:ht,all:ht,some:vt,any:vt,contains:k,includes:k,include:k,invoke:yt,pluck:dt,where:function(n,t){return T(n,A(t))},max:gt,min:function(n,e,t){var r,u,o=1/0,i=1/0;if(null==e||"number"==typeof e&&"object"!=typeof n[0]&&null!=n)for(var a=0,f=(n=E(n)?n:j(n)).length;a<f;a++)null!=(r=n[a])&&r<o&&(o=r);else e=S(e,t),N(n,function(n,t,r){((u=e(n,t,r))<i||u===1/0&&o===1/0)&&(o=n,i=u)});return o},shuffle:function(n){return jt(n,1/0)},sample:jt,sortBy:function(n,e,t){var u=0;return e=S(e,t),dt(I(n,function(n,t,r){return{value:n,index:u++,criteria:e(n,t,r)}}).sort(function(n,t){var r=n.criteria,e=t.criteria;if(r!==e){if(e<r||void 0===r)return 1;if(r<e||void 0===e)return-1}return n.index-t.index}),"value")},groupBy:wt,indexBy:_t,countBy:At,partition:xt,toArray:mt,size:function(n){return null==n?0:(E(n)?n:b(n)).length},pick:Ot,omit:Mt,first:Bt,head:Bt,take:Bt,initial:Et,last:function(n,t,r){return null==n||n.length<1?null==t||r?void 0:[]:null==t||r?n[n.length-1]:R(n,Math.max(0,n.length-t))},rest:R,tail:R,drop:R,compact:function(n){return T(n,Boolean)},flatten:function(n,t){return B(n,t,!1)},without:It,uniq:Tt,unique:Tt,union:kt,intersection:function(n){for(var t=[],r=arguments.length,e=0,u=g(n);e<u;e++){var o=n[e];if(!k(t,o)){for(var i=1;i<r&&k(arguments[i],o);i++);i===r&&t.push(o)}}return t},difference:Nt,unzip:Dt,transpose:Dt,zip:Rt,object:function(n,t){for(var r={},e=0,u=g(n);e<u;e++)t?r[n[e]]=t[e]:r[n[e][0]]=n[e][1];return r},range:function(n,t,r){null==t&&(t=n||0,n=0),r=r||(t<n?-1:1);for(var e=Math.max(Math.ceil((t-n)/r),0),u=Array(e),o=0;o<e;o++,n+=r)u[o]=n;return u},chunk:function(n,t){if(null==t||t<1)return[];for(var r=[],e=0,u=n.length;e<u;)r.push(f.call(n,e,e+=t));return r},mixin:Ft,default:m});return n._=n});'use strict';var avia_js_shortcodes=avia_js_shortcodes||{};var aviaJS=aviaJS||{};(function(){if(!avia_js_shortcodes.aviaImageDiff){class scAviaImageDiff{container=null;id='';divider='vertical';handle=null;settings={};wrapperDiv=[];btnOverlay=[];btnBefore=[];btnAfter=[];imgBefore=[];imgAfter=[];imgDimension={};mouseCapture=!1;touchCapture=!1;touchMoved=!1;downScreenX=0;downScreenY=0;downClientX=0;downClientY=0;downHandlePos=0;preview=!1;constructor(container){this.container=container;this.container.scAviaImageDiff=this;this.id=container.getAttribute('id');this.handle=container.getElementsByClassName('av-image-diff-handle');if(!this.handle.length){return};this.handle=this.handle[0];this.init()};init(){this.settings=JSON.parse(this.container.dataset.image_diff);this.wrapperDiv=this.container.getElementsByClassName('av-image-diff-wrapper');this.btnOverlay=this.container.getElementsByClassName('av-image-diff-overlay');this.btnBefore=this.btnOverlay[0].getElementsByClassName('label-before');this.btnAfter=this.btnOverlay[0].getElementsByClassName('label-after');this.imgBefore=this.container.getElementsByClassName('av-img-before');this.imgAfter=this.container.getElementsByClassName('av-img-after');if(!this.imgBefore.length||!this.imgAfter.length){this.hideHandlerDOM();return};if(this.container.classList.contains('av-handle-horizontal')){this.divider='horizontal'};this.preview=document.getElementById('av-admin-preview')!=null;this.bindEvents();this.initialPositionHandler()};hideHandlerDOM(){this.handle.style.display='none';if(this.btnOverlay.length){this.btnOverlay[0].style.display='none'}};initialPositionHandler(){let start=('undefined'==typeof this.settings.drag_start)?50:parseInt(this.settings.drag_start);if(isNaN(start)){start=50};let offset=0;this.imgDimension=this.imgBefore[0].getBoundingClientRect();if(this.divider=='horizontal'){offset=this.imgDimension.height*(start/100.0)}
else{offset=this.imgDimension.width*(start/100.0)};this.container.classList.add('av-initialise');this.adjustDividerFrame(offset);let obj=this;setTimeout(function(){obj.container.classList.remove('av-initialise')},700)};adjustDividerFrame(offset){const overhead=5;this.container.classList.remove('av-handler-at-before','av-handler-at-after');offset=Math.round(offset);if(offset<=0){offset=0;this.container.classList.add('av-handler-at-before')};if(this.divider=='horizontal'){if(offset>=(this.imgDimension.height+overhead)){offset=Math.round(this.imgDimension.height+overhead);this.container.classList.add('av-handler-at-after')};let bottom=this.imgDimension.height-offset;this.handle.style.top=offset+'px';this.imgBefore[0].style['clip-path']='inset( 0 0 '+bottom+'px 0 )';this.imgAfter[0].style['clip-path']='inset( '+offset+'px 0 0 0 )'}
else{if(offset>=(this.imgDimension.width+overhead)){offset=Math.round(this.imgDimension.width+overhead);this.container.classList.add('av-handler-at-after')};let right=this.imgDimension.width-offset;this.handle.style.left=offset+'px';this.imgBefore[0].style['clip-path']='inset( 0 '+right+'px 0 0 )';this.imgAfter[0].style['clip-path']='inset( 0 0 0 '+offset+'px )'}};bindEvents(){this.container.onavia_start_animation=(e)=>{const opt={'bubbles':!0,'cancelable':!0};const event=new CustomEvent('avia_start_animation',opt);this.container.dispatchEvent(event)};this.container.addEventListener('avia_start_animation',this.onAviaStartAnimation.bind(this));this.handle.addEventListener('click',this.onHandleClick.bind(this));this.handle.addEventListener('mousedown',this.onMouseDown.bind(this));if(this.wrapperDiv.length>0){this.wrapperDiv[0].addEventListener('click',this.onClickWrapper.bind(this));this.wrapperDiv[0].addEventListener('touchstart',this.onTouchStart.bind(this))};if(this.btnBefore.length>0){this.btnBefore[0].addEventListener('click',this.onClickBtnBefore.bind(this))};if(this.btnAfter.length>0){this.btnAfter[0].addEventListener('click',this.onClickBtnAfter.bind(this))};window.addEventListener('mousemove',this.onMouseMove.bind(this));window.addEventListener('mouseup',this.onMouseUp.bind(this));window.addEventListener('touchmove',this.onTouchMove.bind(this));window.addEventListener('touchend',this.onTouchEnd.bind(this));window.addEventListener('resize',aviaJS.aviaJSHelpers.debounce(this.onResize.bind(this),200));if(this.preview){this.container.addEventListener('animationend',this.onAnimationEnd.bind(this))}};onAviaStartAnimation(event){if(this.container.classList.contains('avia_animation_finished')){return};if(this.preview){this.container.classList.add('avia_start_animation','avia_animation_finished')};if('undefined'!=typeof event){this.container.classList.add('avia_animation_finished','avia_start_delayed_animation')}};onAnimationEnd(event){if(!this.preview){return};this.initialPositionHandler()};onMouseDown(event){if(this.touchCapture){return};event.preventDefault();event.stopPropagation();this.mouseCapture=!0;this.container.classList.add('av-active-drag');this.downScreenX=event.screenX;this.downScreenY=event.screenY;if(this.divider=='horizontal'){this.downHandlePos=this.handle.style.top}
else{this.downHandlePos=this.handle.style.left};this.downHandlePos=parseInt(this.downHandlePos.replace('px',''))};onMouseMove(event){if(!this.mouseCapture){return};event.preventDefault();event.stopPropagation();let newPos=0,diff=0;if(this.divider=='horizontal'){diff=event.screenY-this.downScreenY}
else{diff=event.screenX-this.downScreenX};if(Math.abs(diff)<5){return};newPos=this.downHandlePos+diff;this.adjustDividerFrame(newPos)};onMouseUp(event){if(!this.mouseCapture){return};event.preventDefault();event.stopPropagation();this.mouseCapture=!1;this.container.classList.remove('av-active-drag')};onTouchStart(event){if(this.mouseCapture){return};if(!event.touches.length){return};event.preventDefault();event.stopPropagation();if(event.explicitOriginalTarget){if(event.explicitOriginalTarget.classList.contains('av-img-diff-label')){let opacity=window.getComputedStyle(event.explicitOriginalTarget).getPropertyValue('opacity');if(opacity>0){event.explicitOriginalTarget.dispatchEvent(new MouseEvent('click'));return}}};this.touchCapture=!0;this.container.classList.add('av-active-drag');this.downScreenX=event.touches[0].screenX;this.downScreenY=event.touches[0].screenY;this.downClientX=event.touches[0].clientX;this.downClientY=event.touches[0].clientY;if(this.divider=='horizontal'){this.downHandlePos=this.handle.style.top}
else{this.downHandlePos=this.handle.style.left};this.downHandlePos=parseInt(this.downHandlePos.replace('px',''))};onTouchMove(event){if(!this.touchCapture){return};event.preventDefault();event.stopPropagation();let newPos=0,diff=0;if(this.divider=='horizontal'){diff=event.touches[0].screenY-this.downScreenY}
else{diff=event.touches[0].screenX-this.downScreenX};if(Math.abs(diff)<5){return};newPos=this.downHandlePos+diff;this.adjustDividerFrame(newPos);this.touchMoved=!0};onTouchEnd(event){if(!this.touchCapture){return};if(!this.touchMoved){let newPos=0,maxCheck=0,rect=this.wrapperDiv[0].getBoundingClientRect();if(this.divider=='horizontal'){newPos=this.downClientY-rect.top;maxCheck=rect.height}
else{newPos=this.downClientX-rect.left;maxCheck=rect.width};if(newPos<0){newPos=0}
else if(newPos>maxCheck){newPos=maxCheck};this.adjustDividerFrame(newPos)};event.preventDefault();event.stopPropagation();this.touchCapture=!1;this.touchMoved=!1;this.container.classList.remove('av-active-drag')};onResize(event){let lastPos=0,lastDim=0;if(this.divider=='horizontal'){lastPos=this.handle.style.top;lastDim=this.imgDimension.height}
else{lastPos=this.handle.style.left;lastDim=this.imgDimension.width};lastPos=parseInt(lastPos.replace('px',''));if(lastPos<0){lastDim=0}
else if(lastDim!=0){lastDim=Math.round((lastPos/lastDim)*100.0)};if(lastDim>100){lastDim=100};this.settings.drag_start=lastDim;this.imgBefore[0].style['clip-path']='inset( 0 0 0 0 )';this.imgAfter[0].style['clip-path']='inset( 0 0 0 0 )';this.initialPositionHandler()};onHandleClick(event){event.preventDefault();event.stopPropagation()};onClickBtnBefore(event){event.preventDefault();event.stopPropagation();this.adjustDividerFrame(0)};onClickBtnAfter(event){event.preventDefault();event.stopPropagation();let newPos=0;if(this.divider=='horizontal'){newPos=this.imgDimension.height}
else{newPos=this.imgDimension.width};this.adjustDividerFrame(newPos+15)};onClickWrapper(event){event.preventDefault();event.stopPropagation();let newPos=0;if(this.divider=='horizontal'){newPos=event.layerY}
else{newPos=event.layerX};this.adjustDividerFrame(newPos)}};avia_js_shortcodes.aviaImageDiff=function(e){return new scAviaImageDiff(e)};aviaJS.aviaPlugins.register(avia_js_shortcodes.aviaImageDiff,'.avia-image-diff-container')}})();(function(t){'use strict';t.fn.aviaHotspots=function(n){if(!this.length){return};return this.each(function(){var n={};n.container=t(this);n.hotspots=n.container.find('.av-image-hotspot');n.container.on('avia_start_animation',function(){setTimeout(function(){n.hotspots.each(function(n){var i=t(this);setTimeout(function(){i.addClass('av-display-hotspot')},300*n)})},400)})})}}(jQuery));'use strict';var avia_js_shortcodes=avia_js_shortcodes||{};var aviaJS=aviaJS||{};(function(){if(!avia_js_shortcodes.aviaLottieAnimation){class scAviaLottieAnimation{container=null;id='';player=null;settings={};loaded=!1;started=!1;preview=!1;constructor(container){this.container=container;this.container.scAviaLottieAnimation=this;this.id=container.getAttribute('id');this.loaded=!1;this.started=!1;this.preview=document.getElementById('av-admin-preview')!=null;this.container.scAviaLottieAnimation=this;this.player=this.container.querySelector('dotlottie-player');this.settings=JSON.parse(this.player.dataset.av_lottie);this.initPlayer();this.container.onavia_start_animation=(e)=>{const opt={'bubbles':!0,'cancelable':!0};const event=new CustomEvent('avia_start_animation',opt);this.container.dispatchEvent(event)};this.container.addEventListener('avia_start_animation',this.avia_start_animation.bind(this));this.player.addEventListener('ready',this.lottie_animation_loaded.bind(this));const obj=this;setTimeout(function(){obj.prepareAnimation()})};initPlayer(){this.player.__speed=this.settings.speed!=''?this.settings.speed:1;this.player.__autoplay=!1;this.player.__loop=this.settings.loop=='';this.player.__hover=this.settings.hover!='';this.player.__direction=this.settings.direction!=''?-1:1;this.player.__mode=this.settings.mode!=''?'bounce':'normal';this.player.__controls=this.settings.controls!='';this.player.__background=this.settings.background=!''?this.settings.background:'transparent'};prepareAnimation(){if(this.container.classList.contains('avia_start_animation')){if(this.settings.autoplay!='no_autoplay'){this.settings.autoplay='start_loaded'};this.avia_start_animation()}
else if(this.settings.autoplay=='start_loaded'||this.settings.lazy_loading==''||this.preview){this.load_animation()}};avia_start_animation(event){if(this.container.classList.contains('avia_animation_finished')){this.start()};if(this.preview){this.container.classList.add('avia_start_animation','avia_animation_finished')};if('undefined'!=typeof event){this.container.classList.add('avia_animation_finished','avia_start_delayed_animation')};if(this.loaded){this.start()}
else{this.load_animation()}};load_animation(){if(this.loaded){return};this.player.load(this.settings.src)};start(){this.started=!0;this.container.classList.add('av-lottie-animation-started');this.player.play()};lottie_animation_loaded(event){this.loaded=!0;this.container.classList.add('av-lottie-animation-loaded');if(this.settings.autoplay=='no_autoplay'){return};if(this.settings.autoplay=='start_loaded'||this.preview||this.container.classList.contains('avia_start_delayed_animation')){this.start()};if(this.container.classList.contains('avia_start_animation')&&this.settings.lazy_loading!=''){this.start();this.container.classList.add('avia_start_delayed_animation')}}};avia_js_shortcodes.aviaLottieAnimation=function(t){return new scAviaLottieAnimation(t)};aviaJS.aviaPlugins.register(avia_js_shortcodes.aviaLottieAnimation,'.av-lottie-animation-container')}})();(function(t){'use strict';var a=!1,i={switchMag:function(n,i){var e=t(n);if(e.is('.active_sort')||a){return};var s=e.data('filter'),r=i.container.filter(':visible'),o=i.container.filter('.'+s);a=!0;i.sort_buttons.removeClass('active_sort');e.addClass('active_sort');i.magazine.height(i.magazine.outerHeight());r.avia_animate({opacity:0},200,function(){r.css({display:'none'});o.css({opacity:0,display:'block'}).avia_animate({opacity:1},150,function(){i.magazine.avia_animate({height:(o.outerHeight()+i.sort_bar.outerHeight())},150,function(){i.magazine.height('auto');a=!1})})})}};t.fn.aviaMagazine=function(a){if(!this.length){return};return this.each(function(){var a={};a.magazine=t(this),a.sort_buttons=a.magazine.find('.av-magazine-sort a');a.container=a.magazine.find('.av-magazine-group');a.sort_bar=a.magazine.find('.av-magazine-top-bar');a.sort_buttons.each(function(i){var n=t(this),r=n.data('filter'),e=a.container.filter('.'+r);if(e.length==0||e.html().trim()==''){n.hide();n.prev('span.text-sep').hide()}});a.sort_buttons.on('click',function(t){t.preventDefault();i.switchMag(this,a)})})}}(jQuery));/*!
 * Isotope PACKAGED v3.0.6
 *
 * Licensed GPLv3 for open source use
 * or Isotope Commercial License for commercial use
 *
 * https://isotope.metafizzy.co
 * Copyright 2010-2018 Metafizzy
 */

!function(t,e){"function"==typeof define&&define.amd?define("jquery-bridget/jquery-bridget",["jquery"],function(i){return e(t,i)}):"object"==typeof module&&module.exports?module.exports=e(t,require("jquery")):t.jQueryBridget=e(t,t.jQuery)}(window,function(t,e){"use strict";function i(i,s,a){function u(t,e,o){var n,s="$()."+i+'("'+e+'")';return t.each(function(t,u){var h=a.data(u,i);if(!h)return void r(i+" not initialized. Cannot call methods, i.e. "+s);var d=h[e];if(!d||"_"==e.charAt(0))return void r(s+" is not a valid method");var l=d.apply(h,o);n=void 0===n?l:n}),void 0!==n?n:t}function h(t,e){t.each(function(t,o){var n=a.data(o,i);n?(n.option(e),n._init()):(n=new s(o,e),a.data(o,i,n))})}a=a||e||t.jQuery,a&&(s.prototype.option||(s.prototype.option=function(t){a.isPlainObject(t)&&(this.options=a.extend(!0,this.options,t))}),a.fn[i]=function(t){if("string"==typeof t){var e=n.call(arguments,1);return u(this,t,e)}return h(this,t),this},o(a))}function o(t){!t||t&&t.bridget||(t.bridget=i)}var n=Array.prototype.slice,s=t.console,r="undefined"==typeof s?function(){}:function(t){s.error(t)};return o(e||t.jQuery),i}),function(t,e){"function"==typeof define&&define.amd?define("ev-emitter/ev-emitter",e):"object"==typeof module&&module.exports?module.exports=e():t.EvEmitter=e()}("undefined"!=typeof window?window:this,function(){function t(){}var e=t.prototype;return e.on=function(t,e){if(t&&e){var i=this._events=this._events||{},o=i[t]=i[t]||[];return o.indexOf(e)==-1&&o.push(e),this}},e.once=function(t,e){if(t&&e){this.on(t,e);var i=this._onceEvents=this._onceEvents||{},o=i[t]=i[t]||{};return o[e]=!0,this}},e.off=function(t,e){var i=this._events&&this._events[t];if(i&&i.length){var o=i.indexOf(e);return o!=-1&&i.splice(o,1),this}},e.emitEvent=function(t,e){var i=this._events&&this._events[t];if(i&&i.length){i=i.slice(0),e=e||[];for(var o=this._onceEvents&&this._onceEvents[t],n=0;n<i.length;n++){var s=i[n],r=o&&o[s];r&&(this.off(t,s),delete o[s]),s.apply(this,e)}return this}},e.allOff=function(){delete this._events,delete this._onceEvents},t}),function(t,e){"function"==typeof define&&define.amd?define("get-size/get-size",e):"object"==typeof module&&module.exports?module.exports=e():t.getSize=e()}(window,function(){"use strict";function t(t){var e=parseFloat(t),i=t.indexOf("%")==-1&&!isNaN(e);return i&&e}function e(){}function i(){for(var t={width:0,height:0,innerWidth:0,innerHeight:0,outerWidth:0,outerHeight:0},e=0;e<h;e++){var i=u[e];t[i]=0}return t}function o(t){var e=getComputedStyle(t);return e||a("Style returned "+e+". Are you running this code in a hidden iframe on Firefox? See https://bit.ly/getsizebug1"),e}function n(){if(!d){d=!0;var e=document.createElement("div");e.style.width="200px",e.style.padding="1px 2px 3px 4px",e.style.borderStyle="solid",e.style.borderWidth="1px 2px 3px 4px",e.style.boxSizing="border-box";var i=document.body||document.documentElement;i.appendChild(e);var n=o(e);r=200==Math.round(t(n.width)),s.isBoxSizeOuter=r,i.removeChild(e)}}function s(e){if(n(),"string"==typeof e&&(e=document.querySelector(e)),e&&"object"==typeof e&&e.nodeType){var s=o(e);if("none"==s.display)return i();var a={};a.width=e.offsetWidth,a.height=e.offsetHeight;for(var d=a.isBorderBox="border-box"==s.boxSizing,l=0;l<h;l++){var f=u[l],c=s[f],m=parseFloat(c);a[f]=isNaN(m)?0:m}var p=a.paddingLeft+a.paddingRight,y=a.paddingTop+a.paddingBottom,g=a.marginLeft+a.marginRight,v=a.marginTop+a.marginBottom,_=a.borderLeftWidth+a.borderRightWidth,z=a.borderTopWidth+a.borderBottomWidth,I=d&&r,x=t(s.width);x!==!1&&(a.width=x+(I?0:p+_));var S=t(s.height);return S!==!1&&(a.height=S+(I?0:y+z)),a.innerWidth=a.width-(p+_),a.innerHeight=a.height-(y+z),a.outerWidth=a.width+g,a.outerHeight=a.height+v,a}}var r,a="undefined"==typeof console?e:function(t){console.error(t)},u=["paddingLeft","paddingRight","paddingTop","paddingBottom","marginLeft","marginRight","marginTop","marginBottom","borderLeftWidth","borderRightWidth","borderTopWidth","borderBottomWidth"],h=u.length,d=!1;return s}),function(t,e){"use strict";"function"==typeof define&&define.amd?define("desandro-matches-selector/matches-selector",e):"object"==typeof module&&module.exports?module.exports=e():t.matchesSelector=e()}(window,function(){"use strict";var t=function(){var t=window.Element.prototype;if(t.matches)return"matches";if(t.matchesSelector)return"matchesSelector";for(var e=["webkit","moz","ms","o"],i=0;i<e.length;i++){var o=e[i],n=o+"MatchesSelector";if(t[n])return n}}();return function(e,i){return e[t](i)}}),function(t,e){"function"==typeof define&&define.amd?define("fizzy-ui-utils/utils",["desandro-matches-selector/matches-selector"],function(i){return e(t,i)}):"object"==typeof module&&module.exports?module.exports=e(t,require("desandro-matches-selector")):t.fizzyUIUtils=e(t,t.matchesSelector)}(window,function(t,e){var i={};i.extend=function(t,e){for(var i in e)t[i]=e[i];return t},i.modulo=function(t,e){return(t%e+e)%e};var o=Array.prototype.slice;i.makeArray=function(t){if(Array.isArray(t))return t;if(null===t||void 0===t)return[];var e="object"==typeof t&&"number"==typeof t.length;return e?o.call(t):[t]},i.removeFrom=function(t,e){var i=t.indexOf(e);i!=-1&&t.splice(i,1)},i.getParent=function(t,i){for(;t.parentNode&&t!=document.body;)if(t=t.parentNode,e(t,i))return t},i.getQueryElement=function(t){return"string"==typeof t?document.querySelector(t):t},i.handleEvent=function(t){var e="on"+t.type;this[e]&&this[e](t)},i.filterFindElements=function(t,o){t=i.makeArray(t);var n=[];return t.forEach(function(t){if(t instanceof HTMLElement){if(!o)return void n.push(t);e(t,o)&&n.push(t);for(var i=t.querySelectorAll(o),s=0;s<i.length;s++)n.push(i[s])}}),n},i.debounceMethod=function(t,e,i){i=i||100;var o=t.prototype[e],n=e+"Timeout";t.prototype[e]=function(){var t=this[n];clearTimeout(t);var e=arguments,s=this;this[n]=setTimeout(function(){o.apply(s,e),delete s[n]},i)}},i.docReady=function(t){var e=document.readyState;"complete"==e||"interactive"==e?setTimeout(t):document.addEventListener("DOMContentLoaded",t)},i.toDashed=function(t){return t.replace(/(.)([A-Z])/g,function(t,e,i){return e+"-"+i}).toLowerCase()};var n=t.console;return i.htmlInit=function(e,o){i.docReady(function(){var s=i.toDashed(o),r="data-"+s,a=document.querySelectorAll("["+r+"]"),u=document.querySelectorAll(".js-"+s),h=i.makeArray(a).concat(i.makeArray(u)),d=r+"-options",l=t.jQuery;h.forEach(function(t){var i,s=t.getAttribute(r)||t.getAttribute(d);try{i=s&&JSON.parse(s)}catch(a){return void(n&&n.error("Error parsing "+r+" on "+t.className+": "+a))}var u=new e(t,i);l&&l.data(t,o,u)})})},i}),function(t,e){"function"==typeof define&&define.amd?define("outlayer/item",["ev-emitter/ev-emitter","get-size/get-size"],e):"object"==typeof module&&module.exports?module.exports=e(require("ev-emitter"),require("get-size")):(t.Outlayer={},t.Outlayer.Item=e(t.EvEmitter,t.getSize))}(window,function(t,e){"use strict";function i(t){for(var e in t)return!1;return e=null,!0}function o(t,e){t&&(this.element=t,this.layout=e,this.position={x:0,y:0},this._create())}function n(t){return t.replace(/([A-Z])/g,function(t){return"-"+t.toLowerCase()})}var s=document.documentElement.style,r="string"==typeof s.transition?"transition":"WebkitTransition",a="string"==typeof s.transform?"transform":"WebkitTransform",u={WebkitTransition:"webkitTransitionEnd",transition:"transitionend"}[r],h={transform:a,transition:r,transitionDuration:r+"Duration",transitionProperty:r+"Property",transitionDelay:r+"Delay"},d=o.prototype=Object.create(t.prototype);d.constructor=o,d._create=function(){this._transn={ingProperties:{},clean:{},onEnd:{}},this.css({position:"absolute"})},d.handleEvent=function(t){var e="on"+t.type;this[e]&&this[e](t)},d.getSize=function(){this.size=e(this.element)},d.css=function(t){var e=this.element.style;for(var i in t){var o=h[i]||i;e[o]=t[i]}},d.getPosition=function(){var t=getComputedStyle(this.element),e=this.layout._getOption("originLeft"),i=this.layout._getOption("originTop"),o=t[e?"left":"right"],n=t[i?"top":"bottom"],s=parseFloat(o),r=parseFloat(n),a=this.layout.size;o.indexOf("%")!=-1&&(s=s/100*a.width),n.indexOf("%")!=-1&&(r=r/100*a.height),s=isNaN(s)?0:s,r=isNaN(r)?0:r,s-=e?a.paddingLeft:a.paddingRight,r-=i?a.paddingTop:a.paddingBottom,this.position.x=s,this.position.y=r},d.layoutPosition=function(){var t=this.layout.size,e={},i=this.layout._getOption("originLeft"),o=this.layout._getOption("originTop"),n=i?"paddingLeft":"paddingRight",s=i?"left":"right",r=i?"right":"left",a=this.position.x+t[n];e[s]=this.getXValue(a),e[r]="";var u=o?"paddingTop":"paddingBottom",h=o?"top":"bottom",d=o?"bottom":"top",l=this.position.y+t[u];e[h]=this.getYValue(l),e[d]="",this.css(e),this.emitEvent("layout",[this])},d.getXValue=function(t){var e=this.layout._getOption("horizontal");return this.layout.options.percentPosition&&!e?t/this.layout.size.width*100+"%":t+"px"},d.getYValue=function(t){var e=this.layout._getOption("horizontal");return this.layout.options.percentPosition&&e?t/this.layout.size.height*100+"%":t+"px"},d._transitionTo=function(t,e){this.getPosition();var i=this.position.x,o=this.position.y,n=t==this.position.x&&e==this.position.y;if(this.setPosition(t,e),n&&!this.isTransitioning)return void this.layoutPosition();var s=t-i,r=e-o,a={};a.transform=this.getTranslate(s,r),this.transition({to:a,onTransitionEnd:{transform:this.layoutPosition},isCleaning:!0})},d.getTranslate=function(t,e){var i=this.layout._getOption("originLeft"),o=this.layout._getOption("originTop");return t=i?t:-t,e=o?e:-e,"translate3d("+t+"px, "+e+"px, 0)"},d.goTo=function(t,e){this.setPosition(t,e),this.layoutPosition()},d.moveTo=d._transitionTo,d.setPosition=function(t,e){this.position.x=parseFloat(t),this.position.y=parseFloat(e)},d._nonTransition=function(t){this.css(t.to),t.isCleaning&&this._removeStyles(t.to);for(var e in t.onTransitionEnd)t.onTransitionEnd[e].call(this)},d.transition=function(t){if(!parseFloat(this.layout.options.transitionDuration))return void this._nonTransition(t);var e=this._transn;for(var i in t.onTransitionEnd)e.onEnd[i]=t.onTransitionEnd[i];for(i in t.to)e.ingProperties[i]=!0,t.isCleaning&&(e.clean[i]=!0);if(t.from){this.css(t.from);var o=this.element.offsetHeight;o=null}this.enableTransition(t.to),this.css(t.to),this.isTransitioning=!0};var l="opacity,"+n(a);d.enableTransition=function(){if(!this.isTransitioning){var t=this.layout.options.transitionDuration;t="number"==typeof t?t+"ms":t,this.css({transitionProperty:l,transitionDuration:t,transitionDelay:this.staggerDelay||0}),this.element.addEventListener(u,this,!1)}},d.onwebkitTransitionEnd=function(t){this.ontransitionend(t)},d.onotransitionend=function(t){this.ontransitionend(t)};var f={"-webkit-transform":"transform"};d.ontransitionend=function(t){if(t.target===this.element){var e=this._transn,o=f[t.propertyName]||t.propertyName;if(delete e.ingProperties[o],i(e.ingProperties)&&this.disableTransition(),o in e.clean&&(this.element.style[t.propertyName]="",delete e.clean[o]),o in e.onEnd){var n=e.onEnd[o];n.call(this),delete e.onEnd[o]}this.emitEvent("transitionEnd",[this])}},d.disableTransition=function(){this.removeTransitionStyles(),this.element.removeEventListener(u,this,!1),this.isTransitioning=!1},d._removeStyles=function(t){var e={};for(var i in t)e[i]="";this.css(e)};var c={transitionProperty:"",transitionDuration:"",transitionDelay:""};return d.removeTransitionStyles=function(){this.css(c)},d.stagger=function(t){t=isNaN(t)?0:t,this.staggerDelay=t+"ms"},d.removeElem=function(){this.element.parentNode.removeChild(this.element),this.css({display:""}),this.emitEvent("remove",[this])},d.remove=function(){return r&&parseFloat(this.layout.options.transitionDuration)?(this.once("transitionEnd",function(){this.removeElem()}),void this.hide()):void this.removeElem()},d.reveal=function(){delete this.isHidden,this.css({display:""});var t=this.layout.options,e={},i=this.getHideRevealTransitionEndProperty("visibleStyle");e[i]=this.onRevealTransitionEnd,this.transition({from:t.hiddenStyle,to:t.visibleStyle,isCleaning:!0,onTransitionEnd:e})},d.onRevealTransitionEnd=function(){this.isHidden||this.emitEvent("reveal")},d.getHideRevealTransitionEndProperty=function(t){var e=this.layout.options[t];if(e.opacity)return"opacity";for(var i in e)return i},d.hide=function(){this.isHidden=!0,this.css({display:""});var t=this.layout.options,e={},i=this.getHideRevealTransitionEndProperty("hiddenStyle");e[i]=this.onHideTransitionEnd,this.transition({from:t.visibleStyle,to:t.hiddenStyle,isCleaning:!0,onTransitionEnd:e})},d.onHideTransitionEnd=function(){this.isHidden&&(this.css({display:"none"}),this.emitEvent("hide"))},d.destroy=function(){this.css({position:"",left:"",right:"",top:"",bottom:"",transition:"",transform:""})},o}),function(t,e){"use strict";"function"==typeof define&&define.amd?define("outlayer/outlayer",["ev-emitter/ev-emitter","get-size/get-size","fizzy-ui-utils/utils","./item"],function(i,o,n,s){return e(t,i,o,n,s)}):"object"==typeof module&&module.exports?module.exports=e(t,require("ev-emitter"),require("get-size"),require("fizzy-ui-utils"),require("./item")):t.Outlayer=e(t,t.EvEmitter,t.getSize,t.fizzyUIUtils,t.Outlayer.Item)}(window,function(t,e,i,o,n){"use strict";function s(t,e){var i=o.getQueryElement(t);if(!i)return void(u&&u.error("Bad element for "+this.constructor.namespace+": "+(i||t)));this.element=i,h&&(this.$element=h(this.element)),this.options=o.extend({},this.constructor.defaults),this.option(e);var n=++l;this.element.outlayerGUID=n,f[n]=this,this._create();var s=this._getOption("initLayout");s&&this.layout()}function r(t){function e(){t.apply(this,arguments)}return e.prototype=Object.create(t.prototype),e.prototype.constructor=e,e}function a(t){if("number"==typeof t)return t;var e=t.match(/(^\d*\.?\d*)(\w*)/),i=e&&e[1],o=e&&e[2];if(!i.length)return 0;i=parseFloat(i);var n=m[o]||1;return i*n}var u=t.console,h=t.jQuery,d=function(){},l=0,f={};s.namespace="outlayer",s.Item=n,s.defaults={containerStyle:{position:"relative"},initLayout:!0,originLeft:!0,originTop:!0,resize:!0,resizeContainer:!0,transitionDuration:"0.4s",hiddenStyle:{opacity:0,transform:"scale(0.001)"},visibleStyle:{opacity:1,transform:"scale(1)"}};var c=s.prototype;o.extend(c,e.prototype),c.option=function(t){o.extend(this.options,t)},c._getOption=function(t){var e=this.constructor.compatOptions[t];return e&&void 0!==this.options[e]?this.options[e]:this.options[t]},s.compatOptions={initLayout:"isInitLayout",horizontal:"isHorizontal",layoutInstant:"isLayoutInstant",originLeft:"isOriginLeft",originTop:"isOriginTop",resize:"isResizeBound",resizeContainer:"isResizingContainer"},c._create=function(){this.reloadItems(),this.stamps=[],this.stamp(this.options.stamp),o.extend(this.element.style,this.options.containerStyle);var t=this._getOption("resize");t&&this.bindResize()},c.reloadItems=function(){this.items=this._itemize(this.element.children)},c._itemize=function(t){for(var e=this._filterFindItemElements(t),i=this.constructor.Item,o=[],n=0;n<e.length;n++){var s=e[n],r=new i(s,this);o.push(r)}return o},c._filterFindItemElements=function(t){return o.filterFindElements(t,this.options.itemSelector)},c.getItemElements=function(){return this.items.map(function(t){return t.element})},c.layout=function(){this._resetLayout(),this._manageStamps();var t=this._getOption("layoutInstant"),e=void 0!==t?t:!this._isLayoutInited;this.layoutItems(this.items,e),this._isLayoutInited=!0},c._init=c.layout,c._resetLayout=function(){this.getSize()},c.getSize=function(){this.size=i(this.element)},c._getMeasurement=function(t,e){var o,n=this.options[t];n?("string"==typeof n?o=this.element.querySelector(n):n instanceof HTMLElement&&(o=n),this[t]=o?i(o)[e]:n):this[t]=0},c.layoutItems=function(t,e){t=this._getItemsForLayout(t),this._layoutItems(t,e),this._postLayout()},c._getItemsForLayout=function(t){return t.filter(function(t){return!t.isIgnored})},c._layoutItems=function(t,e){if(this._emitCompleteOnItems("layout",t),t&&t.length){var i=[];t.forEach(function(t){var o=this._getItemLayoutPosition(t);o.item=t,o.isInstant=e||t.isLayoutInstant,i.push(o)},this),this._processLayoutQueue(i)}},c._getItemLayoutPosition=function(){return{x:0,y:0}},c._processLayoutQueue=function(t){this.updateStagger(),t.forEach(function(t,e){this._positionItem(t.item,t.x,t.y,t.isInstant,e)},this)},c.updateStagger=function(){var t=this.options.stagger;return null===t||void 0===t?void(this.stagger=0):(this.stagger=a(t),this.stagger)},c._positionItem=function(t,e,i,o,n){o?t.goTo(e,i):(t.stagger(n*this.stagger),t.moveTo(e,i))},c._postLayout=function(){this.resizeContainer()},c.resizeContainer=function(){var t=this._getOption("resizeContainer");if(t){var e=this._getContainerSize();e&&(this._setContainerMeasure(e.width,!0),this._setContainerMeasure(e.height,!1))}},c._getContainerSize=d,c._setContainerMeasure=function(t,e){if(void 0!==t){var i=this.size;i.isBorderBox&&(t+=e?i.paddingLeft+i.paddingRight+i.borderLeftWidth+i.borderRightWidth:i.paddingBottom+i.paddingTop+i.borderTopWidth+i.borderBottomWidth),t=Math.max(t,0),this.element.style[e?"width":"height"]=t+"px"}},c._emitCompleteOnItems=function(t,e){function i(){n.dispatchEvent(t+"Complete",null,[e])}function o(){r++,r==s&&i()}var n=this,s=e.length;if(!e||!s)return void i();var r=0;e.forEach(function(e){e.once(t,o)})},c.dispatchEvent=function(t,e,i){var o=e?[e].concat(i):i;if(this.emitEvent(t,o),h)if(this.$element=this.$element||h(this.element),e){var n=h.Event(e);n.type=t,this.$element.trigger(n,i)}else this.$element.trigger(t,i)},c.ignore=function(t){var e=this.getItem(t);e&&(e.isIgnored=!0)},c.unignore=function(t){var e=this.getItem(t);e&&delete e.isIgnored},c.stamp=function(t){t=this._find(t),t&&(this.stamps=this.stamps.concat(t),t.forEach(this.ignore,this))},c.unstamp=function(t){t=this._find(t),t&&t.forEach(function(t){o.removeFrom(this.stamps,t),this.unignore(t)},this)},c._find=function(t){if(t)return"string"==typeof t&&(t=this.element.querySelectorAll(t)),t=o.makeArray(t)},c._manageStamps=function(){this.stamps&&this.stamps.length&&(this._getBoundingRect(),this.stamps.forEach(this._manageStamp,this))},c._getBoundingRect=function(){var t=this.element.getBoundingClientRect(),e=this.size;this._boundingRect={left:t.left+e.paddingLeft+e.borderLeftWidth,top:t.top+e.paddingTop+e.borderTopWidth,right:t.right-(e.paddingRight+e.borderRightWidth),bottom:t.bottom-(e.paddingBottom+e.borderBottomWidth)}},c._manageStamp=d,c._getElementOffset=function(t){var e=t.getBoundingClientRect(),o=this._boundingRect,n=i(t),s={left:e.left-o.left-n.marginLeft,top:e.top-o.top-n.marginTop,right:o.right-e.right-n.marginRight,bottom:o.bottom-e.bottom-n.marginBottom};return s},c.handleEvent=o.handleEvent,c.bindResize=function(){t.addEventListener("resize",this),this.isResizeBound=!0},c.unbindResize=function(){t.removeEventListener("resize",this),this.isResizeBound=!1},c.onresize=function(){this.resize()},o.debounceMethod(s,"onresize",100),c.resize=function(){this.isResizeBound&&this.needsResizeLayout()&&this.layout()},c.needsResizeLayout=function(){var t=i(this.element),e=this.size&&t;return e&&t.innerWidth!==this.size.innerWidth},c.addItems=function(t){var e=this._itemize(t);return e.length&&(this.items=this.items.concat(e)),e},c.appended=function(t){var e=this.addItems(t);e.length&&(this.layoutItems(e,!0),this.reveal(e))},c.prepended=function(t){var e=this._itemize(t);if(e.length){var i=this.items.slice(0);this.items=e.concat(i),this._resetLayout(),this._manageStamps(),this.layoutItems(e,!0),this.reveal(e),this.layoutItems(i)}},c.reveal=function(t){if(this._emitCompleteOnItems("reveal",t),t&&t.length){var e=this.updateStagger();t.forEach(function(t,i){t.stagger(i*e),t.reveal()})}},c.hide=function(t){if(this._emitCompleteOnItems("hide",t),t&&t.length){var e=this.updateStagger();t.forEach(function(t,i){t.stagger(i*e),t.hide()})}},c.revealItemElements=function(t){var e=this.getItems(t);this.reveal(e)},c.hideItemElements=function(t){var e=this.getItems(t);this.hide(e)},c.getItem=function(t){for(var e=0;e<this.items.length;e++){var i=this.items[e];if(i.element==t)return i}},c.getItems=function(t){t=o.makeArray(t);var e=[];return t.forEach(function(t){var i=this.getItem(t);i&&e.push(i)},this),e},c.remove=function(t){var e=this.getItems(t);this._emitCompleteOnItems("remove",e),e&&e.length&&e.forEach(function(t){t.remove(),o.removeFrom(this.items,t)},this)},c.destroy=function(){var t=this.element.style;t.height="",t.position="",t.width="",this.items.forEach(function(t){t.destroy()}),this.unbindResize();var e=this.element.outlayerGUID;delete f[e],delete this.element.outlayerGUID,h&&h.removeData(this.element,this.constructor.namespace)},s.data=function(t){t=o.getQueryElement(t);var e=t&&t.outlayerGUID;return e&&f[e]},s.create=function(t,e){var i=r(s);return i.defaults=o.extend({},s.defaults),o.extend(i.defaults,e),i.compatOptions=o.extend({},s.compatOptions),i.namespace=t,i.data=s.data,i.Item=r(n),o.htmlInit(i,t),h&&h.bridget&&h.bridget(t,i),i};var m={ms:1,s:1e3};return s.Item=n,s}),function(t,e){"function"==typeof define&&define.amd?define("isotope-layout/js/item",["outlayer/outlayer"],e):"object"==typeof module&&module.exports?module.exports=e(require("outlayer")):(t.Isotope=t.Isotope||{},t.Isotope.Item=e(t.Outlayer))}(window,function(t){"use strict";function e(){t.Item.apply(this,arguments)}var i=e.prototype=Object.create(t.Item.prototype),o=i._create;i._create=function(){this.id=this.layout.itemGUID++,o.call(this),this.sortData={}},i.updateSortData=function(){if(!this.isIgnored){this.sortData.id=this.id,this.sortData["original-order"]=this.id,this.sortData.random=Math.random();var t=this.layout.options.getSortData,e=this.layout._sorters;for(var i in t){var o=e[i];this.sortData[i]=o(this.element,this)}}};var n=i.destroy;return i.destroy=function(){n.apply(this,arguments),this.css({display:""})},e}),function(t,e){"function"==typeof define&&define.amd?define("isotope-layout/js/layout-mode",["get-size/get-size","outlayer/outlayer"],e):"object"==typeof module&&module.exports?module.exports=e(require("get-size"),require("outlayer")):(t.Isotope=t.Isotope||{},t.Isotope.LayoutMode=e(t.getSize,t.Outlayer))}(window,function(t,e){"use strict";function i(t){this.isotope=t,t&&(this.options=t.options[this.namespace],this.element=t.element,this.items=t.filteredItems,this.size=t.size)}var o=i.prototype,n=["_resetLayout","_getItemLayoutPosition","_manageStamp","_getContainerSize","_getElementOffset","needsResizeLayout","_getOption"];return n.forEach(function(t){o[t]=function(){return e.prototype[t].apply(this.isotope,arguments)}}),o.needsVerticalResizeLayout=function(){var e=t(this.isotope.element),i=this.isotope.size&&e;return i&&e.innerHeight!=this.isotope.size.innerHeight},o._getMeasurement=function(){this.isotope._getMeasurement.apply(this,arguments)},o.getColumnWidth=function(){this.getSegmentSize("column","Width")},o.getRowHeight=function(){this.getSegmentSize("row","Height")},o.getSegmentSize=function(t,e){var i=t+e,o="outer"+e;if(this._getMeasurement(i,o),!this[i]){var n=this.getFirstItemSize();this[i]=n&&n[o]||this.isotope.size["inner"+e]}},o.getFirstItemSize=function(){var e=this.isotope.filteredItems[0];return e&&e.element&&t(e.element)},o.layout=function(){this.isotope.layout.apply(this.isotope,arguments)},o.getSize=function(){this.isotope.getSize(),this.size=this.isotope.size},i.modes={},i.create=function(t,e){function n(){i.apply(this,arguments)}return n.prototype=Object.create(o),n.prototype.constructor=n,e&&(n.options=e),n.prototype.namespace=t,i.modes[t]=n,n},i}),function(t,e){"function"==typeof define&&define.amd?define("masonry-layout/masonry",["outlayer/outlayer","get-size/get-size"],e):"object"==typeof module&&module.exports?module.exports=e(require("outlayer"),require("get-size")):t.Masonry=e(t.Outlayer,t.getSize)}(window,function(t,e){var i=t.create("masonry");i.compatOptions.fitWidth="isFitWidth";var o=i.prototype;return o._resetLayout=function(){this.getSize(),this._getMeasurement("columnWidth","outerWidth"),this._getMeasurement("gutter","outerWidth"),this.measureColumns(),this.colYs=[];for(var t=0;t<this.cols;t++)this.colYs.push(0);this.maxY=0,this.horizontalColIndex=0},o.measureColumns=function(){if(this.getContainerWidth(),!this.columnWidth){var t=this.items[0],i=t&&t.element;this.columnWidth=i&&e(i).outerWidth||this.containerWidth}var o=this.columnWidth+=this.gutter,n=this.containerWidth+this.gutter,s=n/o,r=o-n%o,a=r&&r<1?"round":"floor";s=Math[a](s),this.cols=Math.max(s,1)},o.getContainerWidth=function(){var t=this._getOption("fitWidth"),i=t?this.element.parentNode:this.element,o=e(i);this.containerWidth=o&&o.innerWidth},o._getItemLayoutPosition=function(t){t.getSize();var e=t.size.outerWidth%this.columnWidth,i=e&&e<1?"round":"ceil",o=Math[i](t.size.outerWidth/this.columnWidth);o=Math.min(o,this.cols);for(var n=this.options.horizontalOrder?"_getHorizontalColPosition":"_getTopColPosition",s=this[n](o,t),r={x:this.columnWidth*s.col,y:s.y},a=s.y+t.size.outerHeight,u=o+s.col,h=s.col;h<u;h++)this.colYs[h]=a;return r},o._getTopColPosition=function(t){var e=this._getTopColGroup(t),i=Math.min.apply(Math,e);return{col:e.indexOf(i),y:i}},o._getTopColGroup=function(t){if(t<2)return this.colYs;for(var e=[],i=this.cols+1-t,o=0;o<i;o++)e[o]=this._getColGroupY(o,t);return e},o._getColGroupY=function(t,e){if(e<2)return this.colYs[t];var i=this.colYs.slice(t,t+e);return Math.max.apply(Math,i)},o._getHorizontalColPosition=function(t,e){var i=this.horizontalColIndex%this.cols,o=t>1&&i+t>this.cols;i=o?0:i;var n=e.size.outerWidth&&e.size.outerHeight;return this.horizontalColIndex=n?i+t:this.horizontalColIndex,{col:i,y:this._getColGroupY(i,t)}},o._manageStamp=function(t){var i=e(t),o=this._getElementOffset(t),n=this._getOption("originLeft"),s=n?o.left:o.right,r=s+i.outerWidth,a=Math.floor(s/this.columnWidth);a=Math.max(0,a);var u=Math.floor(r/this.columnWidth);u-=r%this.columnWidth?0:1,u=Math.min(this.cols-1,u);for(var h=this._getOption("originTop"),d=(h?o.top:o.bottom)+i.outerHeight,l=a;l<=u;l++)this.colYs[l]=Math.max(d,this.colYs[l])},o._getContainerSize=function(){this.maxY=Math.max.apply(Math,this.colYs);var t={height:this.maxY};return this._getOption("fitWidth")&&(t.width=this._getContainerFitWidth()),t},o._getContainerFitWidth=function(){for(var t=0,e=this.cols;--e&&0===this.colYs[e];)t++;return(this.cols-t)*this.columnWidth-this.gutter},o.needsResizeLayout=function(){var t=this.containerWidth;return this.getContainerWidth(),t!=this.containerWidth},i}),function(t,e){"function"==typeof define&&define.amd?define("isotope-layout/js/layout-modes/masonry",["../layout-mode","masonry-layout/masonry"],e):"object"==typeof module&&module.exports?module.exports=e(require("../layout-mode"),require("masonry-layout")):e(t.Isotope.LayoutMode,t.Masonry)}(window,function(t,e){"use strict";var i=t.create("masonry"),o=i.prototype,n={_getElementOffset:!0,layout:!0,_getMeasurement:!0};for(var s in e.prototype)n[s]||(o[s]=e.prototype[s]);var r=o.measureColumns;o.measureColumns=function(){this.items=this.isotope.filteredItems,r.call(this)};var a=o._getOption;return o._getOption=function(t){return"fitWidth"==t?void 0!==this.options.isFitWidth?this.options.isFitWidth:this.options.fitWidth:a.apply(this.isotope,arguments)},i}),function(t,e){"function"==typeof define&&define.amd?define("isotope-layout/js/layout-modes/fit-rows",["../layout-mode"],e):"object"==typeof exports?module.exports=e(require("../layout-mode")):e(t.Isotope.LayoutMode)}(window,function(t){"use strict";var e=t.create("fitRows"),i=e.prototype;return i._resetLayout=function(){this.x=0,this.y=0,this.maxY=0,this._getMeasurement("gutter","outerWidth")},i._getItemLayoutPosition=function(t){t.getSize();var e=t.size.outerWidth+this.gutter,i=this.isotope.size.innerWidth+this.gutter;0!==this.x&&e+this.x>i&&(this.x=0,this.y=this.maxY);var o={x:this.x,y:this.y};return this.maxY=Math.max(this.maxY,this.y+t.size.outerHeight),this.x+=e,o},i._getContainerSize=function(){return{height:this.maxY}},e}),function(t,e){"function"==typeof define&&define.amd?define("isotope-layout/js/layout-modes/vertical",["../layout-mode"],e):"object"==typeof module&&module.exports?module.exports=e(require("../layout-mode")):e(t.Isotope.LayoutMode)}(window,function(t){"use strict";var e=t.create("vertical",{horizontalAlignment:0}),i=e.prototype;return i._resetLayout=function(){this.y=0},i._getItemLayoutPosition=function(t){t.getSize();var e=(this.isotope.size.innerWidth-t.size.outerWidth)*this.options.horizontalAlignment,i=this.y;return this.y+=t.size.outerHeight,{x:e,y:i}},i._getContainerSize=function(){return{height:this.y}},e}),function(t,e){"function"==typeof define&&define.amd?define(["outlayer/outlayer","get-size/get-size","desandro-matches-selector/matches-selector","fizzy-ui-utils/utils","isotope-layout/js/item","isotope-layout/js/layout-mode","isotope-layout/js/layout-modes/masonry","isotope-layout/js/layout-modes/fit-rows","isotope-layout/js/layout-modes/vertical"],function(i,o,n,s,r,a){return e(t,i,o,n,s,r,a)}):"object"==typeof module&&module.exports?module.exports=e(t,require("outlayer"),require("get-size"),require("desandro-matches-selector"),require("fizzy-ui-utils"),require("isotope-layout/js/item"),require("isotope-layout/js/layout-mode"),require("isotope-layout/js/layout-modes/masonry"),require("isotope-layout/js/layout-modes/fit-rows"),require("isotope-layout/js/layout-modes/vertical")):t.Isotope=e(t,t.Outlayer,t.getSize,t.matchesSelector,t.fizzyUIUtils,t.Isotope.Item,t.Isotope.LayoutMode)}(window,function(t,e,i,o,n,s,r){function a(t,e){return function(i,o){for(var n=0;n<t.length;n++){var s=t[n],r=i.sortData[s],a=o.sortData[s];if(r>a||r<a){var u=void 0!==e[s]?e[s]:e,h=u?1:-1;return(r>a?1:-1)*h}}return 0}}var u=t.jQuery,h=String.prototype.trim?function(t){return t.trim()}:function(t){return t.replace(/^\s+|\s+$/g,"")},d=e.create("isotope",{layoutMode:"masonry",isJQueryFiltering:!0,sortAscending:!0});d.Item=s,d.LayoutMode=r;var l=d.prototype;l._create=function(){this.itemGUID=0,this._sorters={},this._getSorters(),e.prototype._create.call(this),this.modes={},this.filteredItems=this.items,this.sortHistory=["original-order"];for(var t in r.modes)this._initLayoutMode(t)},l.reloadItems=function(){this.itemGUID=0,e.prototype.reloadItems.call(this)},l._itemize=function(){for(var t=e.prototype._itemize.apply(this,arguments),i=0;i<t.length;i++){var o=t[i];o.id=this.itemGUID++}return this._updateItemsSortData(t),t},l._initLayoutMode=function(t){var e=r.modes[t],i=this.options[t]||{};this.options[t]=e.options?n.extend(e.options,i):i,this.modes[t]=new e(this)},l.layout=function(){return!this._isLayoutInited&&this._getOption("initLayout")?void this.arrange():void this._layout()},l._layout=function(){var t=this._getIsInstant();this._resetLayout(),this._manageStamps(),this.layoutItems(this.filteredItems,t),this._isLayoutInited=!0},l.arrange=function(t){this.option(t),this._getIsInstant();var e=this._filter(this.items);this.filteredItems=e.matches,this._bindArrangeComplete(),this._isInstant?this._noTransition(this._hideReveal,[e]):this._hideReveal(e),this._sort(),this._layout()},l._init=l.arrange,l._hideReveal=function(t){this.reveal(t.needReveal),this.hide(t.needHide)},l._getIsInstant=function(){var t=this._getOption("layoutInstant"),e=void 0!==t?t:!this._isLayoutInited;return this._isInstant=e,e},l._bindArrangeComplete=function(){function t(){e&&i&&o&&n.dispatchEvent("arrangeComplete",null,[n.filteredItems])}var e,i,o,n=this;this.once("layoutComplete",function(){e=!0,t()}),this.once("hideComplete",function(){i=!0,t()}),this.once("revealComplete",function(){o=!0,t()})},l._filter=function(t){var e=this.options.filter;e=e||"*";for(var i=[],o=[],n=[],s=this._getFilterTest(e),r=0;r<t.length;r++){var a=t[r];if(!a.isIgnored){var u=s(a);u&&i.push(a),u&&a.isHidden?o.push(a):u||a.isHidden||n.push(a)}}return{matches:i,needReveal:o,needHide:n}},l._getFilterTest=function(t){return u&&this.options.isJQueryFiltering?function(e){return u(e.element).is(t);
}:"function"==typeof t?function(e){return t(e.element)}:function(e){return o(e.element,t)}},l.updateSortData=function(t){var e;t?(t=n.makeArray(t),e=this.getItems(t)):e=this.items,this._getSorters(),this._updateItemsSortData(e)},l._getSorters=function(){var t=this.options.getSortData;for(var e in t){var i=t[e];this._sorters[e]=f(i)}},l._updateItemsSortData=function(t){for(var e=t&&t.length,i=0;e&&i<e;i++){var o=t[i];o.updateSortData()}};var f=function(){function t(t){if("string"!=typeof t)return t;var i=h(t).split(" "),o=i[0],n=o.match(/^\[(.+)\]$/),s=n&&n[1],r=e(s,o),a=d.sortDataParsers[i[1]];return t=a?function(t){return t&&a(r(t))}:function(t){return t&&r(t)}}function e(t,e){return t?function(e){return e.getAttribute(t)}:function(t){var i=t.querySelector(e);return i&&i.textContent}}return t}();d.sortDataParsers={parseInt:function(t){return parseInt(t,10)},parseFloat:function(t){return parseFloat(t)}},l._sort=function(){if(this.options.sortBy){var t=n.makeArray(this.options.sortBy);this._getIsSameSortBy(t)||(this.sortHistory=t.concat(this.sortHistory));var e=a(this.sortHistory,this.options.sortAscending);this.filteredItems.sort(e)}},l._getIsSameSortBy=function(t){for(var e=0;e<t.length;e++)if(t[e]!=this.sortHistory[e])return!1;return!0},l._mode=function(){var t=this.options.layoutMode,e=this.modes[t];if(!e)throw new Error("No layout mode: "+t);return e.options=this.options[t],e},l._resetLayout=function(){e.prototype._resetLayout.call(this),this._mode()._resetLayout()},l._getItemLayoutPosition=function(t){return this._mode()._getItemLayoutPosition(t)},l._manageStamp=function(t){this._mode()._manageStamp(t)},l._getContainerSize=function(){return this._mode()._getContainerSize()},l.needsResizeLayout=function(){return this._mode().needsResizeLayout()},l.appended=function(t){var e=this.addItems(t);if(e.length){var i=this._filterRevealAdded(e);this.filteredItems=this.filteredItems.concat(i)}},l.prepended=function(t){var e=this._itemize(t);if(e.length){this._resetLayout(),this._manageStamps();var i=this._filterRevealAdded(e);this.layoutItems(this.filteredItems),this.filteredItems=i.concat(this.filteredItems),this.items=e.concat(this.items)}},l._filterRevealAdded=function(t){var e=this._filter(t);return this.hide(e.needHide),this.reveal(e.matches),this.layoutItems(e.matches,!0),e.matches},l.insert=function(t){var e=this.addItems(t);if(e.length){var i,o,n=e.length;for(i=0;i<n;i++)o=e[i],this.element.appendChild(o.element);var s=this._filter(e).matches;for(i=0;i<n;i++)e[i].isLayoutInstant=!0;for(this.arrange(),i=0;i<n;i++)delete e[i].isLayoutInstant;this.reveal(s)}};var c=l.remove;return l.remove=function(t){t=n.makeArray(t);var e=this.getItems(t);c.call(this,t);for(var i=e&&e.length,o=0;i&&o<i;o++){var s=e[o];n.removeFrom(this.filteredItems,s)}},l.shuffle=function(){for(var t=0;t<this.items.length;t++){var e=this.items[t];e.sortData.random=Math.random()}this.options.sortBy="random",this._sort(),this._layout()},l._noTransition=function(t,e){var i=this.options.transitionDuration;this.options.transitionDuration=0;var o=t.apply(this,e);return this.options.transitionDuration=i,o},l.getFilteredItemElements=function(){return this.filteredItems.map(function(t){return t.element})},d});
    
    
/*!
 * Packery layout mode PACKAGED v2.0.1
 * sub-classes Packery
 */

!function(a,b){"function"==typeof define&&define.amd?define("packery/js/rect",b):"object"==typeof module&&module.exports?module.exports=b():(a.Packery=a.Packery||{},a.Packery.Rect=b())}(window,function(){function a(b){for(var c in a.defaults)this[c]=a.defaults[c];for(c in b)this[c]=b[c]}a.defaults={x:0,y:0,width:0,height:0};var b=a.prototype;return b.contains=function(a){var b=a.width||0,c=a.height||0;return this.x<=a.x&&this.y<=a.y&&this.x+this.width>=a.x+b&&this.y+this.height>=a.y+c},b.overlaps=function(a){var b=this.x+this.width,c=this.y+this.height,d=a.x+a.width,e=a.y+a.height;return this.x<d&&b>a.x&&this.y<e&&c>a.y},b.getMaximalFreeRects=function(b){if(!this.overlaps(b))return!1;var c,d=[],e=this.x+this.width,f=this.y+this.height,g=b.x+b.width,h=b.y+b.height;return this.y<b.y&&(c=new a({x:this.x,y:this.y,width:this.width,height:b.y-this.y}),d.push(c)),e>g&&(c=new a({x:g,y:this.y,width:e-g,height:this.height}),d.push(c)),f>h&&(c=new a({x:this.x,y:h,width:this.width,height:f-h}),d.push(c)),this.x<b.x&&(c=new a({x:this.x,y:this.y,width:b.x-this.x,height:this.height}),d.push(c)),d},b.canFit=function(a){return this.width>=a.width&&this.height>=a.height},a}),function(a,b){if("function"==typeof define&&define.amd)define("packery/js/packer",["./rect"],b);else if("object"==typeof module&&module.exports)module.exports=b(require("./rect"));else{var c=a.Packery=a.Packery||{};c.Packer=b(c.Rect)}}(window,function(a){function b(a,b,c){this.width=a||0,this.height=b||0,this.sortDirection=c||"downwardLeftToRight",this.reset()}var c=b.prototype;c.reset=function(){this.spaces=[];var b=new a({x:0,y:0,width:this.width,height:this.height});this.spaces.push(b),this.sorter=d[this.sortDirection]||d.downwardLeftToRight},c.pack=function(a){for(var b=0;b<this.spaces.length;b++){var c=this.spaces[b];if(c.canFit(a)){this.placeInSpace(a,c);break}}},c.columnPack=function(a){for(var b=0;b<this.spaces.length;b++){var c=this.spaces[b],d=c.x<=a.x&&c.x+c.width>=a.x+a.width&&c.height>=a.height-.01;if(d){a.y=c.y,this.placed(a);break}}},c.rowPack=function(a){for(var b=0;b<this.spaces.length;b++){var c=this.spaces[b],d=c.y<=a.y&&c.y+c.height>=a.y+a.height&&c.width>=a.width-.01;if(d){a.x=c.x,this.placed(a);break}}},c.placeInSpace=function(a,b){a.x=b.x,a.y=b.y,this.placed(a)},c.placed=function(a){for(var b=[],c=0;c<this.spaces.length;c++){var d=this.spaces[c],e=d.getMaximalFreeRects(a);e?b.push.apply(b,e):b.push(d)}this.spaces=b,this.mergeSortSpaces()},c.mergeSortSpaces=function(){b.mergeRects(this.spaces),this.spaces.sort(this.sorter)},c.addSpace=function(a){this.spaces.push(a),this.mergeSortSpaces()},b.mergeRects=function(a){var b=0,c=a[b];a:for(;c;){for(var d=0,e=a[b+d];e;){if(e==c)d++;else{if(e.contains(c)){a.splice(b,1),c=a[b];continue a}c.contains(e)?a.splice(b+d,1):d++}e=a[b+d]}b++,c=a[b]}return a};var d={downwardLeftToRight:function(a,b){return a.y-b.y||a.x-b.x},rightwardTopToBottom:function(a,b){return a.x-b.x||a.y-b.y}};return b}),function(a,b){"function"==typeof define&&define.amd?define("packery/js/item",["outlayer/outlayer","./rect"],b):"object"==typeof module&&module.exports?module.exports=b(require("outlayer"),require("./rect")):a.Packery.Item=b(a.Outlayer,a.Packery.Rect)}(window,function(a,b){var c=document.documentElement.style,d="string"==typeof c.transform?"transform":"WebkitTransform",e=function(){a.Item.apply(this,arguments)},f=e.prototype=Object.create(a.Item.prototype),g=f._create;f._create=function(){g.call(this),this.rect=new b};var h=f.moveTo;return f.moveTo=function(a,b){var c=Math.abs(this.position.x-a),d=Math.abs(this.position.y-b),e=this.layout.dragItemCount&&!this.isPlacing&&!this.isTransitioning&&1>c&&1>d;return e?void this.goTo(a,b):void h.apply(this,arguments)},f.enablePlacing=function(){this.removeTransitionStyles(),this.isTransitioning&&d&&(this.element.style[d]="none"),this.isTransitioning=!1,this.getSize(),this.layout._setRectSize(this.element,this.rect),this.isPlacing=!0},f.disablePlacing=function(){this.isPlacing=!1},f.removeElem=function(){this.element.parentNode.removeChild(this.element),this.layout.packer.addSpace(this.rect),this.emitEvent("remove",[this])},f.showDropPlaceholder=function(){var a=this.dropPlaceholder;a||(a=this.dropPlaceholder=document.createElement("div"),a.className="packery-drop-placeholder",a.style.position="absolute"),a.style.width=this.size.width+"px",a.style.height=this.size.height+"px",this.positionDropPlaceholder(),this.layout.element.appendChild(a)},f.positionDropPlaceholder=function(){this.dropPlaceholder.style[d]="translate("+this.rect.x+"px, "+this.rect.y+"px)"},f.hideDropPlaceholder=function(){this.layout.element.removeChild(this.dropPlaceholder)},e}),function(a,b){"function"==typeof define&&define.amd?define("packery/js/packery",["get-size/get-size","outlayer/outlayer","./rect","./packer","./item"],b):"object"==typeof module&&module.exports?module.exports=b(require("get-size"),require("outlayer"),require("./rect"),require("./packer"),require("./item")):a.Packery=b(a.getSize,a.Outlayer,a.Packery.Rect,a.Packery.Packer,a.Packery.Item)}(window,function(a,b,c,d,e){function f(a,b){return a.position.y-b.position.y||a.position.x-b.position.x}function g(a,b){return a.position.x-b.position.x||a.position.y-b.position.y}function h(a,b){var c=b.x-a.x,d=b.y-a.y;return Math.sqrt(c*c+d*d)}c.prototype.canFit=function(a){return this.width>=a.width-1&&this.height>=a.height-1};var i=b.create("packery");i.Item=e;var j=i.prototype;j._create=function(){b.prototype._create.call(this),this.packer=new d,this.shiftPacker=new d,this.isEnabled=!0,this.dragItemCount=0;var a=this;this.handleDraggabilly={dragStart:function(){a.itemDragStart(this.element)},dragMove:function(){a.itemDragMove(this.element,this.position.x,this.position.y)},dragEnd:function(){a.itemDragEnd(this.element)}},this.handleUIDraggable={start:function(b,c){c&&a.itemDragStart(b.currentTarget)},drag:function(b,c){c&&a.itemDragMove(b.currentTarget,c.position.left,c.position.top)},stop:function(b,c){c&&a.itemDragEnd(b.currentTarget)}}},j._resetLayout=function(){this.getSize(),this._getMeasurements();var a,b,c;this._getOption("horizontal")?(a=1/0,b=this.size.innerHeight+this.gutter,c="rightwardTopToBottom"):(a=this.size.innerWidth+this.gutter,b=1/0,c="downwardLeftToRight"),this.packer.width=this.shiftPacker.width=a,this.packer.height=this.shiftPacker.height=b,this.packer.sortDirection=this.shiftPacker.sortDirection=c,this.packer.reset(),this.maxY=0,this.maxX=0},j._getMeasurements=function(){this._getMeasurement("columnWidth","width"),this._getMeasurement("rowHeight","height"),this._getMeasurement("gutter","width")},j._getItemLayoutPosition=function(a){if(this._setRectSize(a.element,a.rect),this.isShifting||this.dragItemCount>0){var b=this._getPackMethod();this.packer[b](a.rect)}else this.packer.pack(a.rect);return this._setMaxXY(a.rect),a.rect},j.shiftLayout=function(){this.isShifting=!0,this.layout(),delete this.isShifting},j._getPackMethod=function(){return this._getOption("horizontal")?"rowPack":"columnPack"},j._setMaxXY=function(a){this.maxX=Math.max(a.x+a.width,this.maxX),this.maxY=Math.max(a.y+a.height,this.maxY)},j._setRectSize=function(b,c){var d=a(b),e=d.outerWidth,f=d.outerHeight;(e||f)&&(e=this._applyGridGutter(e,this.columnWidth),f=this._applyGridGutter(f,this.rowHeight)),c.width=Math.min(e,this.packer.width),c.height=Math.min(f,this.packer.height)},j._applyGridGutter=function(a,b){if(!b)return a+this.gutter;b+=this.gutter;var c=a%b,d=c&&1>c?"round":"ceil";return a=Math[d](a/b)*b},j._getContainerSize=function(){return this._getOption("horizontal")?{width:this.maxX-this.gutter}:{height:this.maxY-this.gutter}},j._manageStamp=function(a){var b,d=this.getItem(a);if(d&&d.isPlacing)b=d.rect;else{var e=this._getElementOffset(a);b=new c({x:this._getOption("originLeft")?e.left:e.right,y:this._getOption("originTop")?e.top:e.bottom})}this._setRectSize(a,b),this.packer.placed(b),this._setMaxXY(b)},j.sortItemsByPosition=function(){var a=this._getOption("horizontal")?g:f;this.items.sort(a)},j.fit=function(a,b,c){var d=this.getItem(a);d&&(this.stamp(d.element),d.enablePlacing(),this.updateShiftTargets(d),b=void 0===b?d.rect.x:b,c=void 0===c?d.rect.y:c,this.shift(d,b,c),this._bindFitEvents(d),d.moveTo(d.rect.x,d.rect.y),this.shiftLayout(),this.unstamp(d.element),this.sortItemsByPosition(),d.disablePlacing())},j._bindFitEvents=function(a){function b(){d++,2==d&&c.dispatchEvent("fitComplete",null,[a])}var c=this,d=0;a.once("layout",b),this.once("layoutComplete",b)},j.resize=function(){this.isResizeBound&&this.needsResizeLayout()&&(this.options.shiftPercentResize?this.resizeShiftPercentLayout():this.layout())},j.needsResizeLayout=function(){var b=a(this.element),c=this._getOption("horizontal")?"innerHeight":"innerWidth";return b[c]!=this.size[c]},j.resizeShiftPercentLayout=function(){var b=this._getItemsForLayout(this.items),c=this._getOption("horizontal"),d=c?"y":"x",e=c?"height":"width",f=c?"rowHeight":"columnWidth",g=c?"innerHeight":"innerWidth",h=this[f];if(h=h&&h+this.gutter){this._getMeasurements();var i=this[f]+this.gutter;b.forEach(function(a){var b=Math.round(a.rect[d]/h);a.rect[d]=b*i})}else{var j=a(this.element)[g]+this.gutter,k=this.packer[e];b.forEach(function(a){a.rect[d]=a.rect[d]/k*j})}this.shiftLayout()},j.itemDragStart=function(a){if(this.isEnabled){this.stamp(a);var b=this.getItem(a);b&&(b.enablePlacing(),b.showDropPlaceholder(),this.dragItemCount++,this.updateShiftTargets(b))}},j.updateShiftTargets=function(a){this.shiftPacker.reset(),this._getBoundingRect();var b=this._getOption("originLeft"),d=this._getOption("originTop");this.stamps.forEach(function(a){var e=this.getItem(a);if(!e||!e.isPlacing){var f=this._getElementOffset(a),g=new c({x:b?f.left:f.right,y:d?f.top:f.bottom});this._setRectSize(a,g),this.shiftPacker.placed(g)}},this);var e=this._getOption("horizontal"),f=e?"rowHeight":"columnWidth",g=e?"height":"width";this.shiftTargetKeys=[],this.shiftTargets=[];var h,i=this[f];if(i=i&&i+this.gutter){var j=Math.ceil(a.rect[g]/i),k=Math.floor((this.shiftPacker[g]+this.gutter)/i);h=(k-j)*i;for(var l=0;k>l;l++)this._addShiftTarget(l*i,0,h)}else h=this.shiftPacker[g]+this.gutter-a.rect[g],this._addShiftTarget(0,0,h);var m=this._getItemsForLayout(this.items),n=this._getPackMethod();m.forEach(function(a){var b=a.rect;this._setRectSize(a.element,b),this.shiftPacker[n](b),this._addShiftTarget(b.x,b.y,h);var c=e?b.x+b.width:b.x,d=e?b.y:b.y+b.height;if(this._addShiftTarget(c,d,h),i)for(var f=Math.round(b[g]/i),j=1;f>j;j++){var k=e?c:b.x+i*j,l=e?b.y+i*j:d;this._addShiftTarget(k,l,h)}},this)},j._addShiftTarget=function(a,b,c){var d=this._getOption("horizontal")?b:a;if(!(0!==d&&d>c)){var e=a+","+b,f=-1!=this.shiftTargetKeys.indexOf(e);f||(this.shiftTargetKeys.push(e),this.shiftTargets.push({x:a,y:b}))}},j.shift=function(a,b,c){var d,e=1/0,f={x:b,y:c};this.shiftTargets.forEach(function(a){var b=h(a,f);e>b&&(d=a,e=b)}),a.rect.x=d.x,a.rect.y=d.y};var k=120;j.itemDragMove=function(a,b,c){function d(){f.shift(e,b,c),e.positionDropPlaceholder(),f.layout()}var e=this.isEnabled&&this.getItem(a);if(e){b-=this.size.paddingLeft,c-=this.size.paddingTop;var f=this,g=new Date;this._itemDragTime&&g-this._itemDragTime<k?(clearTimeout(this.dragTimeout),this.dragTimeout=setTimeout(d,k)):(d(),this._itemDragTime=g)}},j.itemDragEnd=function(a){function b(){d++,2==d&&(c.element.classList.remove("is-positioning-post-drag"),c.hideDropPlaceholder(),e.dispatchEvent("dragItemPositioned",null,[c]))}var c=this.isEnabled&&this.getItem(a);if(c){clearTimeout(this.dragTimeout),c.element.classList.add("is-positioning-post-drag");var d=0,e=this;c.once("layout",b),this.once("layoutComplete",b),c.moveTo(c.rect.x,c.rect.y),this.layout(),this.dragItemCount=Math.max(0,this.dragItemCount-1),this.sortItemsByPosition(),c.disablePlacing(),this.unstamp(c.element)}},j.bindDraggabillyEvents=function(a){this._bindDraggabillyEvents(a,"on")},j.unbindDraggabillyEvents=function(a){this._bindDraggabillyEvents(a,"off")},j._bindDraggabillyEvents=function(a,b){var c=this.handleDraggabilly;a[b]("dragStart",c.dragStart),a[b]("dragMove",c.dragMove),a[b]("dragEnd",c.dragEnd)},j.bindUIDraggableEvents=function(a){this._bindUIDraggableEvents(a,"on")},j.unbindUIDraggableEvents=function(a){this._bindUIDraggableEvents(a,"off")},j._bindUIDraggableEvents=function(a,b){var c=this.handleUIDraggable;a[b]("dragstart",c.start)[b]("drag",c.drag)[b]("dragstop",c.stop)};var l=j.destroy;return j.destroy=function(){l.apply(this,arguments),this.isEnabled=!1},i.Rect=c,i.Packer=d,i}),function(a,b){"function"==typeof define&&define.amd?define(["isotope-layout/js/layout-mode","packery/js/packery"],b):"object"==typeof module&&module.exports?module.exports=b(require("isotope-layout/js/layout-mode"),require("packery")):b(a.Isotope.LayoutMode,a.Packery)}(window,function(a,b){var c=a.create("packery"),d=c.prototype,e={_getElementOffset:!0,_getMeasurement:!0};for(var f in b.prototype)e[f]||(d[f]=b.prototype[f]);var g=d._resetLayout;d._resetLayout=function(){this.packer=this.packer||new b.Packer,this.shiftPacker=this.shiftPacker||new b.Packer,g.apply(this,arguments)};var h=d._getItemLayoutPosition;d._getItemLayoutPosition=function(a){return a.rect=a.rect||new b.Rect,h.call(this,a)};var i=d.needsResizeLayout;d.needsResizeLayout=function(){return this._getOption("horizontal")?this.needsVerticalResizeLayout():i.call(this)};var j=d._getOption;return d._getOption=function(a){return"horizontal"==a?void 0!==this.options.isHorizontal?this.options.isHorizontal:this.options.horizontal:j.apply(this.isotope,arguments)},c});(function(i){'use strict';i.fn.avia_masonry=function(a){if(!this.length){return this};var s=i('body'),e=i(window),n=i.avia_utilities.isMobile,l=i.avia_utilities.isTouchDevice,r=s.hasClass('avia-mobile-no-animations'),o=!1,t={masonry_filter:function(){var a=i(this),l=a.html(),n=a.data('filter'),o=a.parents('.av-masonry').eq(0),s=o.find('.av-masonry-container').eq(0),d=o.find('.av-masonry-sort a'),r=o.find('.av-current-sort-title');d.removeClass('active_sort');a.addClass('active_sort');s.attr('id','masonry_id_'+n);if(r.length){r.html(l)};t.applyMasonry(s,n,function(){s.css({overflow:'visible'})});setTimeout(function(){e.trigger('debouncedresize')},500);return!1},applyMasonry:function(a,o,s){var t=o?{filter:'.'+o}:{};t['layoutMode']='packery';t['packery']={gutter:0};t['percentPosition']=!0;t['itemSelector']='a.isotope-item, div.isotope-item';t['originLeft']=i('body').hasClass('rtl')?!1:!0;a.isotope(t,function(){e.trigger('av-height-change')});if(typeof s==='function'){setTimeout(s,0)}},show_bricks:function(a,t){var s=i.avia_utilities.supports('transition'),o=n&&r?0:100;a.each(function(n){var r=i(this),l=r.find('.avia-curtain-reveal-overlay');if(l.length>0){o=500;l.on('animationstart',function(i){r.css({visibility:'visible'})});l.on('animationend',function(a){i(this).remove()})};setTimeout(function(){if(s===!1){r.css({visibility:'visible',opacity:0}).animate({opacity:1},1500)}
else{r.addClass('av-masonry-item-loaded');l.addClass('avia_start_delayed_animation')};if(n==a.length-1&&typeof t=='function'){t.call();e.trigger('av-height-change')}},(o*n))})},loadMore:function(a){a.preventDefault();if(o){return!1};o=!0;var l=i(this),n=l.data(),r=l.parents('.av-masonry').eq(0),f=r.data('post_id'),c=r.find('.av-masonry-container'),u=r.find('.av-masonry-entry'),d=i.avia_utilities.loading(),v=function(){o=!1;d.hide();s.trigger('av_resize_finished')};if('undefined'!=typeof f){n.post_id=f};if(!n.offset){n.offset=0};n.offset+=n.items;n.action='avia_ajax_masonry_more';n.loaded=[];u.each(function(){var a=i(this).data('av-masonry-item');if(a){n.loaded.push(a)}});i.ajax({url:avia_framework_globals.ajaxurl,type:'POST',data:n,beforeSend:function(){d.show()},success:function(a){if(a.indexOf('{av-masonry-loaded}')!==-1){var a=a.split('{av-masonry-loaded}'),o=i(a.pop()).filter('.isotope-item');if(o.length>n.items){o=o.not(o.last())}
else{l.addClass('av-masonry-no-more-items')};o.find('.avia-animate-admin-preview').removeClass('avia-animate-admin-preview');if(o.find('.avia-curtain-reveal-overlay').length>0){o.css({visibility:'hidden'})};var s=i('<div class="loadcontainer"></div>').append(o);i.avia_utilities.preload({container:s,single_callback:function(){var s=r.find('.av-masonry-sort a'),a=r.find('.av-sort-by-term'),n=a.data('av-allowed-sort');a.hide();d.hide();c.isotope('insert',o);i.avia_utilities.avia_ajax_call(r);setTimeout(function(){t.show_bricks(o,v)},150);setTimeout(function(){e.trigger('av-height-change')},550);if(s){i(s).each(function(a){var t=i(this),e=t.data('filter');if(o){i(o).each(function(a){var s=i(this);if(s.hasClass(e)&&n.indexOf(e)!==-1){var o=t.find('.avia-term-count').text();t.find('.avia-term-count').text(' '+(parseInt(o)+1)+' ');if(t.hasClass('avia_hide_sort')){t.removeClass('avia_hide_sort').addClass('avia_show_sort');r.find('.av-masonry-sort .'+e+'_sep').removeClass('avia_hide_sort').addClass('avia_show_sort');r.find('.av-masonry-sort .av-sort-by-term').removeClass('hidden')}}})}})};a.fadeIn()}})}
else{v()}},error:v,complete:function(){setTimeout(function(){e.trigger('debouncedresize')},500)}})}};return this.each(function(){var a=i(this),e=a.find('.av-masonry-container'),o=a.find('.isotope-item'),s=a.find('.av-masonry-sort').css({visibility:'visible',opacity:0}).on('click','a',t.masonry_filter),l=a.find('.av-masonry-load-more').css({visibility:'visible',opacity:0});if(o.find('.avia-curtain-reveal-overlay').length>0){o.css({visibility:'hidden'})};i.avia_utilities.preload({container:e,single_callback:function(){var d=function(){s.animate({opacity:1},400);if(e.outerHeight()+e.offset().top+i('#footer').outerHeight()>i(window).height()){i('html').css({'overflow-y':'scroll'})};t.applyMasonry(e,!1,function(){a.addClass('avia_sortable_active');e.removeClass('av-js-disabled')});t.show_bricks(o,function(){l.css({opacity:1}).on('click',t.loadMore)})};if(n&&r){d()}
else{a.waypoint(d,{offset:'80%'})};i(window).on('debouncedresize',function(){t.applyMasonry(e,!1,function(){a.addClass('avia_sortable_active')})})}})})}}(jQuery));(function(i){'use strict';i.avia_utilities=i.avia_utilities||{};i(function(){i.avia_utilities=i.avia_utilities||{};if(i.avia_utilities.avia_sticky_submenu){i.avia_utilities.avia_sticky_submenu()}});i.avia_utilities.avia_sticky_submenu=function(){var e=i(window),s=i('html').first(),t=i('.html_header_top.html_header_sticky #header'),a=parseInt(i('html').first().css('margin-top'),10),l=i('.html_header_sidebar #main, .boxed #main'),n=i('.av-submenu-container'),r=s.is('.html_minimal_header')?0:1,u=i('.av-frame-top').height(),b=i('.av-burger-menu-main'),o=function(){a=parseInt(s.css('margin-top'),10);if(!i('.mobile_menu_toggle:visible').length){i('.av-open-submenu').removeClass('av-open-submenu')};n.filter('.av-sticky-submenu').each(function(){i(this).next('.sticky_placeholder').height(i(this).height())})},v=function(){var i=l.width();a=parseInt(s.css('margin-top'),10);n.width(i)},h=function(n,v){var h=this.offset().top,l=n.offset().top,o=e.scrollTop(),i=a,s=!1;if(b.is(':visible')){this.css({top:'auto',position:'absolute'});s=!1;return};if(t.length){i+=t.outerHeight()+parseInt(t.css('margin-top'),10)};if(u){i+=u};if(o+i>l){if(!s){this.css({top:i-r,position:'fixed'});s=!0}}
else{this.css({top:'auto',position:'absolute'});s=!1}},m=function(e){e.preventDefault();var t=i(this),s=t.siblings('.av-subnav-menu');if(s.hasClass('av-open-submenu')){s.removeClass('av-open-submenu')}
else{s.addClass('av-open-submenu')}};e.on('debouncedresize av-height-change',o);o();if(l.length){e.on('debouncedresize av-height-change',v);v()};n.each(function(){var s=i(this),t=s.filter('.av-sticky-submenu'),n=s.next('.sticky_placeholder'),a=s.find('.mobile_menu_toggle');if(t.length){e.on('scroll debouncedresize',function(){window.requestAnimationFrame(h.bind(t,n))})};if(a.length){a.on('click',m)}});s.on('click','.av-submenu-hidden .av-open-submenu li a',function(){var s=i(this),e=s.siblings('ul, .avia_mega_div');if(e.length){if(e.hasClass('av-visible-sublist')){e.removeClass('av-visible-sublist')}
else{e.addClass('av-visible-sublist')};return!1}});i('.avia_mobile').on('click','.av-menu-mobile-disabled li a',function(){var s=i(this),e=s.siblings('ul');if(e.length){if(e.hasClass('av-visible-mobile-sublist')){}
else{i('.av-visible-mobile-sublist').removeClass('av-visible-mobile-sublist');e.addClass('av-visible-mobile-sublist');return!1}}})}}(jQuery));(function(e){'use strict';e.fn.avia_sc_messagebox=function(s){'use strict';return this.each(function(){var s=e(this),a=s.find('.av_message_close'),t=s.attr('id'),i=function(e,i,t){var a='';if(t){var s=new Date();s.setTime(s.getTime()+(t*24*60*60*1000));a='; expires='+s.toGMTString()};document.cookie=e+'='+i+a+'; path=/; samesite=strict'},n=function(t){var n=t+'=',o=document.cookie.split(';');for(var a=0;a<o.length;a++){var e=o[a];while(e.charAt(0)==' '){e=e.substring(1,e.length)};if(e.indexOf(n)==0){var r=s.attr('data-contents'),i=e.substring(n.length,e.length);if(i==r){return i}}};return null};if(!n(t)){s.removeClass('messagebox-hidden')};a.on('click',function(){var a=s.attr('data-contents'),e='';if(s.hasClass('messagebox-session_cookie')){e=''}
else if(s.hasClass('messagebox-custom_cookie')){e=parseInt(s.attr('data-cookielifetime'))};i(t,a,e);s.addClass('messagebox-hidden')})})};e('.avia_message_box').avia_sc_messagebox()}(jQuery));(function(t){t.fn.avia_sc_animated_number=function(a){if(!this.length)return;if(this.is('.avia_sc_animated_number_active'))return;this.addClass('avia_sc_animated_number_active');var e=(a&&a.simple_up)?!0:!1,r=(a&&a.start_timer)?a.start_timer:300,n=function(t,a,n){var r='',s=n.toString().length-t.toString().length;for(var i=s;i>0;i--){r+='0'};t=(e)?t.toString():r+t.toString();if(''==a){return t};return t.split(/(?=(?:...)*$)/).join(a)},i=function(t,a,r,u,f,s){var o=u+r,final='';if(o>=f){final=n(a,s,a);t.text(final)}
else{final=n(o,s,a);t.text(final);window.requestAnimationFrame(function(){i(t,a,r,o,f,s)})}};return this.each(function(){var n=t(this),e=n.find('.__av-single-number'),s=n.data('timer')||3000;e.each(function(a){var n=t(this),i=n.text();if(window.addEventListener)n.text(i.replace(/./g,'0'))});n.addClass('number_prepared').on('avia_start_animation',function(){if(n.is('.avia_animation_done'))return;n.addClass('avia_animation_done');e.each(function(n){var a=t(this),e=a.data('number'),f=e,u=parseInt(a.text(),10),m=/^0+$/.test(e),o=0,d='';if('undefined'!=typeof a.data('start_from')){u=a.data('start_from')};if('undefined'!=typeof a.data('number_format')){d=a.data('number_format')};if(m&&e!==0){f=e.replace(/0/g,'9')};o=Math.round(f*32/s);if(o==0||o%10==0)o+=1;setTimeout(function(){i(a,e,o,u,f,d)},r)})});if(a&&a.instant_start==!0){n.trigger('avia_start_animation')}})}})(jQuery);(function(i){'use strict';i.avia_utilities=i.avia_utilities||{};i.fn.avia_iso_sort=function(t){return this.each(function(){var o=i('body'),t=i(this),l=t.data('portfolio-id'),e=t.closest('.av-portfolio-grid-sorting-container, .entry-content-wrapper, .avia-fullwidth-portfolio'),n=e.find('.sort_width_container[data-portfolio-id="'+l+'"]').find('#js_sort_items').css({visibility:'visible',opacity:0}),s=n.find('a'),c=t.find('.grid-image'),d=!1,f=i('.post-entry',t),r=o.hasClass('rtl')?!1:!0;function a(){t.addClass('isotope_activated').isotope({layoutMode:'fitRows',itemSelector:'.flex_column',originLeft:r});t.isotope('on','layoutComplete',function(){t.css({overflow:'visible'});o.trigger('av_resize_finished')});d=!0;setTimeout(function(){e.addClass('avia_sortable_active')},0)};s.on('click',function(){var a=i(this),o=a.data('filter'),l=a.html(),n=e.find('.av-current-sort-title');if(n.length)n.html(l);s.removeClass('active_sort');a.addClass('active_sort');t.attr('id','grid_id_'+o);e.find('.open_container .ajax_controlls .avia_close').trigger('click');t.isotope({layoutMode:'fitRows',itemSelector:'.flex_column',filter:'.'+o,originLeft:r});return!1});i(window).on('debouncedresize',function(){a()});i.avia_utilities.preload({container:t,single_callback:function(){n.animate({opacity:1},400);a();setTimeout(function(){a()});c.css({height:'auto'}).each(function(t){var e=i(this);setTimeout(function(){e.animate({opacity:1},1500)},(100*t))})}})})};i.fn.avia_portfolio_preview=function(e){var o=i(window),a=i('body'),s=i.avia_utilities.isMobile,n={open_in:'.portfolio-details-inner',easing:'easeOutQuint',timing:800,transition:'slide'},t=i.extend({},n,e);return this.each(function(){var r=i(this),g=r.data('portfolio-id'),l=i('.portfolio_preview_container[data-portfolio-id="'+g+'"]'),d=l.find(t.open_in),p=r.find('.grid-entry'),e={},s=!1,c=!1,v=!1,f=!1,n,u,m=i.avia_utilities.loading();n={load_item:function(t){t.preventDefault();var o=i(this),e=o.parents('.post-entry').eq(0),a='ID_'+e.data('ajax-id'),l=p.index(e);if(a===s||c==!0){return!1};c=!0;r.find('.active_portfolio_item').removeClass('active_portfolio_item');e.addClass('active_portfolio_item');m.show();n.ajax_get_contents(a,l)},scroll_top:function(){setTimeout(function(){var e=l.offset().top-175,a=o.scrollTop();if(a>e||e-a>100){i('html:not(:animated),body:not(:animated)').animate({scrollTop:e},t.timing,t.easing)}},10)},attach_item:function(t){e[t]=i(e[t]).appendTo(d);f=!0},remove_video:function(){var i=l.find('iframe, .avia-video').parents('.ajax_slide:not(.open_slide)');if(i.length>0){i.remove();e['ID_'+i.data('slideId')]=undefined}},show_item:function(o,r){if(o===s){return!1};c=!0;m.hide();if(!1===s){l.addClass('open_container');e[o].addClass('open_slide');n.scroll_top();l.css({display:'none'}).slideDown(t.timing,t.easing,function(){if(f){i.avia_utilities.activate_shortcode_scripts(e[o]);i.avia_utilities.avia_ajax_call(e[o]);a.trigger('av_resize_finished');f=!1};n.remove_video();a.trigger('av_resize_finished')});v=r;s=o;c=!1}
else{n.scroll_top();var p={zIndex:3},u=t.easing;if(v>r){p.left='-110%'};if(t.transition==='fade'){p.left='0%';p.opacity=0;u='easeOutQuad'};d.height(d.height());e[o].css(p).avia_animate({'left':'0%',opacity:1},t.timing,u);e[s].avia_animate({opacity:0},t.timing,u,function(){e[s].attr({'style':''}).removeClass('open_slide');e[o].addClass('open_slide');d.avia_animate({height:e[o].outerHeight()+2},t.timing/2,t.easing,function(){d.attr({'style':''});s=o;v=r;c=!1;n.remove_video();if(f){a.trigger('av_resize_finished');i.avia_utilities.activate_shortcode_scripts(e[o]);i.avia_utilities.avia_ajax_call(e[o]);f=!1}})})}},ajax_get_contents:function(t,a){if(e[t]!==undefined){n.show_item(t,a);return};var o=i('#avia-tmpl-portfolio-preview-'+t.replace(/ID_/,''));if(o.length==0){setTimeout(function(){n.ajax_get_contents(t,a);return},500)};e[t]=o.html();e[t]=e[t].replace('/*<![CDATA[*/','').replace('*]]>','');n.attach_item(t);i.avia_utilities.preload({container:e[t],single_callback:function(){n.show_item(t,a)}})},add_controls:function(){u=l.find('.ajax_controlls');l.avia_keyboard_controls({27:'.avia_close',37:'.ajax_previous',39:'.ajax_next'});p.each(function(){var t=i(this),e;t.addClass('no_combo').on('click',function(i){e=t.find('.slideshow_overlay');if(e.length){i.stopPropagation();n.load_item.apply(t.find('a').eq(0));return!1}})})},control_click:function(){var o,f=r.find('.active_portfolio_item').data('ajax-id'),d=r.find('.post-entry-'+f);switch(this.hash){case'#next':o=d.nextAll('.post-entry:visible').eq(0).find('a').eq(0);if(!o.length){o=i('.post-entry:visible',r).eq(0).find('a').eq(0)};o.trigger('click');break;case'#prev':o=d.prevAll('.post-entry:visible').eq(0).find('a').eq(0);if(!o.length){o=i('.post-entry:visible',r).last().find('a').eq(0)};o.trigger('click');break;case'#close':c=!0;l.slideUp(t.timing,t.easing,function(){r.find('.active_portfolio_item').removeClass('active_portfolio_item');e[s].attr({'style':''}).removeClass('open_slide');l.removeClass('open_container');c=s=v=!1;n.remove_video();a.trigger('av_resize_finished')});break};return!1},resize_reset:function(){if(s===!1){d.html('');e=[]}}};n.add_controls();r.on('click','a',n.load_item);u.on('click','a',n.control_click);o.on('debouncedresize',n.resize_reset)})}}(jQuery));(function(a){'use strict';a.fn.avia_sc_progressbar=function(t){return this.each(function(){var t=a(this),i=t.find('.avia-progress-bar');t.on('avia_start_animation',function(){i.each(function(t){var i=a(this);setTimeout(function(){i.find('.progress').addClass('avia_start_animation');i.find('.progressbar-percent').avia_sc_animated_number({instant_start:!0,simple_up:!0,start_timer:10})},(t*250))})})})}}(jQuery));(function(e){'use strict';e.AviaVideoAPI=function(i,t,o){this.videoElement=t;this.$video=e(t);this.$option_container=o?e(o):this.$video;this.load_btn=this.$option_container.find('.av-click-to-play-overlay');this.video_wrapper=this.$video.parents('ul').eq(0);this.lazy_load=this.video_wrapper.hasClass('av-show-video-on-click')?!0:!1;this.isMobile=e.avia_utilities.isMobile;this.fallback=this.isMobile?this.$option_container.is('.av-mobile-fallback-image'):!1;if(this.fallback){return};this._init(i)};e.AviaVideoAPI.defaults={loop:!1,mute:!1,controls:!1,events:'play pause mute unmute loop toggle reset unload'};e.AviaVideoAPI.apiFiles={youtube:{loaded:!1,src:'https://www.youtube.com/iframe_api'}};e.AviaVideoAPI.players={};e.AviaVideoAPI.prototype={_init:function(i){this.options=this._setOptions(i);this.type=this._getPlayerType();this.player=!1;this._bind_player();this.eventsBound=!1;this.playing=!1;this.$option_container.addClass('av-video-paused');this.pp=e.avia_utilities.playpause(this.$option_container)},_setOptions:function(i){var n=e.extend(!0,{},e.AviaVideoAPI.defaults,i),o=this.$option_container.data(),t='';for(t in o){if(o.hasOwnProperty(t)&&(typeof o[t]==='string'||typeof o[t]==='number'||typeof o[t]==='boolean')){n[t]=o[t]}};return n},_getPlayerType:function(){var e=this.$video.get(0).src||this.$video.data('src');if(this.$video.is('video')){return'html5'};if(this.$video.is('.av_youtube_frame')){return'youtube'};if(e.indexOf('vimeo.com')!=-1){return'vimeo'};if(e.indexOf('youtube.com')!=-1){return'youtube'}},_bind_player:function(){var t=this,o=e('html').hasClass('av-cookies-needs-opt-in')||e('html').hasClass('av-cookies-can-opt-out'),i=!0,n=e('html').hasClass('av-cookies-user-silent-accept'),a='html5'==this.type;if(o&&!n&&!a){if(!document.cookie.match(/aviaCookieConsent/)||e('html').hasClass('av-cookies-session-refused')){i=!1}
else{if(!document.cookie.match(/aviaPrivacyRefuseCookiesHideBar/)){i=!1}
else if(!document.cookie.match(/aviaPrivacyEssentialCookiesEnabled/)){i=!1}
else if(document.cookie.match(/aviaPrivacyVideoEmbedsDisabled/)){i=!1}}};if(window['wp']&&wp.hooks){i=wp.hooks.applyFilters('aviaCookieConsent_allow_continue',i)};let allow_class=i?'avia-video-cookie-allowed':'avia-video-cookie-not-allowed';e('html').addClass(allow_class);if(!i){this._use_external_link();return};if(this.lazy_load&&this.load_btn.length&&this.type!='html5'){this.$option_container.addClass('av-video-lazyload');this.load_btn.on('click',function(){t.load_btn.remove();t._setPlayer()})}
else{this.lazy_load=!1;this._setPlayer()}},_use_external_link:function(){this.$option_container.addClass('av-video-lazyload');this.load_btn.on('click',function(i){if(i.originalEvent===undefined)return;var t=e(this).parents('.avia-slide-wrap').find('div[data-original_url]').data('original_url');if(t)window.open(t,'_blank')})},_setPlayer:function(){var t=this;switch(this.type){case'html5':this.player=this.$video.data('mediaelementplayer');if(!this.player){this.$video.data('mediaelementplayer',e.AviaVideoAPI.players[this.$video.attr('id').replace(/_html5/,'')]);this.player=this.$video.data('mediaelementplayer')};this._playerReady();break;case'vimeo':var i=document.createElement('iframe');var o=e(i);i.onload=function(){t.player=Froogaloop(i);t._playerReady();t.$option_container.trigger('av-video-loaded')};i.setAttribute('src',this.$video.data('src'));o.insertAfter(this.$video);this.$video.remove();this.$video=i;break;case'youtube':this._getAPI(this.type);e('body').on('av-youtube-iframe-api-loaded',function(){t._playerReady()});break}},_getAPI:function(i){if(e.AviaVideoAPI.apiFiles[i].loaded===!1){e.AviaVideoAPI.apiFiles[i].loaded=!0;var t=document.createElement('script'),o=document.getElementsByTagName('script')[0];t.src=e.AviaVideoAPI.apiFiles[i].src;o.parentNode.insertBefore(t,o)}},_playerReady:function(){var i=this;this.$option_container.on('av-video-loaded',function(){i._bindEvents()});switch(this.type){case'html5':this.$video.on('av-mediajs-loaded',function(){i.$option_container.trigger('av-video-loaded')});this.$video.on('av-mediajs-ended',function(){i.$option_container.trigger('av-video-ended')});break;case'vimeo':i.player.addEvent('ready',function(){i.$option_container.trigger('av-video-loaded');i.player.addEvent('finish',function(){i.$option_container.trigger('av-video-ended')})});break;case'youtube':var t=i.$video.data();if(i._supports_video()){t.html5=1};i.player=new YT.Player(i.$video.attr('id'),{videoId:t.videoid,height:i.$video.attr('height'),width:i.$video.attr('width'),playerVars:t,events:{'onReady':function(){i.$option_container.trigger('av-video-loaded')},'onError':function(i){e.avia_utilities.log('YOUTUBE ERROR:','error',i)},'onStateChange':function(e){if(e.data===YT.PlayerState.ENDED){var t=i.options.loop!=!1?'loop':'av-video-ended';i.$option_container.trigger(t)}}}});break};setTimeout(function(){if(i.eventsBound==!0||typeof i.eventsBound=='undefined'||i.type=='youtube'){return};e.avia_utilities.log('Fallback Video Trigger "'+i.type+'":','log',i);i.$option_container.trigger('av-video-loaded')},2000)},_bindEvents:function(){if(this.eventsBound==!0||typeof this.eventsBound=='undefined'){return};var e=this,i='unmute';this.eventsBound=!0;this.$option_container.on(this.options.events,function(i){e.api(i.type)});if(!e.isMobile){if(this.options.mute!=!1){i='mute'};if(this.options.loop!=!1){e.api('loop')};e.api(i)};setTimeout(function(){e.$option_container.trigger('av-video-events-bound').addClass('av-video-events-bound')},50)},_supports_video:function(){return!!document.createElement('video').canPlayType},api:function(e){if(this.isMobile&&!this.was_started())return;if(this.options.events.indexOf(e)===-1)return;this.$option_container.trigger('av-video-'+e+'-executed');if(typeof this['_'+this.type+'_'+e]=='function'){this['_'+this.type+'_'+e].call(this)};if(typeof this['_'+e]=='function'){this['_'+e].call(this)}},was_started:function(){if(!this.player)return!1;switch(this.type){case'html5':if(this.player.getCurrentTime()>0){return!0};break;case'vimeo':if(this.player.api('getCurrentTime')>0){return!0};break;case'youtube':if(this.player.getPlayerState()!==-1){return!0};break};return!1},_play:function(){this.playing=!0;this.$option_container.addClass('av-video-playing').removeClass('av-video-paused')},_pause:function(){this.playing=!1;this.$option_container.removeClass('av-video-playing').addClass('av-video-paused')},_loop:function(){this.options.loop=!0},_toggle:function(){var e=this.playing==!0?'pause':'play';this.api(e);this.pp.set(e)},_vimeo_play:function(){this.player.api('play')},_vimeo_pause:function(){this.player.api('pause')},_vimeo_mute:function(){this.player.api('setVolume',0)},_vimeo_unmute:function(){this.player.api('setVolume',0.7)},_vimeo_loop:function(){},_vimeo_reset:function(){this.player.api('seekTo',0)},_vimeo_unload:function(){this.player.api('unload')},_youtube_play:function(){this.player.playVideo()},_youtube_pause:function(){this.player.pauseVideo()},_youtube_mute:function(){this.player.mute()},_youtube_unmute:function(){this.player.unMute()},_youtube_loop:function(){if(this.playing==!0)this.player.seekTo(0)},_youtube_reset:function(){this.player.stopVideo()},_youtube_unload:function(){this.player.clearVideo()},_html5_play:function(){if(this.player){this.player.options.pauseOtherPlayers=!1;this.player.play()}},_html5_pause:function(){if(this.player)this.player.pause()},_html5_mute:function(){if(this.player)this.player.setMuted(!0)},_html5_unmute:function(){if(this.player)this.player.setVolume(0.7)},_html5_loop:function(){if(this.player)this.player.options.loop=!0},_html5_reset:function(){if(this.player)this.player.setCurrentTime(0)},_html5_unload:function(){this._html5_pause();this._html5_reset()}};e.fn.aviaVideoApi=function(i,t){return this.each(function(){var o=this;if(t){o=e(this).parents(t).get(0)};var n=e.data(o,'aviaVideoApi');if(!n){n=e.data(o,'aviaVideoApi',new e.AviaVideoAPI(i,this,o))}})}})(jQuery);window.onYouTubeIframeAPIReady=function(){jQuery('body').trigger('av-youtube-iframe-api-loaded')};var Froogaloop=(function(){function i(e){return new i.fn.init(e)};var e={},d=!1,t=!1,p=Array.prototype.slice,o='*';i.fn=i.prototype={element:null,init:function(e){if(typeof e==='string'){e=document.getElementById(e)};this.element=e;return this},api:function(e,i){if(!this.element||!e){return!1};var o=this,t=o.element,l=t.id!==''?t.id:null,u=!r(i)?i:null,a=r(i)?i:null;if(a){s(e,a,l)};n(e,u,t);return o},addEvent:function(e,i){if(!this.element){return!1};var a=this,o=a.element,r=o.id!==''?o.id:null;s(e,i,r);if(e!='ready'){n('addEventListener',e,o)}
else if(e=='ready'&&t){i.call(null,r)};return a},removeEvent:function(e){if(!this.element){return!1};var t=this,i=t.element,o=i.id!==''?i.id:null,a=u(e,o);if(e!='ready'&&a){n('removeEventListener',e,i)}}};function n(e,i,t){if(!t.contentWindow.postMessage){return!1};var n=JSON.stringify({method:e,value:i});t.contentWindow.postMessage(n,o)};function a(e){var i,r;try{i=JSON.parse(e.data);r=i.event||i.method}catch(p){};if(r=='ready'&&!t){t=!0};if(!(/^https?:\/\/player.vimeo.com/).test(e.origin)){return!1};if(o==='*'){o=e.origin};var u=i.value,d=i.data,a=a===''?null:i.player_id,s=l(r,a),n=[];if(!s){return!1};if(u!==undefined){n.push(u)};if(d){n.push(d)};if(a){n.push(a)};return n.length>0?s.apply(null,n):s.call()};function s(i,t,o){if(o){if(!e[o]){e[o]={}};e[o][i]=t}
else{e[i]=t}};function l(i,t){if(t&&e[t]&&e[t][i]){return e[t][i]}
else{return e[i]}};function u(i,t){if(t&&e[t]){if(!e[t][i]){return!1};e[t][i]=null}
else{if(!e[i]){return!1};e[i]=null};return!0};function r(e){return!!(e&&e.constructor&&e.call&&e.apply)};function h(e){return toString.call(e)==='[object Array]'};i.fn.init.prototype=i.fn;if(window.addEventListener){window.addEventListener('message',a,!1)}
else{window.attachEvent('onmessage',a)};return(window.Froogaloop=window.$f=i)})();(function(i){'use strict';i.AviaccordionSlider=function(t,e){this.$slider=i(e);this.$inner=this.$slider.find('.aviaccordion-inner');this.$slides=this.$inner.find('.aviaccordion-slide');this.$images=this.$inner.find('.aviaccordion-image');this.$last=this.$slides.last();this.$titles=this.$slider.find('.aviaccordion-preview');this.$titlePos=this.$slider.find('.aviaccordion-preview-title-pos');this.$titleWrap=this.$slider.find('.aviaccordion-preview-title-wrap');this.$win=i(window);if(i.avia_utilities.supported.transition===undefined){i.avia_utilities.supported.transition=i.avia_utilities.supports('transition')};this.options={};this.browserPrefix=i.avia_utilities.supported.transition;this.cssActive=this.browserPrefix!==!1?!0:!1;this.transform3d=document.documentElement.className.indexOf('avia_transform3d')!==-1?!0:!1;this.isMobile=i.avia_utilities.isMobile;this.isTouchDevice=i.avia_utilities.isTouchDevice;this.property=this.browserPrefix+'transform';this.count=this.$slides.length;this.open=!1;this.autoplay=!1;this.increaseTitle=this.$slider.is('.aviaccordion-title-on-hover');this._init(t)};i.AviaccordionSlider.defaults={interval:5,autoplay:!0,loop_autoplay:'endless'};i.AviaccordionSlider.prototype={_init:function(t){var e=this;this.options=this._setOptions(t);i.avia_utilities.preload({container:this.$slider,single_callback:function(){e._kickOff()}})},_setOptions:function(t){var s=this.$slider.data('slideshow-options');if('object'==typeof s){var e=i.extend({},i.AviaccordionSlider.defaults,t,s);return e};var e=i.extend({},i.AviaccordionSlider.defaults,t,this.$slider.data());return e},_kickOff:function(){var i=this;i._calcMovement();i._bindEvents();i._showImages();i._autoplay()},_autoplay:function(){var i=this;if(i.options.autoplay){i.autoplay=setInterval(function(){i.open=i.open===!1?0:i.open+1;if(i.open>=i.count){if(i.options.loop_autoplay=='once'){clearInterval(i.autoplay);i.options.autoplay=!1;i.autoplay=!1;return};i.open=0};i._move({},i.open)},i.options.interval*1000)}},_showImages:function(){var t=this,a=0,e=300,s=this.count*e;if(this.cssActive){setTimeout(function(){t.$slider.addClass('av-animation-active')},10)};this.$images.each(function(t){var s=i(this),a=e*(t+1);setTimeout(function(){s.avia_animate({opacity:1},400,function(){s.css(i.avia_utilities.supported.transition+'transform','none')})},a)});if(t.increaseTitle){s=0};this.$titlePos.each(function(t){var e=i(this),a=s+100*(t+1);setTimeout(function(){e.avia_animate({opacity:1},200,function(){e.css(i.avia_utilities.supported.transition+'transform','none')})},a)})},_bindEvents:function(){var i=this.isMobile?'click':'mouseenter';this.$slider.on(i,'.aviaccordion-slide',this._move.bind(this));this.$slider.on('mouseleave','.aviaccordion-inner',this._move.bind(this));this.$win.on('debouncedresize',this._calcMovement.bind(this));this.$slider.on('av-prev av-next',this._moveTo.bind(this));if(this.isMobile||this.isTouchDevice){this.$slider.avia_swipe_trigger({next:this.$slider,prev:this.$slider,event:{prev:'av-prev',next:'av-next'}})}},_titleHeight:function(){var t=0;this.$titleWrap.css({'height':'auto'}).each(function(){var e=i(this).outerHeight();if(e>t){t=e}}).css({'height':t+2})},_calcMovement:function(t,s){var e=this,r=this.$slider.width(),p=this.$last.data('av-left'),c=this.$images.last().width()||r,a=Math.floor((100/r)*c),l=a*e.count,h=3,d=100-a,n=d>p/h?d:0,o=n/(e.count-1),v=c;if(l<110&&s!==!1){var u=this.$slider.height(),f=(u/l)*110;this.$slider.css({'max-height':f});e._calcMovement(t,!1);return};if(o<2){n=0};this.$slides.each(function(t){var l=i(this),s=0,r=0,c=l.data('av-left');if(n!==0){s=o*t;r=a+s-o}
else{s=c/Math.abs(h);r=100-((s/t)*(e.count-t))};if(t==1&&e.increaseTitle){v=r+1};if(e.cssActive){s=s-c;r=r-c;c=0};l.data('av-calc-default',c);l.data('av-calc-left',s);l.data('av-calc-right',r)});if(e.increaseTitle){e.$titles.css({width:v+'%'})}},_moveTo:function(i){var e=i.type=='av-next'?1:-1,t=this.open===!1?0:this.open+e;if(t>=0&&t<this.$slides.length){this._move(i,t)}},_move:function(t,s){var e=this,n=t.currentTarget,a=typeof s!='undefined'?s:this.$slides.index(n);this.open=a;if(e.autoplay&&typeof n!='undefined'){clearInterval(e.autoplay);e.autoplay=!1};this.$slides.removeClass('aviaccordion-active-slide').each(function(s){var n=i(this),c=n.data(),o=s<=a?c.avCalcLeft:c.avCalcRight,r={},l=t.type=='mouseleave'?1:0,h=a===s?e.$titleWrap.eq(s):!1;if(h){n.addClass('aviaccordion-active-slide')};if(l){o=c.avCalcDefault;this.open=!1};if(e.cssActive){r[e.property]=e.transform3d?'translate3d('+o+'%, 0, 0)':'translate('+o+'%,0)';n.css(r)}
else{r.left=o+'%';n.stop().animate(r,700,'easeOutQuint')}})}};i.fn.aviaccordion=function(t){return this.each(function(){var e=i.data(this,'AviaccordionSlider');if(!e){i.data(this,'AviaccordionSlider',1);new i.AviaccordionSlider(t,this)}})}})(jQuery);(function(i){'use strict';i.AviaFullscreenSlider=function(t,e){this.$slider=i(e);this.$inner=this.$slider.find('.avia-slideshow-inner');this.$innerLi=this.$inner.find('>li');this.$caption=this.$inner.find('.avia-slide-wrap .caption_container');this.$win=i(window);this.isMobile=i.avia_utilities.isMobile;this.isTouchDevice=i.avia_utilities.isTouchDevice;this.mobile_no_animation=i('body').hasClass('avia-mobile-no-animations');this.options={};this.property={};this.scrollPos='0';this.transform3d=document.documentElement.className.indexOf('avia_transform3d')!==-1?!0:!1;this.ticking=!1;if(i.avia_utilities.supported.transition===undefined){i.avia_utilities.supported.transition=i.avia_utilities.supports('transition')};this._init(t)};i.AviaFullscreenSlider.defaults={height:100,subtract:'#wpadminbar, #header, #main>.title_container',image_attachment:'scroll',parallax_enabled:!0};i.AviaFullscreenSlider.prototype={_init:function(t){var e=this,s=this.$slider.data('slideshow-options');this.options=i.extend(!0,{},i.AviaFullscreenSlider.defaults,t);if('object'==typeof s){this.options.height='undefined'!=typeof s.slide_height?s.slide_height:this.options.height;this.options.image_attachment='undefined'!=typeof s.image_attachment?s.image_attachment:this.options.image_attachment}
else{if(this.$slider.data('slide_height')){this.options.height=this.$slider.data('slide_height')};if(this.$slider.data('image_attachment')){this.options.image_attachment=this.$slider.data('image_attachment')}};this.options.parallax_enabled=this.options.image_attachment==''?!0:!1;this.$subtract=i(this.options.subtract);this._setSize();this.$win.on('debouncedresize',this._setSize.bind(this));setTimeout(function(){if(e.options.parallax_enabled){if(!e.isMobile||(e.isMobile&&!this.mobile_no_animation)){e.$win.on('scroll',e._on_scroll.bind(e))}}},100);this.$slider.aviaSlider({bg_slider:!0})},_on_scroll:function(i){var t=this;if(!t.ticking){t.ticking=!0;window.requestAnimationFrame(t._parallaxRequest.bind(t))}},_fetch_properties:function(i){this.property.offset=this.$slider.offset().top;this.property.wh=this.$win.height();this.property.height=i||this.$slider.outerHeight();this._parallax_scroll()},_setSize:function(){if(!i.fn.avia_browser_height){var e=this.$win.height(),t=Math.ceil((e/100)*this.options.height);if(this.$subtract.length&&this.options.height==100){this.$subtract.each(function(){t-=this.offsetHeight-0.5})}
else{t-=1};this.$slider.height(t).removeClass('av-default-height-applied');this.$inner.css('padding',0)};this._fetch_properties(t)},_parallaxRequest:function(i){var t=this;setTimeout(t._parallax_scroll.bind(t),0)},_parallax_scroll:function(t){if(!this.options.parallax_enabled){return};if(this.isMobile&&this.mobile_no_animation){return};var s=this.$win.scrollTop(),n=s+this.property.wh,e='0',a={};if(this.property.offset<s&&s<=this.property.offset+this.property.height){e=Math.round((s-this.property.offset)*0.3)};if(this.scrollPos!=e){this.scrollPos=e;if(this.transform3d){a[i.avia_utilities.supported.transition+'transform']='translate3d(0px,'+e+'px,0px)'}
else{a[i.avia_utilities.supported.transition+'transform']='translate(0px,'+e+'px)'};this.$inner.css(a)};this.ticking=!1}};i.fn.aviaFullscreenSlider=function(t){return this.each(function(){var e=i.data(this,'aviaFullscreenSlider');if(!e){i.data(this,'aviaFullscreenSlider',1);new i.AviaFullscreenSlider(t,this)}})}})(jQuery);(function(t){'use strict';t.fn.layer_slider_height_helper=function(e){return this.each(function(){var e=t(this),i=e.find('>div').first(),n=!1,h=0,r=function(){if(i.height()>0||h>5){e.height('auto')}
else{n=setTimeout(r,500);h++}};if(!i.length){return};n=setTimeout(r,0)})}}(jQuery));(function(a){'use strict';a.fn.avia_sc_tab_section=function(){var t=a(window),v=a.avia_utilities.supports('transition'),n=this.browserPrefix!==!1?!0:!1,i=a.avia_utilities.isMobile,s=a.avia_utilities.isTouchDevice,l=a('body').hasClass('avia-mobile-no-animations'),o=document.documentElement.className.indexOf('avia_transform3d')!==-1?!0:!1,e={},r=['avia_animate_when_visible','avia_animate_when_almost_visible','av-animated-generic','av-animated-when-visible','av-animated-when-almost-visible','av-animated-when-visible-95'];return this.each(function(){var v=a(this),d=v.find('.av-section-tab-title'),b=v.find('.av-tab-section-outer-container'),C=v.find('.av-tab-section-tab-title-container'),oa=v.find('.av_tab_navigation'),x=v.find('.av-tabsection-arrow'),la=x.find('.av-tab-section-slide'),da=v.find('.av-slide-section-container-wrap'),p=v.find('.av-tabsection-slides-arrow'),ra=p.find('.av-tab-section-slide-content'),E=v.find('.av-tabsection-slides-dots'),va=E.find('.goto-slide'),h=v.find('.av-tab-section-inner-container'),ca=v.find('.av-animation-delay-container'),y=v.find('.av-layout-tab'),k=v.find('.av-layout-tab-inner'),I=v.is('.av-tab-content-auto'),N=v.hasClass('av-minimum-height'),f=null,g='1',O=1,u=0,m='none',c={animation:'av-tab-slide-transition',autoplay:!1,loop_autoplay:'once',interval:5,loop_manual:'manual-endless',autoplay_stopper:!1,noNavigation:!1},Q=b.data('slideshow-data'),D={},w=null;if('undefined'!=typeof Q){c=a.extend({},c,Q)};y.each(function(){var e=a(this),t=e.data('av-deeplink-tabs'),i=e.data('av-tab-section-content');if(t){D[t.toLowerCase()]=i}});g=v.find('.av-active-tab-title').data('av-tab-section-title');g='undefined'!=typeof g?g:'1';O=parseInt(g,10);f=v.find('[data-av-tab-section-content="'+g+'"]');f.addClass('__av_init_open av-active-tab-content');if('av-tab-slide-transition'==c.animation){m='slide_sidewards'}
else if('av-tab-slide-up-transition'==c.animation){m='slide_up'}
else if('av-tab-fade-transition'==c.animation){m='fade'};if('slide_up'==m){a.each(r,function(a,e){k.find('.'+e).addClass('avia_start_animation_when_active')})};var j=function(t,p){t.preventDefault();if(v.hasClass('av-is-slideshow')&&t.originalEvent!==undefined){return};var b=a(t.currentTarget),w=b.data('av-tab-section-title'),r=parseInt(w,10),k=f;d.removeClass('av-active-tab-title');k.removeClass('av-active-tab-content');b.removeClass('no-scroll');f=v.find('[data-av-tab-section-content="'+w+'"]');g=w;O=r;b.addClass('av-active-tab-title');f.addClass('av-active-tab-content');var s=((r-1)*-100);if(a('body').hasClass('rtl')){s=((r-1)*100)};T();if(['none','slide_sidewards'].indexOf(m)>=0){if(n){s=s/d.length;e['transform']=o?'translate3d('+s+'%, 0, 0)':'translate('+s+'%,0)';e['left']='0%';h.css(e)}
else{h.css('left',s+'%')}}
else if('slide_up'==m){y.css('opacity',1);if(n){var u=f.data('slide-top');if('undefined'==typeof u){u=0};e['transform']=o?'translate3d(0, -'+u+'px, 0)':'translate(0, -'+u+'px ,0)';e['left']='0';h.css(e)}
else{h.css('top','-'+s+'px')};y.filter(':not(.av-active-tab-content)').css('opacity',0)};L();ea(r);ta(r);if(!(p||c.autoplay)){var x=b.attr('href'),C=f.data('av-deeplink-tabs');if('undefined'!=typeof(C)&&''!=C){x=C};location.hash=x};setTimeout(function(){f.trigger('avia_start_animation_if_current_slide_is_active');if(!i||(i&&!l)){ca.not(f).trigger('avia_remove_animation')}},600)},aa=function(){u=0;d.each(function(){u+=a(this).outerWidth()});C.css('min-width',u)},T=function(){var d=v.hasClass('av-hide-tabs')?0:C.height(),s=d?C.outerHeight():0,i=0,u=0,l=0,e=0,o=0;if(N){var n=v.hasClass('av-minimum-height-custom')?v.data('av_minimum_height_px'):v.css('min-height');n=parseInt(n,10);if(!isNaN(n)){i=n};if(!i){N=!1}};if(!I){k.css('height','');h.css('min-height','');var c=y.first();u=c.outerHeight()-c.height();y.each(function(){var e=a(this),t=e.find('.av-layout-tab-inner');l=Math.max(l,t.height())});e=l+u;o=e+s;if(N){if(o<i){e=i-s;o=i}};h.css('min-height',e);h.css('height',e)}
else if(I&&N){e=i-s;o=i;h.css('min-height',e);h.css('height',e)};if(['none','slide_sidewards','fade'].indexOf(m)>=0){if(!f.length){return};if(I){k.height('auto');var p=f.find('.av-layout-tab-inner').height(),g=f.outerHeight(),w=g+d+100;b.css('max-height',w);k.height(p);k.css('overflow','hidden')};setTimeout(function(){t.trigger('av-height-change')},600);return};var r=0;y.each(function(){var e=a(this),i=e.find('.av-layout-tab-inner'),n=e.data('av-tab-section-content'),o=parseInt(n,10),t=e.outerHeight();e.data('slide-top',r);r+=t;if(I&&o==O){b.css('max-height',t+s);i.css('overflow','hidden')}})},L=function(){var o=v.find('.av-active-tab-title'),t=v.width(),e=(o.position().left*-1)-(o.outerWidth()/2)+(t/2);if(!a('body').hasClass('rtl')){if(t>=u){e=0};if(e+u<t){e=(u-t)*-1};if(e>0){e=0};C.css('left',e);var n=e!==0,s=e+u>t;M(n,s)}
else{var i=0;if(t<u){if(e+u>t){if(e>0){e=0};i=(e+u-t)*-1}};C.css('left','auto');C.css('right',i);var n=i+u>t,s=i!==0;M(n,s)}},M=function(a,e){if(a){x.addClass('av-visible-prev')}
else{x.removeClass('av-visible-prev')};if(e){x.addClass('av-visible-next')}
else{x.removeClass('av-visible-next')}},ea=function(a){if(a>1){p.addClass('av-visible-prev')}
else{p.removeClass('av-visible-prev')};if(a<d.length){p.addClass('av-visible-next')}
else{p.removeClass('av-visible-next')}},ta=function(a){E.find('a').removeClass('active');E.find('a').eq(a-1).addClass('active')},ia=function(a){if(c.noNavigation){return};W(a)},W=function(e){e.preventDefault();var i=a(e.currentTarget),t=v.find('.av-active-tab-title');if(v.hasClass('av-slideshow-section')){if(i.hasClass('av_prev_tab_section')){p.find('.av_prev_tab_section').trigger('click')}
else{p.find('.av_next_tab_section').trigger('click')};return};if(i.is('.av_prev_tab_section')){if(!a('body').hasClass('rtl')){t.prev('.av-section-tab-title').trigger('click')}
else{t.next('.av-section-tab-title').trigger('click')}}
else{if(!a('body').hasClass('rtl')){t.next('.av-section-tab-title').trigger('click')}
else{t.prev('.av-section-tab-title').trigger('click')}}},na=function(e){e.preventDefault();if(c.noNavigation&&e.originalEvent!==undefined){return};var n=a(e.currentTarget),s=v.find('.av-active-tab-title'),o=s.data('av-tab-section-title'),l=parseInt(o,10),i=0;if(n.hasClass('av_prev_tab_section')){i=!a('body').hasClass('rtl')?-1:1}
else{i=!a('body').hasClass('rtl')?1:-1};var t=l+i;if(t<=0||t>d.length){if('endless'!=c.loop_autoplay&&'manual-endless'!=c.loop_manual){return};t=t<=0?d.length:1};H();d.eq(t-1).trigger('click');q()},sa=function(e){e.preventDefault();var i=a(e.currentTarget);if(i.hasClass('active')){return};var n=i.attr('href').replace('#',''),t=parseInt(n,10);if(t>d.length){return};H();d.eq(t-1).trigger('click');q()},z=function(){var t=window.location.hash?window.location.hash:'',e=t.toLowerCase().replace('#',''),a=null;if('undefined'!=typeof(D[e])&&''!=D[e]){var i=D[e];a=d.filter('[data-av-tab-section-title="'+i+'"]')}
else{a=d.filter('[href="'+t+'"]')};if(a.length){if(!a.is('.active_tab')){a.trigger('click')}}
else{v.find('.av-active-tab-title').trigger('click',!0)}},H=function(){if(typeof w==='number'){clearTimeout(w)};w=null},q=function(){if(!v.hasClass('av-slideshow-section')){return};if(!0!==c.autoplay){b.removeClass('av-slideshow-autoplay').addClass('av-slideshow-manual')};if('undefined'==typeof c.loop_autoplay||'endless'!=c.loop_autoplay){c.loop_autoplay='once'};if('undefined'==typeof c.interval){c.interval=5};if('undefined'==typeof c.autoplay||!0!==c.autoplay){c.autoplay=!1;b.removeClass('av-slideshow-autoplay').addClass('av-slideshow-manual');return};H();w=setTimeout(function(){P()},c.interval*1000)},P=function(){var n=v.find('.av-active-tab-title'),s=n.data('av-tab-section-title'),e=parseInt(s,10),i=!1,t=0;w=null;if('endless'==c.loop_autoplay){if(!a('body').hasClass('rtl')){t=e<d.length?e+1:1}
else{t=e>1?e-1:d.length}}
else{if(!a('body').hasClass('rtl')){i=e==d.length;t=e+1}
else{i=e==1;t=e-1};if(i){c.autoplay=!1;c.loop_autoplay='manual';b.removeClass('av-slideshow-autoplay').addClass('av-slideshow-manual');b.removeClass('av-loop-endless').addClass('av-loop-once');return}};d.eq(t-1).trigger('click');w=setTimeout(function(){P()},c.interval*1000)};a.avia_utilities.preload({container:f,single_callback:function(){d.on('click',j);la.on('click',W);ra.on('click',na);va.on('click',sa);if(i||s){oa.on('click',ia)};t.on('debouncedresize',L);t.on('hashchange',z);t.on('debouncedresize av-content-el-height-changed',T);aa();T();z();q()}});if(i||s){if(!c.noNavigation){h.avia_swipe_trigger({prev:'.av_prev_tab_section',next:'.av_next_tab_section'})}};T()})}}(jQuery));(function(t){'use strict';t.fn.avia_sc_tabs=function(e){var a={heading:'.tab',content:'.tab_content',active:'active_tab',sidebar:!1};var i=t(window),e=t.extend(a,e);return this.each(function(){var a=t(this),c=t('<div class="tab_titles" role="tablist"></div>').prependTo(a),n=t(e.heading,a),r=t(e.content,a),o=!1,d=!1;o=n.clone();d=n.addClass('fullsize-tab').attr({'aria-hidden':!0,'aria-selected':!1,id:'',role:'','aria-controls':'',tabindex:0});n=o;n.prependTo(c).each(function(e){var a=t(this),i=!1;if(o){i=d.eq(e)};a.addClass('tab_counter_'+e).attr({tab_counter:e}).on('click',function(){l(a,e,i);return!1});a.on('keydown',function(t){if(t.keyCode===13){a.trigger('click')}});if(o){i.on('click',function(){l(i,e,a);return!1});i.on('keydown',function(t){if(t.keyCode===13){i.trigger('click')}})}});s();f(!1);i.on('debouncedresize',s);t('a').on('click',function(){var e=t(this).attr('href');if(typeof e!='undefined'&&e){e=e.replace(/^.*?#/,'');f('#'+e)}});function s(){if(!e.sidebar){return};r.css({'min-height':c.outerHeight()+1})};function l(n,l,o){if(!n.is('.'+e.active)){t('.'+e.active,a).removeClass(e.active).attr({'aria-selected':!1,tabindex:0});t('.'+e.active+'_content',a).removeClass(e.active+'_content').attr('aria-hidden',!0);n.addClass(e.active).attr({'aria-selected':!0,tabindex:0});var s=n.data('fake-id');if(typeof s=='string'){window.location.replace(s)};if(o){o.addClass(e.active)};var d=r.eq(l).addClass(e.active+'_content').attr('aria-hidden',!1);if(typeof click_container!='undefined'&&click_container.length){sidebar_shadow.height(d.outerHeight())};var c=d.offset().top,f=c-50-parseInt(t('html').css('margin-top'),10);if(i.scrollTop()>c){t('html:not(:animated),body:not(:animated)').scrollTop(f)}};i.trigger('av-content-el-height-changed',n)};function f(t){if(!t&&window.location.hash){t=window.location.hash};if(!t){return};var e=n.filter('[data-fake-id="'+t+'"]');if(e.length){if(!e.is('.active_tab')){e.trigger('click')};window.scrollTo(0,a.offset().top-70)}}})}}(jQuery));(function(i){'use strict';i.fn.avia_sc_testimonial=function(t){return this.each(function(){var t=i(this),a=t.find('.avia-testimonial');t.on('avia_start_animation',function(){a.each(function(t){var a=i(this);setTimeout(function(){a.addClass('avia_start_animation')},(t*150))})})})}}(jQuery));(function(i){'use strict';i(window).on('load',function(e){if(i.AviaSlider){i('.avia-timeline-container').avia_sc_timeline()}});i.fn.avia_sc_timeline=function(e){return this.each(function(){var n=this,e='#'+i(this).attr('id'),a=i(e),t;t={matchHeights:function(){this.setMinHeight(i(e+' .av-milestone-placement-top .av-milestone-date'),!0);this.setMinHeight(i(e+' .av-milestone-placement-bottom .av-milestone-content-wrap'),!0);this.setMinHeight(i(e+' .av-milestone-placement-bottom.avia-timeline-boxshadow .av-milestone-contentbox'),!1);this.setMinHeight(i(e+' .av-milestone-placement-top.avia-timeline-boxshadow .av-milestone-contentbox'),!1);this.setMinHeight(i(e+' .avia-timeline-horizontal.av-milestone-placement-alternate li >:first-child'),!0)},setMinHeight:function(e,t){if(e.length<2){return};var n=[];e.css('min-height','0').each(function(e){var t=i(this),a=t.outerHeight(!0);n.push(a)});var l=Math.max.apply(null,n);e.css('min-height',l);if(t){var a=e.first(),s=a.closest('.avia-timeline-container'),o=a.height();s.find('.av-timeline-nav').css('top',o)}},createCarousel:function(t){var o=this,l=i(e+'.avia-slideshow-carousel'),n=3,s=1;if(a.attr('avia-data-slides')){n=parseInt(a.attr('avia-data-slides'))};if(n>=2){s=2};var c={carousel:'yes',keep_padding:!0,carouselSlidesToShow:n,carouselSlidesToScroll:3,carouselResponsive:[{breakpoint:989,settings:{carouselSlidesToShow:s,carouselSlidesToScroll:s}},{breakpoint:767,settings:{carouselSlidesToShow:1,carouselSlidesToScroll:1}}]};l.aviaSlider(c);l.on('_kickOff',function(){o.matchHeights()});i(window).on('resize',function(){o.matchHeights()})},layoutHelpers:function(t){i(e+' .avia-timeline-vertical li').each(function(e,n){var s=i(this).parents('ul').find('li').length,t=i(this).find('.av-milestone-icon-wrap'),a=t.outerHeight(!0),o=parseInt(a/2);if(e===(s-1)){t.css({'height':o})}
else{t.css({'height':a})}})},fireAnimations:function(t){if(i(e+' > ul').hasClass('avia-timeline-vertical')){var n=a.find('.av-milestone');a.on('avia_start_animation',function(){n.each(function(e){var t=i(this);setTimeout(function(){t.addClass('avia_start_animation')},(e*350))})})}}};t.createCarousel();t.layoutHelpers();t.fireAnimations();t.matchHeights()})}})(jQuery);(function(t){'use strict';t.fn.avia_sc_toggle=function(e){var i={single:'.single_toggle',heading:'.toggler',content:'.toggle_wrap',sortContainer:'.taglist'};var a=t(window),e=t.extend(i,e);return this.each(function(){var i=t(this).addClass('enable_toggles'),l=t(e.single,i),n=t(e.heading,i),h=t(e.content,i),s=t(e.sortContainer+' a',i),o=t('#av-admin-preview'),d='',r='';n.each(function(g){var l=t(this),s=l.hasClass('av-title-below')?l.prev(e.content,i):l.next(e.content,i),c=parseInt(l.data('slide-speed'));c=isNaN(c)?200:c;function f(){var e=s.offset().top,i=e-50-parseInt(t('html').css('margin-top'),10);if(a.scrollTop()>e){t('html:not(:animated),body:not(:animated)').animate({scrollTop:i},c)}};if(s.css('visibility')!='hidden'){l.addClass('activeTitle').attr('style',d)};l.on('keydown',function(t){if(t.keyCode===13||t.keyCode===32){l.trigger('click')}});l.on('click',function(){if(s.css('visibility')!='hidden'){s.slideUp(c,function(){s.removeClass('active_tc').attr({style:''});a.trigger('av-height-change');a.trigger('av-content-el-height-changed',this);if(o.length==0){location.replace(l.data('fake-id')+'-closed')}});l.removeClass('activeTitle').attr('style',r)}
else{if(i.is('.toggle_close_all')){h.not(s).slideUp(c,function(){t(this).removeClass('active_tc').attr({style:''});f()});n.removeClass('activeTitle').attr('style',r)};s.addClass('active_tc');setTimeout(function(){s.slideDown(c,function(){if(!i.is('.toggle_close_all')){f()};a.trigger('av-height-change');a.trigger('av-content-el-height-changed',this)})},1);l.addClass('activeTitle').attr('style',d);if(o.length==0){location.replace(l.data('fake-id'))}}})});s.on('click',function(e){e.preventDefault();var a=l.filter('[data-tags~="'+t(this).data('tag')+'"]'),i=l.not('[data-tags~="'+t(this).data('tag')+'"]');s.removeClass('activeFilter');t(this).addClass('activeFilter');n.filter('.activeTitle').trigger('click');a.slideDown();i.slideUp()});function c(){n.each(function(a){let $heading=t(this),title_open=$heading.attr('data-title-open'),title=$heading.attr('data-title'),aria_collapsed=$heading.attr('data-aria_collapsed'),aria_expanded=$heading.attr('data-aria_expanded'),content=$heading.hasClass('av-title-below')?$heading.prev(e.content,i):$heading.next(e.content,i),titleHasHtml=!1,currentTitle=$heading.contents()[0].data;if(!title){title='***'};if(!aria_collapsed){aria_collapsed='Expand Toggle'};if(!aria_expanded){aria_expanded='Collapse Toggle'};titleHasHtml=title.indexOf('<')>=0;if(content.css('visibility')!='hidden'){if(title_open&&!titleHasHtml&&currentTitle!=title_open){$heading.contents()[0].data=title_open};$heading.attr('aria-expanded','true');$heading.attr('aria-label',aria_expanded);content.attr({'aria-hidden':'false',tabindex:0})}
else{if(title_open&&!titleHasHtml&&currentTitle!=title){$heading.contents()[0].data=title};$heading.attr('aria-expanded','false');$heading.attr('aria-label',aria_collapsed);content.attr({'aria-hidden':'true',tabindex:-1})}});setTimeout(function(){c()},150)};function g(t){if(!t&&window.location.hash){t=window.location.hash};if(!t){return};var e=n.filter('[data-fake-id="'+t+'"]');if(e.length){if(!e.is('.activeTitle')){e.trigger('click')};window.scrollTo(0,i.offset().top-70)}};c();g(!1);t('a').on('click',function(){var e=t(this).attr('href');if(typeof e!='undefined'&&e){e=e.replace(/^.*?#/,'');g('#'+e)}})})}}(jQuery));(function(i){'use strict';i('body').on('click','.av-lazyload-video-embed .av-click-to-play-overlay',function(l){var n=i(this),d=i('html').hasClass('av-cookies-needs-opt-in')||i('html').hasClass('av-cookies-can-opt-out'),e=!0,c=i('html').hasClass('av-cookies-user-silent-accept');if(d&&!c){if(!document.cookie.match(/aviaCookieConsent/)||i('html').hasClass('av-cookies-session-refused')){e=!1}
else{if(!document.cookie.match(/aviaPrivacyRefuseCookiesHideBar/)){e=!1}
else if(!document.cookie.match(/aviaPrivacyEssentialCookiesEnabled/)){e=!1}
else if(document.cookie.match(/aviaPrivacyVideoEmbedsDisabled/)){e=!1}}};if(window['wp']&&wp.hooks){e=wp.hooks.applyFilters('aviaCookieConsent_allow_continue',e)};var a=n.parents('.av-lazyload-video-embed');if(a.hasClass('avia-video-lightbox')&&a.hasClass('avia-video-standard-html')){e=!0};if(!e){if(typeof l.originalEvent=='undefined'){return};var t=a.data('original_url');if(t)window.open(t,'_blank','noreferrer noopener');return};var s=a.find('.av-video-tmpl').html(),o='';if(a.hasClass('avia-video-lightbox')){o=a.find('a.lightbox-link');if(o.length==0){a.append(s);setTimeout(function(){o=a.find('a.lightbox-link');if(i('html').hasClass('av-default-lightbox')){o.addClass('lightbox-added').magnificPopup(i.avia_utilities.av_popup);o.trigger('click')}
else{o.trigger('avia-open-video-in-lightbox')}},100)}
else{o.trigger('click')}}
else{a.html(s)}});i('.av-lazyload-immediate .av-click-to-play-overlay').trigger('click')}(jQuery));;jQuery(function(t){cart_improvement_functions();cart_dropdown_improvement();track_ajax_add_to_cart();if(t.fn.avia_sc_slider){t('.shop_slider_yes ul').avia_sc_slider({appendControlls:!1,group:!0,slide:'.product',arrowControll:!0,autorotationInterval:'parent'})};t('body.single-product').on('click','.single-product-main-image .avia-wc-30-product-gallery-lightbox',function(e){e.preventDefault();var i=t(this),n=i.parents('.single-product-main-image'),a=n.find('.flex-active-slide a.lightbox-added').eq(0);if(a.length==0){a=n.find('a.lightbox-added').eq(0)};if(i.hasClass('av-remove-size-attr')){let img_tag=a.find('img').eq(0);if(img_tag.length){img_tag.removeAttr('sizes')}};a.trigger('click')});product_add_to_cart_click();function e(){t('.quantity input[type=number]').each(function(){var a=t(this),c=a.val(),n=a.clone(!0);if(('undefined'==typeof(c))||(''==(c+'').trim())){var i=n.attr('placeholder');i=(('undefined'==typeof(i))||(''==(i+'').trim()))?1:i;n.attr('value',i)};var r=parseFloat(a.attr('max')),o=parseFloat(a.attr('min')),d=parseInt(a.attr('step'),10),e=n.insertAfter(a);e.addClass('no-spin-num');a.remove();setTimeout(function(){var a=null,i=null;if(e.next('.plus').length===0){a=t('<input type="button" value="-" class="minus">').insertBefore(e),i=t('<input type="button" value="+" class="plus">').insertAfter(e)}
else{a=e.prev('.minus');i=e.next('.plus')};a.on('click',function(){var t=parseInt(e.val(),10);if(isNaN(t)){t=0};let new_step=parseInt(e.attr('step'),10);if(isNaN(new_step)){new_step=d};t-=new_step;t=t<0?0:t;t=t<o?o:t;e.val(t).trigger('change')});i.on('click',function(){var t=parseInt(e.val(),10);if(isNaN(t)){t=0};let new_step=parseInt(e.attr('step'),10);if(isNaN(new_step)){new_step=d};t+=new_step;t=t>r?r:t;e.val(t).trigger('change')})},10)})};e();t(document).on('updated_cart_totals',e);setTimeout(first_load_amount,10);t('body').on('added_to_cart',update_cart_dropdown);t('body').on('wc_fragments_refreshed',avia_cart_dropdown_changed);t('.avia_mobile .sort-param').on('touchstart',function(){});function a(){let links=t('.avia-product-sorting .avia-product-sorting-link');links.on('click',function(){let el=t(this),href=el.attr('data-href'),li=el.closest('li');if(li.hasClass('current-param')){return};if('undefined'!=typeof href&&''!=href){window.location.href=href}})};a()});function avia_cart_dropdown_changed(){var a=jQuery('html'),i=jQuery('body').is('.woocommerce-cart'),e=jQuery('.cart_dropdown .av-cart-counter'),n=jQuery('.cart_dropdown'),t=0,r=jQuery('body').hasClass('avia-woocommerce-30');if(!i){return};if(!r){n.find('.cart_list li .quantity').each(function(){t+=parseInt(jQuery(this).text(),10)})}
else{t=parseInt(e.text(),10)};if(t==0){e.removeClass('av-active-counter').text(t);setTimeout(function(){a.removeClass('html_visible_cart')},200)}
else if((e.length>0)&&(t>0)){setTimeout(function(){e.addClass('av-active-counter').text(t);a.addClass('html_visible_cart')},10)};return};function update_cart_dropdown(t){var c=jQuery('html'),r=jQuery('.cart_dropdown'),a=jQuery('.cart_dropdown .av-cart-counter'),s=r.find('.empty'),u=r.data('success'),o=jQuery.extend({name:'Product',price:'',image:''},avia_clicked_product),i=0,d=jQuery('body').hasClass('avia-woocommerce-30');if(a.length==0){return};if((s.length>0)&&('undefined'!=typeof t)){c.addClass('html_visible_cart')};if(typeof t!=='undefined'){var n=jQuery('.html_header_sticky #header_main .cart_dropdown_first, .html_header_sidebar #header_main .cart_dropdown_first'),l=jQuery('.added_to_cart_notification').trigger('avia_hide'),e=jQuery('<div class=\'added_to_cart_notification\'><span class=\'avia-arrow\'></span><div class=\'added-product-text\'><strong>"'+o.name+'"</strong> '+u+'</div> '+o.image+'</div>').css('opacity',0);if(!n.length){n='body'};e.on('mouseenter avia_hide',function(){e.animate({opacity:0,top:parseInt(e.css('top'),10)+15},function(){e.remove()})}).appendTo(n).animate({opacity:1},500);setTimeout(function(){e.trigger('avia_hide')},2500)};if('object'==typeof t&&'added_to_cart'==t.type&&d){return};setTimeout(function(){if(!d){r.find('.cart_list li .quantity').each(function(){i+=parseInt(jQuery(this).text(),10)})}
else{i=a.text()};if((a.length>0)&&(i>0)){setTimeout(function(){a.addClass('av-active-counter').text(i)},10)}},300)};var avia_clicked_product={};function track_ajax_add_to_cart(){jQuery('body').on('click','.add_to_cart_button',function(a){var e=jQuery(this).parents('.product').eq(0),t={};t.name=e.find('.woocommerce-loop-product__title').text();t.image=e.find('.thumbnail_container img');t.price=e.find('.price .amount').last().text();if(t.name===''){t.name=e.find('.inner_product_header h3').text()};if(e.length===0){e=jQuery(this);t.name=e.find('.av-cart-update-title').text();t.image=e.find('.av-cart-update-image');t.price=e.find('.av-cart-update-price').text()};if(t.image.length){t.image='<img class=\'added-product-image\' src=\''+t.image.get(0).src+'\' title=\'\' alt=\'\' />'}
else{t.image=''};avia_clicked_product=t})};function first_load_amount(){var e=0,i=15,n=500,a=function(){var t=jQuery('.cart_dropdown .dropdown_widget_cart').eq(0).find('.total .amount');if(t.length){update_cart_dropdown()}
else{e++;if(e<i){setTimeout(a,n)}}};a();if(jQuery('.av-display-cart-on-load').length&&jQuery('.woocommerce-message').length===0){var t=jQuery('.cart_dropdown');setTimeout(function(){t.trigger('mouseenter')},500);setTimeout(function(){t.trigger('mouseleave')},2500)}};function product_add_to_cart_click(){var e=jQuery('body'),a=jQuery('.av-catalogue-item'),t=!1;if(a.length){t=jQuery.avia_utilities.loading()};e.on('click','.add_to_cart_button',function(e){var i=jQuery(this);i.parents('.product').eq(0).addClass('adding-to-cart-loading').removeClass('added-to-cart-check');if(i.is('.av-catalogue-item')){t.show()};var a=jQuery('html');if(!a.hasClass('html_visible_cart')){a.addClass('html_visible_cart')}});e.on('added_to_cart',function(){jQuery('.adding-to-cart-loading').removeClass('adding-to-cart-loading').addClass('added-to-cart-check');if(t!==!1){t.hide()}})};function cart_improvement_functions(){jQuery('.product_type_downloadable, .product_type_virtual').addClass('product_type_simple');jQuery('.woocommerce-tabs .tabs a').addClass('no-scroll');jQuery('.single-product-main-image>.images a').attr('rel','product_images[grouped]')};function cart_dropdown_improvement(){var t=jQuery('.cart_dropdown'),a=t.find('.cart_dropdown_link'),e=t.find('.dropdown_widget').css({display:'none',opacity:0});a.on('focus',function(){t.trigger('mouseenter')}).on('blur',function(){t.trigger('mouseleave')});t.on('mouseenter',function(){const content=t.find('.widget_shopping_cart_content');if(jQuery.trim(content.html()).length){e.css({display:'block'}).stop().animate({opacity:1})}}).on('mouseleave',function(){e.stop().animate({opacity:0},function(){e.css({display:'none'})})})};(function(e){'use strict';e(function(){e.avia_utilities=e.avia_utilities||{};if('undefined'==typeof e.avia_utilities.isMobile){if(/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)&&'ontouchstart' in document.documentElement){e.avia_utilities.isMobile=!0}
else{e.avia_utilities.isMobile=!1}};i();e(window).trigger('resize')});e.avia_utilities=e.avia_utilities||{};function i(){var m=e('#header'),u=e('#main .av-logo-container'),h=e('#avia-menu'),l=e('.av-burger-menu-main a'),a=e('html').eq(0),n=e('<div class="av-burger-overlay" role="menu" aria-orientation="vertical"></div>'),p=e('<div class="av-burger-overlay-scroll"></div>').appendTo(n),g=e('<div class="av-burger-overlay-inner"></div>').appendTo(p),k=e('<div class="av-burger-overlay-bg"></div>').appendTo(n),r=!1,v={},b=e('.av-logo-container .inner-container'),C=b.find('.main_menu'),d=a.is('.html_av-submenu-display-click.html_av-submenu-clone, .html_av-submenu-display-hover.html_av-submenu-clone'),y=!1,T=0;if(!a.hasClass('html_av-submenu-hidden')){a.addClass('html_av-submenu-visible')};var f=e('#avia_alternate_menu');if(f.length>0){h=f};var c=function(){if(e.avia_utilities.isMobile){p.outerHeight(window.innerHeight)}},o=function(i,u){if(!i){return};var c,s,t,r,v,f,m,a,n;i.each(function(){t=e(this);r=t.find(' > .sub-menu > li');if(r.length==0){r=t.find(' > .children > li')};v=t.find('.avia_mega_div > .sub-menu > li.menu-item');var i=t.find('>a'),c=!0;if(i.length){if(i.get(0).hash=='#'||'undefined'==typeof i.attr('href')||i.attr('href')=='#'){if(r.length>0||v.length>0){c=!1}}};s=i.clone(c).attr('style','');if('undefined'==typeof i.attr('href')){s.attr('href','#')};a=e('<li>').append(s);a.attr('role','menuitem');var l=[];if('undefined'!=typeof t.attr('class')){l=t.attr('class').split(/\s+/);e.each(l,function(e,i){if((i.indexOf('menu-item')!=0)&&(i.indexOf('page-item')<0)&&(i.indexOf('page_item')!=0)&&(i.indexOf('dropdown_ul')<0)){a.addClass(i)};return!0})};if('undefined'!=typeof t.attr('id')&&''!=t.attr('id')){a.addClass(t.attr('id'))}
else{e.each(l,function(e,i){if(i.indexOf('page-item-')>=0){a.addClass(i);return!1}})};u.append(a);if(r.length){n=e('<ul class="sub-menu">').appendTo(a);if(d&&(s.get(0).hash!='#'&&s.attr('href')!='#')){a.clone(!0).prependTo(n)};a.addClass('av-width-submenu').find('>a').append('<span class="av-submenu-indicator">');o(r,n)}
else if(v.length){n=e('<ul class="sub-menu">').appendTo(a);if(d&&(s.get(0).hash!='#'&&s.attr('href')!='#')){a.clone(!0).prependTo(n)};v.each(function(i){var v=e(this),t=v.find('> .sub-menu'),s=v.find('> .mega_menu_title'),c=s.find('a').attr('href')||'#',r=t.length>0?t.find('>li'):null,f=!1,l=a.find('>a'),m='';if((r===null)||(r.length==0)){if(c=='#'){m=' style="display: none;"'}};if(i==0)a.addClass('av-width-submenu').find('>a').append('<span class="av-submenu-indicator">');if(s.length&&s.text()!=''){f=!0;if(i>0){var u=a.parents('li').eq(0);if(u.length)a=u;n=e('<ul class="sub-menu">').appendTo(a)};a=e('<li'+m+'>').appendTo(n);n=e('<ul class="sub-menu">').appendTo(a);e('<a href="'+c+'"><span class="avia-bullet"></span><span class="avia-menu-text">'+s.text()+'</span></a>').insertBefore(n);l=a.find('>a');if(d&&(t.length>0)&&(l.length&&l.get(0).hash!='#'&&l.attr('href')!='#')){a.clone(!0).addClass('av-cloned-title').prependTo(n)}};if(f&&(t.length>0)){a.addClass('av-width-submenu').find('>a').append('<span class="av-submenu-indicator">')};o(r,n)})}});l.trigger('avia_burger_list_created');return c},s,i;e('body').on('mousewheel DOMMouseScroll touchmove','.av-burger-overlay-scroll',function(e){var n=this.offsetHeight,i=this.scrollHeight,a=e.originalEvent.wheelDelta;if(i!=this.clientHeight){if((this.scrollTop>=(i-n)&&a<0)||(this.scrollTop<=0&&a>0)){e.preventDefault()}}
else{e.preventDefault()}});e(document).on('mousewheel DOMMouseScroll touchmove','.av-burger-overlay-bg, .av-burger-overlay-active .av-burger-menu-main',function(e){e.preventDefault()});var t={};e(document).on('touchstart','.av-burger-overlay-scroll',function(e){t.Y=e.originalEvent.touches[0].clientY});e(document).on('touchend','.av-burger-overlay-scroll',function(e){t={}});e(document).on('touchmove','.av-burger-overlay-scroll',function(i){if(!t.Y){t.Y=i.originalEvent.touches[0].clientY};var l=i.originalEvent.touches[0].clientY-t.Y,a=this,n=a.scrollTop,r=a.scrollHeight,o=n+a.offsetHeight,s=l>0?'up':'down';e('body').get(0).scrollTop=t.body;if(n<=0){if(s=='up'){i.preventDefault()}}
else if(o>=r){if(s=='down'){i.preventDefault()}}});e(window).on('debouncedresize',function(n){var s=!0;if(e.avia_utilities.isMobile&&a.hasClass('av-mobile-menu-switch-portrait')&&a.hasClass('html_text_menu_active')){var t=e(window).height(),o=e(window).width();if(o<=t){a.removeClass('html_burger_menu')}
else{var r=a.hasClass('html_mobile_menu_phone')?768:990;if(t<r){a.addClass('html_burger_menu');s=!1}
else{a.removeClass('html_burger_menu')}}};if(s&&i&&i.length){if(!l.is(':visible')){i.filter('.is-active').parents('a').eq(0).trigger('click')}};c()});e('.html_av-overlay-side').on('click','.av-burger-overlay-bg',function(e){e.preventDefault();i.parents('a').eq(0).trigger('click')});e(window).on('avia_smooth_scroll_start',function(){if(i&&i.length){i.filter('.is-active').parents('a').eq(0).trigger('click')}});e('.html_av-submenu-display-hover').on('mouseenter','.av-width-submenu',function(i){e(this).children('ul.sub-menu').slideDown('fast')});e('.html_av-submenu-display-hover').on('mouseleave','.av-width-submenu',function(i){e(this).children('ul.sub-menu').slideUp('fast')});e('.html_av-submenu-display-hover').on('click','.av-width-submenu > a',function(e){e.preventDefault();e.stopImmediatePropagation()});e('.html_av-submenu-display-hover').on('touchstart','.av-width-submenu > a',function(i){var a=e(this);w(a,i)});e('.html_av-submenu-display-click').on('click','.av-width-submenu > a',function(i){var a=e(this);w(a,i)});e('.html_av-submenu-display-click, .html_av-submenu-visible').on('click','.av-burger-overlay a',function(a){var n=window.location.href.match(/(^[^#]*)/)[0],t=e(this).attr('href').match(/(^[^#]*)/)[0];if(t==n){a.preventDefault();a.stopImmediatePropagation();i.parents('a').eq(0).trigger('click');return!1};return!0});function w(e,i){i.preventDefault();i.stopImmediatePropagation();var a=e.parents('li').eq(0);a.toggleClass('av-show-submenu');if(a.is('.av-show-submenu')){a.children('ul.sub-menu').slideDown('fast')}
else{a.children('ul.sub-menu').slideUp('fast')}};(function(){if(C.length){return};var i=e('#header .main_menu').clone(!0),t=i.find('ul.av-main-nav'),n=t.attr('id');if('string'==typeof n&&''!=n.trim()){t.attr('id',n+'-'+T++)};i.find('.menu-item:not(.menu-item-avia-special)').remove();i.insertAfter(b.find('.logo').first());var a=e('#header .social_bookmarks').clone(!0);if(!a.length){a=e('.av-logo-container .social_bookmarks').clone(!0)};if(a.length){i.find('.avia-menu').addClass('av_menu_icon_beside');i.append(a)};l=e('.av-burger-menu-main a')}());l.on('click',function(t){if(r){return};i=e(this).find('.av-hamburger'),r=!0;if(!y){y=!0;i.addClass('av-inserted-main-menu');s=e('<ul>').attr({id:'av-burger-menu-ul',class:'','aria-haspopup':'true','aria-controls':'menu2'});var d=h.find('> li:not(.menu-item-avia-special)'),f=o(d,s);s.find('.noMobile').remove();s.appendTo(g);v=g.find('#av-burger-menu-ul > li');if(e.fn.avia_smoothscroll){e('a[href*="#"]',n).avia_smoothscroll(n)}};if(i.is('.is-active')){i.removeClass('is-active');a.removeClass('av-burger-overlay-active-delayed');n.animate({opacity:0},function(){n.css({display:'none'});a.removeClass('av-burger-overlay-active');r=!1})}
else{c();var l=u.length?u.outerHeight()+u.position().top:m.outerHeight()+m.position().top;n.appendTo(e(t.target).parents('.avia-menu'));s.css({padding:(l)+'px 0px'});v.removeClass('av-active-burger-items');i.addClass('is-active');a.addClass('av-burger-overlay-active');n.css({display:'block'}).animate({opacity:1},function(){r=!1});setTimeout(function(){a.addClass('av-burger-overlay-active-delayed')},100);v.each(function(i){var a=e(this);setTimeout(function(){a.addClass('av-active-burger-items')},(i+1)*125)})};t.preventDefault()})}})(jQuery);(function(t){'use strict';t.avia_utilities=t.avia_utilities||{};t(function(){if(t.fn.avia_parallax){t('.av-parallax,.av-parallax-object').avia_parallax()}});var i=function(i,e){if(!(this.transform||this.transform3d)){return};this.options=t.extend({},i);this.win=t(window);this.body=t('body');this.isMobile=t.avia_utilities.isMobile,this.winHeight=this.win.height();this.winWidth=this.win.width();this.el=t(e).addClass('active-parallax');this.objectType=this.el.hasClass('av-parallax-object')?'object':'background-image';this.elInner=this.el;this.elBackgroundParent=this.el.parent();this.elParallax=this.el.data('parallax')||{};this.direction='';this.speed=0.5;this.elProperty={};this.ticking=!1,this.isTransformed=!1;if(t.avia_utilities.supported.transition===undefined){t.avia_utilities.supported.transition=t.avia_utilities.supports('transition')};this._init(i)};i.prototype={mediaQueries:{'av-mini-':'(max-width: 479px)','av-small-':'(min-width: 480px) and (max-width: 767px)','av-medium-':'(min-width: 768px) and (max-width: 989px)','av-desktop-':'(min-width: 990px)'},transform:document.documentElement.className.indexOf('avia_transform')!==-1,transform3d:document.documentElement.className.indexOf('avia_transform3d')!==-1,mobileNoAnimation:t('body').hasClass('avia-mobile-no-animations'),defaultSpeed:0.5,defaultDirections:['bottom_top','left_right','right_left','no_parallax'],transformCSSProps:['transform','-webkit-transform','-moz-transform','-ms-transform','-o-transform'],matrixDef:[1,0,0,1,0,0],matrix3dDef:[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],_init:function(){var t=this;if(typeof this.el.data('parallax-selector')!='undefined'&&this.el.data('parallax-selector')!==''){this.elInner=this.el.find(this.el.data('parallax-selector'));if(this.elInner.length==0){this.elInner=this.el}};if('background-image'==this.objectType){if(this.isMobile&&this.mobileNoAnimation){return};this.elParallax.parallax='bottom_top';this.elParallax.parallax_speed=parseFloat(this.el.data('avia-parallax-ratio'))||0.5};setTimeout(function(){t._fetchProperties()},30);this.win.on('debouncedresize av-height-change',t._fetchProperties.bind(t));this.body.on('av_resize_finished',t._fetchProperties.bind(t));setTimeout(function(){t.win.on('scroll',t._onScroll.bind(t))},100)},_setParallaxProps:function(){if('background-image'==this.objectType){this.direction=this.elParallax.parallax;this.speed=this.elParallax.parallax_speed;return};var e=this.elParallax.parallax||'',s=this.elParallax.parallax_speed||'',i='',a='',r='all';if(this.defaultDirections.indexOf(e)<0){e='no_parallax'};if(typeof window.matchMedia=='function'){t.each(this.mediaQueries,function(t,i){var e=window.matchMedia(i);if(e.matches){r=t;return!1}})};if('all'==r){this.direction=e;this.speed=''==s?this.defaultSpeed:parseFloat(s)/100.0;return};i=this.elParallax[r+'parallax']||'';a=this.elParallax[r+'parallax_speed']||'';if('inherit'==i){i=e;a=s};if(this.defaultDirections.indexOf(i)<0){i='no_parallax'};this.direction=i;this.speed=''==a?this.defaultSpeed:parseFloat(a)/100.0},_getTranslateObject:function(e){var i={type:'',matrix:[],x:0,y:0,z:0};t.each(this.transformCSSProps,function(t,s){var r=e.css(s);if('string'!=typeof r||'none'==r){return};if(r.indexOf('matrix')>=0){var a=r.match(/matrix.*\((.+)\)/)[1].split(', ');if(r.indexOf('matrix3d')>=0){i.type='3d';i.matrix=a;i.x=a[12];i.y=a[13];i.z=a[14]}
else{i.type='2d';i.matrix=a;i.x=a[4];i.y=a[5]};return!1}
else{i.type='';var n=r.match(/translateX\((-?\d+\.?\d*px)\)/);if(n){i.x=parseInt(n[1],10)};var l=r.match(/translateY\((-?\d+\.?\d*px)\)/);if(l){i.y=parseInt(l[1],10)}}});return i},_getTranslateMatrix:function(i,r){var s='';t.each(r,function(t,e){i[t]=e});if(this.transform3d){var e=this.matrix3dDef.slice(0);switch(i.type){case'2d':e[0]=i.matrix[0];e[1]=i.matrix[1];e[4]=i.matrix[2];e[5]=i.matrix[3];e[12]=i.x;e[13]=i.y;break;case'3d':e=i.matrix.slice(0);e[12]=i.x;e[13]=i.y;e[14]=i.z;break;default:e[12]=i.x;e[13]=i.y;break};s='matrix3d('+e.join(', ')+')'}
else if(this.transform){var a=this.matrixDef.slice(0);switch(i.type){case'2d':a=i.matrix.slice(0);a[4]=i.x;a[5]=i.y;break;case'3d':a[0]=i.matrix[0];a[1]=i.matrix[1];a[2]=i.matrix[4];a[3]=i.matrix[5];a[4]=i.x;a[5]=i.y;break;default:a[4]=i.x;a[5]=i.y;break};s='matrix('+a.join(', ')+')'};return s},_fetchProperties:function(){this._setParallaxProps();this.el.css(t.avia_utilities.supported.transition+'transform','');this.winHeight=this.win.height();this.winWidth=this.win.width();if('background-image'==this.objectType){this.elProperty.top=this.elBackgroundParent.offset().top;this.elProperty.height=this.elBackgroundParent.outerHeight();this.el.height(Math.ceil((this.winHeight*Math.abs(this.speed))+this.elProperty.height))}
else{this.elProperty.top=this.elInner.offset().top;this.elProperty.left=this.elInner.offset().left;this.elProperty.height=this.elInner.outerHeight();this.elProperty.width=this.elInner.outerWidth();this.elProperty.bottom=this.elProperty.top+this.elProperty.height;this.elProperty.right=this.elProperty.left+this.elProperty.width;this.elProperty.distanceLeft=this.elProperty.right;this.elProperty.distanceRight=this.winWidth-this.elProperty.left};this.elProperty.translateObj=this._getTranslateObject(this.el);this._parallaxScroll()},_onScroll:function(t){var i=this;if(!i.ticking){i.ticking=!0;window.requestAnimationFrame(i._parallaxRequest.bind(i))}},_inViewport:function(t,i,e,a,r,s,l,n){return!(t>s+10||e<r-10||a>n+10||i<l-10)},_parallaxRequest:function(t){var i=this;setTimeout(i._parallaxScroll.bind(i),0)},_parallaxScroll:function(i){if(('no_parallax'==this.direction||''==this.direction)&&!this.isTransformed){this.ticking=!1;return};var l=this.win.scrollTop(),o=this.win.scrollLeft(),d=o+this.winWidth,s=l+this.winHeight,e=0,a='';if('background-image'==this.objectType){if(this.elProperty.top<s&&l<=this.elProperty.top+this.elProperty.height){e=Math.ceil((s-this.elProperty.top)*this.speed);a=this._getTranslateMatrix(this.elProperty.translateObj,{y:e});this.el.css(t.avia_utilities.supported.transition+'transform',a)};this.ticking=!1;return};if(('no_parallax'==this.direction||''==this.direction)){a=this._getTranslateMatrix(this.elProperty.translateObj,{x:0,y:0});this.el.css(t.avia_utilities.supported.transition+'transform',a);this.ticking=!1;this.isTransformed=!1;return};var x=Math.ceil(this.elProperty.top-l),p=Math.ceil(s-this.elProperty.top),n=0,h=0,r={x:0,y:0};if(this.elProperty.top<this.winHeight){h=Math.ceil(this.winHeight-this.elProperty.top)};if(this.elProperty.top>s){n=0;p=0}
else{n=1-(x+h)/this.winHeight};switch(this.direction){case'bottom_top':e=Math.ceil((p-h)*this.speed);r.y=-e;a=this._getTranslateMatrix(this.elProperty.translateObj,{y:-e});break;case'left_right':e=Math.ceil(this.elProperty.distanceRight*n*this.speed);r.x=e;a=this._getTranslateMatrix(this.elProperty.translateObj,{x:e});break;case'right_left':e=Math.ceil(this.elProperty.distanceLeft*n*this.speed);r.x=-e;a=this._getTranslateMatrix(this.elProperty.translateObj,{x:-e});break;default:break};var f=this._inViewport(this.elProperty.top,this.elProperty.right,this.elProperty.bottom,this.elProperty.left,l,s,o,d),c=this._inViewport(this.elProperty.top+r.y,this.elProperty.right+r.x,this.elProperty.bottom+r.y,this.elProperty.left+r.x,l,s,o,d);if(f||c){this.el.css(t.avia_utilities.supported.transition+'transform',a)};this.ticking=!1;this.isTransformed=!0}};t.fn.avia_parallax=function(e){return this.each(function(){var a=t(this),r=a.data('aviaParallax');if(!r){r=a.data('aviaParallax',new i(e,this))}})}})(jQuery);'use strict';var avia_js_shortcodes=avia_js_shortcodes||{};var aviaJS=aviaJS||{};(function(){if(!avia_js_shortcodes.aviaFoldUnfoldSection){class avFoldUnfoldSection{container=null;id='';settings={};button=[];foldContainer=[];folded=!1;preview=!1;innerDimension={};textblock=[];multiColumsTextblock=!1;gridRow=[];colorSection=[];column=[];constructor(container){this.container=container;this.container.avFoldUnfoldSection=this;this.id=container.getAttribute('id');this.init()};init(){this.settings=JSON.parse(this.container.dataset.fold_unfold);this.preview=document.getElementById('av-admin-preview')!=null;this.moveIntoFoldContainer();if(!this.button.length||!this.foldContainer.length||this.checkMissingInnerContainers()){return};if(this.isNested()){this.container.classList.remove('avia-fold-init');this.foldContainer[0].classList.remove('unfolded','folded');this.foldContainer[0].style['max-height']='unset';this.button[0].remove();return};this.foldContainer[0].style['max-height']=this.settings.height+'px';this.foldContainer[0].classList.add('folded');this.foldContainer[0].classList.remove('unfolded');this.folded=!0;this.container.classList.add('avia-fold-init-done');this.getMaxHeight();this.foldChanged();this.bindEvents();this.container.classList.remove('avia-fold-init')};moveIntoFoldContainer(){if(this.container.hasChildNodes()){let children=this.container.childNodes;for(const child of children){if(child.classList){if(child.classList.contains('av-fold-unfold-container')){this.foldContainer[0]=child};if(child.classList.contains('av-fold-button-wrapper')){const btn=child.getElementsByClassName('av-fold-button-container');if(btn.length){this.button[0]=btn[0]}}}}};let move=null;if(this.settings.context=='avia_sc_text'){let el=this.foldContainer[0].nextSibling;while(el){if(el.classList&&el.classList.contains('avia_textblock')){move=el;break};el=el.nextSibling}}
else if(this.settings.context=='avia_sc_columns'){let el=this.foldContainer[0].nextSibling;this.column=this.foldContainer[0].getElementsByClassName('av-fold-unfold-inner');if(this.column.length){while(el){if(el.classList&&el.classList.contains('av-fold-button-wrapper')){el=el.nextSibling}
else{const next=el.nextSibling;this.column[0].append(el);el=next}}}}
else{const el=this.container.nextSibling;if(el){move=el}};if(move){this.foldContainer[0].append(move)}};checkMissingInnerContainers(){let retVal=!1;switch(this.settings.context){case'avia_sc_text':this.textblock=this.container.getElementsByClassName('avia_textblock');if(this.textblock.length==0){retVal=!0}
else{this.multiColumsTextblock=this.textblock[0].classList.contains('av_multi_colums')};break;case'avia_sc_grid_row':this.gridRow=this.container.getElementsByClassName('av-layout-grid-container');if(this.gridRow.length==0){retVal=!0};break;case'avia_sc_section':this.colorSection=this.container.getElementsByClassName('avia-section');if(this.colorSection.length==0){retVal=!0};break;case'avia_sc_columns':if(!this.column[0].childNodes.length){retVal=!0};break;default:retVal=!0};return retVal};isNested(){const parent=this.container.parentElement;if(null==parent){return!1};let closest=parent.closest('.avia-fold-unfold-section');if(closest==parent){closest=null};return closest!=null};bindEvents(){this.container.addEventListener('transitionend',this.onTransitionEnd.bind(this));this.container.addEventListener('webkitTransitionEnd',this.onTransitionEnd.bind(this));this.button[0].addEventListener('click',this.onClickFoldUnfold.bind(this));window.addEventListener('avia_fold_unfold_changed',this.onFoldUnfoldChanged.bind(this));window.addEventListener('resize',aviaJS.aviaJSHelpers.debounce(this.onResize.bind(this),200))};getMaxHeight(){switch(this.settings.context){case'avia_sc_text':this.innerDimension=this.textblock[0].getBoundingClientRect();break;case'avia_sc_grid_row':this.innerDimension=this.gridRow[0].getBoundingClientRect();break;case'avia_sc_section':this.innerDimension=this.colorSection[0].getBoundingClientRect();break;case'avia_sc_columns':this.innerDimension=this.column[0].getBoundingClientRect();break}};foldChanged(){let btnText='',btnLink='';if(this.folded){this.foldContainer[0].style['max-height']=this.settings.height+'px';btnText=this.settings.more;btnLink='#'}
else{this.getMaxHeight();this.foldContainer[0].style['max-height']=Math.ceil(this.innerDimension.height)+200+'px';btnText=this.settings.less;btnLink+='#'+this.id};this.button[0].setAttribute('href',btnLink);this.button[0].textContent=btnText;this.triggerHeightChange()};onClickFoldUnfold(event){event.preventDefault();event.stopPropagation();if(this.foldContainer[0].classList.contains('folded')){this.foldContainer[0].classList.remove('folded');this.foldContainer[0].classList.add('unfolded');this.folded=!1}
else{this.foldContainer[0].classList.remove('unfolded');this.foldContainer[0].classList.add('folded');this.folded=!0};this.foldChanged();let obj=this;setTimeout(function(){const opt={'bubbles':!0,'cancelable':!0,detail:{caller:obj}};const event=new CustomEvent('avia_fold_unfold_changed',opt);obj.container.dispatchEvent(event)},500)};onTransitionEnd(event){this.container.classList.remove('avia-fold-init-done');this.triggerHeightChange()};onResize(event){this.foldChanged()};onFoldUnfoldChanged(event){this.foldChanged()};triggerHeightChange(){const opt={'bubbles':!0,'cancelable':!0};const event=new CustomEvent('avia_height_change',opt);window.dispatchEvent(event)}};avia_js_shortcodes.aviaFoldUnfoldSection=function(t){return new avFoldUnfoldSection(t)};aviaJS.aviaPlugins.register(avia_js_shortcodes.aviaFoldUnfoldSection,'.avia-fold-unfold-section')}})();/*! Magnific Popup - v1.3 - 2022-09-14
* http://dimsemenov.com/plugins/magnific-popup/
* Copyright (c) 2016 Dmitry Semenov; */
!function(e){var t,i,n,o,a,r,s="Close",l="BeforeClose",c="MarkupParse",d="Open",p="Change",u="mfp",f="."+u,m="mfp-ready",g="mfp-removing",v="mfp-prevent-close",h=function(){},y=!!window.jQuery,C=e(window),b=function(e,i){t.ev.on(u+e+f,i)},w=function(t,i,n,o){var a=document.createElement("div");return a.className="mfp-"+t,n&&(a.innerHTML=n),o?i&&i.appendChild(a):(a=e(a),i&&a.appendTo(i)),a},I=function(e,i){t.ev.triggerHandler(u+e,i),t.st.callbacks&&(e=e.charAt(0).toLowerCase()+e.slice(1),t.st.callbacks[e]&&t.st.callbacks[e].apply(t,Array.isArray(i)?i:[i]))},x=function(i){return i===r&&t.currTemplate.closeBtn||(t.currTemplate.closeBtn=e(t.st.closeMarkup.replace("%title%",t.st.tClose)),r=i),t.currTemplate.closeBtn},k=function(){e.magnificPopup.instance||((t=new h).init(),e.magnificPopup.instance=t)};h.prototype={constructor:h,init:function(){var i=navigator.appVersion;t.isLowIE=t.isIE8=document.all&&!document.addEventListener,t.isAndroid=/android/gi.test(i),t.isIOS=/iphone|ipad|ipod/gi.test(i),t.supportsTransition=function(){var e=document.createElement("p").style,t=["ms","O","Moz","Webkit"];if(void 0!==e.transition)return!0;for(;t.length;)if(t.pop()+"Transition"in e)return!0;return!1}(),t.probablyMobile=t.isAndroid||t.isIOS||/(Opera Mini)|Kindle|webOS|BlackBerry|(Opera Mobi)|(Windows Phone)|IEMobile/i.test(navigator.userAgent),n=e(document),t.popupsCache={}},open:function(i){var o;if(!1===i.isObj){t.items=i.items.toArray(),t.index=0;var r,s=i.items;for(o=0;o<s.length;o++)if((r=s[o]).parsed&&(r=r.el[0]),r===i.el[0]){t.index=o;break}}else t.items=Array.isArray(i.items)?i.items:[i.items],t.index=i.index||0;if(!t.isOpen){t.types=[],a="",i.mainEl&&i.mainEl.length?t.ev=i.mainEl.eq(0):t.ev=n,i.key?(t.popupsCache[i.key]||(t.popupsCache[i.key]={}),t.currTemplate=t.popupsCache[i.key]):t.currTemplate={},t.st=e.extend(!0,{},e.magnificPopup.defaults,i),t.fixedContentPos="auto"===t.st.fixedContentPos?!t.probablyMobile:t.st.fixedContentPos,t.st.modal&&(t.st.closeOnContentClick=!1,t.st.closeOnBgClick=!1,t.st.showCloseBtn=!1,t.st.enableEscapeKey=!1),t.bgOverlay||(t.bgOverlay=w("bg").on("click"+f,(function(){t.close()})),t.wrap=w("wrap").attr("tabindex",-1).on("click"+f,(function(e){t._checkIfClose(e.target)&&t.close()})),t.container=w("container",t.wrap)),t.contentContainer=w("content"),t.st.preloader&&(t.preloader=w("preloader",t.container,t.st.tLoading));var l=e.magnificPopup.modules;for(o=0;o<l.length;o++){var p=l[o];p=p.charAt(0).toUpperCase()+p.slice(1),t["init"+p].call(t)}I("BeforeOpen"),t.st.showCloseBtn&&(t.st.closeBtnInside?(b(c,(function(e,t,i,n){i.close_replaceWith=x(n.type)})),a+=" mfp-close-btn-in"):t.wrap.append(x())),t.st.alignTop&&(a+=" mfp-align-top"),t.fixedContentPos?t.wrap.css({overflow:t.st.overflowY,overflowX:"hidden",overflowY:t.st.overflowY}):t.wrap.css({top:C.scrollTop(),position:"absolute"}),(!1===t.st.fixedBgPos||"auto"===t.st.fixedBgPos&&!t.fixedContentPos)&&t.bgOverlay.css({height:n.height(),position:"absolute"}),t.st.enableEscapeKey&&n.on("keyup"+f,(function(e){27===e.keyCode&&t.close()})),C.on("resize"+f,(function(){t.updateSize()})),t.st.closeOnContentClick||(a+=" mfp-auto-cursor"),a&&t.wrap.addClass(a);var u=t.wH=C.height(),g={};if(t.fixedContentPos&&t._hasScrollBar(u)){var v=t._getScrollbarSize();v&&(g.marginRight=v)}t.fixedContentPos&&(t.isIE7?e("body, html").css("overflow","hidden"):g.overflow="hidden");var h=t.st.mainClass;return t.isIE7&&(h+=" mfp-ie7"),h&&t._addClassToMFP(h),t.updateItemHTML(),I("BuildControls"),e("html").css(g),t.bgOverlay.add(t.wrap).prependTo(t.st.prependTo||e(document.body)),t._lastFocusedEl=document.activeElement,setTimeout((function(){t.content?(t._addClassToMFP(m),t._setFocus()):t.bgOverlay.addClass(m),n.on("focusin"+f,t._onFocusIn)}),16),t.isOpen=!0,t.updateSize(u),I(d),i}t.updateItemHTML()},close:function(){t.isOpen&&(I(l),t.isOpen=!1,t.st.removalDelay&&!t.isLowIE&&t.supportsTransition?(t._addClassToMFP(g),setTimeout((function(){t._close()}),t.st.removalDelay)):t._close())},_close:function(){I(s);var i=g+" "+m+" ";if(t.bgOverlay.detach(),t.wrap.detach(),t.container.empty(),t.st.mainClass&&(i+=t.st.mainClass+" "),t._removeClassFromMFP(i),t.fixedContentPos){var o={marginRight:""};t.isIE7?e("body, html").css("overflow",""):o.overflow="",e("html").css(o)}n.off("keyup.mfp focusin"+f),t.ev.off(f),t.wrap.attr("class","mfp-wrap").removeAttr("style"),t.bgOverlay.attr("class","mfp-bg"),t.container.attr("class","mfp-container"),!t.st.showCloseBtn||t.st.closeBtnInside&&!0!==t.currTemplate[t.currItem.type]||t.currTemplate.closeBtn&&t.currTemplate.closeBtn.detach(),t.st.autoFocusLast&&t._lastFocusedEl&&e(t._lastFocusedEl).trigger("focus"),t.currItem=null,t.content=null,t.currTemplate=null,t.prevHeight=0,I("AfterClose")},updateSize:function(e){if(t.isIOS){var i=document.documentElement.clientWidth/window.innerWidth,n=window.innerHeight*i;t.wrap.css("height",n),t.wH=n}else t.wH=e||C.height();t.fixedContentPos||t.wrap.css("height",t.wH),I("Resize")},updateItemHTML:function(){var i=t.items[t.index];t.contentContainer.detach(),t.content&&t.content.detach(),i.parsed||(i=t.parseEl(t.index));var n=i.type;if(I("BeforeChange",[t.currItem?t.currItem.type:"",n]),t.currItem=i,!t.currTemplate[n]){var a=!!t.st[n]&&t.st[n].markup;I("FirstMarkupParse",a),t.currTemplate[n]=!a||e(a)}o&&o!==i.type&&t.container.removeClass("mfp-"+o+"-holder");var r=t["get"+n.charAt(0).toUpperCase()+n.slice(1)](i,t.currTemplate[n]);t.appendContent(r,n),i.preloaded=!0,I(p,i),o=i.type,t.container.prepend(t.contentContainer),I("AfterChange")},appendContent:function(e,i){t.content=e,e?t.st.showCloseBtn&&t.st.closeBtnInside&&!0===t.currTemplate[i]?t.content.find(".mfp-close").length||t.content.append(x()):t.content=e:t.content="",I("BeforeAppend"),t.container.addClass("mfp-"+i+"-holder"),t.contentContainer.append(t.content)},parseEl:function(i){var n,o=t.items[i];if(o.tagName?o={el:e(o)}:(n=o.type,o={data:o,src:o.src}),o.el){for(var a=t.types,r=0;r<a.length;r++)if(o.el.hasClass("mfp-"+a[r])){n=a[r];break}o.src=o.el.attr("data-mfp-src"),o.src||(o.src=o.el.attr("href"))}return o.type=n||t.st.type||"inline",o.index=i,o.parsed=!0,t.items[i]=o,I("ElementParse",o),t.items[i]},addGroup:function(e,i){var n=function(n){n.mfpEl=this,t._openClick(n,e,i)};i||(i={});var o="click.magnificPopup";i.mainEl=e,i.items?(i.isObj=!0,e.off(o).on(o,n)):(i.isObj=!1,i.delegate?e.off(o).on(o,i.delegate,n):(i.items=e,e.off(o).on(o,n)))},_openClick:function(i,n,o){if((void 0!==o.midClick?o.midClick:e.magnificPopup.defaults.midClick)||!(2===i.which||i.ctrlKey||i.metaKey||i.altKey||i.shiftKey)){var a=void 0!==o.disableOn?o.disableOn:e.magnificPopup.defaults.disableOn;if(a)if("function"==typeof a){if(!a.call(t))return!0}else if(C.width()<a)return!0;i.type&&(i.preventDefault(),t.isOpen&&i.stopPropagation()),o.el=e(i.mfpEl),o.delegate&&(o.items=n.find(o.delegate)),t.open(o)}},updateStatus:function(e,n){if(t.preloader){i!==e&&t.container.removeClass("mfp-s-"+i),n||"loading"!==e||(n=t.st.tLoading);var o={status:e,text:n};I("UpdateStatus",o),e=o.status,n=o.text,t.preloader.html(n),t.preloader.find("a").on("click",(function(e){e.stopImmediatePropagation()})),t.container.addClass("mfp-s-"+e),i=e}},_checkIfClose:function(i){if(!e(i).hasClass(v)){var n=t.st.closeOnContentClick,o=t.st.closeOnBgClick;if(n&&o)return!0;if(!t.content||e(i).hasClass("mfp-close")||t.preloader&&i===t.preloader[0])return!0;if(i===t.content[0]||e.contains(t.content[0],i)){if(n)return!0}else if(o&&e.contains(document,i))return!0;return!1}},_addClassToMFP:function(e){t.bgOverlay.addClass(e),t.wrap.addClass(e)},_removeClassFromMFP:function(e){this.bgOverlay.removeClass(e),t.wrap.removeClass(e)},_hasScrollBar:function(e){return(t.isIE7?n.height():document.body.scrollHeight)>(e||C.height())},_setFocus:function(){(t.st.focus?t.content.find(t.st.focus).eq(0):t.wrap).trigger("focus")},_onFocusIn:function(i){if(i.target!==t.wrap[0]&&!e.contains(t.wrap[0],i.target))return t._setFocus(),!1},_parseMarkup:function(t,i,n){var o;n.data&&(i=e.extend(n.data,i)),I(c,[t,i,n]),e.each(i,(function(i,n){if(void 0===n||!1===n)return!0;if((o=i.split("_")).length>1){var a=t.find(f+"-"+o[0]);if(a.length>0){var r=o[1];"replaceWith"===r?a[0]!==n[0]&&a.replaceWith(n):"img"===r?a.is("img")?a.attr("src",n):a.replaceWith(e("<img>").attr("src",n).attr("class",a.attr("class"))):a.attr(o[1],n)}}else t.find(f+"-"+i).html(n)}))},_getScrollbarSize:function(){if(void 0===t.scrollbarSize){var e=document.createElement("div");e.style.cssText="width: 99px; height: 99px; overflow: scroll; position: absolute; top: -9999px;",document.body.appendChild(e),t.scrollbarSize=e.offsetWidth-e.clientWidth,document.body.removeChild(e)}return t.scrollbarSize}},e.magnificPopup={instance:null,proto:h.prototype,modules:[],open:function(t,i){return k(),(t=t?e.extend(!0,{},t):{}).isObj=!0,t.index=i||0,this.instance.open(t)},close:function(){return e.magnificPopup.instance&&e.magnificPopup.instance.close()},registerModule:function(t,i){i.options&&(e.magnificPopup.defaults[t]=i.options),e.extend(this.proto,i.proto),this.modules.push(t)},defaults:{disableOn:0,key:null,midClick:!1,mainClass:"",preloader:!0,focus:"",closeOnContentClick:!1,closeOnBgClick:!0,closeBtnInside:!0,showCloseBtn:!0,enableEscapeKey:!0,modal:!1,alignTop:!1,removalDelay:0,prependTo:null,fixedContentPos:"auto",fixedBgPos:"auto",overflowY:"auto",closeMarkup:'<button title="%title%" type="button" class="mfp-close">&#215;</button>',tClose:"Close (Esc)",tLoading:"Loading...",autoFocusLast:!0}},e.fn.magnificPopup=function(i){k();var n=e(this);if("string"==typeof i)if("open"===i){var o,a=y?n.data("magnificPopup"):n[0].magnificPopup,r=parseInt(arguments[1],10)||0;a.items?o=a.items[r]:(o=n,a.delegate&&(o=o.find(a.delegate)),o=o.eq(r)),t._openClick({mfpEl:o},n,a)}else t.isOpen&&t[i].apply(t,Array.prototype.slice.call(arguments,1));else i=e.extend(!0,{},i),y?n.data("magnificPopup",i):n[0].magnificPopup=i,t.addGroup(n,i);return n};var T,_,z,P="inline",S=function(){z&&(_.after(z.addClass(T)).detach(),z=null)};e.magnificPopup.registerModule(P,{options:{hiddenClass:"hide",markup:"",tNotFound:"Content not found"},proto:{initInline:function(){t.types.push(P),b(s+"."+P,(function(){S()}))},getInline:function(i,n){if(S(),i.src){var o=t.st.inline,a=e(i.src);if(a.length){var r=a[0].parentNode;r&&r.tagName&&(_||(T=o.hiddenClass,_=w(T),T="mfp-"+T),z=a.after(_).detach().removeClass(T)),t.updateStatus("ready")}else t.updateStatus("error",o.tNotFound),a=e("<div>");return i.inlineElement=a,a}return t.updateStatus("ready"),t._parseMarkup(n,{},i),n}}});var E,O="ajax",M=function(){E&&e(document.body).removeClass(E)},B=function(){M(),t.req&&t.req.abort()};e.magnificPopup.registerModule(O,{options:{settings:null,cursor:"mfp-ajax-cur",tError:'<a href="%url%">The content</a> could not be loaded.'},proto:{initAjax:function(){t.types.push(O),E=t.st.ajax.cursor,b(s+"."+O,B),b("BeforeChange."+O,B)},getAjax:function(i){E&&e(document.body).addClass(E),t.updateStatus("loading");var n=e.extend({url:i.src,success:function(n,o,a){var r={data:n,xhr:a};I("ParseAjax",r),t.appendContent(e(r.data),O),i.finished=!0,M(),t._setFocus(),setTimeout((function(){t.wrap.addClass(m)}),16),t.updateStatus("ready"),I("AjaxContentAdded")},error:function(){M(),i.finished=i.loadError=!0,t.updateStatus("error",t.st.ajax.tError.replace("%url%",i.src))}},t.st.ajax.settings);return t.req=e.ajax(n),""}}});var A,L=function(e){if(e.data&&void 0!==e.data.title)return e.data.title;var i=t.st.image.titleSrc;if(i){if("function"==typeof i)return i.call(t,e);if(e.el)return e.el.attr(i)||""}return""};e.magnificPopup.registerModule("image",{options:{markup:'<div class="mfp-figure"><div class="mfp-close"></div><figure><div class="mfp-img"></div><figcaption><div class="mfp-bottom-bar"><div class="mfp-title"></div><div class="mfp-counter"></div></div></figcaption></figure></div>',cursor:"mfp-zoom-out-cur",titleSrc:"title",verticalFit:!0,tError:'<a href="%url%">The image</a> could not be loaded.'},proto:{initImage:function(){var i=t.st.image,n=".image";t.types.push("image"),b(d+n,(function(){"image"===t.currItem.type&&i.cursor&&e(document.body).addClass(i.cursor)})),b(s+n,(function(){i.cursor&&e(document.body).removeClass(i.cursor),C.off("resize"+f)})),b("Resize"+n,t.resizeImage),t.isLowIE&&b("AfterChange",t.resizeImage)},resizeImage:function(){var e=t.currItem;if(e&&e.img&&t.st.image.verticalFit){var i=0;t.isLowIE&&(i=parseInt(e.img.css("padding-top"),10)+parseInt(e.img.css("padding-bottom"),10)),e.img.css("max-height",t.wH-i)}},_onImageHasSize:function(e){e.img&&(e.hasSize=!0,A&&clearInterval(A),e.isCheckingImgSize=!1,I("ImageHasSize",e),e.imgHidden&&(t.content&&t.content.removeClass("mfp-loading"),e.imgHidden=!1))},findImageSize:function(e){var i=0,n=e.img[0],o=function(a){A&&clearInterval(A),A=setInterval((function(){n.naturalWidth>0?t._onImageHasSize(e):(i>200&&clearInterval(A),3===++i?o(10):40===i?o(50):100===i&&o(500))}),a)};o(1)},getImage:function(i,n){var o=0,a=function(){i&&(i.img[0].complete?(i.img.off(".mfploader"),i===t.currItem&&(t._onImageHasSize(i),t.updateStatus("ready")),i.hasSize=!0,i.loaded=!0,I("ImageLoadComplete")):++o<200?setTimeout(a,100):r())},r=function(){i&&(i.img.off(".mfploader"),i===t.currItem&&(t._onImageHasSize(i),t.updateStatus("error",s.tError.replace("%url%",i.src))),i.hasSize=!0,i.loaded=!0,i.loadError=!0)},s=t.st.image,l=n.find(".mfp-img");if(l.length){var c=document.createElement("img");if(c.className="mfp-img",i.el&&i.el.find("img").length&&(c.alt=i.el.find("img").attr("alt")),i.img=e(c).on("load.mfploader",a).on("error.mfploader",r),c.src=i.src,e("body").hasClass("responsive-images-lightbox-support")){var d=i.el.data("srcset"),p=i.el.data("sizes");void 0!==d?(c.srcset=d,void 0!==p&&(c.sizes=p)):(void 0!==(d=i.el.find("img").attr("srcset"))&&(c.srcset=d),void 0!==(p=i.el.find("img").attr("sizes"))&&(c.sizes=p))}l.is("img")&&(i.img=i.img.clone()),(c=i.img[0]).naturalWidth>0?i.hasSize=!0:c.width||(i.hasSize=!1)}return t._parseMarkup(n,{title:L(i),img_replaceWith:i.img},i),t.resizeImage(),i.hasSize?(A&&clearInterval(A),i.loadError?(n.addClass("mfp-loading"),t.updateStatus("error",s.tError.replace("%url%",i.src))):(n.removeClass("mfp-loading"),t.updateStatus("ready")),n):(t.updateStatus("loading"),i.loading=!0,i.hasSize||(i.imgHidden=!0,n.addClass("mfp-loading"),t.findImageSize(i)),n)}}});var H;e.magnificPopup.registerModule("zoom",{options:{enabled:!1,easing:"ease-in-out",duration:300,opener:function(e){return e.is("img")?e:e.find("img")}},proto:{initZoom:function(){var e,i=t.st.zoom,n=".zoom";if(i.enabled&&t.supportsTransition){var o,a,r=i.duration,c=function(e){var t=e.clone().removeAttr("style").removeAttr("class").addClass("mfp-animated-image"),n="all "+i.duration/1e3+"s "+i.easing,o={position:"fixed",zIndex:9999,left:0,top:0,"-webkit-backface-visibility":"hidden"},a="transition";return o["-webkit-"+a]=o["-moz-"+a]=o["-o-"+a]=o[a]=n,t.css(o),t},d=function(){t.content.css("visibility","visible")};b("BuildControls"+n,(function(){if(t._allowZoom()){if(clearTimeout(o),t.content.css("visibility","hidden"),!(e=t._getItemToZoom()))return void d();(a=c(e)).css(t._getOffset()),t.wrap.append(a),o=setTimeout((function(){a.css(t._getOffset(!0)),o=setTimeout((function(){d(),setTimeout((function(){a.remove(),e=a=null,I("ZoomAnimationEnded")}),16)}),r)}),16)}})),b(l+n,(function(){if(t._allowZoom()){if(clearTimeout(o),t.st.removalDelay=r,!e){if(!(e=t._getItemToZoom()))return;a=c(e)}a.css(t._getOffset(!0)),t.wrap.append(a),t.content.css("visibility","hidden"),setTimeout((function(){a.css(t._getOffset())}),16)}})),b(s+n,(function(){t._allowZoom()&&(d(),a&&a.remove(),e=null)}))}},_allowZoom:function(){return"image"===t.currItem.type},_getItemToZoom:function(){return!!t.currItem.hasSize&&t.currItem.img},_getOffset:function(i){var n,o=(n=i?t.currItem.img:t.st.zoom.opener(t.currItem.el||t.currItem)).offset(),a=parseInt(n.css("padding-top"),10),r=parseInt(n.css("padding-bottom"),10);o.top-=e(window).scrollTop()-a;var s={width:n.width(),height:(y?n.innerHeight():n[0].offsetHeight)-r-a};return void 0===H&&(H=void 0!==document.createElement("p").style.MozTransform),H?s["-moz-transform"]=s.transform="translate("+o.left+"px,"+o.top+"px)":(s.left=o.left,s.top=o.top),s}}});var F="iframe",j=function(e){if(t.currTemplate[F]){var i=t.currTemplate[F].find("iframe");i.length&&(e||(i[0].src="//about:blank"),t.isIE8&&i.css("display",e?"block":"none"))}};e.magnificPopup.registerModule(F,{options:{markup:'<div class="mfp-iframe-scaler"><div class="mfp-close"></div><iframe class="mfp-iframe" src="//about:blank" frameborder="0" allowfullscreen allow="autoplay; encrypted-media" ></iframe></div>',srcAction:"iframe_src",patterns:{youtube:{index:"youtube.com",id:"v=",src:"//www.youtube.com/embed/%id%?autoplay=1"},vimeo:{index:"vimeo.com/",id:"/",src:"//player.vimeo.com/video/%id%?autoplay=1"},gmaps:{index:"//maps.google.",src:"%id%&output=embed"}}},proto:{initIframe:function(){t.types.push(F),b("BeforeChange",(function(e,t,i){t!==i&&(t===F?j():i===F&&j(!0))})),b(s+"."+F,(function(){j()}))},getIframe:function(i,n){var o=i.src,a=t.st.iframe;e.each(a.patterns,(function(){if(o.indexOf(this.index)>-1)return this.id&&(o="string"==typeof this.id?o.substr(o.lastIndexOf(this.id)+this.id.length,o.length):this.id.call(this,o)),o=this.src.replace("%id%",o),!1}));var r={};return a.srcAction&&(r[a.srcAction]=o),t._parseMarkup(n,r,i),t.updateStatus("ready"),n}}});var N=function(e){var i=t.items.length;return e>i-1?e-i:e<0?i+e:e},W=function(e,t,i){return e.replace(/%curr%/gi,t+1).replace(/%total%/gi,i)};e.magnificPopup.registerModule("gallery",{options:{enabled:!1,arrowMarkup:'<button title="%title%" type="button" class="mfp-arrow mfp-arrow-%dir%"></button>',preload:[0,2],navigateByImgClick:!0,arrows:!0,tPrev:"Previous (Left arrow key)",tNext:"Next (Right arrow key)",tCounter:"%curr% of %total%"},proto:{initGallery:function(){var i=t.st.gallery,o=".mfp-gallery";if(t.direction=!0,!i||!i.enabled)return!1;a+=" mfp-gallery",b(d+o,(function(){i.navigateByImgClick&&t.wrap.on("click"+o,".mfp-img",(function(){if(t.items.length>1)return t.next(),!1})),n.on("keydown"+o,(function(e){37===e.keyCode?t.prev():39===e.keyCode&&t.next()}))})),b("UpdateStatus"+o,(function(e,i){i.text&&(i.text=W(i.text,t.currItem.index,t.items.length))})),b(c+o,(function(e,n,o,a){var r=t.items.length;o.counter=r>1?W(i.tCounter,a.index,r):""})),b("BuildControls"+o,(function(){if(t.items.length>1&&i.arrows&&!t.arrowLeft){var n=i.arrowMarkup,o=t.arrowLeft=e(n.replace(/%title%/gi,i.tPrev).replace(/%dir%/gi,"left")).addClass(v),a=t.arrowRight=e(n.replace(/%title%/gi,i.tNext).replace(/%dir%/gi,"right")).addClass(v);o.on("click",(function(){t.prev()})),a.on("click",(function(){t.next()})),t.container.append(o.add(a))}})),b(p+o,(function(){t._preloadTimeout&&clearTimeout(t._preloadTimeout),t._preloadTimeout=setTimeout((function(){t.preloadNearbyImages(),t._preloadTimeout=null}),16)})),b(s+o,(function(){n.off(o),t.wrap.off("click"+o),t.arrowRight=t.arrowLeft=null}))},next:function(){t.direction=!0,t.index=N(t.index+1),t.updateItemHTML()},prev:function(){t.direction=!1,t.index=N(t.index-1),t.updateItemHTML()},goTo:function(e){t.direction=e>=t.index,t.index=e,t.updateItemHTML()},preloadNearbyImages:function(){var e,i=t.st.gallery.preload,n=Math.min(i[0],t.items.length),o=Math.min(i[1],t.items.length);for(e=1;e<=(t.direction?o:n);e++)t._preloadItem(t.index+e);for(e=1;e<=(t.direction?n:o);e++)t._preloadItem(t.index-e)},_preloadItem:function(i){if(i=N(i),!t.items[i].preloaded){var n=t.items[i];if(n.parsed||(n=t.parseEl(i)),I("LazyLoad",n),"image"===n.type&&(n.img=e('<img class="mfp-img" />').on("load.mfploader",(function(){n.hasSize=!0})).on("error.mfploader",(function(){n.hasSize=!0,n.loadError=!0,I("LazyLoadError",n)})).attr("src",n.src),e("body").hasClass("responsive-images-lightbox-support")&&n.el.length>0)){var o=e(n.el[0]),a=o.data("srcset"),r=o.data("sizes");if(void 0!==a)n.img.attr("srcset",a),void 0!==r&&n.img.attr("sizes",r);else{var s=e(n.el[0]).find("img");void 0!==(a=s.attr("srcset"))&&n.img.attr("srcset",a),void 0!==(r=s.attr("sizes"))&&n.img.attr("sizes",r)}}n.preloaded=!0}}}});var R="retina";e.magnificPopup.registerModule(R,{options:{replaceSrc:function(e){return e.src.replace(/\.\w+$/,(function(e){return"@2x"+e}))},ratio:1},proto:{initRetina:function(){if(window.devicePixelRatio>1){var e=t.st.retina,i=e.ratio;(i=isNaN(i)?i():i)>1&&(b("ImageHasSize."+R,(function(e,t){t.img.css({"max-width":t.img[0].naturalWidth/i,width:"100%"})})),b("ElementParse."+R,(function(t,n){n.src=e.replaceSrc(n,i)})))}}}}),k()}(jQuery);(function(e){'use strict';e.avia_utilities=e.avia_utilities||{};e.avia_utilities.av_popup={type:'image',mainClass:'avia-popup mfp-zoom-in',tLoading:'',tClose:'',removalDelay:300,closeBtnInside:!0,closeOnContentClick:!1,midClick:!0,autoFocusLast:!1,fixedContentPos:e('html').hasClass('av-default-lightbox-no-scroll'),iframe:{patterns:{youtube:{index:'youtube.com/watch',id:function(e){let m=e.match(/[\\?\\&]v=([^\\?\\&]+)/),id,params;if(!m||!m[1]){return null};id=m[1];params=e.split('/watch');params=params[1];return id+params},src:'//www.youtube.com/embed/%id%'},youtube_shorts:{index:'youtube.com/shorts',id:function(e){let m=e.match(/(?:youtube\.com\/shorts\/)([a-zA-Z0-9_-]*)/),id,params;if(!m||!m[1]){return null};id=m[1];params=e.split('/shorts');params=params[1];return id+params},src:'//www.youtube.com/embed/%id%'},vimeo:{index:'vimeo.com/',id:function(e){let m=e.match(/(https?:\/\/)?(www.)?(player.)?vimeo.com\/([a-z]*\/)*([0-9]{6,11})\/(\w{6,11})[?]?.*/),params,vid;m=m?m:e.match(/(https?:\/\/)?(www.)?(player.)?vimeo.com\/([a-z]*\/)*([0-9]{6,11})[?]?.*/);if(!m||!m[5]){return null};vid=m[5];params=e.split('?');params=params[1]?'?'+params[1]:'';if(m[6]){vid=vid+(params?params+'&h=':'?h=')+m[6]}
else{vid=vid+params};return vid},src:'//player.vimeo.com/video/%id%'}}},image:{titleSrc:function(t){var a=t.el.attr('title');if(!a){a=t.el.find('img').attr('title')};if(!a){a=t.el.parent().next('.wp-caption-text').html()};if(typeof a!='undefined'){return a};if(!e('body').hasClass('avia-mfp-show-alt-text')){return''};var i=t.el.attr('alt');if(typeof i!='undefined'){return i};i=t.el.find('img').attr('alt');if(typeof i!='undefined'){return i};return''}},gallery:{tPrev:'',tNext:'',tCounter:'%curr% / %total%',enabled:!0,preload:[1,1]},callbacks:{beforeOpen:function(){if(this.st.el&&this.st.el.data('fixed-content')){this.fixedContentPos=!0};let elementCustomClass='';if(this.st.el&&this.st.el.data('custom_class')){elementCustomClass=this.st.el.data('custom_class').trim()}
else if(this.st.el){let element=e(this.st.el),href=element.attr('href');if((href.indexOf('youtube.com')>=0)&&(href.indexOf('/shorts/')>=0)){elementCustomClass='avia-mfp-is-video avia-mfp-video-9-16'}};if(elementCustomClass){this.st.mainClass+=' '+elementCustomClass}},open:function(){e.magnificPopup.instance.next=function(){var t=this;t.wrap.removeClass('mfp-image-loaded');setTimeout(function(){e.magnificPopup.proto.next.call(t)},120)};e.magnificPopup.instance.prev=function(){var t=this;t.wrap.removeClass('mfp-image-loaded');setTimeout(function(){e.magnificPopup.proto.prev.call(t)},120)};if(this.st.el&&this.st.el.data('av-extra-class')){this.wrap.addClass(this.currItem.el.data('av-extra-class'))};this.wrap.avia_swipe_trigger({prev:'.mfp-arrow-left',next:'.mfp-arrow-right'})},markupParse:function(t,a,r){if(typeof a.img_replaceWith=='undefined'||typeof a.img_replaceWith.length=='undefined'||a.img_replaceWith.length==0){return};var o=e(a.img_replaceWith[0]);if(typeof o.attr('alt')!='undefined'){return};var i=r.el.attr('alt');if(typeof i=='undefined'){i=r.el.find('img').attr('alt')};if(typeof i!='undefined'){o.attr('alt',i)};return},imageLoadComplete:function(){var e=this;setTimeout(function(){e.wrap.addClass('mfp-image-loaded')},16)},change:function(){if(this.currItem.el){var e=this.currItem.el;this.content.find('.av-extra-modal-content, .av-extra-modal-markup').remove();if(e.data('av-extra-content')){var a=e.data('av-extra-content');this.content.append('<div class=\'av-extra-modal-content\'>'+a+'</div>')};if(e.data('av-extra-markup')){var t=e.data('av-extra-markup');this.wrap.append('<div class=\'av-extra-modal-markup\'>'+t+'</div>')}}}}};e.fn.avia_activate_lightbox=function(t){var i={groups:['.avia-slideshow','.avia-gallery','.av-horizontal-gallery','.av-instagram-pics','.portfolio-preview-image','.portfolio-preview-content','.isotope','.post-entry','.sidebar','#main','.main_menu','.woocommerce-product-gallery'],autolinkElements:'a.lightbox, a[rel^="prettyPhoto"], a[rel^="lightbox"], a[href$=jpg], a[href$=webp], a[href$=png], a[href$=gif], a[href$=jpeg], a[href*=".jpg?"], a[href*=".png?"], a[href*=".gif?"], a[href*=".jpeg?"], a[href$=".mov"] , a[href$=".swf"] , a:regex(href, .vimeo\.com/[0-9]) , a[href*="youtube.com/watch"] , a[href*="youtube.com/shorts"] , a[href*="screenr.com"], a[href*="iframe=true"]',videoElements:'a[href$=".mov"] , a[href$=".swf"] , a:regex(href, .vimeo\.com/[0-9]) , a[href*="youtube.com/watch"] , a[href*="youtube.com/shorts"] , a[href*="screenr.com"], a[href*="iframe=true"]',exclude:'.noLightbox, .noLightbox a, .fakeLightbox, .lightbox-added, a[href*="dropbox.com"], .pagination a'},a=e.extend({},i,t),r=!e('html').is('.av-custom-lightbox');if(!r){return this};return this.each(function(){var i=e(this),o=e(a.videoElements,this).not(a.exclude).addClass('mfp-iframe'),r=!i.is('body')&&!i.is('.ajax_slide');for(var t=0;t<a.groups.length;t++){i.find(a.groups[t]).each(function(){var t=e(a.autolinkElements,this);if(r){t.removeClass('lightbox-added')};t.not(a.exclude).addClass('lightbox-added').magnificPopup(e.avia_utilities.av_popup)})}})}})(jQuery);(function(e){'use strict';e(function(){i()});function a(e,i,a){if(e[0].classList){if(i=='add'){e[0].classList.add(a)}
else{e[0].classList.remove(a)}}
else{if(i=='add'){e.addClass(a)}
else{e.removeClass(a)}}};function i(){var h=e(window),i=e('.html_header_top.html_header_sticky #header'),r=e('.av_header_unstick_top');if(!i.length&&!r.length){return};var u=e('#header_main .container .logo img, #header_main .container .logo svg, #header_main .container .logo a'),o=e('#header_main .container:not(#header_main_alternate>.container), #header_main .main_menu ul:first-child > li > a:not(.avia_mega_div a, #header_main_alternate a), #header_main #menu-item-shop .cart_dropdown_link'),t=e(o).first().height(),v=e.avia_utilities.isMobile,H=e('#scroll-top-link'),f=i.is('.av_header_transparency'),s=i.is('.av_header_shrinking'),c=i.data('av_shrink_factor'),l=t/2.0,g=t/2.0,p=i.find('#header_meta'),n=p.length?p.outerHeight():0,m=i.find('#header_main_alternate'),y=m.length?m.outerHeight():0,d=function(){var d=h.scrollTop(),c=0,p=d;if(r){d-=n};if(d<0){d=0};if(s&&!v){if(d<l){c=t-d;if(d<=0){c=t};a(i,'remove','header-scrolled')}
else{c=g;a(i,'add','header-scrolled')};if(d-30<t){a(i,'remove','header-scrolled-full')}
else{a(i,'add','header-scrolled-full')};o.css({'height':c+'px','lineHeight':c+'px'});u.css({'maxHeight':c+'px'});let propHeight=c+y;if(i.length){if(!r.length){propHeight+=n}
else{if(d<=n){propHeight=propHeight+n-p}}};e(':root')[0].style.setProperty('--enfold-header-height',Math.round(propHeight)+'px')};if(r.length){if(d<=0){if(p<=0){p=0};r.css({'margin-top':'-'+p+'px'})}
else{r.css({'margin-top':'-'+n+'px'})}};if(f){if(d>50){a(i,'remove','av_header_transparency')}
else{a(i,'add','av_header_transparency')}}};if(typeof c!='undefined'){const value=parseInt(c);if(!isNaN(value)){l=t*(value/100.0);g=t-l}};if(e('body').is('.avia_deactivate_menu_resize')){s=!1};if(!f&&!s&&!r.length){return};h.on('debouncedresize',function(){t=e(o).attr('style','').first().height();d()});h.on('scroll',function(){window.requestAnimationFrame(d)});d()}})(jQuery);(function(n){'use strict';var r=null,a=null,t=null,i=null,e=null;n(function(){r=n(window);a=n('body');if(a.hasClass('av-curtain-footer')){o();return};return});function o(){i=a.find('.av-curtain-footer-container');if(i.length==0){a.removeClass('av-curtain-footer av-curtain-activated av-curtain-numeric av-curtain-screen');return};t=n('<div id="av-curtain-footer-placeholder"></div>');i.before(t);if(a.hasClass('av-curtain-numeric')){e=i.data('footer_max_height');if('undefined'==typeof e){e=70}
else{e=parseInt(e,10);if(isNaN(e)){e=70}}};u();r.on('debouncedresize',u)};function u(){var n=Math.floor(i.outerHeight()),o=r.innerHeight();if(null==e){t.css({height:n+'px'})}
else{var u=Math.floor(o*(e/100.0));if(n>u){a.removeClass('av-curtain-activated');t.css({height:''})}
else{a.addClass('av-curtain-activated');t.css({height:n+'px'})}}}})(jQuery);(function(t){'use strict';t(function(){t('.avia_auto_toc').each(function(){var s=t(this).attr('id'),n='h1',c=[],a='',r=t(this).find('.avia-toc-container');if(r.length){var i=r.attr('data-level'),o=r.attr('data-exclude');if(typeof i!='undefined'){n=i};if(typeof o!='undefined'){a=o.trim()}};c=n.split(',');t('.entry-content-wrapper').find(n).each(function(){var n=t(this);if(n.hasClass('av-no-toc')){return};if(a!=''&&(n.hasClass(a)||n.parent().hasClass(a))){return};var i=n.attr('id'),l=n.prop('tagName').toLowerCase(),s=n.text(),h=c.indexOf(l);if(typeof i=='undefined'){var o=e(s);n.attr('id',o);i=o};var f='<a href="#'+i+'" class="avia-toc-link avia-toc-level-'+h+'"><span>'+s+'</span></a>';r.append(f)});t('.avia-toc-smoothscroll .avia-toc-link').on('click',function(e){e.preventDefault();var n=t(this).attr('href'),a=50,r=t('.html_header_top.html_header_sticky #header');if(r.length){a=r.outerHeight()+50};t('html,body').animate({scrollTop:t(n).offset().top-a})})})});function e(t){return t.replace(/[ÄÖÜäöüß]/g,function(t){return{'Ä':'Ae','Ö':'Oe','Ü':'Ue','ä':'ae','ö':'oe','ü':'ue','ß':'ss'}[t]}).toLowerCase().replace(/[^a-z0-9]+/g,'-').replace(/^-+|-+$/g,'-').replace(/^-+|-+$/g,'')}})(jQuery);(function(e){'use strict';var t=e('.has-background, .has-text-color');t.each(function(s){var t=e(this);if(!(t.hasClass('has-background')||t.hasClass('has-text-color'))){return};var o=t.attr('class').split(/\s+/),a='',r='';if(t.hasClass('has-background')){e.each(o,function(s,e){e=e.trim().toLowerCase();if(0==e.indexOf('has-col-')&&-1!=e.indexOf('-background-color')){a=e.replace('has-col-','');a=a.replace('-background-color','');a=a.replace(/-|[^0-9a-fA-F]/g,'');if(a.length==3||a.length==6){t.css({'background-color':'','border-color':''});r='undefined'!=typeof t.attr('style')?t.attr('style')+';':'';t.attr('style',r+' background-color: #'+a+'; border-color: #'+a+';')}}})};if(t.hasClass('has-text-color')){e.each(o,function(s,e){e=e.trim().toLowerCase();if(0==e.indexOf('has-col-')&&-1==e.indexOf('-background-color')&&-1!=e.indexOf('-color')){var a=e.replace('has-col-','');a=a.replace('-color','');a=a.replace(/-|[^0-9a-fA-F]/g,'');if(a.length==3||a.length==6){t.css('color','');r='undefined'!=typeof t.attr('style')?t.attr('style')+';':'';t.attr('style',r+' color: #'+a+';')}}})}});t=e('[class^="has-fs-"], [class$="-font-size"]');t.each(function(t){var a=e(this),s=a.attr('class').split(/\s+/);e.each(s,function(t,e){e=e.trim().toLowerCase();if(0==e.indexOf('has-fs-')&&-1!=e.indexOf('-font-size')){e=e.replace('has-fs-','');e=e.replace('-font-size','');e=e.split('-');if(e.length!=2){return};var s='undefined'!=typeof a.attr('style')?a.attr('style')+';':'';a.attr('style',s+' font-size:'+e[0]+e[1]+';')}})})})(jQuery);!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var t;"undefined"!=typeof window?t=window:"undefined"!=typeof global?t=global:"undefined"!=typeof self&&(t=self),t.sbjs=e()}}(function(){return function e(t,r,n){function a(s,o){if(!r[s]){if(!t[s]){var c="function"==typeof require&&require;if(!o&&c)return c(s,!0);if(i)return i(s,!0);var u=new Error("Cannot find module '"+s+"'");throw u.code="MODULE_NOT_FOUND",u}var p=r[s]={exports:{}};t[s][0].call(p.exports,function(e){var r=t[s][1][e];return a(r||e)},p,p.exports,e,t,r,n)}return r[s].exports}for(var i="function"==typeof require&&require,s=0;s<n.length;s++)a(n[s]);return a}({1:[function(e,t,r){"use strict";var n=e("./init"),a={init:function(e){this.get=n(e),e&&e.callback&&"function"==typeof e.callback&&e.callback(this.get)}};t.exports=a},{"./init":6}],2:[function(e,t,r){"use strict";var n=e("./terms"),a=e("./helpers/utils"),i={containers:{current:"sbjs_current",current_extra:"sbjs_current_add",first:"sbjs_first",first_extra:"sbjs_first_add",session:"sbjs_session",udata:"sbjs_udata",promocode:"sbjs_promo"},service:{migrations:"sbjs_migrations"},delimiter:"|||",aliases:{main:{type:"typ",source:"src",medium:"mdm",campaign:"cmp",content:"cnt",term:"trm",id:"id",platform:"plt",format:"fmt",tactic:"tct"},extra:{fire_date:"fd",entrance_point:"ep",referer:"rf"},session:{pages_seen:"pgs",current_page:"cpg"},udata:{visits:"vst",ip:"uip",agent:"uag"},promo:"code"},pack:{main:function(e){return i.aliases.main.type+"="+e.type+i.delimiter+i.aliases.main.source+"="+e.source+i.delimiter+i.aliases.main.medium+"="+e.medium+i.delimiter+i.aliases.main.campaign+"="+e.campaign+i.delimiter+i.aliases.main.content+"="+e.content+i.delimiter+i.aliases.main.term+"="+e.term+i.delimiter+i.aliases.main.id+"="+e.id+i.delimiter+i.aliases.main.platform+"="+e.platform+i.delimiter+i.aliases.main.format+"="+e.format+i.delimiter+i.aliases.main.tactic+"="+e.tactic},extra:function(e){return i.aliases.extra.fire_date+"="+a.setDate(new Date,e)+i.delimiter+i.aliases.extra.entrance_point+"="+document.location.href+i.delimiter+i.aliases.extra.referer+"="+(document.referrer||n.none)},user:function(e,t){return i.aliases.udata.visits+"="+e+i.delimiter+i.aliases.udata.ip+"="+t+i.delimiter+i.aliases.udata.agent+"="+navigator.userAgent},session:function(e){return i.aliases.session.pages_seen+"="+e+i.delimiter+i.aliases.session.current_page+"="+document.location.href},promo:function(e){return i.aliases.promo+"="+a.setLeadingZeroToInt(a.randomInt(e.min,e.max),e.max.toString().length)}}};t.exports=i},{"./helpers/utils":5,"./terms":9}],3:[function(e,t,r){"use strict";var n=e("../data").delimiter;t.exports={useBase64:!1,setBase64Flag:function(e){this.useBase64=e},encodeData:function(e){return encodeURIComponent(e).replace(/\!/g,"%21").replace(/\~/g,"%7E").replace(/\*/g,"%2A").replace(/\'/g,"%27").replace(/\(/g,"%28").replace(/\)/g,"%29")},decodeData:function(e){try{return decodeURIComponent(e).replace(/\%21/g,"!").replace(/\%7E/g,"~").replace(/\%2A/g,"*").replace(/\%27/g,"'").replace(/\%28/g,"(").replace(/\%29/g,")")}catch(t){try{return unescape(e)}catch(r){return""}}},set:function(e,t,r,n,a){var i,s;if(r){var o=new Date;o.setTime(o.getTime()+60*r*1e3),i="; expires="+o.toGMTString()}else i="";s=n&&!a?";domain=."+n:"";var c=this.encodeData(t);this.useBase64&&(c=btoa(c).replace(/=+$/,"")),document.cookie=this.encodeData(e)+"="+c+i+s+"; path=/"},get:function(e){for(var t=this.encodeData(e)+"=",r=document.cookie.split(";"),n=0;n<r.length;n++){for(var a=r[n];" "===a.charAt(0);)a=a.substring(1,a.length);if(0===a.indexOf(t)){var i=a.substring(t.length,a.length);if(/^[A-Za-z0-9+/]+$/.test(i))try{i=atob(i.padEnd(4*Math.ceil(i.length/4),"="))}catch(s){}return this.decodeData(i)}}return null},destroy:function(e,t,r){this.set(e,"",-1,t,r)},parse:function(e){var t=[],r={};if("string"==typeof e)t.push(e);else for(var a in e)e.hasOwnProperty(a)&&t.push(e[a]);for(var i=0;i<t.length;i++){var s;r[this.unsbjs(t[i])]={},s=this.get(t[i])?this.get(t[i]).split(n):[];for(var o=0;o<s.length;o++){var c=s[o].split("="),u=c.splice(0,1);u.push(c.join("=")),r[this.unsbjs(t[i])][u[0]]=this.decodeData(u[1])}}return r},unsbjs:function(e){return e.replace("sbjs_","")}}},{"../data":2}],4:[function(e,t,r){"use strict";t.exports={parse:function(e){for(var t=this.parseOptions,r=t.parser[t.strictMode?"strict":"loose"].exec(e),n={},a=14;a--;)n[t.key[a]]=r[a]||"";return n[t.q.name]={},n[t.key[12]].replace(t.q.parser,function(e,r,a){r&&(n[t.q.name][r]=a)}),n},parseOptions:{strictMode:!1,key:["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],q:{name:"queryKey",parser:/(?:^|&)([^&=]*)=?([^&]*)/g},parser:{strict:/^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,loose:/^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/}},getParam:function(e){for(var t={},r=(e||window.location.search.substring(1)).split("&"),n=0;n<r.length;n++){var a=r[n].split("=");if("undefined"==typeof t[a[0]])t[a[0]]=a[1];else if("string"==typeof t[a[0]]){var i=[t[a[0]],a[1]];t[a[0]]=i}else t[a[0]].push(a[1])}return t},getHost:function(e){return this.parse(e).host.replace("www.","")}}},{}],5:[function(e,t,r){"use strict";t.exports={escapeRegexp:function(e){return e.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&")},setDate:function(e,t){var r=e.getTimezoneOffset()/60,n=e.getHours(),a=t||0===t?t:-r;return e.setHours(n+r+a),e.getFullYear()+"-"+this.setLeadingZeroToInt(e.getMonth()+1,2)+"-"+this.setLeadingZeroToInt(e.getDate(),2)+" "+this.setLeadingZeroToInt(e.getHours(),2)+":"+this.setLeadingZeroToInt(e.getMinutes(),2)+":"+this.setLeadingZeroToInt(e.getSeconds(),2)},setLeadingZeroToInt:function(e,t){for(var r=e+"";r.length<t;)r="0"+r;return r},randomInt:function(e,t){return Math.floor(Math.random()*(t-e+1))+e}}},{}],6:[function(e,t,r){"use strict";var n=e("./data"),a=e("./terms"),i=e("./helpers/cookies"),s=e("./helpers/uri"),o=e("./helpers/utils"),c=e("./params"),u=e("./migrations");t.exports=function(e){var t,r,p,f,m,d,l,g,h,y,_,v,b,x=c.fetch(e),k=s.getParam(),w=x.domain.host,q=x.domain.isolate,I=x.lifetime;function j(e){switch(e){case a.traffic.utm:t=a.traffic.utm,r="undefined"!=typeof k.utm_source?k.utm_source:"undefined"!=typeof k.gclid?"google":"undefined"!=typeof k.yclid?"yandex":a.none,p="undefined"!=typeof k.utm_medium?k.utm_medium:"undefined"!=typeof k.gclid?"cpc":"undefined"!=typeof k.yclid?"cpc":a.none,f="undefined"!=typeof k.utm_campaign?k.utm_campaign:"undefined"!=typeof k[x.campaign_param]?k[x.campaign_param]:"undefined"!=typeof k.gclid?"google_cpc":"undefined"!=typeof k.yclid?"yandex_cpc":a.none,m="undefined"!=typeof k.utm_content?k.utm_content:"undefined"!=typeof k[x.content_param]?k[x.content_param]:a.none,l=k.utm_id||a.none,g=k.utm_source_platform||a.none,h=k.utm_creative_format||a.none,y=k.utm_marketing_tactic||a.none,d="undefined"!=typeof k.utm_term?k.utm_term:"undefined"!=typeof k[x.term_param]?k[x.term_param]:function(){var e=document.referrer;if(k.utm_term)return k.utm_term;if(!(e&&s.parse(e).host&&s.parse(e).host.match(/^(?:.*\.)?yandex\..{2,9}$/i)))return!1;try{return s.getParam(s.parse(document.referrer).query).text}catch(t){return!1}}()||a.none;break;case a.traffic.organic:t=a.traffic.organic,r=r||s.getHost(document.referrer),p=a.referer.organic,f=a.none,m=a.none,d=a.none,l=a.none,g=a.none,h=a.none,y=a.none;break;case a.traffic.referral:t=a.traffic.referral,r=r||s.getHost(document.referrer),p=p||a.referer.referral,f=a.none,m=s.parse(document.referrer).path,d=a.none,l=a.none,g=a.none,h=a.none,y=a.none;break;case a.traffic.typein:t=a.traffic.typein,r=x.typein_attributes.source,p=x.typein_attributes.medium,f=a.none,m=a.none,d=a.none,l=a.none,g=a.none,h=a.none,y=a.none;break;default:t=a.oops,r=a.oops,p=a.oops,f=a.oops,m=a.oops,d=a.oops,l=a.oops,g=a.oops,h=a.oops,y=a.oops}var i={type:t,source:r,medium:p,campaign:f,content:m,term:d,id:l,platform:g,format:h,tactic:y};return n.pack.main(i)}function R(e){var t=document.referrer;switch(e){case a.traffic.organic:return!!t&&H(t)&&function(e){var t=new RegExp("^(?:.*\\.)?"+o.escapeRegexp("yandex")+"\\..{2,9}$"),n=new RegExp(".*"+o.escapeRegexp("text")+"=.*"),a=new RegExp("^(?:www\\.)?"+o.escapeRegexp("google")+"\\..{2,9}$");if(s.parse(e).query&&s.parse(e).host.match(t)&&s.parse(e).query.match(n))return r="yandex",!0;if(s.parse(e).host.match(a))return r="google",!0;if(!s.parse(e).query)return!1;for(var i=0;i<x.organics.length;i++){if(s.parse(e).host.match(new RegExp("^(?:.*\\.)?"+o.escapeRegexp(x.organics[i].host)+"$","i"))&&s.parse(e).query.match(new RegExp(".*"+o.escapeRegexp(x.organics[i].param)+"=.*","i")))return r=x.organics[i].display||x.organics[i].host,!0;if(i+1===x.organics.length)return!1}}(t);case a.traffic.referral:return!!t&&H(t)&&function(e){if(!(x.referrals.length>0))return r=s.getHost(e),!0;for(var t=0;t<x.referrals.length;t++){if(s.parse(e).host.match(new RegExp("^(?:.*\\.)?"+o.escapeRegexp(x.referrals[t].host)+"$","i")))return r=x.referrals[t].display||x.referrals[t].host,p=x.referrals[t].medium||a.referer.referral,!0;if(t+1===x.referrals.length)return r=s.getHost(e),!0}}(t);default:return!1}}function H(e){if(x.domain){if(q)return s.getHost(e)!==s.getHost(w);var t=new RegExp("^(?:.*\\.)?"+o.escapeRegexp(w)+"$","i");return!s.getHost(e).match(t)}return s.getHost(e)!==s.getHost(document.location.href)}function D(){i.set(n.containers.current_extra,n.pack.extra(x.timezone_offset),I,w,q),i.get(n.containers.first_extra)||i.set(n.containers.first_extra,n.pack.extra(x.timezone_offset),I,w,q)}return i.setBase64Flag(x.base64),u.go(I,w,q),i.set(n.containers.current,function(){var e;if("undefined"!=typeof k.utm_source||"undefined"!=typeof k.utm_medium||"undefined"!=typeof k.utm_campaign||"undefined"!=typeof k.utm_content||"undefined"!=typeof k.utm_term||"undefined"!=typeof k.utm_id||"undefined"!=typeof k.utm_source_platform||"undefined"!=typeof k.utm_creative_format||"undefined"!=typeof k.utm_marketing_tactic||"undefined"!=typeof k.gclid||"undefined"!=typeof k.yclid||"undefined"!=typeof k[x.campaign_param]||"undefined"!=typeof k[x.term_param]||"undefined"!=typeof k[x.content_param])D(),e=j(a.traffic.utm);else if(R(a.traffic.organic))D(),e=j(a.traffic.organic);else if(!i.get(n.containers.session)&&R(a.traffic.referral))D(),e=j(a.traffic.referral);else{if(i.get(n.containers.first)||i.get(n.containers.current))return i.get(n.containers.current);D(),e=j(a.traffic.typein)}return e}(),I,w,q),i.get(n.containers.first)||i.set(n.containers.first,i.get(n.containers.current),I,w,q),i.get(n.containers.udata)?(_=parseInt(i.parse(n.containers.udata)[i.unsbjs(n.containers.udata)][n.aliases.udata.visits])||1,_=i.get(n.containers.session)?_:_+1,v=n.pack.user(_,x.user_ip)):(_=1,v=n.pack.user(_,x.user_ip)),i.set(n.containers.udata,v,I,w,q),i.get(n.containers.session)?(b=parseInt(i.parse(n.containers.session)[i.unsbjs(n.containers.session)][n.aliases.session.pages_seen])||1,b+=1):b=1,i.set(n.containers.session,n.pack.session(b),x.session_length,w,q),x.promocode&&!i.get(n.containers.promocode)&&i.set(n.containers.promocode,n.pack.promo(x.promocode),I,w,q),i.parse(n.containers)}},{"./data":2,"./helpers/cookies":3,"./helpers/uri":4,"./helpers/utils":5,"./migrations":7,"./params":8,"./terms":9}],7:[function(e,t,r){"use strict";var n=e("./data"),a=e("./helpers/cookies");t.exports={go:function(e,t,r){var i,s=this.migrations,o={l:e,d:t,i:r};if(a.get(n.containers.first)||a.get(n.service.migrations)){if(!a.get(n.service.migrations))for(i=0;i<s.length;i++)s[i].go(s[i].id,o)}else{var c=[];for(i=0;i<s.length;i++)c.push(s[i].id);var u="";for(i=0;i<c.length;i++)u+=c[i]+"=1",i<c.length-1&&(u+=n.delimiter);a.set(n.service.migrations,u,o.l,o.d,o.i)}},migrations:[{id:"1418474375998",version:"1.0.0-beta",go:function(e,t){var r=e+"=1",i=e+"=0",s=function(e,t,r){return t||r?e:n.delimiter};try{var o=[];for(var c in n.containers)n.containers.hasOwnProperty(c)&&o.push(n.containers[c]);for(var u=0;u<o.length;u++)if(a.get(o[u])){var p=a.get(o[u]).replace(/(\|)?\|(\|)?/g,s);a.destroy(o[u],t.d,t.i),a.destroy(o[u],t.d,!t.i),a.set(o[u],p,t.l,t.d,t.i)}a.get(n.containers.session)&&a.set(n.containers.session,n.pack.session(0),t.l,t.d,t.i),a.set(n.service.migrations,r,t.l,t.d,t.i)}catch(f){a.set(n.service.migrations,i,t.l,t.d,t.i)}}}]}},{"./data":2,"./helpers/cookies":3}],8:[function(e,t,r){"use strict";var n=e("./terms"),a=e("./helpers/uri");t.exports={fetch:function(e){var t=e||{},r={};if(r.lifetime=this.validate.checkFloat(t.lifetime)||6,r.lifetime=parseInt(30*r.lifetime*24*60),r.session_length=this.validate.checkInt(t.session_length)||30,r.timezone_offset=this.validate.checkInt(t.timezone_offset),r.base64=t.base64||!1,r.campaign_param=t.campaign_param||!1,r.term_param=t.term_param||!1,r.content_param=t.content_param||!1,r.user_ip=t.user_ip||n.none,t.promocode?(r.promocode={},r.promocode.min=parseInt(t.promocode.min)||1e5,r.promocode.max=parseInt(t.promocode.max)||999999):r.promocode=!1,t.typein_attributes&&t.typein_attributes.source&&t.typein_attributes.medium?(r.typein_attributes={},r.typein_attributes.source=t.typein_attributes.source,r.typein_attributes.medium=t.typein_attributes.medium):r.typein_attributes={source:"(direct)",medium:"(none)"},t.domain&&this.validate.isString(t.domain)?r.domain={host:t.domain,isolate:!1}:t.domain&&t.domain.host?r.domain=t.domain:r.domain={host:a.getHost(document.location.hostname),isolate:!1},r.referrals=[],t.referrals&&t.referrals.length>0)for(var i=0;i<t.referrals.length;i++)t.referrals[i].host&&r.referrals.push(t.referrals[i]);if(r.organics=[],t.organics&&t.organics.length>0)for(var s=0;s<t.organics.length;s++)t.organics[s].host&&t.organics[s].param&&r.organics.push(t.organics[s]);return r.organics.push({host:"bing.com",param:"q",display:"bing"}),r.organics.push({host:"yahoo.com",param:"p",display:"yahoo"}),r.organics.push({host:"about.com",param:"q",display:"about"}),r.organics.push({host:"aol.com",param:"q",display:"aol"}),r.organics.push({host:"ask.com",param:"q",display:"ask"}),r.organics.push({host:"globososo.com",param:"q",display:"globo"}),r.organics.push({host:"go.mail.ru",param:"q",display:"go.mail.ru"}),r.organics.push({host:"rambler.ru",param:"query",display:"rambler"}),r.organics.push({host:"tut.by",param:"query",display:"tut.by"}),r.referrals.push({host:"t.co",display:"twitter.com"}),r.referrals.push({host:"plus.url.google.com",display:"plus.google.com"}),r},validate:{checkFloat:function(e){return!(!e||!this.isNumeric(parseFloat(e)))&&parseFloat(e)},checkInt:function(e){return!(!e||!this.isNumeric(parseInt(e)))&&parseInt(e)},isNumeric:function(e){return!isNaN(e)},isString:function(e){return"[object String]"===Object.prototype.toString.call(e)}}}},{"./helpers/uri":4,"./terms":9}],9:[function(e,t,r){"use strict";t.exports={traffic:{utm:"utm",organic:"organic",referral:"referral",typein:"typein"},referer:{referral:"referral",organic:"organic",social:"social"},none:"(none)",oops:"(Houston, we have a problem)"}},{}]},{},[1])(1)});!function(t){"use strict";const e=t.params,n=(document.querySelector.bind(document),(t,e)=>e.split(".").reduce((t,e)=>t&&t[e],t)),i=()=>null,s=t=>null===t||t===undefined?"":t,o="wc/store/checkout";function a(t){window.wp&&window.wp.data&&window.wp.data.dispatch&&window.wc&&window.wc.wcBlocksData&&window.wp.data.dispatch(window.wc.wcBlocksData.CHECKOUT_STORE_KEY).__internalSetExtensionData("woocommerce/order-attribution",t,!0)}function r(){return"undefined"!=typeof sbjs}function c(){if(window.wp&&window.wp.data&&"function"==typeof window.wp.data.subscribe){const e=window.wp.data.subscribe(function(){e(),a(t.getAttributionData())},o)}}t.getAttributionData=function(){const s=e.allowTracking&&r()?n:i,o=r()?sbjs.get:{},a=Object.entries(t.fields).map(([t,e])=>[t,s(o,e)]);return Object.fromEntries(a)},t.setOrderTracking=function(n){if(e.allowTracking=n,n){if(!r())return;sbjs.init({lifetime:Number(e.lifetime),session_length:Number(e.session),base64:Boolean(e.base64),timezone_offset:"0"})}else!function(){const t=window.location.hostname;["sbjs_current","sbjs_current_add","sbjs_first","sbjs_first_add","sbjs_session","sbjs_udata","sbjs_migrations","sbjs_promo"].forEach(e=>{document.cookie=`${e}=; path=/; max-age=-999; domain=.${t};`})}();const i=t.getAttributionData();!function(t){for(const e of document.querySelectorAll("wc-order-attribution-inputs"))e.values=t}(i),a(i)},t.setOrderTracking(e.allowTracking),"loading"===document.readyState?document.addEventListener("DOMContentLoaded",c):c(),window.customElements.define("wc-order-attribution-inputs",class extends HTMLElement{constructor(){if(super(),this._fieldNames=Object.keys(t.fields),this.hasOwnProperty("_values")){let t=this.values;delete this.values,this.values=t||{}}}connectedCallback(){this.innerHTML="";const t=new DocumentFragment;for(const n of this._fieldNames){const i=document.createElement("input");i.type="hidden",i.name=`${e.prefix}${n}`,i.value=s(this.values&&this.values[n]||""),t.appendChild(i)}this.appendChild(t)}set values(t){if(this._values=t,this.isConnected)for(const t of this._fieldNames){const n=this.querySelector(`input[name="${e.prefix}${t}"]`);n?n.value=s(this.values[t]):console.warn(`Field "${t}" not found. `+"Most likely, the '<wc-order-attribution-inputs>' element was manipulated.")}}get values(){return this._values}})}(window.wc_order_attribution);